------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 14:09:39 +0100 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_IO; use Text_IO;

package body Version is

   procedure Copyright (Program_Name : in String) is
   begin
      New_Line;
      Put_Line
        (Program_Name &
         " version " &
         Cheddar_Version &
", Copyright (C) 2002-2015, by Frank Singhoff, Alain Plantec, Jerome Legrand");
      Put_Line (Cheddar_svn_version);
      Put_Line(
"The Cheddar project was started in 2002 by Frank Singhoff, Lab-STICC Team, CNRS UMR 6285, Université de Bretagne Occidentale "
);
      Put_Line(
"Since 2008, Ellidiss technologies also contributes to the development of Cheddar and provides industrial support"
);
      Put_Line (Program_Name & " comes with ABSOLUTELY NO WARRANTY; ");
      Put_Line
        ("This is free software, and you are welcome to redistribute it");
      Put_Line(
"under certain conditions; See the GNU General Public License for details.");
      New_Line;
   end Copyright;

   function Cheddar_svn_version return String is
   begin
      return
"Compiled from the SVN source code revision number $Rev: 1835 $,  source code changed on $Date: 2015-08-19 22:09:39 +0100 (Wed, 19 Aug 2015) $"
;
   end Cheddar_svn_version;


end Version;
