with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with unbounded_strings;
use unbounded_strings;

with Processors;
use Processors;

with Address_Space_Set;
use Address_Space_Set;

with Systems;
use Systems;

package Ellidiss_Tools is
	-- set the directory of arinc653 offline partition xml schedule file
	procedure Set_Arinc653_Partition_Table_Directory (directory : in Unbounded_String);

	-- get the directory of arinc653 offline partition xml schedule file
	function Get_Arinc653_Partition_Table_Directory return Unbounded_String;

	-- get the arinc653 offline partition xml schedule file
	function Get_Arinc653_Partition_Table_Filename (name : in Unbounded_String) return Unbounded_String;

	--
	--function Get_Offline_Scheduling_Period (A_Processor : in Generic_Processor_Ptr) return Natural;

	--
	--function Get_Cyclic_Scheduling_Period (My_Address_Spaces : in Address_Spaces_Set) return Natural;

   	-- Get the system hyper period for 1 given processor
   	function Get_Scheduling_Period (A_Sys : in System; A_Processor : Generic_Processor_Ptr) return Natural;

   	--
   	procedure Write_Xml_Event_Table (Sys : in out System; File_Name : in Unbounded_String);

   	-- assessors of default scheduling period
   	procedure Set_Default_Scheduling_Period (Scheduling_Period : in Natural);
   	function Get_Default_Scheduling_Period return Natural;

   	function CheddarKernel_version return String;

   	-- exeption use when there is no hyper period algo available
   	Invalid_Scheduling_Period : exception;

   	-- ellidiss xml tags
	Elli_Feasibility_Test       : Unbounded_String := To_Unbounded_String ("<feasibilityTest");
	Elli_Close_Feasibility_Test : Unbounded_String := To_Unbounded_String ("</feasibilityTest>");
	Elli_Computation            : Unbounded_String := To_Unbounded_String ("<computation");
   	Elli_Schedulability         : Unbounded_String := To_Unbounded_String ("<schedulability");
private
	--
   	arinc653_partition_table_directory : Unbounded_String := empty_string;

   	-- default hyper period use if no hyper period has been found
   	Default_Scheduling_Period : Natural := 10000;

   	-- current cheddar kernel version
   	CheddarKernel_Verion : constant String := "3 (XX-XX-2015)";
end Ellidiss_Tools;
