------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 14:09:39 +0100 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with unbounded_strings; use unbounded_strings;
with Version;           use Version;

package body Translate.English_Labels is

   procedure Initialize is

   begin
      ----------------------------------------------------
      --   Menu and sub menu titles
      ----------------------------------------------------

      Lb_Root_Title (English) :=
        To_Unbounded_String
          ("Cheddar : a free real time scheduling simulator");

      Lb_File (English)                                :=
        To_Unbounded_String ("File");
      Lb_New (English)                                 :=
        To_Unbounded_String ("New");
      Lb_Open_Xml (English)                            :=
        To_Unbounded_String ("Open XML project");
      Lb_Save_Xml (English)                            :=
        To_Unbounded_String ("Save XML project");
      Lb_Save_As_Xml (English)                         :=
        To_Unbounded_String ("Save XML project as ");
      Lb_Open (English)                                :=
        To_Unbounded_String ("Open");
      Lb_Save (English)                                :=
        To_Unbounded_String ("Save");
      Lb_Save_As (English)                             :=
        To_Unbounded_String ("Save as ");
      Lb_Aadl (English)                                :=
        To_Unbounded_String ("AADL");
      Lb_Import_Aadl (English)                         :=
        To_Unbounded_String ("AADL project import");
      Lb_Export_Aadl (English)                         :=
        To_Unbounded_String ("AADL project export");
      Lb_export_arinc653_tsp (English)                 :=
        To_Unbounded_String ("Export ARINC653 TSP");
      Lb_Aadl_Options (English)                        :=
        To_Unbounded_String ("AADL options");
      Lb_Other_Aadl_Options (English)                  :=
        To_Unbounded_String ("Other AADL options");
      Lb_Export_Cheddar_Property_Sets (English)        :=
        To_Unbounded_String ("Export Cheddar Property Sets");
      Lb_Export_Aadl_Standard_Properties_Set (English) :=
        To_Unbounded_String ("Export Aadl Standard Properties Set");
      Lb_Exit (English)                                :=
        To_Unbounded_String ("Exit");

      Lb_Edit (English) := To_Unbounded_String ("Edit");

      Lb_Edit_Scheduler (English)                   :=
        To_Unbounded_String ("Edit a scheduler");
      Lb_Parametric (English)                       :=
        To_Unbounded_String ("User-defined");
      Lb_Tools (English)                            :=
        To_Unbounded_String ("Tools");
      Lb_Compute_Buffer (English)                   :=
        To_Unbounded_String ("Buffer analysis with feasibility tests");
      Lb_Draw_Buffer (English)                      :=
        To_Unbounded_String ("Buffer analysis from scheduling simulation");
      Lb_Clear (English)                            :=
        To_Unbounded_String ("Clear work space");
      Lb_Scheduling_Simulation (English)            :=
        To_Unbounded_String ("Scheduling simulation");
      Lb_Scheduling_Feasibility (English)           :=
        To_Unbounded_String ("Scheduling feasibility");
      Lb_Customized_Scheduling_Simulation (English) :=
        To_Unbounded_String ("Customized scheduling simulation");
      Lb_Customized_Feasibility_Tests (English)     :=
        To_Unbounded_String ("Customized scheduling feasibility");
      Lb_Compute_And_Display (English)              :=
        To_Unbounded_String ("Compute and Display");
      Lb_Compute_And_Update (English)               :=
        To_Unbounded_String ("Compute and Update tasks");
      Lb_Compute_And_Display_One_Step (English)     :=
        To_Unbounded_String ("Compute and Display : one step ");
      Lb_Compute_And_Update_One_Step (English)      :=
        To_Unbounded_String ("Compute and Update tasks : one step ");
      Lb_Memory_Requirement_Analysis (English)      :=
        To_Unbounded_String ("Address space Memory Footprint Analysis");
      Lb_Check_And_Update_Address_Space (English)   :=
        To_Unbounded_String ("Check and update Address space");
      Lb_Check_Address_Space (English)              :=
        To_Unbounded_String ("Check Address Space ");

      Lb_Help (English)       := To_Unbounded_String ("Help");
      Lb_Manual (English)     := To_Unbounded_String ("Manual");
      Lb_Ref (English)        :=
        To_Unbounded_String ("Scheduling references");
      Lb_About (English)      := To_Unbounded_String ("About Cheddar");
      Lb_About_Text (English) :=
        To_Unbounded_String ("Cheddar ") &
      Cheddar_Version &
      unbounded_lf &
      Cheddar_svn_version &
      unbounded_lf &
      unbounded_lf &
      To_Unbounded_String ("Cheddar is a free real time scheduling tool.") &
      unbounded_lf &
      To_Unbounded_String
        ("Cheddar is distributed under the GNU GPL license.");
      Lb_About_Text (English) :=
        Lb_About_Text (English) &
      unbounded_lf &
      unbounded_lf &
      To_Unbounded_String
        ("Cheddar is maintened by the Lab-STICC Team, CNRS UMR 6285, Université de Bretagne Occidentale.") &
      unbounded_lf &
      unbounded_lf &
      To_Unbounded_String(
                          "See : http:://beru.univ-brest.fr/~singhoff/cheddar for more details") &
      unbounded_lf;

      ----------------------------------------------------
      --   Update model
      ----------------------------------------------------

      Lb_add (English)    := To_Unbounded_String ("Add");
      lb_delete (English) := To_Unbounded_String ("Delete");

      Lb_Update (English)                := To_Unbounded_String ("Update");
      Lb_Update_Task (English)           :=
        To_Unbounded_String ("Update tasks");
      Lb_Update_Address_Space (English)  :=
        To_Unbounded_String ("Update address spaces");
      lb_update_core_unit (English)      :=
        To_Unbounded_String ("Update core units");
      Lb_Update_Processor (English)      :=
        To_Unbounded_String ("Update processors");
      Lb_Update_Resource (English)       :=
        To_Unbounded_String ("Update resources");
      Lb_Update_Message (English)        :=
        To_Unbounded_String ("Update messages");
      Lb_Update_Buffer (English)         :=
        To_Unbounded_String ("Update buffers");
      Lb_Update_Event_Analyzer (English) :=
        To_Unbounded_String ("Update event analyzers");
      Lb_Update_Network (English)        :=
        To_Unbounded_String ("Update networks");

      ------------------------------------------------------------
      --   Errors on messages/tasks/processors/resources/buffers
      ------------------------------------------------------------

      Lb_core_unit_Not_Found (English)     :=
        To_Unbounded_String ("Core unit not found");
      Lb_cache_Not_Found (English)     :=
        To_Unbounded_String ("Cache not found");
      Lb_Dependency_Not_Found (English)     :=
        To_Unbounded_String ("Dependency not found");
      Lb_Resource_Not_Found (English)       :=
        To_Unbounded_String ("Resource not found");
      Lb_Message_Not_Found (English)        :=
        To_Unbounded_String ("Message not found");
      Lb_Task_Not_Found (English)           :=
        To_Unbounded_String ("Task not found");
      Lb_Task_group_Not_Found (English)           :=
        To_Unbounded_String ("Task group not found");
      Lb_Address_Space_Not_Found (English)  :=
        To_Unbounded_String ("Address space not found");
      Lb_Processor_Not_Found (English)      :=
        To_Unbounded_String ("Processor not found");
      Lb_Buffer_Not_Found (English)         :=
        To_Unbounded_String ("Buffer not found");
      Lb_Event_Analyzer_Not_Found (English) :=
        To_Unbounded_String ("Event analyzer not found");
      Lb_deployment_Not_Found (English) :=
        To_Unbounded_String ("deployment not found");

      Lb_Define_Task_groups_Before (English)           :=
        To_Unbounded_String ("Define a task group before");
      Lb_Define_Tasks_Before (English)           :=
        To_Unbounded_String ("Define a task before");
      Lb_Define_Address_Spaces_Before (English)  :=
        To_Unbounded_String ("Define an address space before");
      Lb_Define_core_units_Before (English)      :=
        To_Unbounded_String ("Define a core unit before");
      Lb_Define_Processors_Before (English)      :=
        To_Unbounded_String ("Define a processor before");
      Lb_Define_Messages_Before (English)        :=
        To_Unbounded_String ("Define a message before");
      Lb_Define_Resources_Before (English)       :=
        To_Unbounded_String ("Define a resource before");
      Lb_Define_Buffers_Before (English)         :=
        To_Unbounded_String ("Define a buffer before");
      Lb_Define_Event_Analyzers_Before (English) :=
        To_Unbounded_String ("Define an event analyzer before");
      Lb_Define_deployments_Before (English) :=
        To_Unbounded_String ("Define a deployment before");

      Lb_Can_Not_Define_More_core_units (English)      :=
        To_Unbounded_String ("Can not define more core units");
      Lb_Can_Not_Define_More_sections (English)        :=
        To_Unbounded_String ("Can not define more sections");
      Lb_Can_Not_Define_More_Networks (English)        :=
        To_Unbounded_String ("Can not define more networks");
      Lb_Can_Not_Define_More_Task_groups (English)           :=
        To_Unbounded_String ("Can not define more task groups");
      Lb_Can_Not_Define_More_Tasks (English)           :=
        To_Unbounded_String ("Can not define more tasks");
      Lb_Can_Not_Define_More_Address_Spaces (English)  :=
        To_Unbounded_String ("Can not define more address spaces");
      Lb_Can_Not_Define_More_Processors (English)      :=
        To_Unbounded_String ("Can not define more processors");
      Lb_Can_Not_Define_More_Resources (English)       :=
        To_Unbounded_String ("Can not define more resources");
      Lb_Can_Not_Define_More_Buffers (English)         :=
        To_Unbounded_String ("Can not define more buffers");
      Lb_Can_Not_Define_More_Messages (English)        :=
        To_Unbounded_String ("Can not define more messages");
      Lb_Can_Not_Define_More_Event_Analyzers (English) :=
        To_Unbounded_String ("Can not define more event analyzers");
      Lb_Can_Not_Define_More_deployments (English) :=
        To_Unbounded_String ("Can not define more deployments");

      ----------------------------------------------------
      --    I/O Errors and messages
      ----------------------------------------------------

      Lb_Open_File (English)         := To_Unbounded_String ("Open file");
      Lb_Save_File (English)         := To_Unbounded_String ("Save file");
      Lb_Not_Saved_File (English)    :=
        To_Unbounded_String ("Warning : the file is not saved");
      Lb_Can_Not_Open_File (English) :=
        To_Unbounded_String ("Can not open file");
      Lb_Can_Not_Read_File (English) :=
        To_Unbounded_String ("Can not read file");
      Lb_Can_Not_Save_File (English) :=
        To_Unbounded_String ("Can not save file");
      Lb_File_Name (English)         := To_Unbounded_String ("File name");

      Lb_Open_Project (English)         :=
        To_Unbounded_String ("Open project");
      Lb_Save_Project (English)         :=
        To_Unbounded_String ("Save project");
      Lb_Not_Saved_Project (English)    :=
        To_Unbounded_String ("Warning : the project is not saved");
      Lb_Can_Not_Open_Project (English) :=
        To_Unbounded_String ("Can not open project files");
      Lb_Can_Not_Save_Project (English) :=
        To_Unbounded_String ("Can not save project files");

      Lb_Select_File (English) := To_Unbounded_String ("File selection");

lb_entity_referenced_elsewhere (English)  :=
        To_Unbounded_String(" Cannot proceed : entity referenced elsewhere ");



      ----------------------------------------------------
      --   Widget text fields
      ----------------------------------------------------

      Lb_Select_Line_Before (English) :=
        To_Unbounded_String ("Select a Lign Before ");

      --
      --  deployments widgets
      --

      Lb_deployment(English) :=
        To_Unbounded_String ("deployment ");
      Lb_deployment_name(English) :=
        To_Unbounded_String ("deployment name ");
      Lb_can_not_be_empty(English) :=
        To_Unbounded_String ("can not be empty");
      Lb_sink_set(English) :=
        To_Unbounded_String ("Resource set ");
      Lb_source_set(English) :=
        To_Unbounded_String ("Consumer set ");


      --
      --  Event analyzer widgets
      --

      Lb_Event_Analyzer_Name (English) :=
        To_Unbounded_String ("Event analyzer name");
      Lb_Event_Analyzer (English)      :=
        To_Unbounded_String ("Event analyzer");
      Lb_Run_Event_Analyzers (English) :=
        To_Unbounded_String ("Run event analyzers");

      --
      --  Processors and core unit widgets
      --

      lb_speed (English)                  := To_Unbounded_String ("Speed");
      Lb_Parametric_File_Name (English)   :=
        To_Unbounded_String ("User-defined file name");
      Lb_Select_core_unit_First (English) :=
        To_Unbounded_String ("Select a core unit first");
      Lb_Select_Processor_First (English) :=
        To_Unbounded_String ("Select a processor first");
      Lb_File_Name_Control (English)      :=
        To_Unbounded_String
          ("Invalid file name with the selected scheduler");
      Lb_Only_On_Parametric (English)     :=
        To_Unbounded_String ("Only permitted on user-defined scheduler");
      Lb_Read (English)                   := To_Unbounded_String ("Read");
      Lb_Quantum_Control (English)        :=
        To_Unbounded_String ("Invalid quantum with selected scheduler");
      lb_core_unit (English)              :=
        To_Unbounded_String ("Core Unit ");
      lb_core_unit_id (English)              :=
        To_Unbounded_String ("Core Unit id");
      lb_core_unit_name (English)         :=
        To_Unbounded_String ("Core unit name");
      Lb_Processor (English)              :=
        To_Unbounded_String ("Processor ");
      Lb_Processor_Name (English)         :=
        To_Unbounded_String ("Processor name");
      Lb_Processor_id (English)         :=
        To_Unbounded_String ("Processor id");
      Lb_Scheduler (English)              :=
        To_Unbounded_String ("Scheduler");
      Lb_Option (English)                 := To_Unbounded_String ("Option");
      Lb_Preemptive (English)             :=
        To_Unbounded_String ("Preemptive");
      Lb_Not_Preemptive (English)         :=
        To_Unbounded_String ("Not preemptive");
      Lb_Invalid_Identifier (English)     :=
        To_Unbounded_String ("Invalid identifier");
      lb_automaton (English)              :=
        To_Unbounded_String ("Automaton");
      Lb_core_units_name_Mandatory (English) :=
        To_Unbounded_String ("Core Units Name is Mandatory");
      Lb_address_space_name_Mandatory (English) :=
        To_Unbounded_String ("Address Space Name is Mandatory");
      Lb_network_name_Mandatory (English) :=
        To_Unbounded_String ("Network Name is Mandatory");
      Lb_buffer_name_Mandatory (English) :=
        To_Unbounded_String ("Buffer Name is Mandatory");
      Lb_task_name_Mandatory (English) :=
        To_Unbounded_String ("Task Name is Mandatory");
      Lb_Policy_Mandatory (English) :=
        To_Unbounded_String ("Policy Type is Mandatory");
      Lb_task_type_Mandatory (English) :=
        To_Unbounded_String ("Task type is Mandatory");
      lb_create_only_one_core_unit  (English) :=
        To_Unbounded_String ("With only one core unit, select monocore and no migration");
      Lb_processor_name_Mandatory (English) :=
        To_Unbounded_String ("Processor Name is Mandatory");
      Lb_scheduler_type_Mandatory (English):=
        To_Unbounded_String ("Scheduler Type is Mandatory");
      Lb_network_type_Mandatory (English):=
        To_Unbounded_String ("Network Type is Mandatory");
      Lb_preemptive_type_Mandatory (English):=
        To_Unbounded_String ("Pre-emptive Type is Mandatory");
      Lb_processor_type_Mandatory (English):=
        To_Unbounded_String ("Processor Type is Mandatory");
      Lb_migration_type_Mandatory (English):=
        To_Unbounded_String ("Migration Type is Mandatory");
      lb_Migration_Type_Not_Allow_With_Several_Cores (English):=
        To_Unbounded_String ("Migration Type not allowed with several cores");
      lb_Processor_Type_Not_Allow_With_Several_Cores (English):=
        To_Unbounded_String ("Processor Type not allowed with several cores");
      Lb_priority_Mandatory (English):=
        To_Unbounded_String ("Priority is Mandatory");
      Lb_core_with_same_scheduler (English)  :=
        To_Unbounded_String("All cores of a processor must have the same scheduler.");
      Lb_multicore_with_hierarchical_not_allowed(English)  :=
        To_Unbounded_String("Multicore processors not allowed with hierarchical scheduling.");

      --
      -- Cache Block
      --
      Lb_Cache_Block_Id (English) 			:=
        To_Unbounded_String("Cache Block Id");
      Lb_Cache_Block (English) 				:=
        To_Unbounded_String("Cache Block");
      Lb_Cache_Block_Name (English) 			:=
        To_Unbounded_String("Cache Block name");
      Lb_Can_Not_Define_More_Cache_Blocks (English) 	:=
        To_Unbounded_String("Cannot define more Cache Block");

      --
      -- Cache
      --
      Lb_Cache_Id (English)			:=
        To_Unbounded_String ("Cache Id");
      Lb_Cache (English)			:=
        To_Unbounded_String ("Cache");
      Lb_Cache_Name (English)			:=
        To_Unbounded_String ("Cache name");
      Lb_Cache_Size (English)			:=
        To_Unbounded_String ("Cache size");
      Lb_Number_Of_Block (English)		:=
        To_Unbounded_String ("Number of block");
      Lb_Line_Size (English)			:=
        To_Unbounded_String ("Line size");
      Lb_Associativity (English)	 	:=
        To_Unbounded_String ("Associativity");
      Lb_Hit_Time (English)			:=
        To_Unbounded_String ("Hit time");
      Lb_Miss_Time (English)			:=
        To_Unbounded_String ("Miss time");
      Lb_Miss_Rate (English)			:=
        To_Unbounded_String ("Miss rate");
      Lb_Can_Not_Define_More_Caches (English) 	:=
        To_Unbounded_String ("Cannot define more caches");


      --
      -- Cache_Access_Profile
      --
      Lb_Cache_Access_Profile_Id (English)	:=
        To_Unbounded_String ("Cache Access Profile Id");
      Lb_Cache_Access_Profile (English)	:=
        To_Unbounded_String ("Cache Access Profile");
      Lb_Cache_Access_Profile_Name (English)	:=
        To_Unbounded_String ("Cache Access Profile name");
      Lb_UCBs (English)				:=
        To_Unbounded_String ("UCBs");
      Lb_UCBs_Nb_Entries (English)		:=
        To_Unbounded_String ("Number of UCBs");
      Lb_ECBs (English)				:=
        To_Unbounded_String ("ECBs");
      Lb_ECBs_Nb_Entries (English)		:=
        To_Unbounded_String ("Number of ECBs");
      Lb_Can_Not_Define_More_Cache_Access_Profiles (English)	:=
        To_Unbounded_String ("Cannot define more Cache Access Profile");
      Lb_Cache_Access_Profile_Not_Found	(English)		:=
        To_Unbounded_String("Cache Access Profile not found");
      Lb_Compute_Cache_Access_Profile (English)			:=
        To_Unbounded_String("Compute Cache Access Profile");
      Lb_Compute_Cache_Access_Profile_Method (English)		:=
        To_Unbounded_String("with UCB and ECB analysis");
      Lb_Cache_Access_Profile_Must_Be_Defined (English) :=
        To_Unbounded_String("ERROR: Cache Access Profiles of all tasks must be defined/computed before performing scheduling simulation with CRPD");
      --
      --  Address space widgets
      --

      Lb_Address_Space_Name (English)         :=
        To_Unbounded_String ("Address space name");
      Lb_Address_Space_Name (English)         :=
        To_Unbounded_String ("Address space id");
      Lb_Address_Space (English)              :=
        To_Unbounded_String ("Address space");
      Lb_Invalid_Scheduler (English)          :=
        To_Unbounded_String ("Invalid scheduler");
      Lb_Select_Address_Space_First (English) :=
        To_Unbounded_String ("Select an address space first");
      Lb_Text_Memory_Size (English)           :=
        To_Unbounded_String ("Text memory size");
      Lb_Heap_Memory_Size (English)           :=
        To_Unbounded_String ("Heap memory size");
      Lb_Data_Memory_Size (English)           :=
        To_Unbounded_String ("Data memory size");
      Lb_Stack_Memory_Size (English)          :=
        To_Unbounded_String ("Stack memory size");
      Lb_Text (English)                       := To_Unbounded_String ("Text");
      Lb_Heap (English)                       := To_Unbounded_String ("Heap");
      Lb_Data (English)                       := To_Unbounded_String ("Data");
      Lb_Stack (English)                      :=
        To_Unbounded_String ("Stack");
      Lb_require_same_Scheduler_on_all_address_space(english) := to_unbounded_string(
                                                                                     "Require the same scheduler on all address space");


      --
      -- Labels related to sections
      --
      Lb_Task_Name (English) := To_Unbounded_String ("Section name");
      Lb_Task (English)      := To_Unbounded_String ("Section");

      --
      --  Tasks widgets
      --

      Lb_Task_Name (English)                        :=
        To_Unbounded_String ("Task name");
      Lb_Task_Group_Name (English)                  :=
        To_Unbounded_String ("Task group name");
      Lb_Task_id (English)                          :=
        To_Unbounded_String ("Task id");
      Lb_Task_Group_id (English)                    :=
        To_Unbounded_String ("Task group id");
      Lb_Task (English)                             :=
        To_Unbounded_String ("Task");
      Lb_Task_Group (English)                       :=
        To_Unbounded_String ("Task Group");
      Lb_Task_Type (English)                        :=
        To_Unbounded_String ("Task type");
      Lb_Capacity (English)                         :=
        To_Unbounded_String ("Capacity");
      Lb_Criticality (English)                      :=
        To_Unbounded_String ("Criticality");
      Lb_Deadline (English)                         :=
        To_Unbounded_String ("Deadline");
      Lb_Period (English)                           :=
        To_Unbounded_String ("Period");
      Lb_Jitter (English)                           :=
        To_Unbounded_String ("Jitter");
      Lb_Priority (English)                         :=
        To_Unbounded_String ("Priority");
      Lb_Policy (English)                           :=
        To_Unbounded_String ("Policy");
      Lb_Policy_Control (English)                   :=
        To_Unbounded_String
          ("Invalid policy with the selected priority level");
      Lb_Start_Time (English)                       :=
        To_Unbounded_String ("Start time");
      Lb_Offset_Val (English)                       :=
        To_Unbounded_String ("Offset val.");
      Lb_Offset_Act (English)                       :=
        To_Unbounded_String ("Offset act.");
      Lb_Offsets (English)                          :=
        To_Unbounded_String ("Offsets");
      Lb_Activations (English)                      :=
        To_Unbounded_String ("Activations");
      Lb_Activation (English)                       :=
        To_Unbounded_String ("Activation");
      Lb_Values (English)                           :=
        To_Unbounded_String ("Values");
      Lb_Value (English)                            :=
        To_Unbounded_String ("Value");
      Lb_User_Defined_Parameter (English)           :=
        To_Unbounded_String ("User's defined parameters");
      Lb_Rule_For_Parametric_Only (English)         :=
        To_Unbounded_String ("Activation rule only with user-defined task");
      Lb_Main (English)                             :=
        To_Unbounded_String ("Main page");
      Lb_Can_Not_Modify (English)                   :=
        To_Unbounded_String ("Can not be modified");
      Lb_No_Period (English)                        :=
        To_Unbounded_String ("does not have period");
      Lb_Require_Period (English)                   :=
        To_Unbounded_String ("requires period");
      Lb_Require_Activation_Rule (English)          :=
        To_Unbounded_String ("requires activation rule");
      Lb_Have_To_Be_On_The_Same_Processor (English) :=
        To_Unbounded_String ("have to be on the same processor");
      Lb_Select_Task_First (English)                :=
        To_Unbounded_String ("Select a task first");
      Lb_Seed (English)                             :=
        To_Unbounded_String ("Seed");
      Lb_Predictable (English)                      :=
        To_Unbounded_String ("Predictable");
      Lb_Unpredictable (English)                    :=
        To_Unbounded_String ("Unpredictable");
      Lb_Task_Not_Permitted (English)               :=
        To_Unbounded_String
          ("Operation not permitted with the selected task");
      Lb_Activation_Rule (English)                  :=
        To_Unbounded_String ("Activation rule");
      lb_context_switch_overhead (English)          :=
        To_Unbounded_String ("Context switch overhead");
      lb_Every(English)          :=
        To_Unbounded_String ("Every");

      --
      --  Messages widgets
      --

      Lb_Response_Time_Message (English)      :=
        To_Unbounded_String ("Response time");
      Lb_Communication_Time_Message (English) :=
        To_Unbounded_String ("Communication time");
      Lb_Message_id (English)               :=
        To_Unbounded_String ("Message id");
      Lb_Message_Type (English)               :=
        To_Unbounded_String ("Message type");
      Lb_Message (English)                    :=
        To_Unbounded_String ("Message");
      Lb_Message_Name (English)               :=
        To_Unbounded_String ("Message name");

      --
      --  Buffers widgets
      --

      Lb_Buffer (English)              := To_Unbounded_String ("Buffer");
      Lb_Buffer_Name (English)         := To_Unbounded_String ("Buffer name");
      Lb_Buffer_id(English)         := To_Unbounded_String ("Buffer id");
      Lb_Size (English)                := To_Unbounded_String ("Size");
      Lb_Time (English)                := To_Unbounded_String ("Time");
      Lb_Timeout (English)                := To_Unbounded_String ("Timeout");
      Lb_Select_Buffer_First (English) :=
        To_Unbounded_String ("Select a buffer first");
      Lb_Utilization_Level (English)   :=
        To_Unbounded_String ("Utilization factor");
      Lb_Bound_Buffer (English)        :=
        To_Unbounded_String ("Bound on buffers");
      Lb_Role_Type (English)           := To_Unbounded_String ("Type");
      Lb_Role (English)                := To_Unbounded_String ("Role");
      Lb_Role_Consumer (English)       := To_Unbounded_String ("Consumer");
      Lb_Role_Producer (English)       := To_Unbounded_String ("Producer");
      Lb_Buffer_Information (English)  :=
        To_Unbounded_String ("Buffer information ");
      Lb_Buffer_List (English)         :=
        To_Unbounded_String ("Buffer list ");
      Lb_Role_List (English)           :=
        To_Unbounded_String ("Tasks using the buffer ");
      Lb_Queueing_System (English)     :=
        To_Unbounded_String ("Queueing system ");
      Lb_duplicated_buffer_role(English)     :=
        To_Unbounded_String (" Duplicated buffer role ");

      --
      --  Resources widgets
      --

      Lb_Resource_id(English)                           :=
        To_Unbounded_String ("Resource id");
      Lb_Resource_Name (English)                           :=
        To_Unbounded_String ("Resource name");
      Lb_Resource (English)                                :=
        To_Unbounded_String ("Resource");
      Lb_Select_Resource_First (English)                   :=
        To_Unbounded_String ("Select a resource first");
      Lb_Update_Resource_Control (English)                 :=
        To_Unbounded_String ("Invalid selected task");
      Lb_Resource_Filter (English)                         :=
        To_Unbounded_String ("Select a Resource");
      Lb_Cpu_Filter (English)                              :=
        To_Unbounded_String ("Select a processor");
      lb_address (English)                                 :=
        To_Unbounded_String ("Address");
      Lb_State (English)                                   :=
        To_Unbounded_String ("State");
      Lb_Protocol (English)                                :=
        To_Unbounded_String ("Protocol");
      Lb_Modify (English)                                  :=
        To_Unbounded_String ("Modify");
      Lb_Used_Protocol (English)                           :=
        To_Unbounded_String ("Used Protocol : ");
      Lb_Resource_State (English)                          :=
        To_Unbounded_String ("Resource State (Integer) : ");
      Lb_Task_Begin (English)                              :=
        To_Unbounded_String ("Begin");
      Lb_Task_End (English)                                :=
        To_Unbounded_String ("End");
      Lb_Resources (English)                               :=
        To_Unbounded_String ("Resources");
      Lb_Resource_Affect (English)                         :=
        To_Unbounded_String ("Resource shared by tasks ");
      Lb_Resource_Information (English)                    :=
        To_Unbounded_String ("Resource information ");
      Lb_Invalid_Protocol (English)                        :=
        To_Unbounded_String (" Invalid shared resource protocol ");
      Lb_can_not_add_more_task_for_this_resource (English) :=
        To_Unbounded_String (" Can not add more task for this resource ");
      Lb_duplicated_critical_section(English) :=
        To_Unbounded_String (" Duplicated critical section ");
      --
      -- Networks Widgets
      --

      Lb_Select_network_First (English)       :=
        To_Unbounded_String ("Select a network first");
      Lb_Only_On_Parametric_Network (English) :=
        To_Unbounded_String ("Only on parametric network");
      Lb_Network (English)                    :=
        To_Unbounded_String ("Network");
      Lb_Network_Name (English)              :=
        To_Unbounded_String ("Network name");
      Lb_Network_Type (English)              :=
        To_Unbounded_String ("Network type");
      Lb_Networks_List (English)              :=
        To_Unbounded_String ("List networks");
      Lb_View_Networks_Type (English)         := To_Unbounded_String ("Type");
      Lb_Define_Networks_Before (English)     :=
        To_Unbounded_String ("Define a network before");
      Lb_Delete_Network (English)             :=
        To_Unbounded_String ("Delete a network");
      Lb_Network_Not_Found (English)          :=
        To_Unbounded_String ("Network not found");

      --
      --  Dependency graph widgets
      --

      Lb_New_Buffer_Role (English)   :=
        To_Unbounded_String ("New buffer role");
      Lb_Disp1 (English)             := To_Unbounded_String ("Layout 1");
      Lb_Disp2 (English)             := To_Unbounded_String ("Layout 2");
      Lb_Disp3 (English)             := To_Unbounded_String ("Layout 3");
      Lb_Create (English)            := To_Unbounded_String ("Create");
      Lb_Select (English)            := To_Unbounded_String ("Select");
      Lb_Name (English)              := To_Unbounded_String ("Name");
      Lb_Select_Row_Before (English) :=
        To_Unbounded_String ("Select a row before");
      Lb_Precedencies (English)      := To_Unbounded_String ("Precedencies");
      Lb_dependencies(English)      := To_Unbounded_String ("Dependencies");
      Lb_Arrow (English)             := To_Unbounded_String ("Arrow");
      Lb_New_Item (English)          := To_Unbounded_String ("New item");
      Lb_Graph_View (English)        :=
        To_Unbounded_String ("Precedencies graph");
      Lb_Choose_Item (English)       :=
        To_Unbounded_String ("Choose an item");

      --
      --  Duplicate widget
      --

      Lb_Duplicate (English) := To_Unbounded_String ("Duplicate");
      Lb_Old (English)       := To_Unbounded_String ("Old");
      Lb_Object (English)    := To_Unbounded_String ("Object");

      --
      -- Time line selection widget
      --

      Lb_Select_Time_Line (English)                  :=
        To_Unbounded_String ("Select time lines");
      Lb_Type (English)                              :=
        To_Unbounded_String ("Type");
      Lb_To_Display (English)                        :=
        To_Unbounded_String ("To Display");
      Lb_Can_Not_Display_So_Much_Time_Line (English) :=
        To_Unbounded_String ("Can not display so much time line");
      Lb_Select_At_Least_One_Time_Line (English)     :=
        To_Unbounded_String ("Select at least one time line");

      --
      -- System entity checks
      --
      Lb_are_unconsistent(English)     :=
        To_Unbounded_String (" are unconsistent");


      --
      -- AADL options widget
      --

      Lb_Aadl_Process_Second_Import_Pass (English)            :=
        To_Unbounded_String(
                            "Process the second AADL import pass which binds software components to hardware components"
                           );
      Lb_Aadl_Process_Third_Import_Pass (English)             :=
        To_Unbounded_String(
                            "Process the third AADL import pass which build component relationships (i.e. connections)"
                           );
      Lb_Import_Aadl_Event_To_Precedencies (English)          :=
        To_Unbounded_String ("Transform event port to task precedencies");
      Lb_Import_Aadl_Event_To_Buffers_Messages (English)      :=
        To_Unbounded_String ("Transform event port to buffers and messages");
      Lb_Import_Aadl_Event_Data_To_Precedencies (English)     :=
        To_Unbounded_String
          ("Transform event data port to task precedencies");
      Lb_Import_Aadl_Event_Data_To_Buffers_Messages (English) :=
        To_Unbounded_String
          ("Transform event data port to buffers and messages");
      Lb_Aadl_Debug (English)                                 :=
        To_Unbounded_String ("Activate AADL Debug switch");
      Lb_Import_Aadl_System_Name (English)                    :=
        To_Unbounded_String
          ("Include system/sub-system name in Cheddar's features name");
      Lb_Export_Aadl_Precedencies_To_Event (English)          :=
        To_Unbounded_String
          ("Transform task precedencies to event port connections");
      Lb_Export_Aadl_Precedencies_To_Event_Data (English)     :=
        To_Unbounded_String
          ("Transform task precedencies to event data port connections");
      Lb_Export_Aadl_Precedencies_To_Properties (English)     :=
        To_Unbounded_String
          ("Transform task precedencies to Cheddar's properties");

      --
      -- Others ...
      --

      Lb_Advanced (English) := To_Unbounded_String ("Advanced");
      Lb_Cancel (English)   := To_Unbounded_String ("Cancel");
      Lb_Warning (English)  := To_Unbounded_String ("- Warning : ");
      Lb_See (English)      := To_Unbounded_String ("see ");
      Lb_Equation (English) := To_Unbounded_String ("equation ");
      Lb_Theorem (English)  := To_Unbounded_String ("theorem ");
      Lb_Lemma (English)    := To_Unbounded_String ("lemma ");
      Lb_less_than (English) := To_Unbounded_String ("less than ");
      Lb_greater_than (English) := To_Unbounded_String ("greater than ");
      Lb_less_or_equal_than (English) := To_Unbounded_String ("less or equal than ");
      Lb_greater_or_equal_than (English) := To_Unbounded_String ("greater or equal than ");
      Lb_Divisible (English) := To_Unbounded_String ("divisible by");
      Lb_Close (English)    := To_Unbounded_String ("Close");
      Lb_And (English)      := To_Unbounded_String ("and ");
      Lb_Continue (English) := To_Unbounded_String ("Do you want to continue ?");


      ----------------------------------------------------
      --   Event table services
      ----------------------------------------------------

      Lb_Export_Event_Table (English)                          :=
        To_Unbounded_String ("Export event table");
      Lb_Import_Event_Table (English)                          :=
        To_Unbounded_String ("Import event table");
      Lb_Event_Table_Services (English)                        :=
        To_Unbounded_String ("Event table services");
      Lb_Compute_Scheduling_And_Generate_Event_Table (English) :=
        To_Unbounded_String ("Compute scheduling and generate event table");
      Lb_Run_Analysis_On_Event_Table (English)                 :=
        To_Unbounded_String ("Run analysis on event table");
      Lb_Draw_Time_Line_From_Event_Table (English)             :=
        To_Unbounded_String ("Draw time line from event table");
      Lb_Display_Event_Table (English)                         :=
        To_Unbounded_String ("Display event table");
      Lb_Automatically_Export_Event_Table (English)            :=
        To_Unbounded_String ("Automatically export of event table");
      Lb_Event_Table_File_Name (English)                       :=
        To_Unbounded_String ("Event table file name");

      ----------------------------------------------------
      --   Options
      ----------------------------------------------------

      Lb_Seed_Options (English)      :=
        To_Unbounded_String ("Seed options :");
      Lb_Task_Specific (English)     :=
        To_Unbounded_String ("Task specific seed");
      Lb_All_Predictable (English)   :=
        To_Unbounded_String ("Predictable for all tasks");
      Lb_All_Unpredictable (English) :=
        To_Unbounded_String ("Unpredictable for all tasks");
      Lb_Max_time_line_to_display (English) :=
        To_Unbounded_String ("Max time line to display ");
      Lb_Time_Line_Between_Time_Axis(English) :=
        To_Unbounded_String ("Time Line Between Time Axis");

      ----------------------------------------------------
      --   Data controls
      ----------------------------------------------------

      Lb_Invalid_Priority (English) :=
        To_Unbounded_String ("Invalid priority value");
      Lb_Mandatory (English)        := To_Unbounded_String (" is mandatory");
      Lb_Already_Defined (English)  :=
        To_Unbounded_String (" already defined");
      Lb_Must_Be (English)          := To_Unbounded_String (" must be ");
      Lb_Must_Be_Numeric (English)  :=
        To_Unbounded_String (" must be numeric");
      Lb_Parameter (English)        := To_Unbounded_String ("Parameter ");

      ----------------------------------------------------
      --   Parametric scheduler messages
      ----------------------------------------------------

      --
      -- Parser and parametric simulation error
      --
      Lb_Parametric_File_Error (English)                                 :=
        To_Unbounded_String ("User-defined file error");
      Lb_Type_Error (English)                                            :=
        To_Unbounded_String ("Type error");
      Lb_Statement_Error (English)                                       :=
        To_Unbounded_String ("Statement error");
      Lb_Variable_Error (English)                                        :=
        To_Unbounded_String ("Variable error");
      Lb_Syntax_Error (English)                                          :=
        To_Unbounded_String ("Parsing error");
      Lb_Identifier_Already_Exists (English)                             :=
        To_Unbounded_String ("Undeclared identifier");
      Lb_Variable_Declaration_Have_To_Be_Done_In_Start_Section (English) :=
        To_Unbounded_String
          ("Variable Declaration Have To Be Done In Start Section");
      Lb_Undeclared_Identifier (English)                                 :=
        To_Unbounded_String ("Undeclared Identifier");
      Lb_Identifier (English)                                            :=
        To_Unbounded_String ("Identifier");
      Lb_Integer_Conversion_Error (English)                              :=
        To_Unbounded_String ("Integer conversion error");
      Lb_Double_Conversion_Error (English)                               :=
        To_Unbounded_String ("Double conversion error");
      Lb_Index_Error (English)                                           :=
        To_Unbounded_String ("Table index error");
      Lb_Uncompatible_Type_Error (English)                               :=
        To_Unbounded_String ("Uncompatible types");
      Lb_Can_Not_Edit_To_Parametric_Object (English)                     :=
        To_Unbounded_String
          ("Cannot edit two user-defined objects at the same time");
      Lb_Identifier_Already_Declared (English)                           :=
        To_Unbounded_String ("Identifier Already Declared");
      Lb_Operation_Not_Permitted (English)                               :=
        To_Unbounded_String ("Operation not permitted ");
      Lb_Variable_Size (English)                                         :=
        To_Unbounded_String
          ("Left and Right Variables should have the same array size");

      ----------------------------------------------------
      --   Logic messages/errors (scheduling, buffer
      --           and blocking time)
      ----------------------------------------------------

      --
      -- Shared resources logic
      --

      Lb_Compute_Blocking_Error1 (English) :=
        To_Unbounded_String ("All resources have to use the same protocol.");
      Lb_Compute_Blocking_Error2 (English) :=
        To_Unbounded_String(
                            "- Protocol error : shared resources use protocol which does not work with the selected scheduler."
                           );
      Lb_Compute_Blocking_Error3 (English) :=
        To_Unbounded_String(
                            "Can not compute worst case blocking time with such shared resource protocol.");

      Lb_Deadlock_Detection (English)            :=
        To_Unbounded_String ("Looking for deadlock from simulation ");
      Lb_Priority_Inversion_Detection (English)  :=
        To_Unbounded_String
          ("Looking for priority inversion from simulation ");
      Lb_Simulation_Deadlock (English)           :=
        To_Unbounded_String ("Deadlock from simulation ");
      Lb_Simulation_Priority_Inversion (English) :=
        To_Unbounded_String ("Priority inversion from simulation ");
      Lb_Deadlock_At_Time (English)              :=
        To_Unbounded_String ("- Deadlock at time");

      Lb_No_Deadlock_Found (English)           :=
        To_Unbounded_String ("- No deadlock found in the last simulation.");
      Lb_No_Priority_Inversion_Found (English) :=
        To_Unbounded_String
          ("- No priority inversion found in the last simulation.");

      Lb_Has_Priority_Inversion (English) :=
        To_Unbounded_String ("  has a priority inversion on the resource ");
      Lb_From_The_Time (English)          :=
        To_Unbounded_String (" from the time ");
      Lb_To_The_Time (English)            :=
        To_Unbounded_String (" to the time ");

      Lb_Worst_Case_Blocking_Time (English)          :=
        To_Unbounded_String ("Worst Case blocking time ");
      Lb_Blocking_Time (English)                :=
        To_Unbounded_String ("Blocking time ");
      Lb_Simulation_Blocking_Time (English)     :=
        To_Unbounded_String(
                            "Blocking time from simulation");
      Lb_Blocking_Time_Inject_Success (English) :=
        To_Unbounded_String ("- Task blocking times are updated.");
      Lb_Blocking_Time_Inject_Failed (English)  :=
        To_Unbounded_String ("- Task blocking times are not updated.");
      Lb_Ceiling_Priority(English) :=
        To_Unbounded_String ("Ceiling Priority ");
      Lb_Ceiling_Priority_Inject_Success (English) :=
        To_Unbounded_String ("- Ceiling Priority times are updated.");
      Lb_Ceiling_Priority_Inject_Failed (English)  :=
        To_Unbounded_String ("- Ceiling Priority times are not updated.");


      --
      -- Scheduling logic
      --

      Lb_Pb_Strict_Constraints (English)    :=
        To_Unbounded_String(
                            "- None strict constraints : can not apply the feasibility test on processor utilization factor."
                           );
      Lb_Pb_Sched_Unknown (English)         :=
        To_Unbounded_String(
                            "- Invalid scheduler : can not apply  the feasibility test on processor utilization factor."
                           );
      Lb_feasibility_test_by_name(english) :=
        To_Unbounded_String ("Apply a feasibility test");
      Lb_Select_Almost_One_Feasilibity_Test (English) :=
        To_Unbounded_String ("Select almost one feasibility test");
      Lb_Feasibility_Number1 (English)                :=
        To_Unbounded_String
          ("1) Feasibility test based on the processor utilization factor : ")
;
      Lb_Feasibility_Number2 (English)                :=
        To_Unbounded_String
          ("2) Feasibility test based on worst case response time for periodic tasks : ");
      Lb_Compute_Scheduling (English)                 :=
        To_Unbounded_String ("Compute scheduling");
      Lb_Generate_Events (English)                    :=
        To_Unbounded_String ("Generate events");
      Lb_Para (English)                               :=
        To_Unbounded_String ("with a Parametric scheduler, ");
      Lb_Edf (English)                                :=
        To_Unbounded_String ("with EDF, ");
      Lb_Rm (English)                                 :=
        To_Unbounded_String ("with RM, ");
      Lb_Muf (English)                                :=
        To_Unbounded_String ("with MUF, ");
      Lb_D_Over (English)                             :=
        To_Unbounded_String ("with D-Over, ");

      Lb_Dm (English)                                               :=
        To_Unbounded_String ("with DM, ");
      Lb_Llf (English)                                              :=
        To_Unbounded_String ("with LLF, ");
      Lb_Run_Simulation_On_One_Processor_Only (English)             :=
        To_Unbounded_String ("Schedule all processors");
      Lb_Run_Feasibility_Tests_On_One_Processor_Only (English)      :=
        To_Unbounded_String (" Feasibility on all processors");
      Lb_Worst_Case (English)                                       :=
        To_Unbounded_String ("Worst case");
      Lb_Best_Case (English)                                        :=
        To_Unbounded_String ("Best case");
      Lb_Average_Case (English)                                     :=
        To_Unbounded_String ("Average case");
      Lb_Curve (English)                                            :=
        To_Unbounded_String ("Graph");
      Lb_Simulation_warning (English)                               :=
        To_Unbounded_String ("Simulation warning : ");
      Lb_Simulation_Error (English)                                 :=
        To_Unbounded_String ("Simulation error : ");
      Lb_Priorities_Error1(English)                                 :=
        To_Unbounded_String
          ("Tasks must be periodic : can not set priorities.");
      Lb_Priorities_Error2 (English)                                :=
        To_Unbounded_String
          ("Processor without tasks : can not set priorities.");
      Lb_Priorities_Error_OPA (English)				    :=
        To_Unbounded_String
          ("- Task set is not feasible under any priority orders: can not set priorities according to OPA.");
      Lb_Priorities_Error_OPA_CRPD (English)				    :=
        To_Unbounded_String
          ("- Task set is not feasible under any priority orders with chosen CRPD Interference computation solution.");
      Lb_Set_Priorities_Dm (English)                                :=
        To_Unbounded_String
          ("Set priorities according to Deadline Monotonic");
      Lb_Set_Priorities_Rm (English)                                :=
        To_Unbounded_String ("Set priorities according to Rate Monotonic");
      Lb_Set_Priorities_Audsley_OPA (English)				:=
        To_Unbounded_String ("Set priorities according to Audsley OPA");
       Lb_Set_Priorities_OPA_CRPD_PT (English)				:=
        To_Unbounded_String ("Set priorities according to Audsley OPA with CRPD (OPA_CRPD-PT solution)");
       Lb_Set_Priorities_OPA_CRPD_PT_Simplified (English)		:=
        To_Unbounded_String ("Set priorities according to Audsley OPA with CRPD (OPA_CRPD-PT-Simplified solution)");
       Lb_Set_Priorities_OPA_CRPD_Tree (English)			:=
        To_Unbounded_String ("Set priorities according to Audsley OPA with CRPD (OPA_CRPD-Tree solution)");
      Lb_Set_Priorities (English)                                   :=
        To_Unbounded_String ("Set priorities");
      Lb_Scheduling_Options (English)                               :=
        To_Unbounded_String ("Scheduling options");
      Lb_Schedule_According_To (English)                            :=
        To_Unbounded_String ("Scheduling according to : ");
      Lb_Unit_Of_Times (English)                                    :=
        To_Unbounded_String (" unit of time ");
      Lb_Draw_From (English)                                        :=
        To_Unbounded_String ("Draw from");
      Lb_Draw_To (English)                                          :=
        To_Unbounded_String ("Draw upto");
      Lb_Schedule_To (English)                                      :=
        To_Unbounded_String ("Schedule from 0 to");
      Lb_Schedule_Time_Line_Too_Large (English)                     :=
        To_Unbounded_String (" Can not compute a so large time line ");
      Lb_Draw_Time_Line_Too_Large (English)                         :=
        To_Unbounded_String (" Can not draw more than 1500 unit of times ");
      Lb_Periodic_Situation (English)                               :=
        To_Unbounded_String (" in periodic case");
      Lb_Scheduling (English)                                       :=
        To_Unbounded_String ("Scheduling");
      Lb_Free_Unit_Time (English)                                   :=
        To_Unbounded_String
          (" units of time are unused in the hyperperiod.");
      Lb_Utilization_With_Period (English)                          :=
        To_Unbounded_String
          ("- Processor utilization factor with period is ");
      Lb_Utilization_With_Deadline (English)                        :=
        To_Unbounded_String
          ("- Processor utilization factor with deadline is ");
      Lb_Utilization_Bound1 (English)                               :=
        To_Unbounded_String ("- In the preemptive case, ");
      Lb_Utilization_Bound11 (English)                              :=
        To_Unbounded_String ("- In the non preemptive case, ");
      Lb_Sched_Explanation1 (English)                               :=
        To_Unbounded_String(
                            "the task set is schedulable because the processor utilization factor ");
      Lb_Sched_Explanation12 (English)                              :=
        To_Unbounded_String (" is equal or less than ");
      Lb_Sched_Explanation2 (English)                               :=
        To_Unbounded_String(
                            "the task set is not schedulable because the processor utilization factor ");
      Lb_Sched_Explanation3 (English)                               :=
        To_Unbounded_String(
                            "we can not prove that the task set is schedulable because the processor utilization factor "
                           );
      Lb_Sched_Explanation22 (English)                              :=
        To_Unbounded_String (" is more than ");
      Lb_Sched_Explanation5 (English)                               :=
        To_Unbounded_String
          ("the task set is schedulable because for each task ");
      Lb_Sched_Explanation52 (English)                              :=
        To_Unbounded_String
          ("the utilization factor is equal or less than the bound ");
      Lb_Sched_Explanation6 (English)                               :=
        To_Unbounded_String ("the task set is not schedulable because ");
      Lb_Sched_Explanation62 (English)                              :=
        To_Unbounded_String(
                            "one or many tasks doesn't/don't satisfy the processor utilization factor feasibility test"
                           );
      Lb_Sched_Explanation7 (English)                               :=
        To_Unbounded_String ("  List of tasks not schedulable : ");
      Lb_Sched_Explanation8 (English)                               :=
        To_Unbounded_String
          ("we can not prove that tasks are schedulable because ");
      Lb_Sched_Explanation81 (English)                              :=
        To_Unbounded_String(
                            "one or many tasks doesn't/don't satisfy the processor utilization factor feasibility test"
                           );
      Lb_Sched_Explanation82 (English)                              :=
        To_Unbounded_String ("List of concerned tasks : ");
      Lb_No_Deadline_Missed_In_The_Computed_Scheduling (English)    :=
        To_Unbounded_String(
                            "No deadline missed in the computed scheduling : the task set is schedulable if you computed the scheduling on the feasibility interval."
                           );
Lb_Cannot_Say_If_Deadline_will_be_Missed_In_The_Computed_Scheduling
(English)    :=
        To_Unbounded_String(
                            "One or several tasks did not complete their execution."
                           );

      Lb_No_Deadline_Will_Be_Missed_Task_Are_Schedulable (English)  :=
        To_Unbounded_String
          ("All task deadlines will be met : the task set is schedulable.");
      Lb_Deadline_Will_Be_Missed_Task_Are_Not_Schedulable (English) :=
        To_Unbounded_String(
                            "Some task deadlines will be missed : the task set is not schedulable.");
      Lb_Worst_Case_Task_Response_Time (English)                      :=
        To_Unbounded_String ("Worst Case task response time");
      Lb_Task_Response_Time (English)                               :=
        To_Unbounded_String ("Task response time");
      Lb_Task_Response_Time_From_Simulation (English)               :=
        To_Unbounded_String ("Task response time computed from simulation");
      Lb_Scheduling_Period (English)                                :=
        To_Unbounded_String ("- The hyperperiod is");
      Lb_Number_Of_Preemption (English)                             :=
        To_Unbounded_String ("Number of preemptions");
      Lb_Number_Of_Context_Switch (English)                         :=
        To_Unbounded_String ("Number of context switches");
      Lb_Priorities (English)                                       :=
        To_Unbounded_String ("Updated priorities :");
      Lb_Partition_General_Task (English)                           :=
        To_Unbounded_String ("With General Task");
      Lb_Partition_Best_Fit (English)                               :=
        To_Unbounded_String ("With Best Fit");
      Lb_Partition_Next_Fit (English)                               :=
        To_Unbounded_String ("With Next Fit");
      Lb_Partition_First_Fit (English)                              :=
        To_Unbounded_String ("With First Fit");
      Lb_Partition_Small_Task (English)                             :=
        To_Unbounded_String ("With Small Task");
      Lb_Partition (English)                                        :=
        To_Unbounded_String ("Partition ");
      Lb_Partitioning_Result (English)                              :=
        To_Unbounded_String ("Task assignement after partitioning ");
      Lb_Partition_Error1 (English)                                 :=
        To_Unbounded_String(
                            "Can not do partitioning : all processors must have the same scheduler.");
      Lb_Partition_Error2 (English)                                 :=
        To_Unbounded_String
          ("Can not do partitioning : you must define more processors.");
      Lb_Partition_Error3 (English)                                 :=
        To_Unbounded_String
          ("Can not do partitioning : invalid scheduler.");
      Lb_Partition_Error4 (English)                                 :=
        To_Unbounded_String
          ("Can not do partitioning : tasks must be periodic.");

      Lb_Compute_Scheduling_Error_1 (English)                     :=
        To_Unbounded_String(
                            "Task model error : can not apply the selected scheduler with this task set."
                           );
      Lb_Compute_Scheduling_Error_2 (English)                     :=
        To_Unbounded_String(
                            "Tasks must be periodic : can not compute hyperperiod with this task set. ");
      Lb_Compute_Scheduling_Error_3 (English)                     :=
        To_Unbounded_String(
                            "Task model error : can not compute hyperperiod with this task set. ");
      Lb_Compute_Scheduling_Error_4 (English)                     :=
        To_Unbounded_String(
                            "Tasks must have period equal to deadline : can not compute worst case response time with this task set. "
                           );
      Lb_Compute_Scheduling_Error_5 (English)                     :=
        To_Unbounded_String(
                            "Tasks must be periodic : can not compute worst case response time with this task set."
                           );
      Lb_Compute_Scheduling_Error_6 (English)                     :=
        To_Unbounded_String(
                            "Task model error : can not compute worst case response time with this task set."
                           );
      Lb_Compute_Scheduling_Error_7 (English)                     :=
        To_Unbounded_String(
                            "Processor utilization exceeded : can not compute worst case response time with this task set. "
                           );
      Lb_Compute_Scheduling_Error_8 (English)                     :=
        To_Unbounded_String(
                            "Internal Error : can not compute worst case response time with this task set."
                           );
      Lb_Compute_Scheduling_Error_9 (English)                     :=
        To_Unbounded_String(
                            "Tasks must be periodic : can not compute bound on processor utilization factor with period on this task set. "
                           );
      Lb_Compute_Scheduling_Error_10 (English)                    :=
        To_Unbounded_String(
                            "Task model error : can not compute processor utilization factor with period. "
                           );
      Lb_Compute_Scheduling_Error_11 (English)                    :=
        To_Unbounded_String(
                            "- Several tasks have same priority level : can not apply the selected scheduler with this task set."
                           );
      Lb_Compute_Scheduling_Error_12 (English)                    :=
        To_Unbounded_String(
                            "Task with non zero start time : can not compute worst case response time with this task set."
                           );
      Lb_Compute_Scheduling_Error_13 (English)                    :=
        To_Unbounded_String(
                            "Task with non zero offset : can not compute worst case response time with this task set."
                           );
      Lb_Compute_Scheduling_Error_14 (English)                    :=
        To_Unbounded_String(
                            "Task must have period equal to deadline : can not apply the selected scheduler with this task set. "
                           );
      Lb_Compute_Scheduling_Error_15 (English)                    :=
        To_Unbounded_String(
                            "Task must be periodic : can not apply the selected scheduler with this task set. "
                           );
      Lb_Compute_Scheduling_Error_18 (English)                    :=
        To_Unbounded_String(
                            "Invalid scheduler : can not compute worst case response time with this scheduler. "
                           );
      Lb_Compute_Scheduling_Error_19 (English)                    :=
        To_Unbounded_String(
                            "Invalid scheduler : can not compute bound on processor utilization factor. "
                           );
      Lb_Compute_Scheduling_Error_21 (English)                    :=
        To_Unbounded_String(
                            "Tasks must have deadline > 0 : can not compute processor utilization factor with deadline on this task set. "
                           );
      Lb_Compute_Scheduling_Error_22 (English)                    :=
        To_Unbounded_String
          ("Can not compute a so large scheduling simulation.");
      Lb_Compute_Scheduling_Error_23 (English)                    :=
        To_Unbounded_String(
                            "Task with non zero start time : can not compute processor utilization factor with this task set."
                           );
      Lb_Compute_Scheduling_Error_24 (English)                    :=
        To_Unbounded_String(
                            "Task with non zero offset : can not compute processor utilization factor test with this task set."
                           );
      Lb_Compute_Scheduling_Error_25 (English)                    :=
        To_Unbounded_String(
                            "Task groups are not transaction : can not compute worst case response time with this task set."
                           );
      Lb_Compute_Scheduling_Error_26 (English)                    :=
        To_Unbounded_String(
                            "Task groups transactions have no task : can not compute worst case response time with this task set."
                           );
      Lb_Check_Deadline (English)                                 :=
        To_Unbounded_String (" missed its deadline (deadline = ");
      Lb_Check_absolute_Deadline (English)                                 :=
        To_Unbounded_String (" missed its deadline (absolute deadline = ");
      Lb_Periodic (English)                                       :=
        To_Unbounded_String ("Periodic task ");
      Lb_Frame (English)                                       :=
        To_Unbounded_String ("Frame ");
      Lb_Aperiodic (English)                                      :=
        To_Unbounded_String ("Aperiodic task ");
      Lb_Poisson_Process_Task (English)                           :=
        To_Unbounded_String ("Poisson process task ");
      Lb_Sporadic_Task (English)                                  :=
        To_Unbounded_String ("Sporadic task ");
      Lb_Parametric_Task (English)                                :=
        To_Unbounded_String ("User-defined task ");
      Lb_Completion_Time (English)                                :=
        To_Unbounded_String (" ; completion time = ");
      lb_task_is_not_over_response_time_is_not_computed (English) :=
        To_Unbounded_String(
                            " response time not computed since the task did not run all its capacity");
      Lb_Computation_time_exceeded(English)                                :=
        To_Unbounded_String ("- Computation exceeded exception : unable to perform analysis with this task set.");

      --
      -- Buffer logic
      --

      Lb_Schedule_Before (English)        :=
        To_Unbounded_String ("Compute a scheduling before");
      Lb_Buffer_Utilization (English)     :=
        To_Unbounded_String ("Buffer utilization factor : ");
      Lb_Compute_Buffer_Error_1 (English) :=
        To_Unbounded_String(
                            "- Data flow constraint not respected : can not compute buffer bound with this task set. "
                           );
      Lb_Compute_Buffer_Error_2 (English) :=
        To_Unbounded_String(
                            "- Tasks must be periodic : can not compute buffer bound with this task set. ")
;
      Lb_Harmonic (English)               := To_Unbounded_String ("Harmonic");
      Lb_Compute_Buffer_Error_3 (English) :=
        To_Unbounded_String(
                            "- Task model error : can not compute bound with several consumers. ");
      Lb_Compute_Buffer_Error_4 (English) :=
        To_Unbounded_String(
                            "- Queueing system error : can not compute performance criterion with such queueing system. "
                           );

      Lb_Maximum_Buffer_Size (English)  :=
        To_Unbounded_String
          ("- Maximum number of messages in the buffer : ");
      Lb_Average_Buffer_Size (English)  :=
        To_Unbounded_String
          ("- Average number of messages in the buffer : ");
      Lb_Maximum_Waiting_Time (English) :=
        To_Unbounded_String ("- Maximum message waiting time : ");
      Lb_Average_Waiting_Time (English) :=
        To_Unbounded_String ("- Average message waiting time : ");

      --
      -- Dependencies logic
      --

      Lb_Chetto (English)          :=
        To_Unbounded_String ("Applying Chetto/Blazewicz rules");
      Lb_Chetto_Deadline (English) :=
        To_Unbounded_String ("Chetto/Blazewicz modifications on deadlines");
      Lb_Chetto_Priority (English) :=
        To_Unbounded_String ("Chetto/Blazewicz modifications on priorities");

      Lb_Jitter_From_Response_Time (English)           :=
        To_Unbounded_String ("End to end worst case response time");
      Lb_Jitter_From_Response_Time_One_Step (English)  :=
        To_Unbounded_String ("Compute one step");
      Lb_Jitter_From_Response_Time_All_Steps (English) :=
        To_Unbounded_String ("Compute all steps");

      Lb_Deadlines_Are_Updated (English)     :=
        To_Unbounded_String ("- Deadlines are updated.");
      Lb_Priorities_Are_Updated (English)    :=
        To_Unbounded_String ("- Priorities are updated.");
      Lb_Jitters_Are_Updated (English)       :=
        To_Unbounded_String ("- Jitters are updated.");
      Lb_Precedencies_Period_Error (English) :=
        To_Unbounded_String(
                            "- Can not schedule with precedencies : task precedencies required that tasks have the same period."
                           );
      Lb_holistique_Error1 (English)             :=
        To_Unbounded_String(
                            "- Tasks must have the same period when related with precedencies : can not apply holistique end to end worst case response time on this task set."
                           );
      Lb_holistique_Error2 (English)             :=
        To_Unbounded_String(
                            "- Tasks must have the same type when related with precedencies : can not apply holistique end to end worst case response time on this task set."
                           );
      Lb_Chetto_Error1 (English)             :=
        To_Unbounded_String(
                            "- Can not apply Chetto/Blazewicz parameter modifications : the dependency graph has to be acyclic."
                           );
      Lb_Chetto_Error2 (English)             :=
        To_Unbounded_String(
                            "- Tasks must have the same period : can not apply Chetto/Blazewicz method on this task set."
                           );
      Lb_Chetto_Error3 (English)             :=
        To_Unbounded_String(
                            "- Tasks model error : can not apply Chetto/Blazewicz method on this task set as tasks of the graph have different types  "
                           );
      Lb_Chetto_Error4 (English)             :=
        To_Unbounded_String(
                            "- Can not apply Chetto/Blazewicz deadline modifications : deadlines of some tasks are too short. "
                           );

      Lb_Select_Precedence_Sink_Before (English) :=
        To_Unbounded_String(
                            "Select Precedence Sink Before "
                           );

      Lb_Select_Precedence_Source_Before (English) :=
        To_Unbounded_String(
                            "Select Precedence Source Before "
                           );

      Lb_Select_buffer_dependency_task_Before (English) :=
        To_Unbounded_String(
                            "Select Buffer Dependency Task Before "
                           );

      Lb_Select_buffer_dependency_object_Before (English) :=
        To_Unbounded_String(
                            "Select Buffer Dependency Object Before "
                           );

      Lb_Select_Buffer_Orientation_Before (English) :=
        To_Unbounded_String(
                            "Select Buffer Orientation Before "
                           );

      Lb_Select_communication_orientation_Before (English) :=
        To_Unbounded_String(
                            "Select Communication Orientation Before "
                           );

      Lb_Select_communication_dependency_object_Before (English) :=
        To_Unbounded_String(
                            "Select Communication Dependency Object Before "
                           );

      Lb_Select_communication_dependency_task_Before (English) :=
        To_Unbounded_String(
                            "Select Communication Dependency Task Before "
                           );

      Lb_Select_time_triggered_communication_sink_Before (English) :=
        To_Unbounded_String(
                            "Select time triggered communication sink Before "
                           );

      Lb_Select_time_triggered_communication_source_Before (English) :=
        To_Unbounded_String(
                            "Select time triggered communication source Before "
                           );

      Lb_Select_timing_property_Before (English) :=
        To_Unbounded_String(
                            "Select timing property Before "
                           );

      Lb_Select_resource_dependency_resource_Before (English) :=
        To_Unbounded_String(
                            "Select resource dependency resource Before "
                           );

      Lb_Select_resource_dependency_task_Before (English) :=
        To_Unbounded_String(
                            "Select resource dependency task Before "
                           );

      Lb_Select_black_board_dependent_task_Before (English) :=
        To_Unbounded_String(
                            "Select black board dependent task Before "
                           );

      Lb_Select_black_board_dependency_object_Before (English) :=
        To_Unbounded_String(
                            "Select black board dependency object Before "
                           );

      Lb_Select_dependency_type_Before (English) :=
        To_Unbounded_String(
                            "Select dependency type Before "
                           );

      Lb_Select_black_board_orientation_Before (English) :=
        To_Unbounded_String(
                            "Select black board orientation Before "
                           );

      Lb_Add_Precedence_Dependency_Before (English) :=
        To_Unbounded_String(
                            "Add Precedence Dependency Before "
                           );

      Lb_Add_Queuing_Buffer_Dependency_Before (English) :=
        To_Unbounded_String(
                            "Add Queuing Buffer Dependency Before "
                           );

      Lb_Add_Communication_Dependency_Before (English) :=
        To_Unbounded_String(
                            "Add Communication Dependency Before "
                           );

      Lb_Add_Time_Triggered_Dependency_Before (English) :=
        To_Unbounded_String(
                            "Add Time Triggered Dependency Before "
                           );

      Lb_Add_Resource_Dependency_Before (English) :=
        To_Unbounded_String(
                            "Add Resource Dependency Before "
                           );

      Lb_Add_Black_Board_Buffer_Dependency_Before (English) :=
        To_Unbounded_String(
                            "Add Black Board Buffer Dependency Before "
                           );
      --
      -- Random tools
      --
      Lb_Random (English)                        :=
        To_Unbounded_String ("Random");
      Lb_Compute_Response_Time_Density (English) :=
        To_Unbounded_String ("Compute response time density");
      Lb_Response_Time_Density (English)         :=
        To_Unbounded_String ("Response time density");
      Lb_Response_Time (English)                 :=
        To_Unbounded_String ("response time");

      --
      -- CFG
      --
      Lb_CFG (English)				:=
        To_Unbounded_String("CFG");
      Lb_CFG_Id (English)			:=
        To_Unbounded_String("CFG Id");
      Lb_CFG_Name (English)			:=
        To_Unbounded_String("CFG Name");
      Lb_Can_Not_Define_More_CFG (English)	:=
        To_Unbounded_String("Cannot defind more CFG");

      --
      -- CFG_Node
      --
      Lb_CFG_Node (English)			:=
        To_Unbounded_String("CFG Node");
      Lb_CFG_Node_Id (English)		:=
        To_Unbounded_String("Basic Block Id");
      Lb_CFG_Node_Name (English)		:=
        To_Unbounded_String("CFG Node Name");
      Lb_Previous_Nodes (English)		:=
        To_Unbounded_String("Previous CFG Nodes");
      Lb_Next_Nodes (English)			:=
        To_Unbounded_String("Next CFG Nodes");
      Lb_Instruction_Offset (English)		:=
        To_Unbounded_String("Instruction Offset");
      Lb_Instruction_Capacity (English)		:=
        To_Unbounded_String("Instruction Capacity");
      Lb_Data_Offset (English)			:=
        To_Unbounded_String("Data Offset");
      Lb_Data_Capacity (English)		:=
        To_Unbounded_String("Data Capacity");
      Lb_CFG_Node_Type (English)		:=
        To_Unbounded_String("CFG Node Type");
      Lb_Can_Not_Define_More_CFG_Node (English)	:=
        To_Unbounded_String("Cannot define more cfg nodes");

      --
      -- CFG_Edge
      --
      Lb_CFG_Edge_Id (English)			:=
        To_Unbounded_String("CFG Edge Id");
      Lb_CFG_Edge (English)			:=
        To_Unbounded_String("CFG Edge");
      Lb_CFG_Edge_Name (English)		:=
        To_Unbounded_String("CFG Edge Name");
      LB_Can_Not_Define_More_CFG_Edge (English)	:=
        To_Unbounded_String("Cannot define more cfg edges");

      --
      -- OPA, OPA_CRPD Requirement
      --
      Lb_Offset_Must_Be_Defined_For_OPA (English) :=
        To_Unbounded_String("Task offsets must be defined before performing Audsley's OPA");
      Lb_Cache_Access_Profile_Must_Be_Defined_For_OPA (English) :=
        To_Unbounded_String("Cache Access Profiles of all tasks must be defined/computed before performing Audsley's OPA");

      --
      -- WCRT+CRPD
      --
      Lb_WCRT_CRPD_Preemptive_Only (English) :=
        To_Unbounded_String("WCRT analysis + CRPD only applied to preemptive scheduler");

	--
	-- Ellidiss
	--
    Lb_Elli_Base_Period (English) := To_Unbounded_String ("base period");
    Lb_Elli_Utilization_Factor (English) := To_Unbounded_String ("processor utilization factor");
    Lb_Elli_Utilization_Factor_Deadline (English) := To_Unbounded_String ("processor utilization factor with deadline");
    Lb_Elli_Utilization_Factor_Period (English) := To_Unbounded_String ("processor utilization factor with period");
    Lb_Elli_Response_Time (English) := To_Unbounded_String ("response time");
    Lb_Elli_Worst_Case_Response_Time (English) := To_Unbounded_String ("worst case task response time");
    Lb_Elli_Unknown_Sched (English) := To_Unbounded_String ("unknown scheduler");
   end Initialize;

end Translate.English_Labels;
