------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 15:09:39 +0200 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with arinc_653_schema;
use arinc_653_schema;
with Multiprocessor_Services; use Multiprocessor_Services;
with Multiprocessor_Services_Interface; use Multiprocessor_Services_Interface;
use Multiprocessor_Services_Interface.Scheduling_Result_Per_Processor_Package;
with systems;
use systems;
with ada.strings.unbounded;
use ada.strings.unbounded;


package arinc_653_Services is


   -- Raised when architecture uses partition scheduler that are not supposed to be used
   -- un ARINC 653 systems 
   --
   Invalid_Scheduler : exception;


 ------------------------------------------------------------------------------------
 -- Check if a Cheddar ADL model is compliant with ARINC 653 services requirements
 ------------------------------------------------------------------------------------

 procedure Check_Arinc_653
     (Sys       : in System);

 ------------------------------------------------------
 -- Produce XML ARINC 653 PST
 ------------------------------------------------------

  function Build_ARINC653_Module
     (Sched     : in Scheduling_Table_Ptr;
      Sys       : in System;
      majorTimeFrame       : in natural)
	 return ARINC_653_Module_Ptr;



end arinc_653_Services;



