----------------------------------------------
----------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 399 $
--    $Date: 2011-04-12 01:21:27 +0200 (mar., 12 avr. 2011) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Framework_Config;      use Framework_Config;
with Systems;               use Systems;

package body cache_system_analysis is

   function compute_resource_cache_position
     (a_resource : in Generic_Resource_Ptr;
      a_cache    : in Generic_Cache_Ptr)
      return       Natural
   is
   begin
      return compute_resource_cache_position (a_resource.all, a_cache.all);
   end compute_resource_cache_position;

   function compute_resource_cache_position
     (a_resource : in Generic_Resource'Class;
      a_cache    : in Generic_Cache'Class)
      return       Natural
   is
   begin
      return (a_resource.address / a_cache.cache_size mod
              a_cache.line_size);
   end compute_resource_cache_position;

end cache_system_analysis;
