------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 503 $
--    $Date: 2012-02-08 01:45:16 +0100 (mer. 08 févr. 2012) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Xml_Tag;                           use Xml_Tag;
with Tasks;                             use Tasks;
with Task_Set;                          use Task_Set;
use Task_Set.Generic_Task_Set;
with Resource_Set;                      use Resource_Set;
use Resource_Set.Generic_Resource_Set;
with Processor_Set;                     use Processor_Set;
use Processor_Set.Generic_Processor_Set;
with Translate;                         use Translate;
with Unbounded_Strings;                 use Unbounded_Strings;
with Framework_Config;                  use Framework_Config;
with Scheduler_Interface;               use Scheduler_Interface;
with Scheduler;                         use Scheduler;
with Scheduler.Fixed_Priority;          use Scheduler.Fixed_Priority;
with Scheduling_Analysis;               use Scheduling_Analysis;
with Scheduling_Analysis.extended;      use Scheduling_Analysis.extended;
use Scheduling_Analysis.Deadlock_Package;
use Scheduling_Analysis.Double_Tasks_Parameters_Package;
use Scheduling_Analysis.Priority_Inversion_List_Package;
with Multiprocessor_Services_Interface; use Multiprocessor_Services_Interface;
use Multiprocessor_Services_Interface.Scheduling_Result_Per_Processor_Package;
with Call_Scheduling_Framework;         use Call_Scheduling_Framework;
with Double_Util;                       use Double_Util;
with Ada.Numerics.Aux;                  use Ada.Numerics.Aux;
with Debug;                             use Debug;
with architecture_analyzer; 		use architecture_analyzer;


package body Call_Design_Pattern_Framework is
   procedure Select_Feasibility_Tests_Simple_System
      (Sys                        : in out System;
      Result                     : in out Unbounded_String;
      Output               : in Output_Format := String_Output) is
	begin
		Result := Result & analyze(sys);
end  Select_Feasibility_Tests_Simple_System;


   procedure Select_Feasibility_Tests_Compositional_System
      (Sys                        : in out System;
      Result                     : in out Unbounded_String;
      Output               : in Output_Format := String_Output) is
	begin
		Result := To_Unbounded_String ("     This Call is not functionnal yet     ");
end Select_Feasibility_Tests_Compositional_System;

end Call_Design_Pattern_Framework;
