------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 484 $
--    $Date: 2011-11-29 00:33:30 +0100 (mar. 29 nov. 2011) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Call_Framework_Interface; use Call_Framework_Interface;
with Systems;                  use Systems;
with Ada.Strings.Unbounded;    use Ada.Strings.Unbounded;
with Processors;               use Processors;
with architecture_analyzer;    use architecture_analyzer;

package Call_Design_Pattern_Framework is

   procedure Select_Feasibility_Tests_Simple_System
     (Sys                        : in out System;
      Result                     : in out Unbounded_String;
      Output               : in Output_Format := String_Output);

   procedure Select_Feasibility_Tests_Compositional_System
     (Sys                        : in out System;
      Result                     : in out Unbounded_String;
      Output               : in Output_Format := String_Output);

end Call_Design_Pattern_Framework;
