
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;



Package Body Address_Spaces is 
 

-- --------= Address_Space =--------

procedure Initialize(obj : in out Address_Space) is 
begin
	initialize(Named_Object(obj));
	obj.cpu_name := empty_string;
	obj.text_memory_size := 0;
	obj.stack_memory_size := 0;
	obj.data_memory_size := 0;
	obj.heap_memory_size := 0;
	obj.object_type := Address_Space_Object_Type;
end Initialize;

function Copy ( obj : in Address_Space ) return Address_Space_Ptr is
	New_Address_Space : Address_Space_Ptr;
begin
	New_Address_Space := new Address_Space'(obj);
	return (New_Address_Space);
end Copy;

function Copy ( obj : in Address_Space_Ptr ) return Address_Space_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Address_Space) is 
begin
	put(Named_Object(obj));
	put("cpu_name: "); put(obj.cpu_name); put ( "; " );
	put("text_memory_size: "); standards_io.natural_io.put(obj.text_memory_size); put ( "; " );
	put("stack_memory_size: "); standards_io.natural_io.put(obj.stack_memory_size); put ( "; " );
	put("data_memory_size: "); standards_io.natural_io.put(obj.data_memory_size); put ( "; " );
	put("heap_memory_size: "); standards_io.natural_io.put(obj.heap_memory_size); put ( "; " );
	put("scheduling: "); put(obj.scheduling); put ( "; " );
end Put;
 
procedure Put(obj : in Address_Space_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Address_Space_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Address_Space) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Address_Space_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Address_Space ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("ADDRESS_SPACES.ADDRESS_SPACE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Address_Space_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Address_Space; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Named_Object(obj), result);
	if (XML_String(obj.cpu_name) /= Empty_String) then
		result := result & to_unbounded_string("<cpu_name>") & XML_String(obj.cpu_name) & to_unbounded_string("</cpu_name>");
	end if;
	if (XML_String(obj.text_memory_size) /= Empty_String) then
		result := result & to_unbounded_string("<text_memory_size>") & XML_String(obj.text_memory_size) & to_unbounded_string("</text_memory_size>");
	end if;
	if (XML_String(obj.stack_memory_size) /= Empty_String) then
		result := result & to_unbounded_string("<stack_memory_size>") & XML_String(obj.stack_memory_size) & to_unbounded_string("</stack_memory_size>");
	end if;
	if (XML_String(obj.data_memory_size) /= Empty_String) then
		result := result & to_unbounded_string("<data_memory_size>") & XML_String(obj.data_memory_size) & to_unbounded_string("</data_memory_size>");
	end if;
	if (XML_String(obj.heap_memory_size) /= Empty_String) then
		result := result & to_unbounded_string("<heap_memory_size>") & XML_String(obj.heap_memory_size) & to_unbounded_string("</heap_memory_size>");
	end if;
	if (XML_String(obj.scheduling) /= Empty_String) then
		result := result & to_unbounded_string("<scheduling>") & XML_String(obj.scheduling) & to_unbounded_string("</scheduling>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Address_Space) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<address_space id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</address_space>");
	return (result);
end XML_String;

function XML_String(obj : in Address_Space_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Address_Space) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<address_space ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Address_Space_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Address_Spaces;
