
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;



Package Body Basic_Blocks is 
 

-- --------= Basic_Block =--------

procedure Initialize(obj : in out Basic_Block) is 
begin
	initialize(CFG_Node(obj));
	obj.instruction_offset := 0;
	obj.instruction_capacity := 0;
	obj.data_offset := 0;
	obj.data_capacity := 0;
	obj.loop_bound := 0;
	obj.graph_type := CFG_Basic_Block;
end Initialize;

function Copy ( obj : in Basic_Block ) return Basic_Block_Ptr is
	New_Basic_Block : Basic_Block_Ptr;
begin
	New_Basic_Block := new Basic_Block'(obj);
	return (New_Basic_Block);
end Copy;

function Copy ( obj : in Basic_Block_Ptr ) return Basic_Block_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Basic_Block) is 
begin
	put(CFG_Node(obj));
	put("instruction_offset: "); standards_io.natural_io.put(obj.instruction_offset); put ( "; " );
	put("instruction_capacity: "); standards_io.natural_io.put(obj.instruction_capacity); put ( "; " );
	put("data_offset: "); standards_io.natural_io.put(obj.data_offset); put ( "; " );
	put("data_capacity: "); standards_io.natural_io.put(obj.data_capacity); put ( "; " );
	put("loop_bound: "); standards_io.natural_io.put(obj.loop_bound); put ( "; " );
end Put;
 
procedure Put(obj : in Basic_Block_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Basic_Block_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Basic_Block) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Basic_Block_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Basic_Block ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("CFG_NODES.CFG_NODE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("BASIC_BLOCKS.BASIC_BLOCK");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Basic_Block_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Basic_Block; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(CFG_Node(obj), result);
	if (XML_String(obj.instruction_offset) /= Empty_String) then
		result := result & to_unbounded_string("<instruction_offset>") & XML_String(obj.instruction_offset) & to_unbounded_string("</instruction_offset>");
	end if;
	if (XML_String(obj.instruction_capacity) /= Empty_String) then
		result := result & to_unbounded_string("<instruction_capacity>") & XML_String(obj.instruction_capacity) & to_unbounded_string("</instruction_capacity>");
	end if;
	if (XML_String(obj.data_offset) /= Empty_String) then
		result := result & to_unbounded_string("<data_offset>") & XML_String(obj.data_offset) & to_unbounded_string("</data_offset>");
	end if;
	if (XML_String(obj.data_capacity) /= Empty_String) then
		result := result & to_unbounded_string("<data_capacity>") & XML_String(obj.data_capacity) & to_unbounded_string("</data_capacity>");
	end if;
	if (XML_String(obj.loop_bound) /= Empty_String) then
		result := result & to_unbounded_string("<loop_bound>") & XML_String(obj.loop_bound) & to_unbounded_string("</loop_bound>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Basic_Block) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<basic_block id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</basic_block>");
	return (result);
end XML_String;

function XML_String(obj : in Basic_Block_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Basic_Block) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<basic_block ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Basic_Block_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Basic_Blocks;
