
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

with id_generators;
use id_generators;

with Objects;
use Objects;

with CFG_Nodes;
use CFG_Nodes;

with standards_io;
use standards_io;

use standards_io.natural_io;

with Ada.Finalization;

with unbounded_strings;
use unbounded_strings;

use unbounded_strings.Unbounded_String_List_Package;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with Tables;



Package Basic_Blocks is 
 
type Basic_Block; type Basic_Block_Ptr is access all Basic_Block'Class;



-- --------= Basic_Block =--------

type Basic_Block is new CFG_Node with 
record
 instruction_offset : Natural;
 instruction_capacity : Natural;
 data_offset : Natural;
 data_capacity : Natural;
 loop_bound : Natural;
end record;

procedure Initialize(obj : in out Basic_Block);
procedure Put(obj : in Basic_Block);
procedure Put(obj : in Basic_Block_Ptr);
procedure Put_Name(obj : in Basic_Block_Ptr);
procedure Build_Attributes_XML_String(obj : in Basic_Block; result : in out Unbounded_String);
function XML_String(obj : in Basic_Block) return Unbounded_String;
function XML_String(obj : in Basic_Block_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Basic_Block) return Unbounded_String;
function XML_Ref_String(obj : in Basic_Block_Ptr) return Unbounded_String;
function Get_Name (obj : in Basic_Block) return Unbounded_String;
function Get_Name (obj : in Basic_Block_Ptr) return Unbounded_String;
function Copy(obj : in Basic_Block_Ptr) return Basic_Block_Ptr;
function Copy(obj : in Basic_Block) return Basic_Block_Ptr;
function type_of(obj : in Basic_Block) return unbounded_string_list;
function type_of(obj : in Basic_Block_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Basic_Block'Class, Basic_Block_Ptr);

package Basic_Blocks_Table_Package is new Tables(Basic_Block_Ptr, Framework_Config.Max_CFG_Nodes, Put, XML_String, XML_Ref_String);
use Basic_Blocks_Table_Package;
subtype Basic_Blocks_Range is Basic_Blocks_Table_Package.table_range;
subtype Basic_Blocks_Range_Ptr is  Basic_Blocks_Table_Package.table_range_Ptr;
subtype Basic_Blocks_Table is Basic_Blocks_Table_Package.table;
subtype Basic_Blocks_Table_Ptr is  Basic_Blocks_Table_Package.table_Ptr;


End Basic_Blocks;
