----------------------------------------------------------
----------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 15:09:39 +0200 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Task_Set;         use Task_Set;
use Task_Set.Generic_Task_Set;
with Ada.Numerics.Aux; use Ada.Numerics.Aux;

package Buffers.Extended is

   function Is_Cons_Prod_Harmonic
     (My_Buff  : in Buffer_Ptr;
      My_Tasks : in Tasks_Set)
      return     Boolean;

   Flow_Constraint_Not_Respected : exception;
   Task_Model_Error : exception;

   procedure Buffer_Flow_Control
     (My_Buff   : in Buffer_Ptr;
      My_Tasks  : in Tasks_Set;
      Flow_Cons : in out Double;
      Flow_Prod : in out Double);

end Buffers.Extended;
