
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with Queueing_Systems;

use Queueing_Systems.Queueing_Systems_Type_io;



Package Body Buffers is 
 
function XML_String(obj : in Buffer_Role_Type) return Unbounded_String is
begin
	return to_unbounded_string(Buffer_Role_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Buffer_Role_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;



-- --------= Buffer_Role =--------

procedure Initialize(obj : out Buffer_Role) is 
begin
	obj.the_role := Queuing_Producer;
	obj.size := 0;
	obj.time := 0;
	obj.timeout := 0;
end Initialize;

procedure Put(obj : in Buffer_Role) is 
begin
	put("the_role: "); put(obj.the_role); put ( "; " );
	put("size: "); standards_io.natural_io.put(obj.size); put ( "; " );
	put("time: "); standards_io.natural_io.put(obj.time); put ( "; " );
	put("timeout: "); standards_io.natural_io.put(obj.timeout); put ( "; " );
end Put;
 
procedure Put(obj : in Buffer_Role_Ptr) is
begin
	Put(Obj.All);
end Put;


procedure Build_Attributes_XML_String(obj : in Buffer_Role; result : in out Unbounded_String) is 
begin
	if (XML_String(obj.the_role) /= Empty_String) then
		result := result & to_unbounded_string("<the_role>") & XML_String(obj.the_role) & to_unbounded_string("</the_role>");
	end if;
	if (XML_String(obj.size) /= Empty_String) then
		result := result & to_unbounded_string("<size>") & XML_String(obj.size) & to_unbounded_string("</size>");
	end if;
	if (XML_String(obj.time) /= Empty_String) then
		result := result & to_unbounded_string("<time>") & XML_String(obj.time) & to_unbounded_string("</time>");
	end if;
	if (XML_String(obj.timeout) /= Empty_String) then
		result := result & to_unbounded_string("<timeout>") & XML_String(obj.timeout) & to_unbounded_string("</timeout>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Buffer_Role) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<buffer_role>");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</buffer_role>");
	return (result);
end XML_String;

function XML_String(obj : in Buffer_Role_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Buffer_Role) return Unbounded_String is
	result : Unbounded_String;
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;

function Copy ( obj : in Buffer_Role ) return Buffer_Role_Ptr is
	New_Buffer_Role : Buffer_Role_Ptr;
begin
	New_Buffer_Role := new Buffer_Role'(obj);
	return (New_Buffer_Role);
end Copy;

function Copy ( obj : in Buffer_Role_Ptr ) return Buffer_Role_Ptr is
begin
	return copy(obj.all);
end Copy;



-- --------= Buffer =--------

procedure Initialize(obj : in out Buffer) is 
begin
	initialize(Named_Object(obj));
	obj.cpu_name := empty_string;
	obj.address_space_name := empty_string;
	obj.queueing_system_type := Qs_Mm1;
	obj.buffer_size := 0;
	obj.object_type := Buffer_Object_Type;
end Initialize;

function Copy ( obj : in Buffer ) return Buffer_Ptr is
	New_Buffer : Buffer_Ptr;
begin
	New_Buffer := new Buffer'(obj);
	return (New_Buffer);
end Copy;

function Copy ( obj : in Buffer_Ptr ) return Buffer_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Buffer) is 
begin
	put(Named_Object(obj));
	put("cpu_name: "); put(obj.cpu_name); put ( "; " );
	put("address_space_name: "); put(obj.address_space_name); put ( "; " );
	put("queueing_system_type: "); put(obj.queueing_system_type); put ( "; " );
	put("buffer_size: "); standards_io.natural_io.put(obj.buffer_size); put ( "; " );
	put("roles: "); put(obj.roles); put ( "; " );
end Put;
 
procedure Put(obj : in Buffer_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Buffer_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Buffer) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Buffer_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Buffer ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("BUFFERS.BUFFER");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Buffer_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Buffer; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Named_Object(obj), result);
	if (XML_String(obj.cpu_name) /= Empty_String) then
		result := result & to_unbounded_string("<cpu_name>") & XML_String(obj.cpu_name) & to_unbounded_string("</cpu_name>");
	end if;
	if (XML_String(obj.address_space_name) /= Empty_String) then
		result := result & to_unbounded_string("<address_space_name>") & XML_String(obj.address_space_name) & to_unbounded_string("</address_space_name>");
	end if;
	if (XML_String(obj.queueing_system_type) /= Empty_String) then
		result := result & to_unbounded_string("<queueing_system_type>") & XML_String(obj.queueing_system_type) & to_unbounded_string("</queueing_system_type>");
	end if;
	if (XML_String(obj.buffer_size) /= Empty_String) then
		result := result & to_unbounded_string("<buffer_size>") & XML_String(obj.buffer_size) & to_unbounded_string("</buffer_size>");
	end if;
	if (XML_String(obj.roles) /= Empty_String) then
		result := result & to_unbounded_string("<roles>") & XML_String(obj.roles) & to_unbounded_string("</roles>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Buffer) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<buffer id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</buffer>");
	return (result);
end XML_String;

function XML_String(obj : in Buffer_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Buffer) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<buffer ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Buffer_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Buffers;
