with CFG_Nodes;			use CFG_Nodes;
with Basic_Blocks;		use Basic_Blocks;
with Integer_Arrays;		use Integer_Arrays;
with Scheduling_Analysis; 	use Scheduling_Analysis;
with Scheduling_Analysis;     	use Scheduling_Analysis.Relative_Priority_Records_Table_Package;
with Scheduling_Analysis;     	use Scheduling_Analysis.Task_Release_Records_Table_Package;

package CFG_Nodes.Extended is

   ----------------------------------------------------
   --
   ----------------------------------------------------
   type CFG_Node_Ext;
   type CFG_Node_Ext_Ptr is access all CFG_Node_Ext'Class;
   type CFG_Node_Ext is new CFG_Node with
      record
         next_nodes : CFG_Nodes_Table;
         previous_nodes : CFG_Nodes_Table;
      end record;

   ----------------------------------------------------
   --
   ----------------------------------------------------
   type Basic_Block_Ext;
   type Basic_Block_Ext_Ptr is access all Basic_Block_Ext'Class;
   type Basic_Block_Ext is new Basic_Block with
      record
         next_nodes : CFG_Nodes_Table;
         previous_nodes : CFG_Nodes_Table;
      end record;

   ----------------------------------------------------
   -- This object is used for Useful Basic Block (Lee, 1996) Analysis.
   -- It helps the analysis becomes easier to implement, debug.
   ----------------------------------------------------
   type Basic_Block_UCB_Arr is array(natural range <>) of Integer_Array;
   type Basic_Block_UCB_Arr_Ptr is access Basic_Block_UCB_Arr;

   type Basic_Block_UCB;
   type Basic_Block_UCB_Ptr is access all Basic_Block_UCB'Class;
   type Basic_Block_UCB is new Basic_Block_Ext with
      record
         GenCBR : Integer_Array;
         GenCBL : Integer_Array;
         RMBIn	: Basic_Block_UCB_Arr_Ptr;
         RMBOut : Basic_Block_UCB_Arr_Ptr;
         LMBIn	: Basic_Block_UCB_Arr_Ptr;
         LMBOut : Basic_Block_UCB_Arr_Ptr;
         UCBs	: Integer_Array;
         NumberOfUsefulBlock : Integer;
      end record;

   ----------------------------------------------------
   --
   ----------------------------------------------------
   type CRPD_Node;
   type CRPD_Node_Ptr is access all CRPD_Node'Class;
   type CRPD_Node is new CFG_Node_Ext with
      record
         job_index 	  : Natural;
         task_index 	  : Natural;
         task_name 	  : Unbounded_String;
         crpd_value 	  : Natural;
         a_trrt 	  : Task_Release_Records_Table_Ptr;
         a_rprt 	  : Relative_Priority_Records_Table_Ptr;
      end record;

   procedure Add_Next_CRPD_Node
     (a_CRPD_Node		: in CRPD_Node_Ptr;
      a_next_CRPD_Node		: in CRPD_Node_Ptr);

   ----------------------------------------------------
   --
   ----------------------------------------------------
   procedure Get_Description;

end CFG_Nodes.Extended;
