
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

with id_generators;
use id_generators;

with Objects;
use Objects;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with Ada.Finalization;

with unbounded_strings;
use unbounded_strings;

use unbounded_strings.Unbounded_String_List_Package;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with Tables;



Package CFG_Nodes is 
 
type CFG_Node; type CFG_Node_Ptr is access all CFG_Node'Class;


type CFG_Graph_Type is (
	CFG_Basic_Block,
	CFG_Atomic_Operation,
	DFG_Basic_block);

procedure To_CFG_Graph_Type is
new Convert_Strings(CFG_Graph_Type, CFG_Basic_Block);
procedure To_CFG_Graph_Type is
new Convert_Unbounded_Strings(CFG_Graph_Type, CFG_Basic_Block);
function XML_String (obj : in CFG_Graph_Type) return Unbounded_String;
function XML_Ref_String (obj : in CFG_Graph_Type) return Unbounded_String;
package CFG_Graph_Type_io is new text_io.enumeration_io(CFG_Graph_Type);
use CFG_Graph_Type_io;


type CFG_Node_Type is (
	Start_Node,
	Middle_Node,
	Terminate_Node);

procedure To_CFG_Node_Type is
new Convert_Strings(CFG_Node_Type, Start_Node);
procedure To_CFG_Node_Type is
new Convert_Unbounded_Strings(CFG_Node_Type, Start_Node);
function XML_String (obj : in CFG_Node_Type) return Unbounded_String;
function XML_Ref_String (obj : in CFG_Node_Type) return Unbounded_String;
package CFG_Node_Type_io is new text_io.enumeration_io(CFG_Node_Type);
use CFG_Node_Type_io;



-- --------= CFG_Node =--------

type CFG_Node is new Named_Object with 
record
 graph_type : CFG_Graph_Type;
 node_type : CFG_Node_Type;
end record;

procedure Initialize(obj : in out CFG_Node);
procedure Put(obj : in CFG_Node);
procedure Put(obj : in CFG_Node_Ptr);
procedure Put_Name(obj : in CFG_Node_Ptr);
procedure Build_Attributes_XML_String(obj : in CFG_Node; result : in out Unbounded_String);
function XML_String(obj : in CFG_Node) return Unbounded_String;
function XML_String(obj : in CFG_Node_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in CFG_Node) return Unbounded_String;
function XML_Ref_String(obj : in CFG_Node_Ptr) return Unbounded_String;
function Get_Name (obj : in CFG_Node) return Unbounded_String;
function Get_Name (obj : in CFG_Node_Ptr) return Unbounded_String;
function Copy(obj : in CFG_Node_Ptr) return CFG_Node_Ptr;
function Copy(obj : in CFG_Node) return CFG_Node_Ptr;
function type_of(obj : in CFG_Node) return unbounded_string_list;
function type_of(obj : in CFG_Node_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (CFG_Node'Class, CFG_Node_Ptr);

package CFG_Nodes_Table_Package is new Tables(CFG_Node_Ptr, Framework_Config.Max_CFG_Nodes, Put, XML_String, XML_Ref_String);
use CFG_Nodes_Table_Package;
subtype CFG_Nodes_Range is CFG_Nodes_Table_Package.table_range;
subtype CFG_Nodes_Range_Ptr is  CFG_Nodes_Table_Package.table_range_Ptr;
subtype CFG_Nodes_Table is CFG_Nodes_Table_Package.table;
subtype CFG_Nodes_Table_Ptr is  CFG_Nodes_Table_Package.table_Ptr;


End CFG_Nodes;
