
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;



Package Body Core_Units is 
 

-- --------= Core_Unit =--------

procedure Initialize(obj : in out Core_Unit) is 
begin
	initialize(Named_Object(obj));
	obj.speed := 0.0;
	obj.l1_cache_system_name := empty_string;
	obj.object_type := Core_Object_Type;
end Initialize;

function Copy ( obj : in Core_Unit ) return Core_Unit_Ptr is
	New_Core_Unit : Core_Unit_Ptr;
begin
	New_Core_Unit := new Core_Unit'(obj);
	return (New_Core_Unit);
end Copy;

function Copy ( obj : in Core_Unit_Ptr ) return Core_Unit_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Core_Unit) is 
begin
	put(Named_Object(obj));
	put("scheduling: "); put(obj.scheduling); put ( "; " );
	put("speed: "); standards_io.double_io.put(obj.speed); put ( "; " );
	put("l1_cache_system_name: "); put(obj.l1_cache_system_name); put ( "; " );
end Put;
 
procedure Put(obj : in Core_Unit_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Core_Unit_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Core_Unit) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Core_Unit_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Core_Unit ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("CORE_UNITS.CORE_UNIT");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Core_Unit_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Core_Unit; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Named_Object(obj), result);
	if (XML_String(obj.scheduling) /= Empty_String) then
		result := result & to_unbounded_string("<scheduling>") & XML_String(obj.scheduling) & to_unbounded_string("</scheduling>");
	end if;
	if (XML_String(obj.speed) /= Empty_String) then
		result := result & to_unbounded_string("<speed>") & XML_String(obj.speed) & to_unbounded_string("</speed>");
	end if;
	if (XML_String(obj.l1_cache_system_name) /= Empty_String) then
		result := result & to_unbounded_string("<l1_cache_system_name>") & XML_String(obj.l1_cache_system_name) & to_unbounded_string("</l1_cache_system_name>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Core_Unit) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<core_unit id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</core_unit>");
	return (result);
end XML_String;

function XML_String(obj : in Core_Unit_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Core_Unit) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<core_unit ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Core_Unit_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Core_Units;
