
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;



Package Body Dependencies is 
 
function XML_String(obj : in Dependency_Type) return Unbounded_String is
begin
	return to_unbounded_string(Dependency_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Dependency_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;


function XML_String(obj : in Time_Triggered_Communication_Timing_Property_Type) return Unbounded_String is
begin
	return to_unbounded_string(Time_Triggered_Communication_Timing_Property_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Time_Triggered_Communication_Timing_Property_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;


function XML_String(obj : in Orientation_Dependency_Type) return Unbounded_String is
begin
	return to_unbounded_string(Orientation_Dependency_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Orientation_Dependency_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;


procedure Initialize (obj : out Dependency_Ptr) is
begin
	obj := NULL;
end Initialize;
 
procedure Put(obj : in Dependency_Ptr) is
begin
	if (obj /= NULL) then
		put("type_of_dependency: "); put(obj.type_of_dependency); put ( "; " );
		put ( "value: " );
		case obj.type_of_dependency is 
			when precedence_dependency => 
				put("precedence_sink: "); if obj.precedence_sink /= null then put(obj.precedence_sink.all); else put("null"); end if;put ( "; " );
				put("precedence_source: "); if obj.precedence_source /= null then put(obj.precedence_source.all); else put("null"); end if;put ( "; " );

			when queueing_buffer_dependency => 
				put("buffer_dependent_task: "); if obj.buffer_dependent_task /= null then put(obj.buffer_dependent_task.all); else put("null"); end if;put ( "; " );
				put("buffer_orientation: "); put(obj.buffer_orientation); put ( "; " );
				put("buffer_dependency_object: "); if obj.buffer_dependency_object /= null then put(obj.buffer_dependency_object.all); else put("null"); end if;put ( "; " );

			when asynchronous_communication_dependency => 
				put("asynchronous_communication_dependent_task: "); if obj.asynchronous_communication_dependent_task /= null then put(obj.asynchronous_communication_dependent_task.all); else put("null"); end if;put ( "; " );
				put("asynchronous_communication_orientation: "); put(obj.asynchronous_communication_orientation); put ( "; " );
				put("asynchronous_communication_dependency_object: "); if obj.asynchronous_communication_dependency_object /= null then put(obj.asynchronous_communication_dependency_object.all); else put("null"); end if;put ( "; " );

			when time_triggered_communication_dependency => 
				put("time_triggered_communication_sink: "); if obj.time_triggered_communication_sink /= null then put(obj.time_triggered_communication_sink.all); else put("null"); end if;put ( "; " );
				put("time_triggered_communication_source: "); if obj.time_triggered_communication_source /= null then put(obj.time_triggered_communication_source.all); else put("null"); end if;put ( "; " );
				put("timing_property: "); put(obj.timing_property); put ( "; " );

			when resource_dependency => 
				put("resource_dependency_resource: "); if obj.resource_dependency_resource /= null then put(obj.resource_dependency_resource.all); else put("null"); end if;put ( "; " );
				put("resource_dependency_task: "); if obj.resource_dependency_task /= null then put(obj.resource_dependency_task.all); else put("null"); end if;put ( "; " );

			when black_board_Buffer_dependency => 
				put("black_board_dependent_task: "); if obj.black_board_dependent_task /= null then put(obj.black_board_dependent_task.all); else put("null"); end if;put ( "; " );
				put("black_board_orientation: "); put(obj.black_board_orientation); put ( "; " );
				put("black_board_dependency_object: "); if obj.black_board_dependency_object /= null then put(obj.black_board_dependency_object.all); else put("null"); end if;put ( "; " );

		end case;
	end if;
	New_Line;
end Put;

function Copy ( obj : in Dependency ) return Dependency_Ptr is
	New_Dependency : Dependency_Ptr;
begin
	New_Dependency := new Dependency'(obj);
	return (New_Dependency);
end Copy;

function Copy ( obj : in Dependency_Ptr ) return Dependency_Ptr is
begin
	return copy(obj.all);
end Copy;

function XML_String(obj : in Dependency) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<dependency>");
	if (XML_String(obj.type_of_dependency) /= Empty_String) then
		result := result & to_unbounded_string("<type_of_dependency>") & XML_String(obj.type_of_dependency) & to_unbounded_string("</type_of_dependency>");
	end if;

	case obj.type_of_dependency is 
		when precedence_dependency => 
			result := result & to_unbounded_string("<precedence_sink ref=""") & obj.precedence_sink.cheddar_private_id & to_unbounded_string(""" />");
			result := result & to_unbounded_string("<precedence_source ref=""") & obj.precedence_source.cheddar_private_id & to_unbounded_string(""" />");

		when queueing_buffer_dependency => 
			result := result & to_unbounded_string("<buffer_dependent_task ref=""") & obj.buffer_dependent_task.cheddar_private_id & to_unbounded_string(""" />");
			if (XML_String(obj.buffer_orientation) /= Empty_String) then
		result := result & to_unbounded_string("<buffer_orientation>") & XML_String(obj.buffer_orientation) & to_unbounded_string("</buffer_orientation>");
	end if;
			result := result & to_unbounded_string("<buffer_dependency_object ref=""") & obj.buffer_dependency_object.cheddar_private_id & to_unbounded_string(""" />");

		when asynchronous_communication_dependency => 
			result := result & to_unbounded_string("<asynchronous_communication_dependent_task ref=""") & obj.asynchronous_communication_dependent_task.cheddar_private_id & to_unbounded_string(""" />");
			if (XML_String(obj.asynchronous_communication_orientation) /= Empty_String) then
		result := result & to_unbounded_string("<asynchronous_communication_orientation>") & XML_String(obj.asynchronous_communication_orientation) & to_unbounded_string("</asynchronous_communication_orientation>");
	end if;
			result := result & to_unbounded_string("<asynchronous_communication_dependency_object ref=""") & obj.asynchronous_communication_dependency_object.cheddar_private_id & to_unbounded_string(""" />");

		when time_triggered_communication_dependency => 
			result := result & to_unbounded_string("<time_triggered_communication_sink ref=""") & obj.time_triggered_communication_sink.cheddar_private_id & to_unbounded_string(""" />");
			result := result & to_unbounded_string("<time_triggered_communication_source ref=""") & obj.time_triggered_communication_source.cheddar_private_id & to_unbounded_string(""" />");
			if (XML_String(obj.timing_property) /= Empty_String) then
		result := result & to_unbounded_string("<timing_property>") & XML_String(obj.timing_property) & to_unbounded_string("</timing_property>");
	end if;

		when resource_dependency => 
			result := result & to_unbounded_string("<resource_dependency_resource ref=""") & obj.resource_dependency_resource.cheddar_private_id & to_unbounded_string(""" />");
			result := result & to_unbounded_string("<resource_dependency_task ref=""") & obj.resource_dependency_task.cheddar_private_id & to_unbounded_string(""" />");

		when black_board_Buffer_dependency => 
			result := result & to_unbounded_string("<black_board_dependent_task ref=""") & obj.black_board_dependent_task.cheddar_private_id & to_unbounded_string(""" />");
			if (XML_String(obj.black_board_orientation) /= Empty_String) then
		result := result & to_unbounded_string("<black_board_orientation>") & XML_String(obj.black_board_orientation) & to_unbounded_string("</black_board_orientation>");
	end if;
			result := result & to_unbounded_string("<black_board_dependency_object ref=""") & obj.black_board_dependency_object.cheddar_private_id & to_unbounded_string(""" />");

	end case;
	result := result & to_unbounded_string("</dependency>");
	return (result);
end XML_String;

function XML_String(obj : in Dependency_Ptr) return Unbounded_String is
begin
	return XML_String(obj.all);
end XML_String;

function XML_Ref_String(obj : in Dependency) return Unbounded_String is
	result : Unbounded_String;
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;
function XML_Ref_String(obj : in Dependency_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;



End Dependencies;
