
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with Objects;
use Objects;

use Objects.Generic_Object_Set_Package;

with Time_Unit_Events;
use Time_Unit_Events;

use Time_Unit_Events.Time_Unit_Package;



Package Body Deployments is 
 
function XML_String(obj : in Deployments_Type) return Unbounded_String is
begin
	return to_unbounded_string(Deployments_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Deployments_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;



-- --------= Generic_Deployment =--------

procedure Initialize(obj : in out Generic_Deployment) is 
begin
	initialize(Named_Object(obj));
	obj.deployment_type := Static_Deployment_Type;
	obj.object_type := Deployment_Type;
end Initialize;

function Copy ( obj : in Generic_Deployment ) return Generic_Deployment_Ptr is
	New_Generic_Deployment : Generic_Deployment_Ptr;
begin
	New_Generic_Deployment := new Generic_Deployment'(obj);
	return (New_Generic_Deployment);
end Copy;

function Copy ( obj : in Generic_Deployment_Ptr ) return Generic_Deployment_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Deployment) is 
begin
	put(Named_Object(obj));
	put("deployment_type: "); put(obj.deployment_type); put ( "; " );
	put("consumer_entities: "); put(obj.consumer_entities); put ( "; " );
	put("resource_entities: "); put(obj.resource_entities); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Deployment_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Deployment_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Deployment) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Deployment_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Generic_Deployment ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DEPLOYMENTS.GENERIC_DEPLOYMENT");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Generic_Deployment_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Generic_Deployment; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Named_Object(obj), result);
	if (XML_String(obj.deployment_type) /= Empty_String) then
		result := result & to_unbounded_string("<deployment_type>") & XML_String(obj.deployment_type) & to_unbounded_string("</deployment_type>");
	end if;
	if (XML_String(obj.consumer_entities) /= Empty_String) then
		result := result & to_unbounded_string("<consumer_entities>") & XML_String(obj.consumer_entities) & to_unbounded_string("</consumer_entities>");
	end if;
	if (XML_String(obj.resource_entities) /= Empty_String) then
		result := result & to_unbounded_string("<resource_entities>") & XML_String(obj.resource_entities) & to_unbounded_string("</resource_entities>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Deployment) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_deployment id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</generic_deployment>");
	return (result);
end XML_String;

function XML_String(obj : in Generic_Deployment_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Generic_Deployment) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_deployment ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Generic_Deployment_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Static_Deployment =--------

procedure Initialize(obj : in out Static_Deployment) is 
begin
	initialize(Generic_Deployment(obj));
	obj.allocation_description := empty_string;
end Initialize;

function Copy ( obj : in Static_Deployment ) return Generic_Deployment_Ptr is
	New_Static_Deployment : Static_Deployment_Ptr;
begin
	New_Static_Deployment := new Static_Deployment'(obj);
	return Generic_Deployment_Ptr(New_Static_Deployment);
end Copy;

function Copy ( obj : in Static_Deployment_Ptr ) return Generic_Deployment_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Static_Deployment) is 
begin
	put(Generic_Deployment(obj));
	put("allocation_description: "); put(obj.allocation_description); put ( "; " );
end Put;
 
procedure Put(obj : in Static_Deployment_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Static_Deployment_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Static_Deployment) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Static_Deployment_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Static_Deployment ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DEPLOYMENTS.GENERIC_DEPLOYMENT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DEPLOYMENTS.STATIC_DEPLOYMENT");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Static_Deployment_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Static_Deployment; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Deployment(obj), result);
	if (XML_String(obj.allocation_description) /= Empty_String) then
		result := result & to_unbounded_string("<allocation_description>") & XML_String(obj.allocation_description) & to_unbounded_string("</allocation_description>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Static_Deployment) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<static_deployment id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</static_deployment>");
	return (result);
end XML_String;

function XML_String(obj : in Static_Deployment_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Static_Deployment) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<static_deployment ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Static_Deployment_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Dynamic_Deployment =--------

procedure Initialize(obj : in out Dynamic_Deployment) is 
begin
	initialize(Generic_Deployment(obj));
end Initialize;

function Copy ( obj : in Dynamic_Deployment ) return Generic_Deployment_Ptr is
	New_Dynamic_Deployment : Dynamic_Deployment_Ptr;
begin
	New_Dynamic_Deployment := new Dynamic_Deployment'(obj);
	return Generic_Deployment_Ptr(New_Dynamic_Deployment);
end Copy;

function Copy ( obj : in Dynamic_Deployment_Ptr ) return Generic_Deployment_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Dynamic_Deployment) is 
begin
	put(Generic_Deployment(obj));
	put("allocation_parameters: "); put(obj.allocation_parameters); put ( "; " );
end Put;
 
procedure Put(obj : in Dynamic_Deployment_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Dynamic_Deployment_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Dynamic_Deployment) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Dynamic_Deployment_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Dynamic_Deployment ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DEPLOYMENTS.GENERIC_DEPLOYMENT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DEPLOYMENTS.DYNAMIC_DEPLOYMENT");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Dynamic_Deployment_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Dynamic_Deployment; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Deployment(obj), result);
	if (XML_String(obj.allocation_parameters) /= Empty_String) then
		result := result & to_unbounded_string("<allocation_parameters>") & XML_String(obj.allocation_parameters) & to_unbounded_string("</allocation_parameters>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Dynamic_Deployment) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<dynamic_deployment id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</dynamic_deployment>");
	return (result);
end XML_String;

function XML_String(obj : in Dynamic_Deployment_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Dynamic_Deployment) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<dynamic_deployment ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Dynamic_Deployment_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Deployments;
