
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

with id_generators;
use id_generators;

with Objects;
use Objects;

with Scheduling_Analysis;
use Scheduling_Analysis;

with Scheduler_Interface;
use Scheduler_Interface;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with standards_io;
use standards_io;

with Ada.Finalization;

with unbounded_strings;
use unbounded_strings;

use unbounded_strings.Unbounded_String_List_Package;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;



Package Deployments is 
 
type Generic_Deployment; type Generic_Deployment_Ptr is access all Generic_Deployment'Class;
type Static_Deployment; type Static_Deployment_Ptr is access all Static_Deployment'Class;
type Dynamic_Deployment; type Dynamic_Deployment_Ptr is access all Dynamic_Deployment'Class;


type Deployments_Type is (
	Static_Deployment_Type,
	Dynamic_Deployment_Type);

procedure To_Deployments_Type is
new Convert_Strings(Deployments_Type, Static_Deployment_Type);
procedure To_Deployments_Type is
new Convert_Unbounded_Strings(Deployments_Type, Static_Deployment_Type);
function XML_String (obj : in Deployments_Type) return Unbounded_String;
function XML_Ref_String (obj : in Deployments_Type) return Unbounded_String;
package Deployments_Type_io is new text_io.enumeration_io(Deployments_Type);
use Deployments_Type_io;



-- --------= Generic_Deployment =--------

type Generic_Deployment is new Named_Object with 
record
 deployment_type : Deployments_Type;
 consumer_entities : Generic_Objects_Set;
 resource_entities : Generic_Objects_Set;
end record;

procedure Initialize(obj : in out Generic_Deployment);
procedure Put(obj : in Generic_Deployment);
procedure Put(obj : in Generic_Deployment_Ptr);
procedure Put_Name(obj : in Generic_Deployment_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Deployment; result : in out Unbounded_String);
function XML_String(obj : in Generic_Deployment) return Unbounded_String;
function XML_String(obj : in Generic_Deployment_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Deployment) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Deployment_Ptr) return Unbounded_String;
function Get_Name (obj : in Generic_Deployment) return Unbounded_String;
function Get_Name (obj : in Generic_Deployment_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Deployment_Ptr) return Generic_Deployment_Ptr;
function Copy(obj : in Generic_Deployment) return Generic_Deployment_Ptr;
function type_of(obj : in Generic_Deployment) return unbounded_string_list;
function type_of(obj : in Generic_Deployment_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Generic_Deployment'Class, Generic_Deployment_Ptr);


-- --------= Static_Deployment =--------

type Static_Deployment is new Generic_Deployment with 
record
 allocation_description : Unbounded_String;
end record;

procedure Initialize(obj : in out Static_Deployment);
procedure Put(obj : in Static_Deployment);
procedure Put(obj : in Static_Deployment_Ptr);
procedure Put_Name(obj : in Static_Deployment_Ptr);
procedure Build_Attributes_XML_String(obj : in Static_Deployment; result : in out Unbounded_String);
function XML_String(obj : in Static_Deployment) return Unbounded_String;
function XML_String(obj : in Static_Deployment_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Static_Deployment) return Unbounded_String;
function XML_Ref_String(obj : in Static_Deployment_Ptr) return Unbounded_String;
function Get_Name (obj : in Static_Deployment) return Unbounded_String;
function Get_Name (obj : in Static_Deployment_Ptr) return Unbounded_String;
function Copy(obj : in Static_Deployment_Ptr) return Generic_Deployment_Ptr;
function Copy(obj : in Static_Deployment) return Generic_Deployment_Ptr;
function type_of(obj : in Static_Deployment) return unbounded_string_list;
function type_of(obj : in Static_Deployment_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Static_Deployment'Class, Static_Deployment_Ptr);


-- --------= Dynamic_Deployment =--------

type Dynamic_Deployment is new Generic_Deployment with 
record
 allocation_parameters : Scheduling_Parameters;
end record;

procedure Initialize(obj : in out Dynamic_Deployment);
procedure Put(obj : in Dynamic_Deployment);
procedure Put(obj : in Dynamic_Deployment_Ptr);
procedure Put_Name(obj : in Dynamic_Deployment_Ptr);
procedure Build_Attributes_XML_String(obj : in Dynamic_Deployment; result : in out Unbounded_String);
function XML_String(obj : in Dynamic_Deployment) return Unbounded_String;
function XML_String(obj : in Dynamic_Deployment_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Dynamic_Deployment) return Unbounded_String;
function XML_Ref_String(obj : in Dynamic_Deployment_Ptr) return Unbounded_String;
function Get_Name (obj : in Dynamic_Deployment) return Unbounded_String;
function Get_Name (obj : in Dynamic_Deployment_Ptr) return Unbounded_String;
function Copy(obj : in Dynamic_Deployment_Ptr) return Generic_Deployment_Ptr;
function Copy(obj : in Dynamic_Deployment) return Generic_Deployment_Ptr;
function type_of(obj : in Dynamic_Deployment) return unbounded_string_list;
function type_of(obj : in Dynamic_Deployment_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Dynamic_Deployment'Class, Dynamic_Deployment_Ptr);


End Deployments;
