
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

with id_generators;
use id_generators;

with Objects;
use Objects;

with CFG_Nodes;
use CFG_Nodes;

use CFG_Nodes.CFG_Nodes_Table_Package;

with CFGs;
use CFGs;

with Ada.Finalization;

with unbounded_strings;
use unbounded_strings;

use unbounded_strings.Unbounded_String_List_Package;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with Tables;

with standards_io;
use standards_io;

use standards_io.natural_io;

with Framework_Config;
use Framework_Config;


Package DFG_Nodes is 
 
type DFG_Variable; type DFG_Variable_Ptr is access all DFG_Variable'Class;
type DFG_Statement; type DFG_Statement_Ptr is access all DFG_Statement'Class;
type DFG_Cfg_Type; type DFG_Cfg_Type_Ptr is access all DFG_Cfg_Type;
type DFG_Def_Use_Association; type DFG_Def_Use_Association_Ptr is access all DFG_Def_Use_Association;
type DFG_Var_Association; type DFG_Var_Association_Ptr is access all DFG_Var_Association;
type DFG_Def_Use_Info; type DFG_Def_Use_Info_Ptr is access all DFG_Def_Use_Info;



-- --------= DFG_Variable =--------

type DFG_Variable is new Named_Object with null record;

procedure Initialize(obj : in out DFG_Variable);
procedure Put(obj : in DFG_Variable);
procedure Put(obj : in DFG_Variable_Ptr);
procedure Put_Name(obj : in DFG_Variable_Ptr);
procedure Build_Attributes_XML_String(obj : in DFG_Variable; result : in out Unbounded_String);
function XML_String(obj : in DFG_Variable) return Unbounded_String;
function XML_String(obj : in DFG_Variable_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in DFG_Variable) return Unbounded_String;
function XML_Ref_String(obj : in DFG_Variable_Ptr) return Unbounded_String;
function Get_Name (obj : in DFG_Variable) return Unbounded_String;
function Get_Name (obj : in DFG_Variable_Ptr) return Unbounded_String;
function Copy(obj : in DFG_Variable_Ptr) return DFG_Variable_Ptr;
function Copy(obj : in DFG_Variable) return DFG_Variable_Ptr;
function type_of(obj : in DFG_Variable) return unbounded_string_list;
function type_of(obj : in DFG_Variable_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (DFG_Variable'Class, DFG_Variable_Ptr);

package DFG_Variables_Table_Package is new Tables(DFG_Variable_Ptr,Framework_Config.MAX_NB_USED_VAR_STATEMENT, Put, XML_String, XML_Ref_String);
use DFG_Variables_Table_Package;
subtype DFG_Variables_Range is DFG_Variables_Table_Package.table_range;
subtype DFG_Variables_Range_Ptr is  DFG_Variables_Table_Package.table_range_Ptr;
subtype DFG_Variables_Table is DFG_Variables_Table_Package.table;
subtype DFG_Variables_Table_Ptr is  DFG_Variables_Table_Package.table_Ptr;


-- --------= DFG_Statement =--------

type DFG_Statement is new Named_Object with 
record
 Defined_Variable : DFG_Variable_Ptr;
 Used_Variables : DFG_Variables_Table;
end record;

procedure Initialize(obj : in out DFG_Statement);
procedure Put(obj : in DFG_Statement);
procedure Put(obj : in DFG_Statement_Ptr);
procedure Put_Name(obj : in DFG_Statement_Ptr);
procedure Build_Attributes_XML_String(obj : in DFG_Statement; result : in out Unbounded_String);
function XML_String(obj : in DFG_Statement) return Unbounded_String;
function XML_String(obj : in DFG_Statement_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in DFG_Statement) return Unbounded_String;
function XML_Ref_String(obj : in DFG_Statement_Ptr) return Unbounded_String;
function Get_Name (obj : in DFG_Statement) return Unbounded_String;
function Get_Name (obj : in DFG_Statement_Ptr) return Unbounded_String;
function Copy(obj : in DFG_Statement_Ptr) return DFG_Statement_Ptr;
function Copy(obj : in DFG_Statement) return DFG_Statement_Ptr;
function type_of(obj : in DFG_Statement) return unbounded_string_list;
function type_of(obj : in DFG_Statement_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (DFG_Statement'Class, DFG_Statement_Ptr);

package DFG_Statements_Table_Package is new Tables(DFG_Statement_Ptr, Framework_Config.MAX_NB_STATEMENTS_BLOCK, Put, XML_String, XML_Ref_String);
use DFG_Statements_Table_Package;
subtype DFG_Statements_Range is DFG_Statements_Table_Package.table_range;
subtype DFG_Statements_Range_Ptr is  DFG_Statements_Table_Package.table_range_Ptr;
subtype DFG_Statements_Table is DFG_Statements_Table_Package.table;
subtype DFG_Statements_Table_Ptr is  DFG_Statements_Table_Package.table_Ptr;

-- --------= DFG_Cfg_Type =--------

type DFG_Cfg_Type is
record
 Blocks : CFG_Nodes_Table;
 Nb_Blocks : Natural;
end record;

procedure Initialize(obj : out DFG_Cfg_Type);
procedure Put(obj : in DFG_Cfg_Type);
procedure Put(obj : in DFG_Cfg_Type_Ptr);
function Copy(obj : in DFG_Cfg_Type_Ptr) return DFG_Cfg_Type_Ptr;
function Copy(obj : in DFG_Cfg_Type) return DFG_Cfg_Type_Ptr;
procedure Build_Attributes_XML_String(obj : in DFG_Cfg_Type; result : in out Unbounded_String);
function XML_String(obj : in DFG_Cfg_Type) return Unbounded_String;
function XML_String(obj : in DFG_Cfg_Type_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in DFG_Cfg_Type) return Unbounded_String;
procedure Free  is new Unchecked_Deallocation (DFG_Cfg_Type, DFG_Cfg_Type_Ptr);


-- --------= DFG_Def_Use_Association =--------

type DFG_Def_Use_Association is
record
 Def_Variable : DFG_Variable_Ptr;
 Def_Statement : DFG_Statement_Ptr;
 Use_Statement : DFG_Statement_Ptr;
end record;

procedure Initialize(obj : out DFG_Def_Use_Association);
procedure Put(obj : in DFG_Def_Use_Association);
procedure Put(obj : in DFG_Def_Use_Association_Ptr);
function Copy(obj : in DFG_Def_Use_Association_Ptr) return DFG_Def_Use_Association_Ptr;
function Copy(obj : in DFG_Def_Use_Association) return DFG_Def_Use_Association_Ptr;
procedure Build_Attributes_XML_String(obj : in DFG_Def_Use_Association; result : in out Unbounded_String);
function XML_String(obj : in DFG_Def_Use_Association) return Unbounded_String;
function XML_String(obj : in DFG_Def_Use_Association_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in DFG_Def_Use_Association) return Unbounded_String;
procedure Free  is new Unchecked_Deallocation (DFG_Def_Use_Association, DFG_Def_Use_Association_Ptr);

package DFG_Def_Use_Associations_Table_Package is new Tables(DFG_Def_Use_Association_Ptr, Framework_Config.MAX_DEF_USE, Put, XML_String, XML_String);
use DFG_Def_Use_Associations_Table_Package;
subtype DFG_Def_Use_Associations_Range is DFG_Def_Use_Associations_Table_Package.table_range;
subtype DFG_Def_Use_Associations_Range_Ptr is  DFG_Def_Use_Associations_Table_Package.table_range_Ptr;
subtype DFG_Def_Use_Associations_Table is DFG_Def_Use_Associations_Table_Package.table;
subtype DFG_Def_Use_Associations_Table_Ptr is  DFG_Def_Use_Associations_Table_Package.table_Ptr;

-- --------= DFG_Var_Association =--------

type DFG_Var_Association is
record
 Def_Variable : DFG_Variable_Ptr;
 Statement : DFG_Statement_Ptr;
end record;

procedure Initialize(obj : out DFG_Var_Association);
procedure Put(obj : in DFG_Var_Association);
procedure Put(obj : in DFG_Var_Association_Ptr);
function Copy(obj : in DFG_Var_Association_Ptr) return DFG_Var_Association_Ptr;
function Copy(obj : in DFG_Var_Association) return DFG_Var_Association_Ptr;
procedure Build_Attributes_XML_String(obj : in DFG_Var_Association; result : in out Unbounded_String);
function XML_String(obj : in DFG_Var_Association) return Unbounded_String;
function XML_String(obj : in DFG_Var_Association_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in DFG_Var_Association) return Unbounded_String;
procedure Free  is new Unchecked_Deallocation (DFG_Var_Association, DFG_Var_Association_Ptr);

package DFG_Var_Association_Defs_Table_Package is new Tables(DFG_Var_Association_Ptr, Framework_Config.MAX_DEF, Put, XML_String, XML_String);
use DFG_Var_Association_Defs_Table_Package;
subtype DFG_Var_Association_Defs_Range is DFG_Var_Association_Defs_Table_Package.table_range;
subtype DFG_Var_Association_Defs_Range_Ptr is  DFG_Var_Association_Defs_Table_Package.table_range_Ptr;
subtype DFG_Var_Association_Defs_Table is DFG_Var_Association_Defs_Table_Package.table;
subtype DFG_Var_Association_Defs_Table_Ptr is  DFG_Var_Association_Defs_Table_Package.table_Ptr;

package DFG_Var_Association_Uses_Table_Package is new Tables(DFG_Var_Association_Ptr, Framework_Config.MAX_USE, Put, XML_String, XML_String);
use DFG_Var_Association_Uses_Table_Package;
subtype DFG_Var_Association_Uses_Range is DFG_Var_Association_Uses_Table_Package.table_range;
subtype DFG_Var_Association_Uses_Range_Ptr is  DFG_Var_Association_Uses_Table_Package.table_range_Ptr;
subtype DFG_Var_Association_Uses_Table is DFG_Var_Association_Uses_Table_Package.table;
subtype DFG_Var_Association_Uses_Table_Ptr is  DFG_Var_Association_Uses_Table_Package.table_Ptr;

-- --------= DFG_Def_Use_Info =--------

type DFG_Def_Use_Info is
record
 Def_In : DFG_Var_Association_Defs_Table;
 Def_Out : DFG_Var_Association_Defs_Table;
 Use_Out : DFG_Var_Association_Uses_Table;
 Def_Use_Asso : DFG_Def_Use_Associations_Table;
end record;

procedure Initialize(obj : out DFG_Def_Use_Info);
procedure Put(obj : in DFG_Def_Use_Info);
procedure Put(obj : in DFG_Def_Use_Info_Ptr);
function Copy(obj : in DFG_Def_Use_Info_Ptr) return DFG_Def_Use_Info_Ptr;
function Copy(obj : in DFG_Def_Use_Info) return DFG_Def_Use_Info_Ptr;
procedure Build_Attributes_XML_String(obj : in DFG_Def_Use_Info; result : in out Unbounded_String);
function XML_String(obj : in DFG_Def_Use_Info) return Unbounded_String;
function XML_String(obj : in DFG_Def_Use_Info_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in DFG_Def_Use_Info) return Unbounded_String;
procedure Free  is new Unchecked_Deallocation (DFG_Def_Use_Info, DFG_Def_Use_Info_Ptr);

package DFG_Def_Use_Infos_Table_Package is new Tables(DFG_Def_Use_Info_Ptr, Framework_Config.MAX_USE, Put, XML_String, XML_String);
use DFG_Def_Use_Infos_Table_Package;
subtype DFG_Def_Use_Infos_Range is DFG_Def_Use_Infos_Table_Package.table_range;
subtype DFG_Def_Use_Infos_Range_Ptr is  DFG_Def_Use_Infos_Table_Package.table_range_Ptr;
subtype DFG_Def_Use_Infos_Table is DFG_Def_Use_Infos_Table_Package.table;
subtype DFG_Def_Use_Infos_Table_Ptr is  DFG_Def_Use_Infos_Table_Package.table_Ptr;

End DFG_Nodes;
