
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with Parameters;
use Parameters;

use parameters.User_Defined_Parameters_Table_Package;



Package Body Messages is 
 
function XML_String(obj : in Messages_Type) return Unbounded_String is
begin
	return to_unbounded_string(Messages_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Messages_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;



-- --------= Generic_Message =--------

procedure Initialize(obj : in out Generic_Message) is 
begin
	initialize(Named_Object(obj));
	obj.message_type := Periodic_Type;
	obj.deadline := 0;
	obj.size := 0;
	obj.response_time := 0;
	obj.communication_time := 0;
	obj.object_type := Message_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Message ) return Generic_Message_Ptr is
	New_Generic_Message : Generic_Message_Ptr;
begin
	New_Generic_Message := new Generic_Message'(obj);
	return (New_Generic_Message);
end Copy;

function Copy ( obj : in Generic_Message_Ptr ) return Generic_Message_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Message) is 
begin
	put(Named_Object(obj));
	put("message_type: "); put(obj.message_type); put ( "; " );
	put("parameters: "); put(obj.parameters); put ( "; " );
	put("deadline: "); standards_io.natural_io.put(obj.deadline); put ( "; " );
	put("size: "); standards_io.natural_io.put(obj.size); put ( "; " );
	put("response_time: "); standards_io.natural_io.put(obj.response_time); put ( "; " );
	put("communication_time: "); standards_io.natural_io.put(obj.communication_time); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Message_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Message_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Message) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Message_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Generic_Message ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("MESSAGES.GENERIC_MESSAGE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Generic_Message_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Generic_Message; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Named_Object(obj), result);
	if (XML_String(obj.message_type) /= Empty_String) then
		result := result & to_unbounded_string("<message_type>") & XML_String(obj.message_type) & to_unbounded_string("</message_type>");
	end if;
	if (XML_String(obj.parameters) /= Empty_String) then
		result := result & to_unbounded_string("<parameters>") & XML_String(obj.parameters) & to_unbounded_string("</parameters>");
	end if;
	if (XML_String(obj.deadline) /= Empty_String) then
		result := result & to_unbounded_string("<deadline>") & XML_String(obj.deadline) & to_unbounded_string("</deadline>");
	end if;
	if (XML_String(obj.size) /= Empty_String) then
		result := result & to_unbounded_string("<size>") & XML_String(obj.size) & to_unbounded_string("</size>");
	end if;
	if (XML_String(obj.response_time) /= Empty_String) then
		result := result & to_unbounded_string("<response_time>") & XML_String(obj.response_time) & to_unbounded_string("</response_time>");
	end if;
	if (XML_String(obj.communication_time) /= Empty_String) then
		result := result & to_unbounded_string("<communication_time>") & XML_String(obj.communication_time) & to_unbounded_string("</communication_time>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Message) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_message id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</generic_message>");
	return (result);
end XML_String;

function XML_String(obj : in Generic_Message_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Generic_Message) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_message ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Generic_Message_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Periodic_Message =--------

procedure Initialize(obj : in out Periodic_Message) is 
begin
	initialize(Generic_Message(obj));
	obj.period := 0;
	obj.jitter := 0;
	obj.message_type := Periodic_Type;
end Initialize;

function Copy ( obj : in Periodic_Message ) return Generic_Message_Ptr is
	New_Periodic_Message : Periodic_Message_Ptr;
begin
	New_Periodic_Message := new Periodic_Message'(obj);
	return Generic_Message_Ptr(New_Periodic_Message);
end Copy;

function Copy ( obj : in Periodic_Message_Ptr ) return Generic_Message_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Periodic_Message) is 
begin
	put(Generic_Message(obj));
	put("period: "); standards_io.natural_io.put(obj.period); put ( "; " );
	put("jitter: "); standards_io.natural_io.put(obj.jitter); put ( "; " );
end Put;
 
procedure Put(obj : in Periodic_Message_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Periodic_Message_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Periodic_Message) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Periodic_Message_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Periodic_Message ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("MESSAGES.GENERIC_MESSAGE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("MESSAGES.PERIODIC_MESSAGE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Periodic_Message_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Periodic_Message; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Message(obj), result);
	if (XML_String(obj.period) /= Empty_String) then
		result := result & to_unbounded_string("<period>") & XML_String(obj.period) & to_unbounded_string("</period>");
	end if;
	if (XML_String(obj.jitter) /= Empty_String) then
		result := result & to_unbounded_string("<jitter>") & XML_String(obj.jitter) & to_unbounded_string("</jitter>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Periodic_Message) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<periodic_message id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</periodic_message>");
	return (result);
end XML_String;

function XML_String(obj : in Periodic_Message_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Periodic_Message) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<periodic_message ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Periodic_Message_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Aperiodic_Message =--------

procedure Initialize(obj : in out Aperiodic_Message) is 
begin
	initialize(Generic_Message(obj));
	obj.message_type := Aperiodic_Type;
end Initialize;

function Copy ( obj : in Aperiodic_Message ) return Generic_Message_Ptr is
	New_Aperiodic_Message : Aperiodic_Message_Ptr;
begin
	New_Aperiodic_Message := new Aperiodic_Message'(obj);
	return Generic_Message_Ptr(New_Aperiodic_Message);
end Copy;

function Copy ( obj : in Aperiodic_Message_Ptr ) return Generic_Message_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Aperiodic_Message) is 
begin
	put(Generic_Message(obj));
end Put;
 
procedure Put(obj : in Aperiodic_Message_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Aperiodic_Message_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Aperiodic_Message) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Aperiodic_Message_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Aperiodic_Message ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("MESSAGES.GENERIC_MESSAGE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("MESSAGES.APERIODIC_MESSAGE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Aperiodic_Message_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Aperiodic_Message; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Message(obj), result);
end Build_Attributes_XML_String;

function XML_String(obj : in Aperiodic_Message) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<aperiodic_message id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</aperiodic_message>");
	return (result);
end XML_String;

function XML_String(obj : in Aperiodic_Message_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Aperiodic_Message) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<aperiodic_message ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Aperiodic_Message_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Messages;
