
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

with id_generators;
use id_generators;

with Objects;
use Objects;

with Parameters;
use Parameters;

use parameters.User_Defined_Parameters_Table_Package;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with standards_io;
use standards_io;

use standards_io.natural_io;

with Ada.Finalization;

with unbounded_strings;
use unbounded_strings;

use unbounded_strings.Unbounded_String_List_Package;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;



Package Messages is 
 
type Generic_Message; type Generic_Message_Ptr is access all Generic_Message'Class;
type Periodic_Message; type Periodic_Message_Ptr is access all Periodic_Message'Class;
type Aperiodic_Message; type Aperiodic_Message_Ptr is access all Aperiodic_Message'Class;


type Messages_Type is (
	Periodic_Type,
	Aperiodic_Type,
	Generic_Type);

procedure To_Messages_Type is
new Convert_Strings(Messages_Type, Periodic_Type);
procedure To_Messages_Type is
new Convert_Unbounded_Strings(Messages_Type, Periodic_Type);
function XML_String (obj : in Messages_Type) return Unbounded_String;
function XML_Ref_String (obj : in Messages_Type) return Unbounded_String;
package Messages_Type_io is new text_io.enumeration_io(Messages_Type);
use Messages_Type_io;



-- --------= Generic_Message =--------

type Generic_Message is new Named_Object with 
record
 message_type : Messages_Type;
 parameters : User_Defined_Parameters_Table;
 deadline : Natural;
 size : Natural;
 response_time : Natural;
 communication_time : Natural;
end record;

procedure Initialize(obj : in out Generic_Message);
procedure Put(obj : in Generic_Message);
procedure Put(obj : in Generic_Message_Ptr);
procedure Put_Name(obj : in Generic_Message_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Message; result : in out Unbounded_String);
function XML_String(obj : in Generic_Message) return Unbounded_String;
function XML_String(obj : in Generic_Message_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Message) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Message_Ptr) return Unbounded_String;
function Get_Name (obj : in Generic_Message) return Unbounded_String;
function Get_Name (obj : in Generic_Message_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Message_Ptr) return Generic_Message_Ptr;
function Copy(obj : in Generic_Message) return Generic_Message_Ptr;
function type_of(obj : in Generic_Message) return unbounded_string_list;
function type_of(obj : in Generic_Message_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Generic_Message'Class, Generic_Message_Ptr);


-- --------= Periodic_Message =--------

type Periodic_Message is new Generic_Message with 
record
 period : Natural;
 jitter : Natural;
end record;

procedure Initialize(obj : in out Periodic_Message);
procedure Put(obj : in Periodic_Message);
procedure Put(obj : in Periodic_Message_Ptr);
procedure Put_Name(obj : in Periodic_Message_Ptr);
procedure Build_Attributes_XML_String(obj : in Periodic_Message; result : in out Unbounded_String);
function XML_String(obj : in Periodic_Message) return Unbounded_String;
function XML_String(obj : in Periodic_Message_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Periodic_Message) return Unbounded_String;
function XML_Ref_String(obj : in Periodic_Message_Ptr) return Unbounded_String;
function Get_Name (obj : in Periodic_Message) return Unbounded_String;
function Get_Name (obj : in Periodic_Message_Ptr) return Unbounded_String;
function Copy(obj : in Periodic_Message_Ptr) return Generic_Message_Ptr;
function Copy(obj : in Periodic_Message) return Generic_Message_Ptr;
function type_of(obj : in Periodic_Message) return unbounded_string_list;
function type_of(obj : in Periodic_Message_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Periodic_Message'Class, Periodic_Message_Ptr);


-- --------= Aperiodic_Message =--------

type Aperiodic_Message is new Generic_Message with null record;

procedure Initialize(obj : in out Aperiodic_Message);
procedure Put(obj : in Aperiodic_Message);
procedure Put(obj : in Aperiodic_Message_Ptr);
procedure Put_Name(obj : in Aperiodic_Message_Ptr);
procedure Build_Attributes_XML_String(obj : in Aperiodic_Message; result : in out Unbounded_String);
function XML_String(obj : in Aperiodic_Message) return Unbounded_String;
function XML_String(obj : in Aperiodic_Message_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Aperiodic_Message) return Unbounded_String;
function XML_Ref_String(obj : in Aperiodic_Message_Ptr) return Unbounded_String;
function Get_Name (obj : in Aperiodic_Message) return Unbounded_String;
function Get_Name (obj : in Aperiodic_Message_Ptr) return Unbounded_String;
function Copy(obj : in Aperiodic_Message_Ptr) return Generic_Message_Ptr;
function Copy(obj : in Aperiodic_Message) return Generic_Message_Ptr;
function type_of(obj : in Aperiodic_Message) return unbounded_string_list;
function type_of(obj : in Aperiodic_Message_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Aperiodic_Message'Class, Aperiodic_Message_Ptr);


End Messages;
