------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 15:09:39 +0200 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with tasks; use tasks;
with buffers; use buffers;
with Processors; use Processors;
with caches; use caches;
with resources; use resources;
with address_spaces; use address_spaces;
with messages; use messages;
with networks; use networks;
with core_units; use core_units;
with Event_Analyzers; use Event_Analyzers;
with task_groups; use Task_Groups;
with deployments; use deployments;

package body Objects.extended is

   function Is_A_Valid_Identifier (Id : Unbounded_String) return Boolean is
      Char : Character;

   begin

      for I in 1 .. Length (Id) loop

         Char := Element (Id, I);
         if Char /= 'a' and
            Char /= 'b' and
            Char /= 'c' and
            Char /= 'd' and
            Char /= 'e' and
            Char /= 'f' and
            Char /= 'g' and
            Char /= 'h' and
            Char /= 'i' and
            Char /= 'j' and
            Char /= 'h' and
            Char /= 'k' and
            Char /= 'l' and
            Char /= 'm' and
            Char /= 'n' and
            Char /= 'o' and
            Char /= 'p' and
            Char /= 'q' and
            Char /= 'r' and
            Char /= 's' and
            Char /= 't' and
            Char /= 'u' and
            Char /= 'v' and
            Char /= 'w' and
            Char /= 'x' and
            Char /= 'y' and
            Char /= 'z' and
            Char /= 'A' and
            Char /= 'B' and
            Char /= 'C' and
            Char /= 'D' and
            Char /= 'E' and
            Char /= 'F' and
            Char /= 'G' and
            Char /= 'H' and
            Char /= 'I' and
            Char /= 'J' and
            Char /= 'K' and
            Char /= 'L' and
            Char /= 'M' and
            Char /= 'N' and
            Char /= 'O' and
            Char /= 'P' and
            Char /= 'Q' and
            Char /= 'R' and
            Char /= 'S' and
            Char /= 'T' and
            Char /= 'U' and
            Char /= 'V' and
            Char /= 'W' and
            Char /= 'X' and
            Char /= 'Y' and
            Char /= 'Z' and
            Char /= '0' and
            Char /= '1' and
            Char /= '2' and
            Char /= '3' and
            Char /= '4' and
            Char /= '5' and
            Char /= '6' and
            Char /= '7' and
            Char /= '8' and
            Char /= '9' and
            Char /= '.' and
            Char /= '/' and
            Char /= '\' and
            Char /= '-' and
            Char /= ':' and
            Char /= '_'
         then
            return False;
         end if;
      end loop;

      return True;

   end Is_A_Valid_Identifier;


   function get_name_of_generic_object (obj :Generic_Object_Ptr) return 
   unbounded_string is
   begin
       return named_object(obj.all).name;
   end get_name_of_generic_object ;

end Objects.extended;
