
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with framework;
use framework;

with id_generators;
use id_generators;



Package Body Objects is 
 
function XML_String(obj : in Objects_Type) return Unbounded_String is
begin
	return to_unbounded_string(Objects_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Objects_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;



-- --------= Generic_Object =--------

procedure Initialize(obj : in out Generic_Object) is 
begin
	generate_id( framework_id, obj.cheddar_private_id );
	obj.object_type := Buffer_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Object ) return Generic_Object_Ptr is
	New_Generic_Object : Generic_Object_Ptr;
begin
	New_Generic_Object := new Generic_Object'(obj);
	return (New_Generic_Object);
end Copy;

function Copy ( obj : in Generic_Object_Ptr ) return Generic_Object_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Object) is 
begin
	put("cheddar_private_id: "); put(obj.cheddar_private_id); put ( "; " );
	put("object_type: "); put(obj.object_type); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Object_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Object_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Generic_Object ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Generic_Object_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Generic_Object; result : in out Unbounded_String) is 
begin
	if (XML_String(obj.object_type) /= Empty_String) then
		result := result & to_unbounded_string("<object_type>") & XML_String(obj.object_type) & to_unbounded_string("</object_type>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Object) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_object id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</generic_object>");
	return (result);
end XML_String;

function XML_String(obj : in Generic_Object_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Generic_Object) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_object ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Generic_Object_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Named_Object =--------

procedure Initialize(obj : in out Named_Object) is 
begin
	initialize(Generic_Object(obj));
	obj.name := empty_string;
end Initialize;

function Copy ( obj : in Named_Object ) return Generic_Object_Ptr is
	New_Named_Object : Named_Object_Ptr;
begin
	New_Named_Object := new Named_Object'(obj);
	return Generic_Object_Ptr(New_Named_Object);
end Copy;

function Copy ( obj : in Named_Object_Ptr ) return Generic_Object_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Named_Object) is 
begin
	put(Generic_Object(obj));
	put("name: "); put(obj.name); put ( "; " );
end Put;
 
procedure Put(obj : in Named_Object_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Named_Object_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Named_Object) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Named_Object_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Named_Object ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Named_Object_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Named_Object; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Object(obj), result);
	if (XML_String(obj.name) /= Empty_String) then
		result := result & to_unbounded_string("<name>") & XML_String(obj.name) & to_unbounded_string("</name>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Named_Object) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<named_object id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</named_object>");
	return (result);
end XML_String;

function XML_String(obj : in Named_Object_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Named_Object) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<named_object ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Named_Object_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Objects;
