
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

with id_generators;
use id_generators;

with Text_io;
use Text_io;

with Unbounded_Strings;
use Unbounded_Strings;

use unbounded_strings.Unbounded_String_List_Package;

with Convert_Strings;

with Convert_Unbounded_Strings;

with Ada.Finalization;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with Sets;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;



Package Objects is 
 
type Generic_Object; type Generic_Object_Ptr is access all Generic_Object'Class;
type Named_Object; type Named_Object_Ptr is access all Named_Object'Class;


type Objects_Type is (
	Buffer_Object_Type,
	Processor_Object_Type,
	Cache_Block_Object_Type,
	Cache_Object_Type,
	Task_Object_Type,
	Resource_Object_Type,
	Address_Space_Object_Type,
	Message_Object_Type,
	State_Object_Type,
	Transition_Object_Type,
	Statement_Object_Type,
	Expression_Object_Type,
	Synchronization_Object_Type,
	Section_Object_Type,
	Network_Object_Type,
	Connexion_Object_Type,
	Core_Object_Type,
	Event_Analyzer_Type,
	Deployment_Type,
	Task_Group_Object_Type,
	CFG_Node_Object_Type,
	CFG_Edge_Object_Type,
	CFG_Object_Type,
	Cache_Access_Profile_Object_Type);

procedure To_Objects_Type is
new Convert_Strings(Objects_Type, Buffer_Object_Type);
procedure To_Objects_Type is
new Convert_Unbounded_Strings(Objects_Type, Buffer_Object_Type);
function XML_String (obj : in Objects_Type) return Unbounded_String;
function XML_Ref_String (obj : in Objects_Type) return Unbounded_String;
package Objects_Type_io is new text_io.enumeration_io(Objects_Type);
use Objects_Type_io;



-- --------= Generic_Object =--------

type Generic_Object is new Ada.Finalization.Controlled with 
record
 cheddar_private_id : Unbounded_String;
 object_type : Objects_Type;
end record;

procedure Initialize(obj : in out Generic_Object);
procedure Put(obj : in Generic_Object);
procedure Put(obj : in Generic_Object_Ptr);
procedure Put_Name(obj : in Generic_Object_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Object; result : in out Unbounded_String);
function XML_String(obj : in Generic_Object) return Unbounded_String;
function XML_String(obj : in Generic_Object_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Object) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Object_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Object_Ptr) return Generic_Object_Ptr;
function Copy(obj : in Generic_Object) return Generic_Object_Ptr;
function type_of(obj : in Generic_Object) return unbounded_string_list;
function type_of(obj : in Generic_Object_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Generic_Object'Class, Generic_Object_Ptr);


-- --------= Named_Object =--------

type Named_Object is new Generic_Object with 
record
 name : Unbounded_String;
end record;

procedure Initialize(obj : in out Named_Object);
procedure Put(obj : in Named_Object);
procedure Put(obj : in Named_Object_Ptr);
procedure Put_Name(obj : in Named_Object_Ptr);
procedure Build_Attributes_XML_String(obj : in Named_Object; result : in out Unbounded_String);
function XML_String(obj : in Named_Object) return Unbounded_String;
function XML_String(obj : in Named_Object_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Named_Object) return Unbounded_String;
function XML_Ref_String(obj : in Named_Object_Ptr) return Unbounded_String;
function Get_Name (obj : in Named_Object) return Unbounded_String;
function Get_Name (obj : in Named_Object_Ptr) return Unbounded_String;
function Copy(obj : in Named_Object_Ptr) return Generic_Object_Ptr;
function Copy(obj : in Named_Object) return Generic_Object_Ptr;
function type_of(obj : in Named_Object) return unbounded_string_list;
function type_of(obj : in Named_Object_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Named_Object'Class, Named_Object_Ptr);

package Generic_Object_Set_Package is new Sets(Max_Element => Framework_Config.Max_Objects, Element => Generic_Object_Ptr, Free => Free, Copy => Copy, Put => Put, XML_String => XML_String, XML_Ref_String => XML_Ref_String);
use Generic_Object_Set_Package;
subtype Generic_Objects_Range is Generic_Object_Set_Package.element_range;
subtype Generic_Objects_Range_Ptr is  Generic_Object_Set_Package.element_range_Ptr;
subtype Generic_Objects_Set is Generic_Object_Set_Package.set;
subtype Generic_Objects_Set_Ptr is  Generic_Object_Set_Package.set_Ptr;


End Objects;
