with ada.Exceptions; use ada.exceptions;
with objects.extended; use objects.extended;
with translate; use translate;
with framework_config; use framework_config;


package body parameters.extended is 

procedure check_parameters(Param : in User_Defined_Parameters_Table;
                component_name : unbounded_string) is

begin  
      for I in 0 .. param.nb_entries - 1 loop

         if param.entries (I).parameter_name = "" then
            Raise_Exception
              (Invalid_Parameter'Identity,
               To_String
                 (component_name &
                    " : " &
                Lb_User_Defined_Parameter (Current_Language) & " "  &
		Lb_Name(Current_Language) & " " &
                Lb_Mandatory (Current_Language)));
         end if;

 if not Is_A_Valid_Identifier (param.entries (I).parameter_name) then
         Raise_Exception
           (Invalid_Parameter'Identity,
            To_String
                 (component_name &
                " : " &
                Lb_User_Defined_Parameter (Current_Language) & " "  &
		Lb_Name(Current_Language) &
                Lb_Colon &
                Lb_Invalid_Identifier (Current_Language)));
      end if;

    end loop;

end check_parameters;

end parameters.extended;


