
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;



Package Body Parameters is 
 
function XML_String(obj : in Parameter_Type) return Unbounded_String is
begin
	return to_unbounded_string(Parameter_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Parameter_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;


procedure Initialize (obj : out Parameter_Ptr) is
begin
	obj := NULL;
end Initialize;
 
procedure Put(obj : in Parameter_Ptr) is
begin
	if (obj /= NULL) then
		put("parameter_name: "); put(obj.parameter_name); put ( "; " );
		put("type_of_parameter: "); put(obj.type_of_parameter); put ( "; " );
		put ( "value: " );
		case obj.type_of_parameter is 
			when boolean_parameter => 
				put("boolean_value: "); standards_io.boolean_io.put(obj.boolean_value); put ( "; " );

			when integer_parameter => 
				put("integer_value: "); standards_io.natural_io.put(obj.integer_value); put ( "; " );

			when double_parameter => 
				put("double_value: "); standards_io.double_io.put(obj.double_value); put ( "; " );

			when string_parameter => 
				put("string_value: "); put(obj.string_value); put ( "; " );

		end case;
	end if;
	New_Line;
end Put;

function Copy ( obj : in Parameter ) return Parameter_Ptr is
	New_Parameter : Parameter_Ptr;
begin
	New_Parameter := new Parameter'(obj);
	return (New_Parameter);
end Copy;

function Copy ( obj : in Parameter_Ptr ) return Parameter_Ptr is
begin
	return copy(obj.all);
end Copy;

function XML_String(obj : in Parameter) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<parameter>");
			if (XML_String(obj.parameter_name) /= Empty_String) then
		result := result & to_unbounded_string("<parameter_name>") & XML_String(obj.parameter_name) & to_unbounded_string("</parameter_name>");
	end if;
	if (XML_String(obj.type_of_parameter) /= Empty_String) then
		result := result & to_unbounded_string("<type_of_parameter>") & XML_String(obj.type_of_parameter) & to_unbounded_string("</type_of_parameter>");
	end if;

	case obj.type_of_parameter is 
		when boolean_parameter => 
			if (XML_String(obj.boolean_value) /= Empty_String) then
		result := result & to_unbounded_string("<boolean_value>") & XML_String(obj.boolean_value) & to_unbounded_string("</boolean_value>");
	end if;

		when integer_parameter => 
			if (XML_String(obj.integer_value) /= Empty_String) then
		result := result & to_unbounded_string("<integer_value>") & XML_String(obj.integer_value) & to_unbounded_string("</integer_value>");
	end if;

		when double_parameter => 
			if (XML_String(obj.double_value) /= Empty_String) then
		result := result & to_unbounded_string("<double_value>") & XML_String(obj.double_value) & to_unbounded_string("</double_value>");
	end if;

		when string_parameter => 
			if (XML_String(obj.string_value) /= Empty_String) then
		result := result & to_unbounded_string("<string_value>") & XML_String(obj.string_value) & to_unbounded_string("</string_value>");
	end if;

	end case;
	result := result & to_unbounded_string("</parameter>");
	return (result);
end XML_String;

function XML_String(obj : in Parameter_Ptr) return Unbounded_String is
begin
	return XML_String(obj.all);
end XML_String;

function XML_Ref_String(obj : in Parameter) return Unbounded_String is
	result : Unbounded_String;
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;
function XML_Ref_String(obj : in Parameter_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;



End Parameters;
