
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with processor_interface;

use processor_interface.Processors_type_io;

use processor_interface.migrations_type_io;

with Core_Units;
use Core_Units;

use Core_Units.Core_Units_Table_Package;



Package Body Processors is 
 

-- --------= Generic_Processor =--------

procedure Initialize(obj : in out Generic_Processor) is 
begin
	initialize(Named_Object(obj));
	obj.network_name := empty_string;
	obj.processor_type := Monocore_type;
	obj.migration_type := No_Migration_Type;
	obj.object_type := Processor_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Processor ) return Generic_Processor_Ptr is
	New_Generic_Processor : Generic_Processor_Ptr;
begin
	New_Generic_Processor := new Generic_Processor'(obj);
	return (New_Generic_Processor);
end Copy;

function Copy ( obj : in Generic_Processor_Ptr ) return Generic_Processor_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Processor) is 
begin
	put(Named_Object(obj));
	put("network_name: "); put(obj.network_name); put ( "; " );
	put("processor_type: "); put(obj.processor_type); put ( "; " );
	put("migration_type: "); put(obj.migration_type); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Processor_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Processor_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Processor) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Processor_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Generic_Processor ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("PROCESSORS.GENERIC_PROCESSOR");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Generic_Processor_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Generic_Processor; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Named_Object(obj), result);
	if (XML_String(obj.network_name) /= Empty_String) then
		result := result & to_unbounded_string("<network_name>") & XML_String(obj.network_name) & to_unbounded_string("</network_name>");
	end if;
	if (XML_String(obj.processor_type) /= Empty_String) then
		result := result & to_unbounded_string("<processor_type>") & XML_String(obj.processor_type) & to_unbounded_string("</processor_type>");
	end if;
	if (XML_String(obj.migration_type) /= Empty_String) then
		result := result & to_unbounded_string("<migration_type>") & XML_String(obj.migration_type) & to_unbounded_string("</migration_type>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Processor) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_processor id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</generic_processor>");
	return (result);
end XML_String;

function XML_String(obj : in Generic_Processor_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Generic_Processor) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_processor ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Generic_Processor_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Mono_Core_Processor =--------

procedure Initialize(obj : in out Mono_Core_Processor) is 
begin
	initialize(Generic_Processor(obj));
end Initialize;

function Copy ( obj : in Mono_Core_Processor ) return Generic_Processor_Ptr is
	New_Mono_Core_Processor : Mono_Core_Processor_Ptr;
begin
	New_Mono_Core_Processor := new Mono_Core_Processor'(obj);
	return Generic_Processor_Ptr(New_Mono_Core_Processor);
end Copy;

function Copy ( obj : in Mono_Core_Processor_Ptr ) return Generic_Processor_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Mono_Core_Processor) is 
begin
	put(Generic_Processor(obj));
	put("core: "); if obj.core /= null then put(obj.core.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Mono_Core_Processor_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Mono_Core_Processor_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Mono_Core_Processor) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Mono_Core_Processor_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Mono_Core_Processor ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("PROCESSORS.GENERIC_PROCESSOR");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("PROCESSORS.MONO_CORE_PROCESSOR");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Mono_Core_Processor_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Mono_Core_Processor; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Processor(obj), result);
	result := result & to_unbounded_string("<core ref=""") & obj.core.cheddar_private_id & to_unbounded_string(""" />");
end Build_Attributes_XML_String;

function XML_String(obj : in Mono_Core_Processor) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<mono_core_processor id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</mono_core_processor>");
	return (result);
end XML_String;

function XML_String(obj : in Mono_Core_Processor_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Mono_Core_Processor) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<mono_core_processor ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Mono_Core_Processor_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Multi_Cores_Processor =--------

procedure Initialize(obj : in out Multi_Cores_Processor) is 
begin
	initialize(Generic_Processor(obj));
	obj.l2_cache_system_name := empty_string;
end Initialize;

function Copy ( obj : in Multi_Cores_Processor ) return Generic_Processor_Ptr is
	New_Multi_Cores_Processor : Multi_Cores_Processor_Ptr;
begin
	New_Multi_Cores_Processor := new Multi_Cores_Processor'(obj);
	return Generic_Processor_Ptr(New_Multi_Cores_Processor);
end Copy;

function Copy ( obj : in Multi_Cores_Processor_Ptr ) return Generic_Processor_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Multi_Cores_Processor) is 
begin
	put(Generic_Processor(obj));
	put("cores: "); put(obj.cores); put ( "; " );
	put("l2_cache_system_name: "); put(obj.l2_cache_system_name); put ( "; " );
end Put;
 
procedure Put(obj : in Multi_Cores_Processor_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Multi_Cores_Processor_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Multi_Cores_Processor) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Multi_Cores_Processor_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Multi_Cores_Processor ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("PROCESSORS.GENERIC_PROCESSOR");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("PROCESSORS.MULTI_CORES_PROCESSOR");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Multi_Cores_Processor_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Multi_Cores_Processor; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Processor(obj), result);
	if (XML_String(obj.cores) /= Empty_String) then
		result := result & to_unbounded_string("<cores>") & XML_String(obj.cores) & to_unbounded_string("</cores>");
	end if;
	if (XML_String(obj.l2_cache_system_name) /= Empty_String) then
		result := result & to_unbounded_string("<l2_cache_system_name>") & XML_String(obj.l2_cache_system_name) & to_unbounded_string("</l2_cache_system_name>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Multi_Cores_Processor) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<multi_cores_processor id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</multi_cores_processor>");
	return (result);
end XML_String;

function XML_String(obj : in Multi_Cores_Processor_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Multi_Cores_Processor) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<multi_cores_processor ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Multi_Cores_Processor_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Processors;
