
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;



Package Body Resources is 
 
function XML_String(obj : in Resources_Type) return Unbounded_String is
begin
	return to_unbounded_string(Resources_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Resources_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;


function XML_String(obj : in Priority_Assignment_Type) return Unbounded_String is
begin
	return to_unbounded_string(Priority_Assignment_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Priority_Assignment_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;



-- --------= Critical_Section =--------

procedure Initialize(obj : out Critical_Section) is 
begin
	obj.task_begin := 0;
	obj.task_end := 0;
end Initialize;

procedure Put(obj : in Critical_Section) is 
begin
	put("task_begin: "); standards_io.natural_io.put(obj.task_begin); put ( "; " );
	put("task_end: "); standards_io.natural_io.put(obj.task_end); put ( "; " );
end Put;
 
procedure Put(obj : in Critical_Section_Ptr) is
begin
	Put(Obj.All);
end Put;


procedure Build_Attributes_XML_String(obj : in Critical_Section; result : in out Unbounded_String) is 
begin
	if (XML_String(obj.task_begin) /= Empty_String) then
		result := result & to_unbounded_string("<task_begin>") & XML_String(obj.task_begin) & to_unbounded_string("</task_begin>");
	end if;
	if (XML_String(obj.task_end) /= Empty_String) then
		result := result & to_unbounded_string("<task_end>") & XML_String(obj.task_end) & to_unbounded_string("</task_end>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Critical_Section) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<critical_section>");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</critical_section>");
	return (result);
end XML_String;

function XML_String(obj : in Critical_Section_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Critical_Section) return Unbounded_String is
	result : Unbounded_String;
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;

function Copy ( obj : in Critical_Section ) return Critical_Section_Ptr is
	New_Critical_Section : Critical_Section_Ptr;
begin
	New_Critical_Section := new Critical_Section'(obj);
	return (New_Critical_Section);
end Copy;

function Copy ( obj : in Critical_Section_Ptr ) return Critical_Section_Ptr is
begin
	return copy(obj.all);
end Copy;



-- --------= Generic_Resource =--------

procedure Initialize(obj : in out Generic_Resource) is 
begin
	initialize(Named_Object(obj));
	obj.state := 0;
	obj.size := 0;
	obj.address := 0;
	obj.protocol := No_Protocol;
	obj.cpu_name := empty_string;
	obj.address_space_name := empty_string;
	obj.priority := 0;
	obj.priority_assignment := Automatic_Assignment;
	obj.object_type := Resource_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Resource ) return Generic_Resource_Ptr is
	New_Generic_Resource : Generic_Resource_Ptr;
begin
	New_Generic_Resource := new Generic_Resource'(obj);
	return (New_Generic_Resource);
end Copy;

function Copy ( obj : in Generic_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Resource) is 
begin
	put(Named_Object(obj));
	put("state: "); standards_io.natural_io.put(obj.state); put ( "; " );
	put("size: "); standards_io.natural_io.put(obj.size); put ( "; " );
	put("address: "); standards_io.natural_io.put(obj.address); put ( "; " );
	put("protocol: "); put(obj.protocol); put ( "; " );
	put("critical_sections: "); put(obj.critical_sections); put ( "; " );
	put("cpu_name: "); put(obj.cpu_name); put ( "; " );
	put("address_space_name: "); put(obj.address_space_name); put ( "; " );
	put("priority: "); put(obj.priority); put ( "; " );
	put("priority_assignment: "); put(obj.priority_assignment); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Generic_Resource ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("RESOURCES.GENERIC_RESOURCE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Generic_Resource_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Generic_Resource; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Named_Object(obj), result);
	if (XML_String(obj.state) /= Empty_String) then
		result := result & to_unbounded_string("<state>") & XML_String(obj.state) & to_unbounded_string("</state>");
	end if;
	if (XML_String(obj.size) /= Empty_String) then
		result := result & to_unbounded_string("<size>") & XML_String(obj.size) & to_unbounded_string("</size>");
	end if;
	if (XML_String(obj.address) /= Empty_String) then
		result := result & to_unbounded_string("<address>") & XML_String(obj.address) & to_unbounded_string("</address>");
	end if;
	if (XML_String(obj.protocol) /= Empty_String) then
		result := result & to_unbounded_string("<protocol>") & XML_String(obj.protocol) & to_unbounded_string("</protocol>");
	end if;
	if (XML_String(obj.critical_sections) /= Empty_String) then
		result := result & to_unbounded_string("<critical_sections>") & XML_String(obj.critical_sections) & to_unbounded_string("</critical_sections>");
	end if;
	if (XML_String(obj.cpu_name) /= Empty_String) then
		result := result & to_unbounded_string("<cpu_name>") & XML_String(obj.cpu_name) & to_unbounded_string("</cpu_name>");
	end if;
	if (XML_String(obj.address_space_name) /= Empty_String) then
		result := result & to_unbounded_string("<address_space_name>") & XML_String(obj.address_space_name) & to_unbounded_string("</address_space_name>");
	end if;
	if (XML_String(obj.priority) /= Empty_String) then
		result := result & to_unbounded_string("<priority>") & XML_String(obj.priority) & to_unbounded_string("</priority>");
	end if;
	if (XML_String(obj.priority_assignment) /= Empty_String) then
		result := result & to_unbounded_string("<priority_assignment>") & XML_String(obj.priority_assignment) & to_unbounded_string("</priority_assignment>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_resource id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</generic_resource>");
	return (result);
end XML_String;

function XML_String(obj : in Generic_Resource_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Generic_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_resource ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Generic_Resource_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Np_Resource =--------

procedure Initialize(obj : in out Np_Resource) is 
begin
	initialize(Generic_Resource(obj));
end Initialize;

function Copy ( obj : in Np_Resource ) return Generic_Resource_Ptr is
	New_Np_Resource : Np_Resource_Ptr;
begin
	New_Np_Resource := new Np_Resource'(obj);
	return Generic_Resource_Ptr(New_Np_Resource);
end Copy;

function Copy ( obj : in Np_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Np_Resource) is 
begin
	put(Generic_Resource(obj));
end Put;
 
procedure Put(obj : in Np_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Np_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Np_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Np_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Np_Resource ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("RESOURCES.GENERIC_RESOURCE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("RESOURCES.NP_RESOURCE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Np_Resource_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Np_Resource; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Resource(obj), result);
end Build_Attributes_XML_String;

function XML_String(obj : in Np_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<np_resource id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</np_resource>");
	return (result);
end XML_String;

function XML_String(obj : in Np_Resource_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Np_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<np_resource ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Np_Resource_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Pip_Resource =--------

procedure Initialize(obj : in out Pip_Resource) is 
begin
	initialize(Generic_Resource(obj));
	obj.protocol := Priority_Inheritance_Protocol;
end Initialize;

function Copy ( obj : in Pip_Resource ) return Generic_Resource_Ptr is
	New_Pip_Resource : Pip_Resource_Ptr;
begin
	New_Pip_Resource := new Pip_Resource'(obj);
	return Generic_Resource_Ptr(New_Pip_Resource);
end Copy;

function Copy ( obj : in Pip_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Pip_Resource) is 
begin
	put(Generic_Resource(obj));
end Put;
 
procedure Put(obj : in Pip_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Pip_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Pip_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Pip_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Pip_Resource ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("RESOURCES.GENERIC_RESOURCE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("RESOURCES.PIP_RESOURCE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Pip_Resource_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Pip_Resource; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Resource(obj), result);
end Build_Attributes_XML_String;

function XML_String(obj : in Pip_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<pip_resource id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</pip_resource>");
	return (result);
end XML_String;

function XML_String(obj : in Pip_Resource_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Pip_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<pip_resource ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Pip_Resource_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Pcp_Resource =--------

procedure Initialize(obj : in out Pcp_Resource) is 
begin
	initialize(Generic_Resource(obj));
	obj.protocol := Priority_Ceiling_Protocol;
end Initialize;

function Copy ( obj : in Pcp_Resource ) return Generic_Resource_Ptr is
	New_Pcp_Resource : Pcp_Resource_Ptr;
begin
	New_Pcp_Resource := new Pcp_Resource'(obj);
	return Generic_Resource_Ptr(New_Pcp_Resource);
end Copy;

function Copy ( obj : in Pcp_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Pcp_Resource) is 
begin
	put(Generic_Resource(obj));
end Put;
 
procedure Put(obj : in Pcp_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Pcp_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Pcp_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Pcp_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Pcp_Resource ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("RESOURCES.GENERIC_RESOURCE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("RESOURCES.PCP_RESOURCE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Pcp_Resource_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Pcp_Resource; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Resource(obj), result);
end Build_Attributes_XML_String;

function XML_String(obj : in Pcp_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<pcp_resource id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</pcp_resource>");
	return (result);
end XML_String;

function XML_String(obj : in Pcp_Resource_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Pcp_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<pcp_resource ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Pcp_Resource_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= IPcp_Resource =--------

procedure Initialize(obj : in out IPcp_Resource) is 
begin
	initialize(Generic_Resource(obj));
	obj.protocol := Immediate_Priority_Ceiling_Protocol;
end Initialize;

function Copy ( obj : in IPcp_Resource ) return Generic_Resource_Ptr is
	New_IPcp_Resource : IPcp_Resource_Ptr;
begin
	New_IPcp_Resource := new IPcp_Resource'(obj);
	return Generic_Resource_Ptr(New_IPcp_Resource);
end Copy;

function Copy ( obj : in IPcp_Resource_Ptr ) return Generic_Resource_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in IPcp_Resource) is 
begin
	put(Generic_Resource(obj));
end Put;
 
procedure Put(obj : in IPcp_Resource_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in IPcp_Resource_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in IPcp_Resource) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in IPcp_Resource_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in IPcp_Resource ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("RESOURCES.GENERIC_RESOURCE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("RESOURCES.IPCP_RESOURCE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in IPcp_Resource_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in IPcp_Resource; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Resource(obj), result);
end Build_Attributes_XML_String;

function XML_String(obj : in IPcp_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<ipcp_resource id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</ipcp_resource>");
	return (result);
end XML_String;

function XML_String(obj : in IPcp_Resource_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in IPcp_Resource) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<ipcp_resource ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in IPcp_Resource_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Resources;
