
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;



Package Body Task_Groups is 
 
function XML_String(obj : in Task_Groups_type) return Unbounded_String is
begin
	return to_unbounded_string(Task_Groups_type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Task_Groups_type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;



-- --------= Generic_Task_Group =--------

procedure Initialize(obj : in out Generic_Task_Group) is 
begin
	initialize(Named_Object(obj));
	obj.task_group_type := Transaction_Type;
	obj.deadline := 0;
	obj.start_time := 0;
	obj.priority := 0;
	obj.criticality := 0;
	obj.period := 0;
	obj.jitter := 0;
	obj.object_type := Task_Group_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Task_Group ) return Generic_Task_Group_Ptr is
	New_Generic_Task_Group : Generic_Task_Group_Ptr;
begin
	New_Generic_Task_Group := new Generic_Task_Group'(obj);
	return (New_Generic_Task_Group);
end Copy;

function Copy ( obj : in Generic_Task_Group_Ptr ) return Generic_Task_Group_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Task_Group) is 
begin
	put(Named_Object(obj));
	put("task_list: "); put(obj.task_list); put ( "; " );
	put("task_group_type: "); put(obj.task_group_type); put ( "; " );
	put("deadline: "); standards_io.natural_io.put(obj.deadline); put ( "; " );
	put("start_time: "); standards_io.natural_io.put(obj.start_time); put ( "; " );
	put("priority: "); put(obj.priority); put ( "; " );
	put("criticality: "); standards_io.natural_io.put(obj.criticality); put ( "; " );
	put("period: "); standards_io.natural_io.put(obj.period); put ( "; " );
	put("jitter: "); standards_io.natural_io.put(obj.jitter); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Task_Group_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Task_Group_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Task_Group) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Task_Group_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Generic_Task_Group ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("TASK_GROUPS.GENERIC_TASK_GROUP");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Generic_Task_Group_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Generic_Task_Group; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Named_Object(obj), result);
	if (XML_String(obj.task_list) /= Empty_String) then
		result := result & to_unbounded_string("<task_list>") & XML_String(obj.task_list) & to_unbounded_string("</task_list>");
	end if;
	if (XML_String(obj.task_group_type) /= Empty_String) then
		result := result & to_unbounded_string("<task_group_type>") & XML_String(obj.task_group_type) & to_unbounded_string("</task_group_type>");
	end if;
	if (XML_String(obj.deadline) /= Empty_String) then
		result := result & to_unbounded_string("<deadline>") & XML_String(obj.deadline) & to_unbounded_string("</deadline>");
	end if;
	if (XML_String(obj.start_time) /= Empty_String) then
		result := result & to_unbounded_string("<start_time>") & XML_String(obj.start_time) & to_unbounded_string("</start_time>");
	end if;
	if (XML_String(obj.priority) /= Empty_String) then
		result := result & to_unbounded_string("<priority>") & XML_String(obj.priority) & to_unbounded_string("</priority>");
	end if;
	if (XML_String(obj.criticality) /= Empty_String) then
		result := result & to_unbounded_string("<criticality>") & XML_String(obj.criticality) & to_unbounded_string("</criticality>");
	end if;
	if (XML_String(obj.period) /= Empty_String) then
		result := result & to_unbounded_string("<period>") & XML_String(obj.period) & to_unbounded_string("</period>");
	end if;
	if (XML_String(obj.jitter) /= Empty_String) then
		result := result & to_unbounded_string("<jitter>") & XML_String(obj.jitter) & to_unbounded_string("</jitter>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Task_Group) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_task_group id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</generic_task_group>");
	return (result);
end XML_String;

function XML_String(obj : in Generic_Task_Group_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Generic_Task_Group) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_task_group ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Generic_Task_Group_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Transaction_Task_Group =--------

procedure Initialize(obj : in out Transaction_Task_Group) is 
begin
	initialize(Generic_Task_Group(obj));
	obj.task_group_type := Transaction_Type;
end Initialize;

function Copy ( obj : in Transaction_Task_Group ) return Generic_Task_Group_Ptr is
	New_Transaction_Task_Group : Transaction_Task_Group_Ptr;
begin
	New_Transaction_Task_Group := new Transaction_Task_Group'(obj);
	return Generic_Task_Group_Ptr(New_Transaction_Task_Group);
end Copy;

function Copy ( obj : in Transaction_Task_Group_Ptr ) return Generic_Task_Group_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Transaction_Task_Group) is 
begin
	put(Generic_Task_Group(obj));
end Put;
 
procedure Put(obj : in Transaction_Task_Group_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Transaction_Task_Group_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Transaction_Task_Group) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Transaction_Task_Group_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Transaction_Task_Group ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("TASK_GROUPS.GENERIC_TASK_GROUP");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("TASK_GROUPS.TRANSACTION_TASK_GROUP");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Transaction_Task_Group_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Transaction_Task_Group; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Task_Group(obj), result);
end Build_Attributes_XML_String;

function XML_String(obj : in Transaction_Task_Group) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<transaction_task_group id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</transaction_task_group>");
	return (result);
end XML_String;

function XML_String(obj : in Transaction_Task_Group_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Transaction_Task_Group) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<transaction_task_group ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Transaction_Task_Group_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Multiframe_Task_Group =--------

procedure Initialize(obj : in out Multiframe_Task_Group) is 
begin
	initialize(Generic_Task_Group(obj));
	obj.task_group_type := Multiframe_Type;
end Initialize;

function Copy ( obj : in Multiframe_Task_Group ) return Generic_Task_Group_Ptr is
	New_Multiframe_Task_Group : Multiframe_Task_Group_Ptr;
begin
	New_Multiframe_Task_Group := new Multiframe_Task_Group'(obj);
	return Generic_Task_Group_Ptr(New_Multiframe_Task_Group);
end Copy;

function Copy ( obj : in Multiframe_Task_Group_Ptr ) return Generic_Task_Group_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Multiframe_Task_Group) is 
begin
	put(Generic_Task_Group(obj));
end Put;
 
procedure Put(obj : in Multiframe_Task_Group_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Multiframe_Task_Group_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Multiframe_Task_Group) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Multiframe_Task_Group_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Multiframe_Task_Group ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("TASK_GROUPS.GENERIC_TASK_GROUP");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("TASK_GROUPS.MULTIFRAME_TASK_GROUP");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Multiframe_Task_Group_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Multiframe_Task_Group; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Task_Group(obj), result);
end Build_Attributes_XML_String;

function XML_String(obj : in Multiframe_Task_Group) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<multiframe_task_group id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</multiframe_task_group>");
	return (result);
end XML_String;

function XML_String(obj : in Multiframe_Task_Group_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Multiframe_Task_Group) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<multiframe_task_group ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Multiframe_Task_Group_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Task_Groups;
