
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

use Framework_Config.Priority_Io;

with id_generators;
use id_generators;

with Objects;
use Objects;

with Tasks;
use Tasks;

use Tasks.Generic_Task_List_Package;

with Offsets;
use Offsets;

with Parameters;
use Parameters;

with standards_io;
use standards_io;

use standards_io.natural_io;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with Ada.Finalization;

with unbounded_strings;
use unbounded_strings;

use unbounded_strings.Unbounded_String_List_Package;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;



Package Task_Groups is 
 
type Generic_Task_Group; type Generic_Task_Group_Ptr is access all Generic_Task_Group'Class;
type Transaction_Task_Group; type Transaction_Task_Group_Ptr is access all Transaction_Task_Group'Class;
type Multiframe_Task_Group; type Multiframe_Task_Group_Ptr is access all Multiframe_Task_Group'Class;


type Task_Groups_type is (
	Transaction_Type,
	Multiframe_Type);

procedure To_Task_Groups_type is
new Convert_Strings(Task_Groups_type, Transaction_Type);
procedure To_Task_Groups_type is
new Convert_Unbounded_Strings(Task_Groups_type, Transaction_Type);
function XML_String (obj : in Task_Groups_type) return Unbounded_String;
function XML_Ref_String (obj : in Task_Groups_type) return Unbounded_String;
package Task_Groups_type_io is new text_io.enumeration_io(Task_Groups_type);
use Task_Groups_type_io;



-- --------= Generic_Task_Group =--------

type Generic_Task_Group is new Named_Object with 
record
 task_list : Generic_Task_List;
 task_group_type : Task_Groups_type;
 deadline : Natural;
 start_time : Natural;
 priority : Priority_Range;
 criticality : Natural;
 period : Natural;
 jitter : Natural;
end record;

procedure Initialize(obj : in out Generic_Task_Group);
procedure Put(obj : in Generic_Task_Group);
procedure Put(obj : in Generic_Task_Group_Ptr);
procedure Put_Name(obj : in Generic_Task_Group_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Task_Group; result : in out Unbounded_String);
function XML_String(obj : in Generic_Task_Group) return Unbounded_String;
function XML_String(obj : in Generic_Task_Group_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Task_Group) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Task_Group_Ptr) return Unbounded_String;
function Get_Name (obj : in Generic_Task_Group) return Unbounded_String;
function Get_Name (obj : in Generic_Task_Group_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Task_Group_Ptr) return Generic_Task_Group_Ptr;
function Copy(obj : in Generic_Task_Group) return Generic_Task_Group_Ptr;
function type_of(obj : in Generic_Task_Group) return unbounded_string_list;
function type_of(obj : in Generic_Task_Group_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Generic_Task_Group'Class, Generic_Task_Group_Ptr);


-- --------= Transaction_Task_Group =--------

type Transaction_Task_Group is new Generic_Task_Group with null record;

procedure Initialize(obj : in out Transaction_Task_Group);
procedure Put(obj : in Transaction_Task_Group);
procedure Put(obj : in Transaction_Task_Group_Ptr);
procedure Put_Name(obj : in Transaction_Task_Group_Ptr);
procedure Build_Attributes_XML_String(obj : in Transaction_Task_Group; result : in out Unbounded_String);
function XML_String(obj : in Transaction_Task_Group) return Unbounded_String;
function XML_String(obj : in Transaction_Task_Group_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Transaction_Task_Group) return Unbounded_String;
function XML_Ref_String(obj : in Transaction_Task_Group_Ptr) return Unbounded_String;
function Get_Name (obj : in Transaction_Task_Group) return Unbounded_String;
function Get_Name (obj : in Transaction_Task_Group_Ptr) return Unbounded_String;
function Copy(obj : in Transaction_Task_Group_Ptr) return Generic_Task_Group_Ptr;
function Copy(obj : in Transaction_Task_Group) return Generic_Task_Group_Ptr;
function type_of(obj : in Transaction_Task_Group) return unbounded_string_list;
function type_of(obj : in Transaction_Task_Group_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Transaction_Task_Group'Class, Transaction_Task_Group_Ptr);


-- --------= Multiframe_Task_Group =--------

type Multiframe_Task_Group is new Generic_Task_Group with null record;

procedure Initialize(obj : in out Multiframe_Task_Group);
procedure Put(obj : in Multiframe_Task_Group);
procedure Put(obj : in Multiframe_Task_Group_Ptr);
procedure Put_Name(obj : in Multiframe_Task_Group_Ptr);
procedure Build_Attributes_XML_String(obj : in Multiframe_Task_Group; result : in out Unbounded_String);
function XML_String(obj : in Multiframe_Task_Group) return Unbounded_String;
function XML_String(obj : in Multiframe_Task_Group_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Multiframe_Task_Group) return Unbounded_String;
function XML_Ref_String(obj : in Multiframe_Task_Group_Ptr) return Unbounded_String;
function Get_Name (obj : in Multiframe_Task_Group) return Unbounded_String;
function Get_Name (obj : in Multiframe_Task_Group_Ptr) return Unbounded_String;
function Copy(obj : in Multiframe_Task_Group_Ptr) return Generic_Task_Group_Ptr;
function Copy(obj : in Multiframe_Task_Group) return Generic_Task_Group_Ptr;
function type_of(obj : in Multiframe_Task_Group) return unbounded_string_list;
function type_of(obj : in Multiframe_Task_Group_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Multiframe_Task_Group'Class, Multiframe_Task_Group_Ptr);


End Task_Groups;
