------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 534 $
--    $Date: 2012-10-05 19:46:28 +0200 (Fri, 05 Oct 2012) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
package body Tasks.Extended is

   procedure Put (My_Task_Occurence : in Task_Occurence) is

   begin

      Put ("Arrival_time : " & My_Task_Occurence.Arrival_time'Img & " ; ");
      Put ("Absolute_Deadline : " & My_Task_Occurence.Absolute_Deadline'Img);
      Put ("Response_Time : " & My_Task_Occurence.Response_Time'Img);
   end Put;

   procedure Initialize
     (My_Task_Occurence : in out Task_Occurence;
      A_Task            : in Generic_Task_Ptr;
      Arrival_time      : in Natural := 0)
   is
   begin
      My_Task_Occurence.Analyzed_Task     := A_Task;
      My_Task_Occurence.Arrival_time      := Arrival_time;
      My_Task_Occurence.completion_time   := 0;
      My_Task_Occurence.Absolute_Deadline := My_Task_Occurence.Arrival_time +
                                             A_Task.deadline;

   end Initialize;

   function XML_ref_String (e : in Task_Occurence) return Unbounded_String is
   begin
      raise XML_Ref_String_Error;
      return To_Unbounded_String ("");
   end XML_ref_String;

   function XML_String (e : in Task_Occurence) return Unbounded_String is
   begin
      raise XML_String_Error;
      return To_Unbounded_String ("");
   end XML_String;

   function Copy ( obj : in Extended_Periodic_Task ) return Generic_Task_Ptr is
      New_Extended_Periodic_Task : Extended_Periodic_Task_Ptr;
   begin
      New_Extended_Periodic_Task := new Extended_Periodic_Task'(obj);
      return Generic_Task_Ptr(New_Extended_Periodic_Task);
   end Copy;

   function Copy ( obj : in Extended_Periodic_Task_Ptr ) return Generic_Task_Ptr is
   begin
      return copy(obj.all);
   end Copy;

end Tasks.Extended;
