------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 15:09:39 +0200 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Text_IO;          use Text_IO;
with Framework_Config; use Framework_Config;
with natural_util;     use natural_util;

package body Debug is

   procedure Put_Debug
     (Str   : in Unbounded_String;
      level : debug_level := very_verbose;
      File  : in String   := GNAT.Source_Info.File;
      Line  : in Natural  := GNAT.Source_Info.Line)
   is
   begin
      put_debug(to_string(str), level, file, line);
   end Put_Debug;

   procedure Put_Debug
     (Str   : in String;
      level : debug_level := very_verbose;
      File  : in String   := GNAT.Source_Info.File;
      Line  : in Natural  := GNAT.Source_Info.Line)
   is
   begin
      if Cheddar_Debug /= no_debug then
         if debug_level'Pos (Cheddar_Debug) >= debug_level'Pos (level) then
            Put_Line (File & ":" & To_String (format (Line)) & ":" & Str);
         end if;
      end if;
   end Put_Debug;

end Debug;
