with Ada.IO_Exceptions;use Ada.IO_Exceptions;
with GNAT.Current_Exception; use GNAT.Current_Exception;
with unbounded_strings;      use unbounded_strings;
with GNAT.Command_Line;      use GNAT.Command_Line;
with GNAT.OS_Lib;            use GNAT.OS_Lib;
with Text_IO;                use Text_IO;
with Version;                use Version;
with Ada.Strings.Unbounded;  use Ada.Strings.Unbounded;
with Systems;                use Systems;
with Dependencies;           use Dependencies;
with Task_Dependencies;      use Task_Dependencies;
with Task_Set;               use Task_Set;
use Task_Set.Generic_Task_Set;
use Task_Dependencies.Half_Dep_Set;
with Processor_Set;          use Processor_Set;
use Processor_Set.Generic_Processor_Set;
with Address_Space_Set;      use Address_Space_Set;
use Address_Space_Set.Generic_Address_Space_Set;
with Resource_Set;           use Resource_Set;
use Resource_Set.Generic_Resource_Set;
with Resources;              use Resources;
with Buffer_Set;             use Buffer_Set;
use Buffer_Set.Generic_Buffer_Set;
with Call_Framework;         use Call_Framework;
with Tasks;                  use Tasks;
with Address_Spaces;         use Address_Spaces;
with unbounded_strings;      use unbounded_strings;
use unbounded_strings.unbounded_string_list_package;
with Debug;                  use Debug;
with Translate;              use Translate;

package body applicability_constraint.allowed_protocol is

   function R11_QUERY1_Condition (r1 : Generic_Resource_Ptr) return Boolean is
   begin

      return (not ((r1.protocol = Priority_Ceiling_Protocol) or
                   (r1.protocol = Priority_Inheritance_Protocol) or
                   (r1.protocol = Immediate_Priority_Ceiling_Protocol)));

   end R11_QUERY1_Condition;

   function R11 (Sys : System) return Boolean is
   begin
      Context := Sys;
      return (get_number_of_elements
                 (select_and_copy
                     (Context.Resources,
                      R11_QUERY1_Condition'Access)) =
              Resources_Range (0));

   end R11;

   function R11_Txt return Unbounded_String is
   begin

      return ("The constraint R11 is not met:") &
             unbounded_lf &
             ("the resource access protocol must be PCP, PIP or IPCP.") &
             unbounded_lf;

   end R11_Txt;

end applicability_constraint.allowed_protocol;
