with Ada.IO_Exceptions;      use Ada.IO_Exceptions;
with GNAT.Current_Exception; use GNAT.Current_Exception;
with Unbounded_Strings;      use Unbounded_Strings;
with GNAT.Command_Line;      use GNAT.Command_Line;
with GNAT.OS_Lib;            use GNAT.OS_Lib;
with Text_IO;                use Text_IO;
with Version;                use Version;
with Ada.Strings.Unbounded;  use Ada.Strings.Unbounded;
with Systems;                use Systems;
with Task_Set;               use Task_Set;
with Processor_Set;          use Processor_Set;
with Address_Space_Set;      use Address_Space_Set;
with Resource_Set;           use Resource_Set;
with Buffer_Set;             use Buffer_Set;
with Call_Framework;         use Call_Framework;
with Tasks;                  use Tasks;
with Debug;                  use Debug;
with applicability_constraint.Period_Equal_Deadline_Constraint;
use applicability_constraint.Period_Equal_Deadline_Constraint;
with applicability_constraint.Period_Smaller_Than_Deadline_Constraint;
use applicability_constraint.Period_Smaller_Than_Deadline_Constraint;
with applicability_constraint.Period_Larger_Than_Deadline_Constraint;
use applicability_constraint.Period_Larger_Than_Deadline_Constraint;
use Task_Set.Generic_Task_Set;

package body applicability_constraint.arbitrary_deadlines is

   function apply (Sys : System) return Boolean is
   begin
      Context := Sys;

      return not applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply(Sys) and not applicability_constraint.Period_Equal_Deadline_Constraint.apply(Sys) and not applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply(Sys);

   end apply;

end applicability_constraint.arbitrary_deadlines;
