with Ada.IO_Exceptions;      use Ada.IO_Exceptions;
with GNAT.Current_Exception; use GNAT.Current_Exception;
with Unbounded_Strings;      use Unbounded_Strings;
with GNAT.Command_Line;      use GNAT.Command_Line;
with GNAT.OS_Lib;            use GNAT.OS_Lib;
with Text_IO;                use Text_IO;
with Version;                use Version;
with Ada.Strings.Unbounded;  use Ada.Strings.Unbounded;
with Systems;                use Systems;
with Dependencies;           use Dependencies;
with Task_Dependencies;      use Task_Dependencies;
with Task_Set;               use Task_Set;
use Task_Set.Generic_Task_Set;
use Task_Dependencies.Half_Dep_Set;
with Processor_Set;          use Processor_Set;
use Processor_Set.Generic_Processor_Set;
with Address_Space_Set;      use Address_Space_Set;
use Address_Space_Set.Generic_Address_Space_Set;
with Resource_Set;           use Resource_Set;
use Resource_Set.Generic_Resource_Set;
with Resources;              use Resources;
use Resources.resource_accesses;
with Buffer_Set;             use Buffer_Set;
use Buffer_Set.Generic_Buffer_Set;
with Call_Framework;         use Call_Framework;
with Tasks;                  use Tasks;
with Address_Spaces;         use Address_Spaces;
with Unbounded_Strings;      use Unbounded_Strings;
use Unbounded_Strings.Unbounded_String_List_Package;
with Debug;                  use Debug;

package body applicability_constraint.data_connectivity is

   function R10_QUERY1_Condition (r1 : Generic_Resource_Ptr) return Boolean is
   begin

      return (r1.critical_sections.Nb_Entries < resource_accesses_Range (2));

   end R10_QUERY1_Condition;

   function R10 (Sys : System) return Boolean is
   begin
      Context := Sys;
      return (Get_Number_Of_Elements
                 (Select_And_Copy
                     (Context.Resources,
                      R10_QUERY1_Condition'Access)) =
              Resources_Range (0));

   end R10;

   function R10_Txt return Unbounded_String is
   begin
     
      return ("The constraint R10 is not met:")& unbounded_lf &
	      ("for each data component, there are at least two connected tasks.")& unbounded_lf ;

   end R10_Txt;


end applicability_constraint.data_connectivity;
