with Ada.IO_Exceptions;use Ada.IO_Exceptions;
with GNAT.Current_Exception; use GNAT.Current_Exception;
with unbounded_strings;      use unbounded_strings;
with GNAT.Command_Line;      use GNAT.Command_Line;
with GNAT.OS_Lib;            use GNAT.OS_Lib;
with Text_IO;                use Text_IO;
with Version;                use Version;
with Ada.Strings.Unbounded;  use Ada.Strings.Unbounded;
with Systems;                use Systems;
with Dependencies;           use Dependencies;
with Task_Dependencies;      use Task_Dependencies;
with Task_Set;               use Task_Set;
use Task_Set.Generic_Task_Set;
use Task_Dependencies.Half_Dep_Set;
with Processor_Set;          use Processor_Set;
use Processor_Set.Generic_Processor_Set;
with Address_Space_Set;      use Address_Space_Set;
use Address_Space_Set.Generic_Address_Space_Set;
with Resource_Set;           use Resource_Set;
use Resource_Set.Generic_Resource_Set;
with Buffer_Set;             use Buffer_Set;
use Buffer_Set.Generic_Buffer_Set;
with Call_Framework;         use Call_Framework;
with Tasks;                  use Tasks;
with Address_Spaces;         use Address_Spaces;
with unbounded_strings;      use unbounded_strings;
use unbounded_strings.unbounded_string_list_package;
with Debug;                  use Debug;

package body applicability_constraint.data_sharing_protocol is

   function R6_QUERY1_Condition (d1 : Dependency_Ptr) return Boolean is
   begin

      return (not (d1.type_of_dependency =
                   Time_Triggered_Communication_Dependency));

   end R6_QUERY1_Condition;

   function R6_QUERY2_Condition (d2 : Dependency_Ptr) return Boolean is
   begin

      return (not ((d2.timing_property = Sampled_Timing) or
                   (d2.timing_property = Immediate_Timing) or
                   (d2.timing_property = Delayed_Timing)));

   end R6_QUERY2_Condition;

   function R6_QUERY3_Condition (d3 : Dependency_Ptr) return Boolean is
   begin

      return (d3.type_of_dependency =
              Time_Triggered_Communication_Dependency);

   end R6_QUERY3_Condition;

   function R6 (Sys : System) return Boolean is
   begin
      Context := Sys;
      return (get_number_of_elements
                 (select_and_copy
                     (Context.Dependencies.Depends,
                      R6_QUERY1_Condition'Access)) =
              Tasks_Dependencies_Range (0)) and
             (get_number_of_elements
                 (select_and_copy
                     ((select_and_copy
                          (Context.Dependencies.Depends,
                           R6_QUERY3_Condition'Access)),
                      R6_QUERY2_Condition'Access)) =
              Tasks_Dependencies_Range (0));

   end R6;
   function R6_Txt return Unbounded_String is
   begin

      return ("The constraint R6 is not met:") &
             unbounded_lf &
             (
"data sharing protocol : port connections with sample, immediate or delayed timing."
) &
             unbounded_lf;

   end R6_Txt;

end applicability_constraint.data_sharing_protocol;
