------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This Ada package was automatically generated by the software engineering
--tool Platypus
--  see http://cassoulet.univ-brest.fr/mme
--
--  Any modification of this file will be lost.
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model.
------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2009   Frank Singhoff
-- Cheddar is developed by the LISYC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with primitive_xml_strings; use primitive_xml_strings;

with Unbounded_Strings; use Unbounded_Strings;
use Unbounded_Strings.Unbounded_String_List_Package;

with Systems; use Systems;

with Processor_Set; use Processor_Set;

with debug; use debug;

package body Applicability_Constraints_Main_Structure.extended is

procedure Initialize(obj : out Applicability_Constraint_ptr) is
begin
      obj                            := new Applicability_Constraint;
      obj.all.Name                   := Empty_String;
      obj.all.Result                 := False;
      obj.all.Corresponding_Function := null;
end Initialize;
procedure Initialize(obj : out Applicability_Constraint_Case_ptr) is
begin
      obj                            := new Applicability_Constraint_Case;
      obj.all.Name                   := Empty_String;
      obj.all.Feasibility_Test_Names := Empty_String;
      Initialize (obj.all.Applicability_Constraints);
end Initialize;
procedure Initialize(obj : out All_Cases_Structure_ptr) is
begin
obj := new All_Cases_Structure;
Initialize (obj.all);
end Initialize;






   procedure evaluate (obj : in out All_Cases_Structure; Sys : in System) is

      constraints_Iterator : Applicability_Constraints_List_Iterator;
      cases_iterator       : Applicability_Constraint_Cases_List_Iterator;

      current_constraint : Applicability_Constraint_Ptr;
      current_case       : Applicability_Constraint_Case_Ptr;
      --temp               : Boolean;
   begin

      Reset_Head_Iterator (obj.Cases, cases_iterator);
      Current_Element (obj.Cases, current_case, cases_iterator);
      loop

         Reset_Head_Iterator
           (current_case.Applicability_Constraints,
            constraints_Iterator);
         Current_Element
           (current_case.Applicability_Constraints,
            current_constraint,
            constraints_Iterator);

         loop
	Put_debug("loop for evaluating all constraints iteration");
        --    temp                          :=
          --     current_constraint.all.Corresponding_Function (Sys);
            current_constraint.all.Result :=
               current_constraint.all.Corresponding_Function (Sys);
            exit when Is_Tail_Element
                         (current_case.Applicability_Constraints,
                          constraints_Iterator);
            Next_Element
              (current_case.all.Applicability_Constraints,
               constraints_Iterator);
            Current_Element
              (current_case.all.Applicability_Constraints,
               current_constraint,
               constraints_Iterator);

         end loop;

         current_constraint.all.Result :=
            current_constraint.all.Corresponding_Function (Sys);
         exit when (Is_Tail_Element (obj.Cases, cases_iterator));
         Next_Element (obj.Cases, cases_iterator);
         Current_Element (obj.Cases, current_case, cases_iterator);

      end loop;

      Reset_Head_Iterator
        (current_case.all.Applicability_Constraints,
         constraints_Iterator);
      Current_Element
        (current_case.all.Applicability_Constraints,
         current_constraint,
         constraints_Iterator);

   end evaluate;

   procedure display_tests_list (obj : in All_Cases_Structure) is

      constraints_Iterator : Applicability_Constraints_List_Iterator;
      cases_iterator       : Applicability_Constraint_Cases_List_Iterator;

      current_constraint : Applicability_Constraint_Ptr;
      current_case       : Applicability_Constraint_Case_Ptr;

      res : Boolean;

   begin

      Reset_Head_Iterator (obj.Cases, cases_iterator);
      Current_Element (obj.Cases, current_case, cases_iterator);
      loop
         res := True;
         Reset_Head_Iterator
           (current_case.Applicability_Constraints,
            constraints_Iterator);
         Current_Element
           (current_case.Applicability_Constraints,
            current_constraint,
            constraints_Iterator);

         loop

            res := res and current_constraint.all.Result;

            exit when (Is_Tail_Element
                          (current_case.Applicability_Constraints,
                           constraints_Iterator));

            Next_Element
              (current_case.all.Applicability_Constraints,
               constraints_Iterator);
            Current_Element
              (current_case.all.Applicability_Constraints,
               current_constraint,
               constraints_Iterator);

         end loop;

         res := res and current_constraint.all.Result;

         if res then
            Put_Line ("*************************************");
            Put_Line ("*****Feasibility tests selection*****");
            Put_Line (current_case.all.Feasibility_Test_Names);
            Put_Line ("*************************************");
         end if;
         exit when (Is_Tail_Element (obj.Cases, cases_iterator));
         Next_Element (obj.Cases, cases_iterator);
         Current_Element (obj.Cases, current_case, cases_iterator);

      end loop;

   end display_tests_list;

   function get_tests_list
     (obj  : in All_Cases_Structure)
      return Unbounded_String
   is
      constraints_Iterator : Applicability_Constraints_List_Iterator;
      cases_iterator       : Applicability_Constraint_Cases_List_Iterator;

      current_constraint : Applicability_Constraint_Ptr;
      current_case       : Applicability_Constraint_Case_Ptr;

      res : Boolean;

   begin

      Reset_Head_Iterator (obj.Cases, cases_iterator);
      Current_Element (obj.Cases, current_case, cases_iterator);
      loop
         res := True;
         Reset_Head_Iterator
           (current_case.Applicability_Constraints,
            constraints_Iterator);
         Current_Element
           (current_case.Applicability_Constraints,
            current_constraint,
            constraints_Iterator);

         loop

            res := res and current_constraint.all.Result;

            exit when (Is_Tail_Element
                          (current_case.Applicability_Constraints,
                           constraints_Iterator));

            Next_Element
              (current_case.all.Applicability_Constraints,
               constraints_Iterator);
            Current_Element
              (current_case.all.Applicability_Constraints,
               current_constraint,
               constraints_Iterator);

         end loop;

         res := res and current_constraint.all.Result;

         if res then


            return Unbounded_lf &
                   current_case.all.Feasibility_Test_Names & Unbounded_lf & current_case.all.Name;
         end if;
         exit when (Is_Tail_Element (obj.Cases, cases_iterator));
         Next_Element (obj.Cases, cases_iterator);
         Current_Element (obj.Cases, current_case, cases_iterator);

      end loop;

      return Unbounded_lf & To_Unbounded_String
               ("No feasibility tests Selected");

   end get_tests_list;


   function duplicate
     (obj  : in Applicability_Constraint_Ptr)
      return Applicability_Constraint_Ptr
   is
      obj2 : Applicability_Constraint_Ptr;

   begin

      Initialize (obj2);
      obj2.all.Name                   := obj.all.Name;
      obj2.all.Result                 := obj.all.Result;
      obj2.all.Corresponding_Function := obj.all.Corresponding_Function;

      return obj2;

   end duplicate;
   function duplicate
     (obj  : in Applicability_Constraint_Case_Ptr)
      return Applicability_Constraint_Case_Ptr
   is
      obj2 : Applicability_Constraint_Case_Ptr;

   begin

      Initialize (obj2);
      obj2.all.Name                   := obj.all.Name;
      obj2.all.Feasibility_Test_Names := obj.all.Feasibility_Test_Names;
      Duplicate
        (obj.all.Applicability_Constraints,
         obj2.all.Applicability_Constraints,
         True);

      return obj2;

   end duplicate;


end Applicability_Constraints_Main_Structure.extended;
