------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2009   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

with id_generators;
use id_generators;

with Text_io;
use Text_io;

with Unbounded_Strings;
use Unbounded_Strings;

use unbounded_strings.Unbounded_String_List_Package;

with Convert_Strings;

with Convert_Unbounded_Strings;

with standards_io;
use standards_io;

use standards_io.boolean_io;

with Ada.Finalization;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with Access_Lists;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with systems; use systems;

Package Applicability_Constraints_Main_Structure is 
 
Type Applicability_Constraint_Function is access function (Context : System) return Boolean;

-- --------= Applicability_Constraint =--------
 
type Applicability_Constraint is
record
 Name : Unbounded_String;
 Result : Boolean;
 Corresponding_Function : Applicability_Constraint_Function;
end record;

type Applicability_Constraint_Ptr is access all Applicability_Constraint;

procedure Initialize(obj : out Applicability_Constraint);
procedure Put(obj : in Applicability_Constraint);
procedure Put(obj : in Applicability_Constraint_Ptr);
function Copy(obj : in Applicability_Constraint_Ptr) return Applicability_Constraint_Ptr;
function Copy(obj : in Applicability_Constraint) return Applicability_Constraint_Ptr;
procedure Build_Attributes_XML_String(obj : in Applicability_Constraint; result : in out Unbounded_String);
function XML_String(obj : in Applicability_Constraint) return Unbounded_String;
function XML_String(obj : in Applicability_Constraint_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Applicability_Constraint) return Unbounded_String;
procedure Free  is new Unchecked_Deallocation (Applicability_Constraint, Applicability_Constraint_Ptr);

package Applicability_Constraints_List_Package is new Access_Lists(Applicability_Constraint, Applicability_Constraint_Ptr, Put, Free, Copy, XML_String);
use Applicability_Constraints_List_Package;
subtype Applicability_Constraints_List is Applicability_Constraints_List_Package.List;
subtype Applicability_Constraints_List_Ptr is  Applicability_Constraints_List_Package.List_Ptr;
subtype Applicability_Constraints_List_Iterator is Applicability_Constraints_List_Package.Iterator;
subtype Applicability_Constraints_List_Iterator_Ptr is  Applicability_Constraints_List_Package.Iterator_Ptr;


-- --------= Applicability_Constraint_Case =--------
 
type Applicability_Constraint_Case is
record
 Name : Unbounded_String;
 Feasibility_Test_Names : Unbounded_String;
 Applicability_Constraints : Applicability_Constraints_List;
end record;

type Applicability_Constraint_Case_Ptr is access all Applicability_Constraint_Case;

procedure Initialize(obj : out Applicability_Constraint_Case);
procedure Put(obj : in Applicability_Constraint_Case);
procedure Put(obj : in Applicability_Constraint_Case_Ptr);
function Copy(obj : in Applicability_Constraint_Case_Ptr) return Applicability_Constraint_Case_Ptr;
function Copy(obj : in Applicability_Constraint_Case) return Applicability_Constraint_Case_Ptr;
procedure Build_Attributes_XML_String(obj : in Applicability_Constraint_Case; result : in out Unbounded_String);
function XML_String(obj : in Applicability_Constraint_Case) return Unbounded_String;
function XML_String(obj : in Applicability_Constraint_Case_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Applicability_Constraint_Case) return Unbounded_String;
procedure Free  is new Unchecked_Deallocation (Applicability_Constraint_Case, Applicability_Constraint_Case_Ptr);

package Applicability_Constraint_Cases_List_Package is new Access_Lists(Applicability_Constraint_Case, Applicability_Constraint_Case_Ptr, Put, Free, Copy, XML_String);
use Applicability_Constraint_Cases_List_Package;
subtype Applicability_Constraint_Cases_List is Applicability_Constraint_Cases_List_Package.List;
subtype Applicability_Constraint_Cases_List_Ptr is  Applicability_Constraint_Cases_List_Package.List_Ptr;
subtype Applicability_Constraint_Cases_List_Iterator is Applicability_Constraint_Cases_List_Package.Iterator;
subtype Applicability_Constraint_Cases_List_Iterator_Ptr is  Applicability_Constraint_Cases_List_Package.Iterator_Ptr;


-- --------= All_Cases_Structure =--------
 
type All_Cases_Structure is
record
 Cases : Applicability_Constraint_Cases_List;
end record;

type All_Cases_Structure_Ptr is access all All_Cases_Structure;

procedure Initialize(obj : out All_Cases_Structure);
procedure Put(obj : in All_Cases_Structure);
procedure Put(obj : in All_Cases_Structure_Ptr);
function Copy(obj : in All_Cases_Structure_Ptr) return All_Cases_Structure_Ptr;
function Copy(obj : in All_Cases_Structure) return All_Cases_Structure_Ptr;
procedure Build_Attributes_XML_String(obj : in All_Cases_Structure; result : in out Unbounded_String);
function XML_String(obj : in All_Cases_Structure) return Unbounded_String;
function XML_String(obj : in All_Cases_Structure_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in All_Cases_Structure) return Unbounded_String;
procedure Free  is new Unchecked_Deallocation (All_Cases_Structure, All_Cases_Structure_Ptr);


End Applicability_Constraints_Main_Structure;

