with applicability_constraint.all_tasks_are_periodic;
use applicability_constraint.all_tasks_are_periodic;
with applicability_constraint.all_tasks_are_periodic_or_sporadic;
use applicability_constraint.all_tasks_are_periodic_or_sporadic;
with applicability_constraint.no_shared_cpu;
use applicability_constraint.no_shared_cpu;
with applicability_constraint.allowed_protocol;
use applicability_constraint.allowed_protocol;
with applicability_constraint.Pip_No_Deadlock;
use applicability_constraint.Pip_No_Deadlock;
with applicability_constraint.no_buffer;
use applicability_constraint.no_buffer;
with applicability_constraint.no_dependencies;
use applicability_constraint.no_dependencies;
with applicability_constraint.Ceiling_Priority_Assignment;
use applicability_constraint.Ceiling_Priority_Assignment;
with applicability_constraint.at_least_one_data;
use applicability_constraint.at_least_one_data;
with applicability_constraint.no_shared_resources;
use applicability_constraint.no_shared_resources;
with applicability_constraint.data_sharing_protocol;
use applicability_constraint.data_sharing_protocol;
with applicability_constraint.data_connectivity;
use applicability_constraint.data_connectivity;
with applicability_constraint.Unsimultaneous_Release_Time_Constraint;
use applicability_constraint.Unsimultaneous_Release_Time_Constraint;
with applicability_constraint.Simultaneous_Release_Time_Constraint;
use applicability_constraint.Simultaneous_Release_Time_Constraint;
with applicability_constraint.Period_Equal_Deadline_Constraint;
use applicability_constraint.Period_Equal_Deadline_Constraint;
with applicability_constraint.Period_Smaller_Than_Deadline_Constraint;
use applicability_constraint.Period_Smaller_Than_Deadline_Constraint;
with applicability_constraint.Period_Larger_Than_Deadline_Constraint;
use applicability_constraint.Period_Larger_Than_Deadline_Constraint;
with feasibility_tests_for_Time_Triggered_Communication;
use feasibility_tests_for_Time_Triggered_Communication;
with Applicability_Constraints_Main_Structure;
use Applicability_Constraints_Main_Structure;
with feasibility_tests_main_structure_factory;
use feasibility_tests_main_structure_factory;
with Generic_Graph;                                                    use 
  Generic_Graph;
with Dependencies;                                                     use 
  Dependencies;
with Ada.IO_Exceptions;                                                use 
  Ada.IO_Exceptions;
with GNAT.Current_Exception;                                           use 
  GNAT.Current_Exception;
with Unbounded_Strings;                                                use 
  Unbounded_Strings;
with GNAT.Command_Line;                                                use 
  GNAT.Command_Line;
with GNAT.OS_Lib;                                                      use 
  GNAT.OS_Lib;
with Text_IO;                                                          use 
  Text_IO;
with Version;                                                          use 
  Version;
with Ada.Strings.Unbounded;                                            use 
  Ada.Strings.Unbounded;
with Systems;                                                          use 
  Systems;
with Task_Set;                                                         use 
  Task_Set;
with Task_Dependencies;                                                use 
  Task_Dependencies;
use Task_Dependencies.Half_Dep_Set;
with Processor_Set;                                                    use 
  Processor_Set;
with Address_Space_Set;                                                use 
  Address_Space_Set;
with Resource_Set;                                                     use 
  Resource_Set;
with Buffer_Set;                                                       use 
  Buffer_Set;
with Call_Framework;                                                   use 
  Call_Framework;
with Tasks;                                                            use 
  Tasks;
use Task_Set.Generic_Task_Set;
with Debug;                                                            use 
  Debug;
with Generic_Graph;                                                    use 
  Generic_Graph;
use Generic_Graph.Edge_Lists_Package;
use Generic_Graph.Node_Lists_Package;
with DP_Graph;                                                         use 
  DP_Graph;
with DP_Graph_view;                                                    use 
  DP_Graph_view;
use DP_Graph_view.Graph_List_Package;
with architecture_factory;                                             use 
  architecture_factory;

package architecture_analyzer is

   function analyze (Sys : System) return Unbounded_String;

   function Time_Triggered_Communication_txt (Sys : System) return Unbounded_String; 
   function Ravenscar_txt (Sys : System) return Unbounded_String;
   function Unplugged_txt (Sys : System) return Unbounded_String;
   function Environment_Uni_Processor_txt (Sys : System) return Unbounded_String;

   function Time_Triggered_Communication_Bool (Sys : System) return boolean; 
   function Ravenscar_Bool (Sys : System) return boolean;
   function Unplugged_Bool (Sys : System) return boolean;
   function Environment_Uni_Processor_Bool (Sys : System) return boolean;

   procedure write_result_to_file
     (Res       : in Unbounded_String;
      File_Name : in Unbounded_String);
end architecture_analyzer;
