
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with Tasks;

use Tasks.Tasks_Type_io;

with Dependencies;

use Dependencies.Time_Triggered_Communication_Timing_Property_Type_io;



Package Body DP_Graph is 
 

-- --------= Task_Node =--------

procedure Initialize(obj : in out Task_Node) is 
begin
	initialize(Generic_Node(obj));
	obj.Kind := Periodic_Type;
end Initialize;

function Copy ( obj : in Task_Node ) return Task_Node_Ptr is
	New_Task_Node : Task_Node_Ptr;
begin
	New_Task_Node := new Task_Node'(obj);
	return (New_Task_Node);
end Copy;

function Copy ( obj : in Task_Node_Ptr ) return Task_Node_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Task_Node) is 
begin
	put(Generic_Node(obj));
	put("TaskRef: "); if obj.TaskRef /= null then put(obj.TaskRef.all); else put("null"); end if;put ( "; " );
	put("Kind: "); put(obj.Kind); put ( "; " );
	put("Proc: "); if obj.Proc /= null then put(obj.Proc.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Task_Node_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Task_Node_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Task_Node ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("GENERIC_GRAPH.GENERIC_NODE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DP_GRAPH.TASK_NODE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Task_Node_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Task_Node; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Node(obj), result);
	result := result & to_unbounded_string("<TaskRef ref=""") & obj.TaskRef.cheddar_private_id & to_unbounded_string(""" />");
	if (XML_String(obj.Kind) /= Empty_String) then
		result := result & to_unbounded_string("<kind>") & XML_String(obj.Kind) & to_unbounded_string("</kind>");
	end if;
	result := result & to_unbounded_string("<Proc ref=""") & obj.Proc.cheddar_private_id & to_unbounded_string(""" />");
end Build_Attributes_XML_String;

function XML_String(obj : in Task_Node) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<task_node id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</task_node>");
	return (result);
end XML_String;

function XML_String(obj : in Task_Node_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Task_Node) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<task_node ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Task_Node_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Time_Triggered_Communication_Edge =--------

procedure Initialize(obj : in out Time_Triggered_Communication_Edge) is 
begin
	initialize(Generic_Edge(obj));
	obj.Timing_Property := Sampled_Timing;
end Initialize;

function Copy ( obj : in Time_Triggered_Communication_Edge ) return Time_Triggered_Communication_Edge_Ptr is
	New_Time_Triggered_Communication_Edge : Time_Triggered_Communication_Edge_Ptr;
begin
	New_Time_Triggered_Communication_Edge := new Time_Triggered_Communication_Edge'(obj);
	return (New_Time_Triggered_Communication_Edge);
end Copy;

function Copy ( obj : in Time_Triggered_Communication_Edge_Ptr ) return Time_Triggered_Communication_Edge_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Time_Triggered_Communication_Edge) is 
begin
	put(Generic_Edge(obj));
	put("Timing_Property: "); put(obj.Timing_Property); put ( "; " );
	put("Time_Triggered_Communication_Sink: "); if obj.Time_Triggered_Communication_Sink /= null then put(obj.Time_Triggered_Communication_Sink.all); else put("null"); end if;put ( "; " );
	put("Time_Triggered_Communication_Source: "); if obj.Time_Triggered_Communication_Source /= null then put(obj.Time_Triggered_Communication_Source.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Time_Triggered_Communication_Edge_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Time_Triggered_Communication_Edge_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Time_Triggered_Communication_Edge ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("GENERIC_GRAPH.GENERIC_EDGE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DP_GRAPH.TIME_TRIGGERED_COMMUNICATION_EDGE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Time_Triggered_Communication_Edge_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Time_Triggered_Communication_Edge; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Edge(obj), result);
	if (XML_String(obj.Timing_Property) /= Empty_String) then
		result := result & to_unbounded_string("<timing_property>") & XML_String(obj.Timing_Property) & to_unbounded_string("</timing_property>");
	end if;
	if (XML_String(obj.Time_Triggered_Communication_Sink) /= Empty_String) then
		result := result & to_unbounded_string("<time_triggered_communication_sink>") & XML_String(obj.Time_Triggered_Communication_Sink) & to_unbounded_string("</time_triggered_communication_sink>");
	end if;
	if (XML_String(obj.Time_Triggered_Communication_Source) /= Empty_String) then
		result := result & to_unbounded_string("<time_triggered_communication_source>") & XML_String(obj.Time_Triggered_Communication_Source) & to_unbounded_string("</time_triggered_communication_source>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Time_Triggered_Communication_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<time_triggered_communication_edge id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</time_triggered_communication_edge>");
	return (result);
end XML_String;

function XML_String(obj : in Time_Triggered_Communication_Edge_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Time_Triggered_Communication_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<time_triggered_communication_edge ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Time_Triggered_Communication_Edge_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Resource_Edge =--------

procedure Initialize(obj : in out Resource_Edge) is 
begin
	initialize(Generic_Edge(obj));
end Initialize;

function Copy ( obj : in Resource_Edge ) return Resource_Edge_Ptr is
	New_Resource_Edge : Resource_Edge_Ptr;
begin
	New_Resource_Edge := new Resource_Edge'(obj);
	return (New_Resource_Edge);
end Copy;

function Copy ( obj : in Resource_Edge_Ptr ) return Resource_Edge_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Resource_Edge) is 
begin
	put(Generic_Edge(obj));
	put("Resource_Dependency_Resource: "); if obj.Resource_Dependency_Resource /= null then put(obj.Resource_Dependency_Resource.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Resource_Edge_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Resource_Edge_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Resource_Edge ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("GENERIC_GRAPH.GENERIC_EDGE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DP_GRAPH.RESOURCE_EDGE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Resource_Edge_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Resource_Edge; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Edge(obj), result);
	result := result & to_unbounded_string("<Resource_Dependency_Resource ref=""") & obj.Resource_Dependency_Resource.cheddar_private_id & to_unbounded_string(""" />");
end Build_Attributes_XML_String;

function XML_String(obj : in Resource_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<resource_edge id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</resource_edge>");
	return (result);
end XML_String;

function XML_String(obj : in Resource_Edge_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Resource_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<resource_edge ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Resource_Edge_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Precedence_Edge =--------

procedure Initialize(obj : in out Precedence_Edge) is 
begin
	initialize(Generic_Edge(obj));
end Initialize;

function Copy ( obj : in Precedence_Edge ) return Precedence_Edge_Ptr is
	New_Precedence_Edge : Precedence_Edge_Ptr;
begin
	New_Precedence_Edge := new Precedence_Edge'(obj);
	return (New_Precedence_Edge);
end Copy;

function Copy ( obj : in Precedence_Edge_Ptr ) return Precedence_Edge_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Precedence_Edge) is 
begin
	put(Generic_Edge(obj));
end Put;
 
procedure Put(obj : in Precedence_Edge_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Precedence_Edge_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Precedence_Edge ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("GENERIC_GRAPH.GENERIC_EDGE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DP_GRAPH.PRECEDENCE_EDGE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Precedence_Edge_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Precedence_Edge; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Edge(obj), result);
end Build_Attributes_XML_String;

function XML_String(obj : in Precedence_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<precedence_edge id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</precedence_edge>");
	return (result);
end XML_String;

function XML_String(obj : in Precedence_Edge_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Precedence_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<precedence_edge ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Precedence_Edge_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Communication_Edge =--------

procedure Initialize(obj : in out Communication_Edge) is 
begin
	initialize(Generic_Edge(obj));
end Initialize;

function Copy ( obj : in Communication_Edge ) return Communication_Edge_Ptr is
	New_Communication_Edge : Communication_Edge_Ptr;
begin
	New_Communication_Edge := new Communication_Edge'(obj);
	return (New_Communication_Edge);
end Copy;

function Copy ( obj : in Communication_Edge_Ptr ) return Communication_Edge_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Communication_Edge) is 
begin
	put(Generic_Edge(obj));
	put("Communication_Dependency_Object: "); if obj.Communication_Dependency_Object /= null then put(obj.Communication_Dependency_Object.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Communication_Edge_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Communication_Edge_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Communication_Edge ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("GENERIC_GRAPH.GENERIC_EDGE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DP_GRAPH.COMMUNICATION_EDGE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Communication_Edge_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Communication_Edge; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Edge(obj), result);
	result := result & to_unbounded_string("<Communication_Dependency_Object ref=""") & obj.Communication_Dependency_Object.cheddar_private_id & to_unbounded_string(""" />");
end Build_Attributes_XML_String;

function XML_String(obj : in Communication_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<communication_edge id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</communication_edge>");
	return (result);
end XML_String;

function XML_String(obj : in Communication_Edge_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Communication_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<communication_edge ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Communication_Edge_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Buffer_Edge =--------

procedure Initialize(obj : in out Buffer_Edge) is 
begin
	initialize(Generic_Edge(obj));
end Initialize;

function Copy ( obj : in Buffer_Edge ) return Buffer_Edge_Ptr is
	New_Buffer_Edge : Buffer_Edge_Ptr;
begin
	New_Buffer_Edge := new Buffer_Edge'(obj);
	return (New_Buffer_Edge);
end Copy;

function Copy ( obj : in Buffer_Edge_Ptr ) return Buffer_Edge_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Buffer_Edge) is 
begin
	put(Generic_Edge(obj));
	put("Buffer_Dependency_Object: "); if obj.Buffer_Dependency_Object /= null then put(obj.Buffer_Dependency_Object.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Buffer_Edge_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Buffer_Edge_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Buffer_Edge ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("GENERIC_GRAPH.GENERIC_EDGE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("DP_GRAPH.BUFFER_EDGE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Buffer_Edge_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Buffer_Edge; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Edge(obj), result);
	result := result & to_unbounded_string("<Buffer_Dependency_Object ref=""") & obj.Buffer_Dependency_Object.cheddar_private_id & to_unbounded_string(""" />");
end Build_Attributes_XML_String;

function XML_String(obj : in Buffer_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<buffer_edge id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</buffer_edge>");
	return (result);
end XML_String;

function XML_String(obj : in Buffer_Edge_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Buffer_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<buffer_edge ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Buffer_Edge_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End DP_Graph;
