with
  applicability_constraint.Unsimultaneous_Release_Time_Constraint;
use  applicability_constraint.Unsimultaneous_Release_Time_Constraint;
with applicability_constraint.Simultaneous_Release_Time_Constraint;
use  applicability_constraint.Simultaneous_Release_Time_Constraint;
with applicability_constraint.Period_Equal_Deadline_Constraint;
use  applicability_constraint.Period_Equal_Deadline_Constraint;
with applicability_constraint.Period_Smaller_Than_Deadline_Constraint;
use  applicability_constraint.Period_Smaller_Than_Deadline_Constraint;
with applicability_constraint.Period_Larger_Than_Deadline_Constraint;
use  applicability_constraint.Period_Larger_Than_Deadline_Constraint;
with Applicability_Constraints_Main_Structure;
use  Applicability_Constraints_Main_Structure;
with Processors;                                                       use
  Processors;
with Scheduler;                                                        use
  Scheduler;
with Ada.IO_Exceptions;                                                use
  Ada.IO_Exceptions;
with GNAT.Current_Exception;                                           use
  GNAT.Current_Exception;
with unbounded_strings;                                                use
  unbounded_strings;
with GNAT.Command_Line;                                                use
  GNAT.Command_Line;
with GNAT.OS_Lib;                                                      use
  GNAT.OS_Lib;
with Text_IO;                                                          use
  Text_IO;
with Version;                                                          use
  Version;
with Ada.Strings.Unbounded;                                            use
  Ada.Strings.Unbounded;
with Systems;                                                          use
  Systems;
with Task_Set;                                                         use
  Task_Set;
with Processor_Set;                                                    use
  Processor_Set;
with Address_Space_Set;                                                use
  Address_Space_Set;
with Resource_Set;                                                     use
  Resource_Set;
with Buffer_Set;                                                       use
  Buffer_Set;
with Call_Framework;                                                   use
  Call_Framework;
with Scheduler_Interface;                                              use
  Scheduler_Interface;
with Tasks;                                                            use
  Tasks;
use Task_Set.Generic_Task_Set;
with Text_IO;                                                          use
  Text_IO;

package body feasibility_tests_for_ravenscar is

   function Function_Case_1 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_1;

   function Function_Case_2 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_2;

   function Function_Case_3 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_3;

   function Function_Case_4 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_4;

   function Function_Case_5 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_5;

   function Function_Case_6 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_6;

   function Function_Case_7 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_7;

   function Function_Case_8 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_8;

   function Function_Case_9 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_9;

   function Function_Case_10 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_10;

   function Function_Case_11 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_11;

   function Function_Case_12 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_12;

   function Function_Case_13 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_13;

   function Function_Case_14 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_14;

   function Function_Case_15 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_15;

   function Function_Case_16 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type = Rate_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_16;

   function Function_Case_17 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_17;

   function Function_Case_18 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_18;

   function Function_Case_19 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_19;

   function Function_Case_20 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_20;

   function Function_Case_21 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_21;

   function Function_Case_22 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_22;

   function Function_Case_23 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_23;

   function Function_Case_24 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_24;

   function Function_Case_25 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_25;

   function Function_Case_26 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_26;

   function Function_Case_27 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_27;

   function Function_Case_28 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_28;

   function Function_Case_29 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_29;

   function Function_Case_30 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_30;

   function Function_Case_31 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_31;

   function Function_Case_32 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Deadline_Monotonic_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_32;

   function Function_Case_33 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_33;

   function Function_Case_34 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_34;

   function Function_Case_35 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_35;

   function Function_Case_36 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_36;

   function Function_Case_37 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_37;

   function Function_Case_38 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_38;

   function Function_Case_39 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_39;

   function Function_Case_40 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_40;

   function Function_Case_41 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_41;

   function Function_Case_42 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_42;

   function Function_Case_43 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_43;

   function Function_Case_44 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_44;

   function Function_Case_45 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_45;

   function Function_Case_46 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_46;

   function Function_Case_47 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_47;

   function Function_Case_48 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Posix_1003_Highest_Priority_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_48;

   function Function_Case_49 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_49;

   function Function_Case_50 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_50;

   function Function_Case_51 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_51;

   function Function_Case_52 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_52;

   function Function_Case_53 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_53;

   function Function_Case_54 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_54;

   function Function_Case_55 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_55;

   function Function_Case_56 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = preemptive);
   end Function_Case_56;

   function Function_Case_57 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_57;

   function Function_Case_58 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_58;

   function Function_Case_59 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_59;

   function Function_Case_60 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_60;

   function Function_Case_61 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_61;

   function Function_Case_62 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_62;

   function Function_Case_63 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_63;

   function Function_Case_64 (Sys : System) return Boolean is
      p  : Generic_Processor_Ptr;
      p2 : Mono_Core_Processor_Ptr;
   begin

      get_element_number (Sys.Processors, p, Processors_Range (0));
      p2 := Mono_Core_Processor_Ptr (p);
      return (p2.core.scheduling.scheduler_type =
              Earliest_Deadline_First_Protocol) and
             (p2.core.scheduling.preemptive_type = not_preemptive);
   end Function_Case_64;

end feasibility_tests_for_ravenscar;
