
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with framework;
use framework;

with id_generators;
use id_generators;



Package Body Generic_Graph is 
 

-- --------= Generic_Node =--------

procedure Initialize(obj : in out Generic_Node) is 
begin
	generate_id( framework_id, obj.cheddar_private_id );
	obj.Id := empty_string;
end Initialize;

function Copy ( obj : in Generic_Node ) return Generic_Node_Ptr is
	New_Generic_Node : Generic_Node_Ptr;
begin
	New_Generic_Node := new Generic_Node'(obj);
	return (New_Generic_Node);
end Copy;

function Copy ( obj : in Generic_Node_Ptr ) return Generic_Node_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Node) is 
begin
	put("cheddar_private_id: "); put(obj.cheddar_private_id); put ( "; " );
	put("Id: "); put(obj.Id); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Node_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Node_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Generic_Node ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("GENERIC_GRAPH.GENERIC_NODE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Generic_Node_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Generic_Node; result : in out Unbounded_String) is 
begin
	if (XML_String(obj.Id) /= Empty_String) then
		result := result & to_unbounded_string("<id>") & XML_String(obj.Id) & to_unbounded_string("</id>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Node) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_node id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</generic_node>");
	return (result);
end XML_String;

function XML_String(obj : in Generic_Node_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Generic_Node) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_node ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Generic_Node_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Generic_Edge =--------

procedure Initialize(obj : in out Generic_Edge) is 
begin
	generate_id( framework_id, obj.cheddar_private_id );
	obj.Id := empty_string;
	obj.Node_1 := empty_string;
	obj.Node_2 := empty_string;
end Initialize;

function Copy ( obj : in Generic_Edge ) return Generic_Edge_Ptr is
	New_Generic_Edge : Generic_Edge_Ptr;
begin
	New_Generic_Edge := new Generic_Edge'(obj);
	return (New_Generic_Edge);
end Copy;

function Copy ( obj : in Generic_Edge_Ptr ) return Generic_Edge_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Edge) is 
begin
	put("cheddar_private_id: "); put(obj.cheddar_private_id); put ( "; " );
	put("Id: "); put(obj.Id); put ( "; " );
	put("Node_1: "); put(obj.Node_1); put ( "; " );
	put("Node_2: "); put(obj.Node_2); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Edge_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Edge_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Generic_Edge ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("GENERIC_GRAPH.GENERIC_EDGE");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Generic_Edge_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Generic_Edge; result : in out Unbounded_String) is 
begin
	if (XML_String(obj.Id) /= Empty_String) then
		result := result & to_unbounded_string("<id>") & XML_String(obj.Id) & to_unbounded_string("</id>");
	end if;
	if (XML_String(obj.Node_1) /= Empty_String) then
		result := result & to_unbounded_string("<node_1>") & XML_String(obj.Node_1) & to_unbounded_string("</node_1>");
	end if;
	if (XML_String(obj.Node_2) /= Empty_String) then
		result := result & to_unbounded_string("<node_2>") & XML_String(obj.Node_2) & to_unbounded_string("</node_2>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_edge id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</generic_edge>");
	return (result);
end XML_String;

function XML_String(obj : in Generic_Edge_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Generic_Edge) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_edge ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Generic_Edge_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Graph =--------

procedure Initialize(obj : in out Graph) is 
begin
	generate_id( framework_id, obj.cheddar_private_id );
end Initialize;

function Copy ( obj : in Graph ) return Graph_Ptr is
	New_Graph : Graph_Ptr;
begin
	New_Graph := new Graph'(obj);
	return (New_Graph);
end Copy;

function Copy ( obj : in Graph_Ptr ) return Graph_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Graph) is 
begin
	put("cheddar_private_id: "); put(obj.cheddar_private_id); put ( "; " );
	put("Nodes: "); put(obj.Nodes); put ( "; " );
	put("Edges: "); put(obj.Edges); put ( "; " );
end Put;
 
procedure Put(obj : in Graph_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Graph_Ptr) is
begin
	Put ( To_String ( Obj.cheddar_private_id ) );
end Put_Name;

function type_of ( obj : in Graph ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("GENERIC_GRAPH.GRAPH");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Graph_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Graph; result : in out Unbounded_String) is 
begin
	if (XML_String(obj.Nodes) /= Empty_String) then
		result := result & to_unbounded_string("<nodes>") & XML_String(obj.Nodes) & to_unbounded_string("</nodes>");
	end if;
	if (XML_String(obj.Edges) /= Empty_String) then
		result := result & to_unbounded_string("<edges>") & XML_String(obj.Edges) & to_unbounded_string("</edges>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Graph) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<graph id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</graph>");
	return (result);
end XML_String;

function XML_String(obj : in Graph_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Graph) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<graph ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Graph_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Generic_Graph;
