


 procedure Compute_Ceiling_Of_Resources
     (My_Scheduler       : in Fixed_Priority_Scheduler;
      Processor_Name     : in Unbounded_String;
      My_Tasks           : in out Tasks_Set;
      My_Resources       : in out Resources_Set;
      Msg            : in out Unbounded_String;
      Blocking_Time  : out Blocking_Time_Table)
   is

   begin

      -- Set priority ceiling of resources : only for PCP and IPCP resources and
      -- only if Automatic_Assignment is requested
      --
      for K in 0 .. Si.Number_Of_Resources - 1 loop

         if (Si.Shared_Resources (K).Shared.protocol =
             Priority_Ceiling_Protocol) or
            (Si.Shared_Resources (K).Shared.protocol =
             Immediate_Priority_Ceiling_Protocol)
         then
       if si.shared_resources(k).shared.priority_assignment = manual_assignment
            then
               Fixed_Priority_Resource_Ptr (Si.Shared_Resources (K)).
                 Priority_Ceiling := si.shared_resources(k).shared.Priority;

                else

               Fixed_Priority_Resource_Ptr (Si.Shared_Resources (K)).
                 Priority_Ceiling := Priority_Range'First;

               for I in 0 ..  Si.Shared_Resources (K).Shared.critical_sections.nb_entries - 1 loop
                  for J in 0 .. Si.Number_Of_Tasks - 1 loop
                        if Si.Shared_Resources (K).Shared.critical_sections.entries (I).
                             item =
                           Si.Tcbs (J).Tsk.name
                        then
                           Fixed_Priority_Resource_Ptr (Si.Shared_Resources (K)
).Priority_Ceiling :=
                              Priority_Range'Max
                                (Fixed_Priority_Tcb_Ptr (Si.Tcbs (J)).
                             Current_Priority,
                                 Fixed_Priority_Resource_Ptr (
                             Si.Shared_Resources (K)).Priority_Ceiling);
                        end if;
                  end loop;
               end loop;
            end if;
       end if;
      end loop;

   end Compute_Ceiling_Of_Resources;


