------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 15:09:39 +0200 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Xml_Tag;                                use Xml_Tag;
with double_util;                            use double_util;
with Feasibility_Test.processor_utilization;
use  Feasibility_Test.processor_utilization;
with Text_IO;             		use Text_IO;
with Translate;           		use Translate;
with unbounded_strings;   		use unbounded_strings;
with Scheduler;           		use Scheduler;
with Scheduling_Analysis; 		use Scheduling_Analysis;
with Call_Framework_Interface; 		use Call_Framework_Interface;
use Scheduling_Analysis.Double_Tasks_Parameters_Package;
with priority_assignment.rm;
use  priority_assignment.rm;
with priority_assignment.dm;
use priority_assignment.dm;
with systems; use systems;
with Scheduler.Fixed_Priority;                       
use Scheduler.Fixed_Priority;
with Scheduler.Fixed_Priority.Dm;                       
use Scheduler.Fixed_Priority.Dm;
with Scheduler.Fixed_Priority.Rm;                       
use Scheduler.Fixed_Priority.Rm;
with Scheduler.Fixed_Priority.Hpf;                      
use Scheduler.Fixed_Priority.Hpf;
with Cache_Set; 			use Cache_Set;
with Caches; 				use Caches;
with Cache_Block_Set;			use Cache_Block_Set;
with Cache_Access_Profile_Set;		use Cache_Access_Profile_Set;




package feasibility_test.periodic_task_worst_case_response_time_fixed_priority is 
      
   procedure Compute_Response_Time
     (My_Scheduler   			: in Rm_Scheduler;
      My_Tasks       			: in out Tasks_Set;
      Processor_Name 			: in Unbounded_String;
      Msg            			: in out Unbounded_String;
      Response_Time  			: out Response_Time_Table;
      With_CRPD 			: in Boolean 				:= false;
      CRPD_Computation_Approach 	: in CRPD_Computation_Approach_Type 	:= ECB_Only;
      Block_Reload_Time 		: in Natural 				:= 0;
      My_Cache_Access_Profiles	     	: in Cache_Access_Profiles_Set 		:= no_cache_access_profile);


   procedure Compute_Response_Time
     (My_Scheduler   			: in Dm_Scheduler;
      My_Tasks       			: in out Tasks_Set;
      Processor_Name 			: in Unbounded_String;
      Msg            			: in out Unbounded_String;
      Response_Time  			: out Response_Time_Table;
      With_CRPD 			: in Boolean 				:= false;
      CRPD_Computation_Approach 	: in CRPD_Computation_Approach_Type 	:= ECB_Only;
      Block_Reload_Time 		: in Natural 				:= 0;
      My_Cache_Access_Profiles	     	: in Cache_Access_Profiles_Set 		:= no_cache_access_profile);

   procedure Compute_Response_Time
     (My_Scheduler   			: in Hpf_Scheduler;
      My_Tasks       			: in out Tasks_Set;
      Processor_Name 			: in Unbounded_String;
      Msg            			: in out Unbounded_String;
      Response_Time  			: out Response_Time_Table;
      With_CRPD 			: in Boolean 				:= false;
      CRPD_Computation_Approach 	: in CRPD_Computation_Approach_Type 	:= ECB_Only;
      Block_Reload_Time 		: in Natural 				:= 0;
      My_Cache_Access_Profiles	     	: in Cache_Access_Profiles_Set 		:= no_cache_access_profile);
   
   procedure Compute_Response_Time
     (My_Scheduler   			: in Fixed_Priority_Scheduler;
      My_Tasks       			: in out Tasks_Set;
      Processor_Name 			: in Unbounded_String;
      Msg            			: in out Unbounded_String;
      Response_Time  			: out Response_Time_Table;
      With_CRPD 			: in Boolean 				:= false;
      CRPD_Computation_Approach 	: in CRPD_Computation_Approach_Type 	:= ECB_Only;
      Block_Reload_Time 		: in Natural 				:= 0;
      My_Cache_Access_Profiles	     	: in Cache_Access_Profiles_Set 		:= no_cache_access_profile);





end feasibility_test.periodic_task_worst_case_response_time_fixed_priority;
