with Text_IO;use Text_IO;
with Framework_Config;          use Framework_Config;
with Translate;                 use Translate;
with unbounded_strings;         use unbounded_strings;
with Scheduler;                 use Scheduler;
with Scheduling_Analysis;       use Scheduling_Analysis;
use Scheduling_Analysis.Double_Tasks_Parameters_Package;
with Deployments;               use Deployments;
with deployment_Set;            use deployment_Set;
use deployment_Set.Generic_deployment_Set;
with Systems;                   use Systems;
with Tasks;                     use Tasks;
with Ada.Numerics.Aux;          use Ada.Numerics.Aux;
with Ada.Numerics.Float_Random; use Ada.Numerics.Float_Random;
with Core_Units;                use Core_Units;

package hierarchical_analysis_methods_temporary is

   function compute_partition_internal_busy_period
     (deployment    : in Generic_Deployment_Ptr;
      priority      : Priority_Range;
      window        : Double;
      bounded_tasks : in Boolean)
      return          Double;

   function compute_partition_internal_gaps
     (deployment    : in Generic_Deployment_Ptr;
      priority      : Priority_Range;
      window        : Double;
      bounded_tasks : in Boolean)
      return          Double;

   function compute_server_interference
     (My_deployments : in deployments_Set;
      Taski_Ptr      : Generic_Task_Ptr;
      window         : Double;
      bounded_tasks  : in Boolean)
      return           Double;

   function compute_wcrt
     (My_sys        : in System;
      Taski_Ptr     : Generic_Task_Ptr;
      bounded_tasks : in Boolean)
      return          Double;

end hierarchical_analysis_methods_temporary;
