
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2009   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with framework;
use framework;

with id_generators;
use id_generators;



Package Body Atomic_Operations is 
 
function XML_String(obj : in Processor_Sort_Type) return Unbounded_String is
begin
	return to_unbounded_string(Processor_Sort_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Processor_Sort_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;


function XML_String(obj : in Task_Sort_Type) return Unbounded_String is
begin
	return to_unbounded_string(Task_Sort_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Task_Sort_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;


function XML_String(obj : in Feasibility_Test_Type) return Unbounded_String is
begin
	return to_unbounded_string(Feasibility_Test_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Feasibility_Test_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;


function XML_String(obj : in Loop_Operation_Type) return Unbounded_String is
begin
	return to_unbounded_string(Loop_Operation_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Loop_Operation_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;



-- --------= Atomic_Operation =--------

procedure Initialize(obj : in out Atomic_Operation) is 
begin
	initialize(CFG_Node(obj));
	obj.task_sorting := Task_Period;
	obj.processor_sorting := Processor_Index;
	obj.feasibility_test := Condition_IP_Test;
	obj.graph_type := CFG_Atomic_Operation;
end Initialize;

function Copy ( obj : in Atomic_Operation ) return Atomic_Operation_Ptr is
	New_Atomic_Operation : Atomic_Operation_Ptr;
begin
	New_Atomic_Operation := new Atomic_Operation'(obj);
	return (New_Atomic_Operation);
end Copy;

function Copy ( obj : in Atomic_Operation_Ptr ) return Atomic_Operation_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Atomic_Operation) is 
begin
	put(CFG_Node(obj));
	put("task_sorting: "); put(obj.task_sorting); put ( "; " );
	put("processor_sorting: "); put(obj.processor_sorting); put ( "; " );
	put("feasibility_test: "); put(obj.feasibility_test); put ( "; " );
end Put;
 
procedure Put(obj : in Atomic_Operation_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Atomic_Operation_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Atomic_Operation) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Atomic_Operation_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Atomic_Operation ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("CFG_NODES.CFG_NODE");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("ATOMIC_OPERATIONS.ATOMIC_OPERATION");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Atomic_Operation_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Atomic_Operation; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(CFG_Node(obj), result);
	if (XML_String(obj.task_sorting) /= Empty_String) then
		result := result & to_unbounded_string("<task_sorting>") & XML_String(obj.task_sorting) & to_unbounded_string("</task_sorting>");
	end if;
	if (XML_String(obj.processor_sorting) /= Empty_String) then
		result := result & to_unbounded_string("<processor_sorting>") & XML_String(obj.processor_sorting) & to_unbounded_string("</processor_sorting>");
	end if;
	if (XML_String(obj.feasibility_test) /= Empty_String) then
		result := result & to_unbounded_string("<feasibility_test>") & XML_String(obj.feasibility_test) & to_unbounded_string("</feasibility_test>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Atomic_Operation) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<atomic_operation id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</atomic_operation>");
	return (result);
end XML_String;

function XML_String(obj : in Atomic_Operation_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Atomic_Operation) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<atomic_operation ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Atomic_Operation_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Partitioning_Algorithm =--------

procedure Initialize(obj : in out Partitioning_Algorithm) is 
begin
	generate_id( framework_id, obj.cheddar_private_id );
	obj.name := empty_string;
	obj.task_set := empty_string;
	obj.processor_set := empty_string;
	obj.task_sorting := Task_Period;
	obj.looping := RMFF_loop;
	obj.processor_sorting := Processor_Index;
	obj.feasibility_test := Condition_IP_Test;
end Initialize;

function Copy ( obj : in Partitioning_Algorithm ) return Partitioning_Algorithm_Ptr is
	New_Partitioning_Algorithm : Partitioning_Algorithm_Ptr;
begin
	New_Partitioning_Algorithm := new Partitioning_Algorithm'(obj);
	return (New_Partitioning_Algorithm);
end Copy;

function Copy ( obj : in Partitioning_Algorithm_Ptr ) return Partitioning_Algorithm_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Partitioning_Algorithm) is 
begin
	put("cheddar_private_id: "); put(obj.cheddar_private_id); put ( "; " );
	put("name: "); put(obj.name); put ( "; " );
	put("task_set: "); put(obj.task_set); put ( "; " );
	put("processor_set: "); put(obj.processor_set); put ( "; " );
	put("task_sorting: "); put(obj.task_sorting); put ( "; " );
	put("looping: "); put(obj.looping); put ( "; " );
	put("processor_sorting: "); put(obj.processor_sorting); put ( "; " );
	put("feasibility_test: "); put(obj.feasibility_test); put ( "; " );
end Put;
 
procedure Put(obj : in Partitioning_Algorithm_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Partitioning_Algorithm_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function type_of ( obj : in Partitioning_Algorithm ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("ATOMIC_OPERATIONS.PARTITIONING_ALGORITHM");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Partitioning_Algorithm_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Partitioning_Algorithm; result : in out Unbounded_String) is 
begin
	if (XML_String(obj.name) /= Empty_String) then
		result := result & to_unbounded_string("<name>") & XML_String(obj.name) & to_unbounded_string("</name>");
	end if;
	if (XML_String(obj.task_set) /= Empty_String) then
		result := result & to_unbounded_string("<task_set>") & XML_String(obj.task_set) & to_unbounded_string("</task_set>");
	end if;
	if (XML_String(obj.processor_set) /= Empty_String) then
		result := result & to_unbounded_string("<processor_set>") & XML_String(obj.processor_set) & to_unbounded_string("</processor_set>");
	end if;
	if (XML_String(obj.task_sorting) /= Empty_String) then
		result := result & to_unbounded_string("<task_sorting>") & XML_String(obj.task_sorting) & to_unbounded_string("</task_sorting>");
	end if;
	if (XML_String(obj.looping) /= Empty_String) then
		result := result & to_unbounded_string("<looping>") & XML_String(obj.looping) & to_unbounded_string("</looping>");
	end if;
	if (XML_String(obj.processor_sorting) /= Empty_String) then
		result := result & to_unbounded_string("<processor_sorting>") & XML_String(obj.processor_sorting) & to_unbounded_string("</processor_sorting>");
	end if;
	if (XML_String(obj.feasibility_test) /= Empty_String) then
		result := result & to_unbounded_string("<feasibility_test>") & XML_String(obj.feasibility_test) & to_unbounded_string("</feasibility_test>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Partitioning_Algorithm) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<partitioning_algorithm id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</partitioning_algorithm>");
	return (result);
end XML_String;

function XML_String(obj : in Partitioning_Algorithm_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Partitioning_Algorithm) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<partitioning_algorithm ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Partitioning_Algorithm_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Atomic_Operations;
