------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 15:09:39 +0200 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with unbounded_strings; use unbounded_strings;

package body Xml_Tag is


   procedure Set_Tag is

   begin
      Start_Result                := To_Unbounded_String ("<results>");
      End_Result                  := To_Unbounded_String ("</results>");
      Start_Line                  := To_Unbounded_String ("<line>");
      End_Line                    := To_Unbounded_String ("</line>");
      Start_Sched_Feas            :=
         To_Unbounded_String ("<scheduling_feasibility>");
      End_Sched_Feas              :=
         To_Unbounded_String ("</scheduling_feasibility>");
      End_Sched_Sim               :=
         To_Unbounded_String ("</scheduling_simulation>");
      Start_Sched_Sim             :=
         To_Unbounded_String ("<scheduling_simulation>");
      Start_Probability           := To_Unbounded_String ("<probability>");
      End_Probability             := To_Unbounded_String ("</probability>");
      Start_Response_Time_Density :=
         To_Unbounded_String ("<response_time_density>");
      End_Response_Time_Density   :=
         To_Unbounded_String ("</response_time_density>");
      Start_Task                  := To_Unbounded_String ("<task>");
      End_Task                    := To_Unbounded_String ("</task>");
      Start_Block                 := To_Unbounded_String ("<blocking_time>");
      End_Block                   := To_Unbounded_String ("</blocking_time>");
      Start_Buf_Bound             := To_Unbounded_String ("<buffer_bound>");
      End_Buf_Bound               := To_Unbounded_String ("</buffer_bound>");
      Start_Response_Time         := To_Unbounded_String ("<response_time>");
      End_Response_Time           := To_Unbounded_String ("</response_time>");
      Start_Title                 := To_Unbounded_String ("<title>");
      End_Title                   := To_Unbounded_String ("</title>");
      Start_Set_Prio              := To_Unbounded_String ("<set_priorities>");
      End_Set_Prio                :=
         To_Unbounded_String ("</set_priorities>");
      Start_End_To_End            :=
         To_Unbounded_String ("<end_to_end_response_time>");
      End_End_To_End              :=
         To_Unbounded_String ("</end_to_end_response_time>");
      Start_Proc                  := To_Unbounded_String ("<processor>");
      End_Proc                    := To_Unbounded_String ("</processor>");
      Start_Num_Of_Preemp         :=
         To_Unbounded_String ("<number_of_preemption>");
      End_Num_Of_Preemp           :=
         To_Unbounded_String ("</number_of_preemption>");
      Start_Num_Of_Context_Switch :=
         To_Unbounded_String ("<number_of_context_switch>");
      End_Num_Of_Context_Switch   :=
         To_Unbounded_String ("</number_of_context_switch>");
      Start_Unit                  := To_Unbounded_String ("<unit>");
      End_Unit                    := To_Unbounded_String ("</unit>");
      Start_Ref                   := To_Unbounded_String ("<reference>");
      End_Ref                     := To_Unbounded_String ("</reference>");
      Start_Fact_Bound            := To_Unbounded_String ("<factor_bound>");
      End_Fact_Bound              := To_Unbounded_String ("</factor_bound>");
      Start_Bas_Per               := To_Unbounded_String ("<base_period>");
      End_Bas_Per                 := To_Unbounded_String ("</base_period>");
      Start_Per_Fact              := To_Unbounded_String ("<period_factor>");
      End_Per_Fact                := To_Unbounded_String ("</period_factor>");
      Start_Deadl_Fact            :=
         To_Unbounded_String ("<deadline_factor>");
      End_Deadl_Fact              :=
         To_Unbounded_String ("</deadline_factor>");
      Start_Jit                   := To_Unbounded_String ("<jitter>");
      End_Jit                     := To_Unbounded_String ("</jitter>");

   end Set_Tag;

   procedure Set_Empty is

   begin

      Start_Result                := empty_string;
      End_Result                  := empty_string;
      Start_Title                 := empty_string;
      End_Title                   := empty_string;
      Start_Line                  := empty_string;
      End_Line                    := empty_string;
      Start_Sched_Feas            := empty_string;
      End_Sched_Feas              := empty_string;
      End_Sched_Sim               := empty_string;
      Start_Sched_Sim             := empty_string;
      Start_Task                  := empty_string;
      End_Task                    := empty_string;
      Start_Block                 := empty_string;
      End_Block                   := empty_string;
      Start_Buf_Bound             := empty_string;
      End_Buf_Bound               := empty_string;
      Start_Title                 := empty_string;
      End_Title                   := empty_string;
      Start_Set_Prio              := empty_string;
      End_Set_Prio                := empty_string;
      Start_End_To_End            := empty_string;
      End_End_To_End              := empty_string;
      Start_Proc                  := empty_string;
      End_Proc                    := empty_string;
      Start_Num_Of_Preemp         := empty_string;
      End_Num_Of_Preemp           := empty_string;
      Start_Unit                  := empty_string;
      End_Unit                    := empty_string;
      Start_Ref                   := empty_string;
      End_Ref                     := empty_string;
      Start_Fact_Bound            := empty_string;
      End_Fact_Bound              := empty_string;
      Start_Bas_Per               := empty_string;
      End_Bas_Per                 := empty_string;
      Start_Per_Fact              := empty_string;
      End_Per_Fact                := empty_string;
      Start_Deadl_Fact            := empty_string;
      End_Deadl_Fact              := empty_string;
      Start_Jit                   := empty_string;
      End_Jit                     := empty_string;
      Start_Probability           := empty_string;
      End_Probability             := empty_string;
      Start_Response_Time_Density := empty_string;
      End_Response_Time_Density   := empty_string;
      Start_Response_Time         := empty_string;
      End_Response_Time           := empty_string;

   end Set_Empty;

end Xml_Tag;
