------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 15:09:39 +0200 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package Xml_Tag is


   procedure Set_Tag;
   procedure Set_Empty;

   Start_Result                : Unbounded_String;
   End_Result                  : Unbounded_String;
   Start_Line                  : Unbounded_String;
   End_Line                    : Unbounded_String;
   Start_Sched_Feas            : Unbounded_String;
   End_Sched_Feas              : Unbounded_String;
   End_Sched_Sim               : Unbounded_String;
   Start_Sched_Sim             : Unbounded_String;
   Start_Task                  : Unbounded_String;
   End_Task                    : Unbounded_String;
   Start_Block                 : Unbounded_String;
   End_Block                   : Unbounded_String;
   Start_Buf_Bound             : Unbounded_String;
   End_Buf_Bound               : Unbounded_String;
   Start_Title                 : Unbounded_String;
   End_Title                   : Unbounded_String;
   Start_Set_Prio              : Unbounded_String;
   End_Set_Prio                : Unbounded_String;
   Start_End_To_End            : Unbounded_String;
   End_End_To_End              : Unbounded_String;
   Start_Proc                  : Unbounded_String;
   End_Proc                    : Unbounded_String;
   Start_Num_Of_Preemp         : Unbounded_String;
   End_Num_Of_Preemp           : Unbounded_String;
   Start_Num_Of_Context_Switch : Unbounded_String;
   End_Num_Of_Context_Switch   : Unbounded_String;
   Start_Unit                  : Unbounded_String;
   End_Unit                    : Unbounded_String;
   Start_Ref                   : Unbounded_String;
   End_Ref                     : Unbounded_String;
   Start_Fact_Bound            : Unbounded_String;
   End_Fact_Bound              : Unbounded_String;
   Start_Bas_Per               : Unbounded_String;
   End_Bas_Per                 : Unbounded_String;
   Start_Per_Fact              : Unbounded_String;
   End_Per_Fact                : Unbounded_String;
   Start_Deadl_Fact            : Unbounded_String;
   End_Deadl_Fact              : Unbounded_String;
   Start_Jit                   : Unbounded_String;
   End_Jit                     : Unbounded_String;
   Start_Probability           : Unbounded_String;
   End_Probability             : Unbounded_String;
   Start_Response_Time_Density : Unbounded_String;
   End_Response_Time_Density   : Unbounded_String;
   Start_Response_Time         : Unbounded_String;
   End_Response_Time           : Unbounded_String;

end Xml_Tag;
