------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with boolean_util; use boolean_util;
with double_util;  use double_util;
with natural_util;  use natural_util;
with integer_util; use integer_util;
with unbounded_strings; use unbounded_strings;


package body primitive_xml_strings is


   function XML_String
     (obj   : in Priority_Range)
      return  Unbounded_String
   is
   begin
      return integer_util.format (Integer (obj));
   end XML_String;

   function XML_String
     (obj   : in Integer)
      return  Unbounded_String
   is
   begin
      return integer_util.format (obj);
   end XML_String;


  function XML_String
     (obj   : in natural_ptr)
      return  Unbounded_String
   is
   begin
      return natural_util.format (obj.all);
   end XML_String;

   function XML_String
     (obj   : in Double)
      return  Unbounded_String
   is
   begin
      return format (obj);
   end XML_String;


   function XML_String
     (obj   : in Double_ptr)
      return  Unbounded_String
   is
   begin
      return format (obj.all);
   end XML_String;

   function XML_String
     (obj   : in Boolean)
      return  Unbounded_String
   is
   begin
      return format (obj);
   end XML_String;

   function XML_String
     (obj   : in Boolean_Ptr)
      return  Unbounded_String
   is
   begin
      return format (obj.all);
   end XML_String;


   function XML_String
     (obj   : in Unbounded_String)
      return  Unbounded_String
   is
   begin
      return obj;
   end XML_String;


   --------------------
   -- XML_Ref_String --
   --------------------

   function XML_ref_String
     (obj   : in Priority_Range)
      return  Unbounded_String
   is
   begin
           raise xml_ref_string_error;
      return empty_string;
   end XML_ref_String;


   function XML_ref_String
     (obj   : in Integer)
      return  Unbounded_String
   is
   begin
           raise xml_ref_string_error;
      return empty_string;
   end XML_ref_String;


   function XML_ref_String
     (obj   : in Double)
      return  Unbounded_String
   is
   begin
           raise xml_ref_string_error;
      return empty_string;
   end XML_ref_String;

   function XML_ref_String
     (obj   : in Boolean)
      return  Unbounded_String
   is
   begin
      raise XML_ref_string_error;
      return empty_string;
   end XML_ref_String;

   function XML_ref_String
     (obj   : in Unbounded_String)
      return  Unbounded_String
   is
   begin
      raise XML_ref_string_error;
      return empty_string;
   end XML_ref_String;

end primitive_xml_strings;
