------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Framework_Config; use Framework_Config;

with Ada.Numerics.Aux;      use Ada.Numerics.Aux;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with double_util; use double_util;
with natural_util; use natural_util;
with boolean_util; use boolean_util;

package primitive_xml_strings is



-- When XML_String or XML_Ref_String can not
-- be run for a type, those exceptions will be raised
--
   XML_String_Error : exception;
   XML_Ref_String_Error : exception;



   function XML_String
     (obj   : in Priority_Range)
      return  Unbounded_String;

   function XML_String
     (obj   : in Integer)
      return  Unbounded_String;

   function XML_String
     (obj   : in Unbounded_String)
      return  Unbounded_String;

   function XML_String
     (obj   : in natural_ptr)
      return  Unbounded_String;

   function XML_String
     (obj   : in Boolean)
      return  Unbounded_String;

   function XML_String
     (obj   : in Boolean_Ptr)
      return  Unbounded_String;

   function XML_String
     (obj   : in Double)
      return  Unbounded_String;

   function XML_String
     (obj   : in Double_ptr)
      return  Unbounded_String;

   function XML_ref_String
     (obj   : in Priority_Range)
      return  Unbounded_String;

   function XML_ref_String
     (obj   : in Integer)
      return  Unbounded_String;

   function XML_ref_String
     (obj   : in Unbounded_String)
      return  Unbounded_String;

   function XML_ref_String
     (obj   : in Boolean)
      return  Unbounded_String;

   function XML_ref_String
     (obj   : in Double)
      return  Unbounded_String;

end primitive_xml_strings;
