with Ada.Numerics.Aux; 			use Ada.Numerics.Aux;
with Ada.Strings.Unbounded; 		use Ada.Strings.Unbounded;
with Text_IO;             		use Text_IO;
with unbounded_strings;   		use unbounded_strings;
with Scheduling_Analysis; 		use Scheduling_Analysis;
with Priority_Assignment.Audsley_OPA;	use Priority_Assignment.Audsley_OPA;
with Task_Set; 				use Task_Set;
with Tasks; 				use Tasks;
with Tasks.Extended; 			use Tasks.Extended;
with Priority_Assignment.Utility; 	use Priority_Assignment.Utility;
with Cache_Set;	 			use Cache_Set;
with CFG_Nodes.Extended; use CFG_Nodes.Extended;


package Priority_Assignment.Audsley_OPA_CRPD_Tree is
   OPTIMIZE_MEMORY : Boolean := TRUE;
   OPTIMIZE_NODES : Boolean := TRUE;
   CRPD_COMPUTATION : Boolean := TRUE;
   --------------------------------
   -- Perform feasibilitty testing with CRPD Interference computed by Tree solution
   --
   --------------------------------
   procedure OPA_Feasibility_Test_CRPD
     (priority_level 	: in Integer;
      number_of_task    : in Integer;
      i_task 		: in out Generic_Task_Ptr;
      my_tasks		: in out Tasks_Set;
      a_tuea		: in Task_UCB_ECB_Array_Ptr;
      is_schedulable 	: out Boolean);


   type Task_Activation_Type is (PREEMPTION,
                                 DENY_PREEMPTION,
                                 NO_EXECUTING_JOB);

   ---------------------------------------
   --
   ---------------------------------------
   procedure Compute_CRPD_Tree
     (tDi			: in Integer;
      number_of_task 		: in Integer;
      state  			: in Boolean := true;
      index  			: in Task_Release_Records_Range; 			-- IMPORTANT: index = a_node.index + 1;
      assessing_job_index 	: in Task_Release_Records_Range;
      counter			: in out Integer;
      a_node 			: in out CRPD_Node_Ptr;
      time   			: in Integer;						-- Release time of the job with index: index-1
      is_schedulable		: in out Boolean);					-- Release time of the job with index: index-1); 					-- Release time of the job with index: index

   ---------------------------------------
   --
   ---------------------------------------
   procedure Assess_Release_Set
     (a_trrt 		  : in out Task_Release_Records_Table_Ptr;
      tDi		  : in Integer;
      number_of_task 	  : in Integer := 0;
      assessing_job_index : in Task_Release_Records_Range;
      is_schedulable	  : in out Boolean);

end Priority_Assignment.Audsley_OPA_CRPD_Tree;
