with framework_config; use framework_config;
with tasks; use tasks;
with resources; use resources;
with resource_set; use resource_set;
use resource_set.Generic_Resource_Set;
use resources.Resource_Accesses;
with scheduling_analysis;
use scheduling_analysis;
use scheduling_analysis.Ceiling_Priority_Table_Package;

   
package body priority_assignment.ceiling_priority is 


procedure Compute_Ceiling_Priority
      (My_Tasks       : in out Tasks_Set;
      My_Resources       : in out Resources_Set;
      Processor_Name : in Unbounded_String := empty_string;
      Msg            : in out Unbounded_String;
      Ceiling_Priorities : out Ceiling_Priority_Table) is


    A_task : Generic_task_Ptr;
    A_resource      : Generic_resource_Ptr;
      My_Iterator : resources_Iterator;
 a_Priority_Ceiling : Priority_Range;
a_Ceiling_Priority_Record : Ceiling_Priority_Record_ptr;


   begin
      if (get_number_of_elements (My_resources) > 0) then

         reset_iterator (My_resources, My_Iterator);
         loop
            current_element (My_resources, A_resource, My_Iterator);

a_Priority_Ceiling := Priority_Range'First;
for i in 0..a_resource.critical_sections.nb_entries-1 loop
        a_task:=search_task(my_tasks, a_resource.critical_sections.entries(i).item);
	a_Priority_Ceiling:=priority_range'max(a_task.priority,a_Priority_Ceiling);
end loop;

a_Ceiling_Priority_Record := new Ceiling_Priority_Record;
a_Ceiling_Priority_Record.resource_name:=a_resource.name;
a_Ceiling_Priority_Record.ceiling_priority:=a_Priority_Ceiling;
add(Ceiling_Priorities, a_Ceiling_Priority_Record);

	
            exit when is_last_element (My_resources, My_Iterator);
            next_element (My_resources, My_Iterator);
         end loop;

      end if;


end Compute_Ceiling_Priority;


end priority_assignment.ceiling_priority;
