------------------------------------------------------------
--------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 15:09:39 +0200 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Systems; use Systems;
with Buffers; use Buffers;
use Buffers.Buffer_Roles_Package;
with Offsets; use Offsets;
use Offsets.Offsets_Table_Package;

package Random_Project is

   -- generate system 1 consumer/Nb_Prod producer
   --
   procedure Random_Project_1_N
     (Nb_Prod      : in Buffer_Roles_Range;
      Per_Max_Prod : in Natural;
      Per_Cons     : in Natural;
      Dea_Max      : in Natural;
      Max_Base_Per : in Natural;
      Sys          : out System);

   -- equal function for numeric stability
   --
   procedure Random_Project_1_N_Harmonic
     (Nb_Prod       : in Buffer_Roles_Range;
      Coef_Max_Prod : in Natural;
      Per_Cons      : in Natural;
      Dea_Max       : in Natural;
      Sys           : out System);

   -- generate system Nb_Cons consumer/Nb_Prod producer
   --
   procedure Random_Project
     (Nb_Prod      : in Buffer_Roles_Range;
      Nb_Cons      : in Buffer_Roles_Range;
      Per_Max_Prod : in Natural;
      Per_Max_Cons : in Natural;
      Per_Min_Cons : in Natural;
      Dea_Max      : in Natural;
      Max_Base_Per : in Natural;
      Sys          : out System);

end Random_Project;
