
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with Scheduling_Analysis;
use Scheduling_Analysis;

with Time_Unit_Events;
use Time_Unit_Events;

use Time_Unit_Events.Time_Unit_Package;



Package Body Multiprocessor_Services_Interface is 
 

-- --------= Scheduling_Result =--------

procedure Initialize(obj : out Scheduling_Result) is 
begin
	obj.scheduling_msg := empty_string;
	obj.has_error := false;
	obj.error_msg := empty_string;
	
	if obj.result /= null then
		Free (obj.result );
	end if;
	obj.result := new Scheduling_Sequence;
	Initialize(obj.result.all);

end Initialize;

procedure Put(obj : in Scheduling_Result) is 
begin
	put("scheduling_msg: "); put(obj.scheduling_msg); put ( "; " );
	put("has_error: "); standards_io.boolean_io.put(obj.has_error); put ( "; " );
	put("error_msg: "); put(obj.error_msg); put ( "; " );
	put("result: "); if obj.result /= null then put(obj.result.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Scheduling_Result_Ptr) is
begin
	Put(Obj.All);
end Put;


procedure Build_Attributes_XML_String(obj : in Scheduling_Result; result : in out Unbounded_String) is 
begin
	if (XML_String(obj.scheduling_msg) /= Empty_String) then
		result := result & to_unbounded_string("<scheduling_msg>") & XML_String(obj.scheduling_msg) & to_unbounded_string("</scheduling_msg>");
	end if;
	if (XML_String(obj.has_error) /= Empty_String) then
		result := result & to_unbounded_string("<has_error>") & XML_String(obj.has_error) & to_unbounded_string("</has_error>");
	end if;
	if (XML_String(obj.error_msg) /= Empty_String) then
		result := result & to_unbounded_string("<error_msg>") & XML_String(obj.error_msg) & to_unbounded_string("</error_msg>");
	end if;
	if (XML_String(obj.result) /= Empty_String) then
		result := result & to_unbounded_string("<result>") & XML_String(obj.result) & to_unbounded_string("</result>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Scheduling_Result) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<scheduling_result>");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</scheduling_result>");
	return (result);
end XML_String;

function XML_String(obj : in Scheduling_Result_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Scheduling_Result) return Unbounded_String is
	result : Unbounded_String;
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;

function Copy ( obj : in Scheduling_Result ) return Scheduling_Result_Ptr is
	New_Scheduling_Result : Scheduling_Result_Ptr;
begin
	New_Scheduling_Result := new Scheduling_Result'(obj);
	return (New_Scheduling_Result);
end Copy;

function Copy ( obj : in Scheduling_Result_Ptr ) return Scheduling_Result_Ptr is
begin
	return copy(obj.all);
end Copy;



-- --------= Run_Server =--------

procedure Initialize(obj : out Run_Server) is 
begin
	obj.Rate := 0.0;
	obj.Deadline := 0;
	obj.is_ready := false;
end Initialize;

procedure Put(obj : in Run_Server) is 
begin
	put("Server: "); if obj.Server /= null then put(obj.Server.all); else put("null"); end if;put ( "; " );
	put("Rate: "); standards_io.double_io.put(obj.Rate); put ( "; " );
	put("Deadline: "); standards_io.natural_io.put(obj.Deadline); put ( "; " );
	put("is_ready: "); standards_io.boolean_io.put(obj.is_ready); put ( "; " );
	put("Childs: "); put(obj.Childs); put ( "; " );
end Put;
 
procedure Put(obj : in Run_Server_Ptr) is
begin
	Put(Obj.All);
end Put;


procedure Build_Attributes_XML_String(obj : in Run_Server; result : in out Unbounded_String) is 
begin
	result := result & to_unbounded_string("<Server ref=""") & obj.Server.cheddar_private_id & to_unbounded_string(""" />");
	if (XML_String(obj.Rate) /= Empty_String) then
		result := result & to_unbounded_string("<rate>") & XML_String(obj.Rate) & to_unbounded_string("</rate>");
	end if;
	if (XML_String(obj.Deadline) /= Empty_String) then
		result := result & to_unbounded_string("<deadline>") & XML_String(obj.Deadline) & to_unbounded_string("</deadline>");
	end if;
	if (XML_String(obj.is_ready) /= Empty_String) then
		result := result & to_unbounded_string("<is_ready>") & XML_String(obj.is_ready) & to_unbounded_string("</is_ready>");
	end if;
	if (XML_String(obj.Childs) /= Empty_String) then
		result := result & to_unbounded_string("<childs>") & XML_String(obj.Childs) & to_unbounded_string("</childs>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Run_Server) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<run_server>");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</run_server>");
	return (result);
end XML_String;

function XML_String(obj : in Run_Server_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Run_Server) return Unbounded_String is
	result : Unbounded_String;
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;

function Copy ( obj : in Run_Server ) return Run_Server_Ptr is
	New_Run_Server : Run_Server_Ptr;
begin
	New_Run_Server := new Run_Server'(obj);
	return (New_Run_Server);
end Copy;

function Copy ( obj : in Run_Server_Ptr ) return Run_Server_Ptr is
begin
	return copy(obj.all);
end Copy;



End Multiprocessor_Services_Interface;
