
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

with id_generators;
use id_generators;

with Scheduling_Analysis;
use Scheduling_Analysis;

with Processors;
use Processors;

with Tasks;
use Tasks;

with Text_io;
use Text_io;

with Unbounded_Strings;
use Unbounded_Strings;

use unbounded_strings.Unbounded_String_List_Package;

with Convert_Strings;

with Convert_Unbounded_Strings;

with standards_io;
use standards_io;

use standards_io.natural_io;

use standards_io.double_io;

use standards_io.boolean_io;

with Ada.Finalization;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with Indexed_Tables;

with Tables;

with Time_Unit_Events;
use Time_Unit_Events;

use Time_Unit_Events.Time_Unit_Package;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;

with Ada.Numerics.Aux;
use Ada.Numerics.Aux;



Package Multiprocessor_Services_Interface is 
 
type Scheduling_Result; type Scheduling_Result_Ptr is access all Scheduling_Result;
type Run_Server; type Run_Server_Ptr is access all Run_Server;



-- --------= Scheduling_Result =--------

type Scheduling_Result is
record
 scheduling_msg : Unbounded_String;
 has_error : Boolean;
 error_msg : Unbounded_String;
 result : Scheduling_Sequence_Ptr;
end record;

procedure Initialize(obj : out Scheduling_Result);
procedure Put(obj : in Scheduling_Result);
procedure Put(obj : in Scheduling_Result_Ptr);
function Copy(obj : in Scheduling_Result_Ptr) return Scheduling_Result_Ptr;
function Copy(obj : in Scheduling_Result) return Scheduling_Result_Ptr;
procedure Build_Attributes_XML_String(obj : in Scheduling_Result; result : in out Unbounded_String);
function XML_String(obj : in Scheduling_Result) return Unbounded_String;
function XML_String(obj : in Scheduling_Result_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Scheduling_Result) return Unbounded_String;
procedure Free  is new Unchecked_Deallocation (Scheduling_Result, Scheduling_Result_Ptr);

package Scheduling_Result_Per_Processor_Package is new Indexed_Tables(Scheduling_Result, Generic_Processor_Ptr, Framework_Config.Max_Processors, 0, Put, Initialize, Processors.Put_Name, Get_Name, XML_String, XML_Ref_String, to_unbounded_string("time_unit"));
use Scheduling_Result_Per_Processor_Package;
subtype Scheduling_Table is Scheduling_Result_Per_Processor_Package.indexed_table;
subtype Scheduling_Table_Ptr is  Scheduling_Result_Per_Processor_Package.indexed_table_Ptr;
subtype Scheduling_Table_Range is Scheduling_Result_Per_Processor_Package.indexed_table_range;
subtype Scheduling_Table_Range_Ptr is  Scheduling_Result_Per_Processor_Package.indexed_table_range_Ptr;

package Periodic_Tasks_Table_Package is new Tables(Periodic_Task_Ptr, Framework_Config.Max_Tasks, Put, XML_String, XML_Ref_String);
use Periodic_Tasks_Table_Package;
subtype Periodic_Tasks_Table_Range is Periodic_Tasks_Table_Package.table_range;
subtype Periodic_Tasks_Table_Range_Ptr is  Periodic_Tasks_Table_Package.table_range_Ptr;
subtype Periodic_Tasks_Table is Periodic_Tasks_Table_Package.table;
subtype Periodic_Tasks_Table_Ptr is  Periodic_Tasks_Table_Package.table_Ptr;


-- --------= Run_Server =--------

type Run_Server is
record
 Server : Periodic_Task_Ptr;
 Rate : Double;
 Deadline : Natural;
 is_ready : Boolean;
 Childs : Periodic_Tasks_Table;
end record;

procedure Initialize(obj : out Run_Server);
procedure Put(obj : in Run_Server);
procedure Put(obj : in Run_Server_Ptr);
function Copy(obj : in Run_Server_Ptr) return Run_Server_Ptr;
function Copy(obj : in Run_Server) return Run_Server_Ptr;
procedure Build_Attributes_XML_String(obj : in Run_Server; result : in out Unbounded_String);
function XML_String(obj : in Run_Server) return Unbounded_String;
function XML_String(obj : in Run_Server_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Run_Server) return Unbounded_String;
procedure Free  is new Unchecked_Deallocation (Run_Server, Run_Server_Ptr);

package Run_Servers_Table_Package is new Tables(Run_Server_Ptr, Framework_Config.Max_Tasks, Put, XML_String, XML_String);
use Run_Servers_Table_Package;
subtype Run_Servers_Table_Range is Run_Servers_Table_Package.table_range;
subtype Run_Servers_Table_Range_Ptr is  Run_Servers_Table_Package.table_range_Ptr;
subtype Run_Servers_Table is Run_Servers_Table_Package.table;
subtype Run_Servers_Table_Ptr is  Run_Servers_Table_Package.table_Ptr;


End Multiprocessor_Services_Interface;
