with Ada.Strings.Unbounded;use Ada.Strings.Unbounded;
with Interpreter;           use Interpreter;
use Interpreter.Sets_Type_Package;
with Expressions;           use Expressions;
use Expressions.Variables_Type_Package;
with section_Set;           use section_Set;
use section_Set.package_Generic_section_Set;

package Parser is

   -- Function to parse a scheduler behavior
   --
   procedure Yyparse;

   -- Initialize parser Data
   -- First_file prepars the parser to read the first file.
   -- Next_file prepars to read all other files
   --
   procedure First_File (A_File_Name : in Unbounded_String);
   procedure Next_File (A_File_Name : in Unbounded_String);

   -- Stores the set of sections with their code
   --
   Root_Statement_Pointer : sections_Set;

   -- Table to store the list of Variables of
   -- a parametric scheduler
   --
   Variables_Table : Variables_Table_Type;

   -- Table to store the list of "set" statements
   -- in a parametric scheduler
   --
   Sets_Table : Sets_Table_Type;

end Parser;
