------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 422 $
--    $Date: 2011-04-20 20:59:09 +0200 (mer., 20 avr. 2011) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------


with Xml_Tag;           use Xml_Tag;
with double_util;       use double_util;
with Translate;         use Translate;
with ada.strings.unbounded;   use ada.strings.unbounded;
with unbounded_strings; use unbounded_strings;
with systems; use systems;
with ada.tags; use ada.tags;
with text_io; use text_io;
with Scheduling_Analysis; use Scheduling_Analysis;
use Scheduling_Analysis.Double_Tasks_Parameters_Package;
with systems;
use systems;
with task_set; use task_set;
use task_set.Generic_Task_Set;
with multiprocessor_services_interface;
use multiprocessor_services_interface;
use multiprocessor_services_interface.Periodic_Tasks_Table_Package;
use multiprocessor_services_interface.run_servers_Table_Package;
with id_generators;
use id_generators;
with debug;
use debug;
with framework_config;
use framework_config;




package run_trees is 


-- Store all data of a computed RUN tree
--
run_tree : array (0..Max_tasks) of run_servers_table;
nb_levels : natural :=0;




function compute_deadline(a_level :  in natural; a_server : in run_server_ptr) return natural;

procedure pack_first_fit (current : in run_servers_table; packed : in out run_servers_table);

procedure initialize_run_tree(my_tasks : in tasks_set; a_processor : in unbounded_string);

procedure dual(primal_server : in run_servers_table; dual_server : in out run_servers_table);

procedure reduce;

end run_trees;



