------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 395 $
--    $Date: 2011-04-11 20:43:38 +0200 (lun., 11 avr. 2011) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

package Scheduler.Fixed_Priority.aperiodic_server.sporadic is

   type sporadic_aperiodic_server_Scheduler is new
     aperiodic_server_Scheduler with private;
   type sporadic_aperiodic_server_Scheduler_Ptr is access all
     sporadic_aperiodic_server_Scheduler'Class;

   procedure Initialize
     (A_Scheduler : in out sporadic_aperiodic_server_Scheduler);

   function Copy
     (A_Scheduler : in sporadic_aperiodic_server_Scheduler)
      return        Generic_Scheduler_Ptr;

   procedure Do_Election
     (My_Scheduler       : in out sporadic_aperiodic_server_Scheduler;
      Si                 : in out Scheduling_Information;
      Result             : in out Scheduling_Sequence_Ptr;
      Msg                : in out Unbounded_String;
      Current_Time       : in Natural;
      Processor_Name     : in Unbounded_String;
      Address_Space_Name : in Unbounded_String;
      My_Dependencies    : in Tasks_Dependencies_Ptr;
      With_Offsets       : in Boolean;
      With_Precedencies  : in Boolean;
      With_Resources     : in Boolean;
      With_jitters     : in Boolean;
      With_minimize_preemption     : in Boolean;
      Event_To_Generate  : in Time_Unit_Event_Type_Boolean_Table;
      Elected            : in out Tasks_Range;
      No_Task            : in out Boolean);

private

	type sporadic_aperiodic_server_Scheduler is new aperiodic_server_Scheduler
	with
		record
			server_is_idle : Boolean := True;
		end record;

end Scheduler.Fixed_Priority.aperiodic_server.sporadic;
