------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 15:09:39 +0200 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Translate;  use Translate;
with Parameters; use Parameters;
use Parameters.User_Defined_Parameters_Table_Package;

package body Scheduler.User_Defined is

   procedure Set_Behavior_File_Name
     (My_Scheduler : in out user_defined_Scheduler;
      To_Set       : in Unbounded_String)
   is
   begin
      My_Scheduler.parameters.user_defined_scheduler_source_file_name :=
        To_Set;
   end Set_Behavior_File_Name;

   function Get_Behavior_File_Name
     (My_Scheduler : in user_defined_Scheduler)
      return         Unbounded_String
   is
   begin
      return My_Scheduler.parameters.user_defined_scheduler_source_file_name;
   end Get_Behavior_File_Name;

   procedure Set_String_Behavior
     (My_Scheduler : in out user_defined_Scheduler;
      To_Set       : in Unbounded_String)
   is
   begin
      My_Scheduler.parameters.user_defined_scheduler_source := To_Set;
   end Set_String_Behavior;

   function Get_String_Behavior
     (My_Scheduler : in user_defined_Scheduler)
      return         Unbounded_String
   is
   begin
      return My_Scheduler.parameters.user_defined_scheduler_source;
   end Get_String_Behavior;




   procedure Check_Before_Scheduling
     (My_Scheduler   : in user_defined_Scheduler;
      My_Tasks       : in Tasks_Set;
      Processor_Name : in Unbounded_String)
   is

   begin
      null;
   end Check_Before_Scheduling;


end Scheduler.User_Defined;
