
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_io;
use Text_io;

with unbounded_strings;
use unbounded_strings;

with primitive_xml_strings;
use primitive_xml_strings;

with Automaton;
use Automaton;

use automaton.Transition_Lists_Package;

use automaton.State_Lists_Package;



Package Body Sections is 
 
function XML_String(obj : in Sections_Type) return Unbounded_String is
begin
	return to_unbounded_string(Sections_Type'image (obj) );
end XML_String;

function XML_Ref_String (obj : in Sections_Type) return Unbounded_String is
begin
	raise xml_ref_string_error;
	return to_unbounded_string("");
end XML_Ref_String;



-- --------= Generic_Section =--------

procedure Initialize(obj : in out Generic_Section) is 
begin
	initialize(Named_Object(obj));
	obj.section_type := Automaton_Type;
	obj.file_name := empty_string;
	obj.object_type := Section_Object_Type;
end Initialize;

function Copy ( obj : in Generic_Section ) return Generic_Section_Ptr is
	New_Generic_Section : Generic_Section_Ptr;
begin
	New_Generic_Section := new Generic_Section'(obj);
	return (New_Generic_Section);
end Copy;

function Copy ( obj : in Generic_Section_Ptr ) return Generic_Section_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Generic_Section) is 
begin
	put(Named_Object(obj));
	put("section_type: "); put(obj.section_type); put ( "; " );
	put("file_name: "); put(obj.file_name); put ( "; " );
end Put;
 
procedure Put(obj : in Generic_Section_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Generic_Section_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Generic_Section) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Generic_Section_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Generic_Section ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("SECTIONS.GENERIC_SECTION");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Generic_Section_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Generic_Section; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Named_Object(obj), result);
	if (XML_String(obj.section_type) /= Empty_String) then
		result := result & to_unbounded_string("<section_type>") & XML_String(obj.section_type) & to_unbounded_string("</section_type>");
	end if;
	if (XML_String(obj.file_name) /= Empty_String) then
		result := result & to_unbounded_string("<file_name>") & XML_String(obj.file_name) & to_unbounded_string("</file_name>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Generic_Section) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_section id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</generic_section>");
	return (result);
end XML_String;

function XML_String(obj : in Generic_Section_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Generic_Section) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<generic_section ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Generic_Section_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Computation_Section =--------

procedure Initialize(obj : in out Computation_Section) is 
begin
	initialize(Generic_Section(obj));
end Initialize;

function Copy ( obj : in Computation_Section ) return Generic_Section_Ptr is
	New_Computation_Section : Computation_Section_Ptr;
begin
	New_Computation_Section := new Computation_Section'(obj);
	return Generic_Section_Ptr(New_Computation_Section);
end Copy;

function Copy ( obj : in Computation_Section_Ptr ) return Generic_Section_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Computation_Section) is 
begin
	put(Generic_Section(obj));
	put("first_statement: "); if obj.first_statement /= null then put(obj.first_statement.all); else put("null"); end if;put ( "; " );
end Put;
 
procedure Put(obj : in Computation_Section_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Computation_Section_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Computation_Section) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Computation_Section_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Computation_Section ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("SECTIONS.GENERIC_SECTION");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("SECTIONS.COMPUTATION_SECTION");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Computation_Section_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Computation_Section; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Section(obj), result);
	result := result & to_unbounded_string("<first_statement ref=""") & obj.first_statement.cheddar_private_id & to_unbounded_string(""" />");
end Build_Attributes_XML_String;

function XML_String(obj : in Computation_Section) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<computation_section id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</computation_section>");
	return (result);
end XML_String;

function XML_String(obj : in Computation_Section_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Computation_Section) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<computation_section ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Computation_Section_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




-- --------= Synchronization_Section =--------

procedure Initialize(obj : in out Synchronization_Section) is 
begin
	initialize(Generic_Section(obj));
end Initialize;

function Copy ( obj : in Synchronization_Section ) return Generic_Section_Ptr is
	New_Synchronization_Section : Synchronization_Section_Ptr;
begin
	New_Synchronization_Section := new Synchronization_Section'(obj);
	return Generic_Section_Ptr(New_Synchronization_Section);
end Copy;

function Copy ( obj : in Synchronization_Section_Ptr ) return Generic_Section_Ptr is
begin
	return copy(obj.all);
end Copy;

procedure Put(obj : in Synchronization_Section) is 
begin
	put(Generic_Section(obj));
	put("state_list: "); put(obj.state_list); put ( "; " );
	put("transition_list: "); put(obj.transition_list); put ( "; " );
end Put;
 
procedure Put(obj : in Synchronization_Section_Ptr) is
begin
	Put(Obj.All);
end Put;
 
procedure Put_Name ( obj : in Synchronization_Section_Ptr) is
begin
	Put ( To_String ( Obj.Name ) );
end Put_Name;

function Get_Name (obj : in Synchronization_Section) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function Get_Name (obj : in Synchronization_Section_ptr) return Unbounded_String is
begin
	return obj.name;
end Get_Name;

function type_of ( obj : in Synchronization_Section ) return unbounded_string_list is
	list : unbounded_string_list;
	s : unbounded_string_ptr;
begin
	Initialize(list);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.GENERIC_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("OBJECTS.NAMED_OBJECT");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("SECTIONS.GENERIC_SECTION");
	Add (list, s);

	s := new unbounded_string;
	s.all := to_unbounded_string("SECTIONS.SYNCHRONIZATION_SECTION");
	Add (list, s);

	return list;
end type_of;

function type_of ( obj : in Synchronization_Section_Ptr ) return unbounded_string_list is
begin
	return type_of(obj.all);
end type_of;


procedure Build_Attributes_XML_String(obj : in Synchronization_Section; result : in out Unbounded_String) is 
begin
	Build_Attributes_XML_String(Generic_Section(obj), result);
	if (XML_String(obj.state_list) /= Empty_String) then
		result := result & to_unbounded_string("<state_list>") & XML_String(obj.state_list) & to_unbounded_string("</state_list>");
	end if;
	if (XML_String(obj.transition_list) /= Empty_String) then
		result := result & to_unbounded_string("<transition_list>") & XML_String(obj.transition_list) & to_unbounded_string("</transition_list>");
	end if;
end Build_Attributes_XML_String;

function XML_String(obj : in Synchronization_Section) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<synchronization_section id=""") & obj.cheddar_private_id & to_unbounded_string(""" >");
	Build_Attributes_XML_String(obj, result);
	result := result & to_unbounded_string("</synchronization_section>");
	return (result);
end XML_String;

function XML_String(obj : in Synchronization_Section_Ptr) return Unbounded_String is
begin
	if obj /= null then
		return XML_String(obj.all);
	else
		return Empty_String;
	end if;
end XML_String;

function XML_Ref_String(obj : in Synchronization_Section) return Unbounded_String is
	result : Unbounded_String;
begin
	result := to_unbounded_string("<synchronization_section ref=""") & obj.cheddar_private_id & to_unbounded_string(""" />");
	return (result);
end XML_Ref_String;

function XML_Ref_String(obj : in Synchronization_Section_Ptr) return Unbounded_String is
begin
	return XML_Ref_String(obj.all);
end XML_Ref_String;




End Sections;
