
------------------------------------------------------------------------------
------------------------------------------------------------------------------
--  This source file was automatically generated by Platypus
--  see http://dossen.univ-brest.fr/apl
-- 
--  Any modification of this file will be lost. 
--  Please see the "platypus" directory instead : it contains the Cheddar's
--  model and its meta-model. 
------------------------------------------------------------------------------
 
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2014   Frank Singhoff
-- Cheddar is developed by the LAB-STICC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
-- 	To post to this mailing list, you must be subscribed
-- 	(see http//beru.univ-brest.fr/~singhoff/cheddar for details)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

with Framework_Config;
use Framework_Config;

with id_generators;
use id_generators;

with Objects;
use Objects;

with Statements;
use Statements;

with Automaton;
use Automaton;

use automaton.Transition_Lists_Package;

use automaton.State_Lists_Package;

with Convert_Strings;

with Convert_Unbounded_Strings;

with text_io;
use text_io;

with Unbounded_Strings;
use Unbounded_Strings;

use unbounded_strings.Unbounded_String_List_Package;

with Ada.Finalization;

with Unchecked_Deallocation;

with Primitive_XML_Strings;
use Primitive_XML_Strings;

with ada.strings.unbounded.text_io;
use ada.strings.unbounded.text_io;



Package Sections is 
 
type Generic_Section; type Generic_Section_Ptr is access all Generic_Section'Class;
type Computation_Section; type Computation_Section_Ptr is access all Computation_Section'Class;
type Synchronization_Section; type Synchronization_Section_Ptr is access all Synchronization_Section'Class;


type Sections_Type is (
	Automaton_Type,
	Start_Type,
	Priority_Type,
	Election_Type,
	Activation_Type,
	Check_Resource_Type,
	Allocate_Resource_Type,
	Release_Resource_Type,
	Gather_Event_Analyzer_Type,
	Display_Event_Analyzer_Type);

procedure To_Sections_Type is
new Convert_Strings(Sections_Type, Automaton_Type);
procedure To_Sections_Type is
new Convert_Unbounded_Strings(Sections_Type, Automaton_Type);
function XML_String (obj : in Sections_Type) return Unbounded_String;
function XML_Ref_String (obj : in Sections_Type) return Unbounded_String;
package Sections_Type_io is new text_io.enumeration_io(Sections_Type);
use Sections_Type_io;



-- --------= Generic_Section =--------

type Generic_Section is new Named_Object with 
record
 section_type : Sections_Type;
 file_name : Unbounded_String;
end record;

procedure Initialize(obj : in out Generic_Section);
procedure Put(obj : in Generic_Section);
procedure Put(obj : in Generic_Section_Ptr);
procedure Put_Name(obj : in Generic_Section_Ptr);
procedure Build_Attributes_XML_String(obj : in Generic_Section; result : in out Unbounded_String);
function XML_String(obj : in Generic_Section) return Unbounded_String;
function XML_String(obj : in Generic_Section_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Section) return Unbounded_String;
function XML_Ref_String(obj : in Generic_Section_Ptr) return Unbounded_String;
function Get_Name (obj : in Generic_Section) return Unbounded_String;
function Get_Name (obj : in Generic_Section_Ptr) return Unbounded_String;
function Copy(obj : in Generic_Section_Ptr) return Generic_Section_Ptr;
function Copy(obj : in Generic_Section) return Generic_Section_Ptr;
function type_of(obj : in Generic_Section) return unbounded_string_list;
function type_of(obj : in Generic_Section_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Generic_Section'Class, Generic_Section_Ptr);


-- --------= Computation_Section =--------

type Computation_Section is new Generic_Section with 
record
 first_statement : Generic_Statement_Ptr;
end record;

procedure Initialize(obj : in out Computation_Section);
procedure Put(obj : in Computation_Section);
procedure Put(obj : in Computation_Section_Ptr);
procedure Put_Name(obj : in Computation_Section_Ptr);
procedure Build_Attributes_XML_String(obj : in Computation_Section; result : in out Unbounded_String);
function XML_String(obj : in Computation_Section) return Unbounded_String;
function XML_String(obj : in Computation_Section_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Computation_Section) return Unbounded_String;
function XML_Ref_String(obj : in Computation_Section_Ptr) return Unbounded_String;
function Get_Name (obj : in Computation_Section) return Unbounded_String;
function Get_Name (obj : in Computation_Section_Ptr) return Unbounded_String;
function Copy(obj : in Computation_Section_Ptr) return Generic_Section_Ptr;
function Copy(obj : in Computation_Section) return Generic_Section_Ptr;
function type_of(obj : in Computation_Section) return unbounded_string_list;
function type_of(obj : in Computation_Section_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Computation_Section'Class, Computation_Section_Ptr);


-- --------= Synchronization_Section =--------

type Synchronization_Section is new Generic_Section with 
record
 state_list : State_Lists;
 transition_list : Transition_Lists;
end record;

procedure Initialize(obj : in out Synchronization_Section);
procedure Put(obj : in Synchronization_Section);
procedure Put(obj : in Synchronization_Section_Ptr);
procedure Put_Name(obj : in Synchronization_Section_Ptr);
procedure Build_Attributes_XML_String(obj : in Synchronization_Section; result : in out Unbounded_String);
function XML_String(obj : in Synchronization_Section) return Unbounded_String;
function XML_String(obj : in Synchronization_Section_Ptr) return Unbounded_String;
function XML_Ref_String(obj : in Synchronization_Section) return Unbounded_String;
function XML_Ref_String(obj : in Synchronization_Section_Ptr) return Unbounded_String;
function Get_Name (obj : in Synchronization_Section) return Unbounded_String;
function Get_Name (obj : in Synchronization_Section_Ptr) return Unbounded_String;
function Copy(obj : in Synchronization_Section_Ptr) return Generic_Section_Ptr;
function Copy(obj : in Synchronization_Section) return Generic_Section_Ptr;
function type_of(obj : in Synchronization_Section) return unbounded_string_list;
function type_of(obj : in Synchronization_Section_Ptr) return unbounded_string_list;
procedure Free  is new Unchecked_Deallocation (Synchronization_Section'Class, Synchronization_Section_Ptr);


End Sections;
