with Text_IO;                   use Text_IO;
with Ada.Strings.Unbounded;     use Ada.Strings.Unbounded;
with CFG_Nodes;		use CFG_Nodes;
with CFG_Nodes.Extended;	use CFG_Nodes.Extended;
with CFG_Node_Set; 		use CFG_Node_Set;
with Systems;			use Systems;
with CFG_Node_Set.Basic_Block_Set; use CFG_Node_Set.Basic_Block_Set;
with Basic_Blocks; use Basic_Blocks;
with CFG_Edge_Set; use CFG_Edge_Set;
with CFG_Edges; use CFG_Edges;

package CFG_Nodes_Builder is

   -------------------------------------------------

   --EXAMPLE FROM MALARDALEN BENCHMARK SUITE - ABSINT
   procedure Build_CFG_Node_Set_Bs_Ait
     (my_cfg_nodes : in out CFG_Nodes_Set;
      my_cfg_edges : in out CFG_Edges_Set;
      offset : in out Integer);

   procedure Build_CFG_Node_Set_Fac_Ait
     (my_cfg_nodes : in out CFG_Nodes_Set;
      my_cfg_edges : in out CFG_Edges_Set;
      offset : in out Integer);

   procedure Build_CFG_Node_Set_Fibcall_Ait
     (my_cfg_nodes : in out CFG_Nodes_Set;
      my_cfg_edges : in out CFG_Edges_Set;
      offset : in out Integer);

   procedure Build_CFG_Node_Set_Fdct_Ait
     (my_cfg_nodes : in out CFG_Nodes_Set;
      my_cfg_edges : in out CFG_Edges_Set;
      offset : in out Integer);

   procedure Build_CFG_Node_Set_InsertSort_Ait
     (my_cfg_nodes : in out CFG_Nodes_Set;
      my_cfg_edges : in out CFG_Edges_Set;
      offset : in out Integer);

   procedure Build_CFG_Node_Set_Ns_Ait
     (my_cfg_nodes : in out CFG_Nodes_Set;
      my_cfg_edges : in out CFG_Edges_Set;
      offset : in out Integer);

   procedure Build_CFG_Node_Set_Prime_Ait
     (my_cfg_nodes : in out CFG_Nodes_Set;
      my_cfg_edges : in out CFG_Edges_Set;
      offset : in out Integer);

   -------------------------------------------------
   procedure Add_CFG_Nodes_Bs_To_System
     (sys : in out System;
      my_cfg_nodes : in out CFG_Nodes_Table;
      my_cfg_edges : in out CFG_Edges_Table;
      offset : in out Integer);

   procedure Add_CFG_Nodes_Fac_To_System
     (sys : in out System;
      my_cfg_nodes : in out CFG_Nodes_Table;
      my_cfg_edges : in out CFG_Edges_Table;
      offset : in out Integer);

   procedure Add_CFG_Nodes_Fibcall_To_System
     (sys : in out System;
      my_cfg_nodes : in out CFG_Nodes_Table;
      my_cfg_edges : in out CFG_Edges_Table;
      offset : in out Integer);

   procedure Add_CFG_Nodes_Fdct_To_System
     (sys : in out System;
      my_cfg_nodes : in out CFG_Nodes_Table;
      my_cfg_edges : in out CFG_Edges_Table;
      offset : in out Integer);

   procedure Add_CFG_Nodes_InsertSort_To_System
     (sys : in out System;
      my_cfg_nodes : in out CFG_Nodes_Table;
      my_cfg_edges : in out CFG_Edges_Table;
      offset : in out Integer);

   procedure Add_CFG_Nodes_Ns_To_System
     (sys : in out System;
      my_cfg_nodes : in out CFG_Nodes_Table;
      my_cfg_edges : in out CFG_Edges_Table;
      offset : in out Integer);

   procedure Add_CFG_Nodes_Prime_To_System
     (sys : in out System;
      my_cfg_nodes : in out CFG_Nodes_Table;
      my_cfg_edges : in out CFG_Edges_Table;
      offset : in out Integer);
   -------------------------------------------------


end CFG_Nodes_Builder;
