
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_IO;                   	use Text_IO;
with Ada.Strings.Unbounded;     	use Ada.Strings.Unbounded;
with Unbounded_Strings;         	use Unbounded_Strings;
use Unbounded_Strings.Strings_Table_Package;
use Unbounded_Strings.Unbounded_String_List_Package;
with Ada.Exceptions;            	use Ada.Exceptions;
with Partitioning_Algorithm_Set; 	use Partitioning_Algorithm_Set;
with Atomic_Operations; 		use Atomic_Operations;
with Task_Set; use Task_Set;
with Processor_Set; use Processor_Set;
use Processor_Set;

package partitioning_algorithms_model is

-- Monocore model, preemptive scheduler, solution of exercise 1
--
   procedure partitioning_first_fit
     (My_Partitioning_Algorithms : in out Partitioning_Algorithms_Set;
      A_Partitioning_Algorithm	 : in out Partitioning_Algorithm_Ptr);


-- off-line partition scheduling hierarchical scheduler : partitions are activated
-- according to a event table (off line scheduling)
--

   procedure build_tasks_set (my_tasks : in out Tasks_Set);

   procedure build_processors_set
     (My_Processors 	: in out Processors_Set;
      My_Core	    	: in out Core_Units_Set;
      New_Processor  	: in out Integer;
      New_Core		: in out Integer);


end partitioning_algorithms_model;

