
with text_io; use text_io;
with ada.strings.unbounded; use ada.strings.unbounded;
with unbounded_strings; use unbounded_strings;

with POSIX.Unsafe_Process_Primitives; use POSIX.Unsafe_Process_Primitives;
with POSIX.Process_Identification; use POSIX.Process_Identification;
with POSIX.Process_primitives; use POSIX.Process_primitives;


procedure cpaes is 


	Max_Iterations : natural := 100;

	procedure cheddar_slave(str : in unbounded_string) is 
	begin
		-- possible job for a slave process (=> maybe 2 functions instead of one):
		--   generate a solution and evaluate it (don't need the config file)
		--   or mutate a solution and evaluate it
		put_line("processing cheddar config file " & to_string(str) );
		Exit_Process;
	end cheddar_slave;


    	P   : Process_ID;
 	slavePids : array (0..Max_Iterations) of Process_ID;
	iterations : natural := 20;
	slaves : natural := 4;
	s :  Termination_Status;

begin
	if (iterations < slaves) 
		-- slaves correspond to the number of process that can be run in parallel
		-- it depends on the parallel machine capacities
		then slaves:=iterations;
	end if;

	for i in 0..slaves-1 loop
 		P := POSIX.Unsafe_Process_Primitives.Fork;
   		if P = Null_Process_ID 
	    		then 
				-- ask a slave to generate and evaluate a new valid solution
				cheddar_slave(to_unbounded_string("chedConfig_") & suppress_space(i'img) & to_unbounded_string(".xml"));
	    		else slavePids(i):=p; 
		end if;
	end loop;


	for i in slaves .. iterations-1 loop
		-- master is waiting for an evaluated solution
		wait_for_child_process(s,P);
		-- the for loop is to know which iteration was processed by process P
		for k in 0..i-1 loop
			if slavePids(k) = P 
				then 
				-- getting the result of a slave
				put_line("reading results in file chedResults_" & to_string(suppress_space(k'img)) & ".trace");
				exit;
			end if;
		end loop;

		-- PAES archive management
		--   add the result solution k to archive (same code that you got after mutating a solution) 
		--   and select next solution
		
 		P := POSIX.Unsafe_Process_Primitives.Fork;
   		if P = Null_Process_ID
		    then
			-- ask a slave to mutate and evaluate the selected solution 
			cheddar_slave(to_unbounded_string("chedConfig_") & suppress_space(i'img) & to_unbounded_string(".xml"));
		    else slavePids(i):=P; 
		end if;
	end loop;

	for i in 0 .. slaves-1 loop
		wait_for_child_process(s,P);
		-- the for loop is to know which iteration was processed by process P
		for k in 0..iterations-1 loop
			if slavePids(k) = P 
				then 	
					put_line("reading results in file chedResults_" & k'img & ".trace");
					exit;
			end if;
		end loop;
		-- PAES archive management
		--   add the result solution k to archive (same code that you got after mutating a solution) 
		
	end loop;

	Exit_Process;

end  cpaes;



