with audsley_opa_test;  		use audsley_opa_test;
with Ada.Strings.Unbounded; 		use Ada.Strings.Unbounded;
with Ada.Calendar; 			use Ada.Calendar;
with Ada.Calendar.Formatting;		use Ada.Calendar.Formatting;
with Ada.Directories;	 		use Ada.Directories;
with Ada.Text_IO; 			use Ada.Text_IO;
with Systems; 				use Systems;
with GNAT.Command_Line;
with GNAT.OS_Lib;                       use GNAT.OS_Lib;
with Ada.Float_Text_IO;		    	use Ada.Float_Text_IO;
with Ada.IO_Exceptions;
with audsley_opa_crpd_test;		use audsley_opa_crpd_test;

procedure call_test
is
   --Configuration for the task generator--------
   number_of_task 		: Integer := 5;
   processor_utilization 	: Float := 0.00;
   cache_utilization		: Float := 5.0;
   reuse_factor			: Float := 0.6;
   cache_size			: Integer := 256;
   ----------------------------------------------

   --Configuration for the scheduling simulator--
   default_Period		: Integer := 1000;
   ----------------------------------------------
   H				: Integer := 0;
   --Time_And_Date  		: TIME;
   filename 	  		: Unbounded_String;
   C		  		: Character;
   sys				: System;
   ----------------------------------------------
   PU_String : Unbounded_String;
begin
   loop
      case GNAT.Command_Line.Getopt ("u: n: c:") is
         when ASCII.NUL =>
            exit;
         when 'u' =>
            PU_String := To_Unbounded_String (GNAT.Command_Line.Parameter);
            processor_utilization := (Float'Value(To_String(PU_String))/100.0);
         when 'n' =>
            Put_Line("Number of tasks: " & GNAT.Command_Line.Parameter);
            number_of_task := Integer'Value(GNAT.Command_Line.Parameter);
         when 'c' =>
            Put_Line("Test mode: " & GNAT.Command_Line.Parameter);
            C := GNAT.Command_Line.Parameter(1);
         when others =>
            OS_Exit(0);
      end case;
   end loop;

   if (processor_utilization = 0.00 AND number_of_task = 5) then
      Put_Line("Choose test: ");
      Get(c);
      Put_Line("");
   end if;

   if(c =  'A')then
      test_OPA;
   elsif (c = 'B') then
      generate_task_set;
   end if;

end call_test;
