------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2015, by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by 
-- Frank Singhoff, Lab-STICC UMR 6285 laboratory, Université de Bretagne Occidentale
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of 
-- Cheddar and provides industrial support.
--
-- The full list of contributors and sponsors are given into AUTHORS.txt and SPONSORS.txt
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
------------------------------------------------------------------------------
-- Last update : 
--    $Rev: 1249 $
--    $Date: 2014-08-28 07:02:15 +0200 (Fri, 28 Aug 2014) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------



with Glib;                              use Glib;
with Gdk;                               use Gdk;
with Gdk.Event;                         use Gdk.Event;
with Gdk.GC;                            use Gdk.GC;
with Gdk.Color;                         use Gdk.Color;
with Gtk.Widget;                        use Gtk.Widget;
with Buffer_Set;                        use Buffer_Set;
with Task_Set;                          use Task_Set;
with Resource_Set;                      use Resource_Set;
with Message_Set;                       use Message_Set;
with processor_set;			use processor_set;
with Multiprocessor_Services_Interface; use Multiprocessor_Services_Interface;
use Multiprocessor_Services_Interface.Scheduling_Result_Per_Processor_Package;
with graphical_editor.scheduling_simulation_draw_callbacks; use graphical_editor.scheduling_simulation_draw_callbacks;
with Gtkada.Builder; use Gtkada.Builder;
with Gtk.Drawing_Area; use Gtk.Drawing_Area;


package graphical_editor.Draw_Scheduling is

procedure Redraw_Time_Line (Draw_Scheduling : access Draw_Scheduling_Record'Class);

procedure Draw_Time_Line(
	Period1         : Natural;
	Start_Draw1     : Natural;
	Sched1          : in Scheduling_Table_Ptr);

procedure Draw_Time_Line_Axis
     (Line_Number     : in Gint);

procedure Clear_Time_Line;

end graphical_editor.Draw_Scheduling;



