------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 209 $
--    $Date: 2008-06-29 14:47:31 +0200 (dim, 29 jun 2008) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Gtk.File_Selection; use Gtk.File_Selection;
with Gtk.Button;         use Gtk.Button;
with Gtk.Notebook;       use Gtk.Notebook;
with ada.strings.unbounded; use ada.strings.unbounded;


package graphical_editor.file_selector  is

   type File_Selector_Record is new Gtk_File_Selection_Record with
      private;
   type File_Selector_Access is access all File_Selector_Record'
     Class;

   procedure Gtk_New (File_Selector : out File_Selector_Access);
   procedure Initialize
     (File_Selector : access File_Selector_Record'Class; label : unbounded_string);


   File_Selector_widget : File_Selector_Access;


   -- Each initialize bellow prepars one windows with its specific 
   -- callbacks
   --
   procedure Initialize_open_xml_file
     (File_Selector : access File_Selector_Record'Class);
   procedure Initialize_saveas_xml_file
     (File_Selector : access File_Selector_Record'Class);
   procedure Initialize_aadl_import
     (File_Selector : access File_Selector_Record'Class);
   procedure Initialize_aadl_export
     (File_Selector : access File_Selector_Record'Class);
   procedure Initialize_import_event_table
     (File_Selector : access File_Selector_Record'Class);
   procedure Initialize_export_event_table
     (File_Selector : access File_Selector_Record'Class);
   procedure Initialize_export_arinc653_tsp
     (File_Selector : access File_Selector_Record'Class);


private

   type File_Selector_Record is new Gtk_File_Selection_Record with
      record
         Ok_Button     : Gtk_Button;
         Cancel_Button : Gtk_Button;
      end record;

end graphical_editor.File_Selector;
