------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2015, by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- Frank Singhoff, Lab-STICC UMR 6285 laboratory, Université de Bretagne Occidentale
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- The full list of contributors and sponsors are given into AUTHORS.txt and SPONSORS.txt
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
------------------------------------------------------------------------------
-- Last update :
--    $Rev: 1249 $
--    $Date: 2014-08-28 07:02:15 +0200 (Fri, 28 Aug 2014) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Gtkada.Builder; use Gtkada.Builder;

package graphical_editor.priorities is

   -- Init the widget
   -- Set the values of components: combobox
   procedure Init_Priorities_Widget
     (Builder : in out Gtkada_Builder);

   procedure Show_Priorities_Widget
     (Builder : in out Gtkada_Builder);

   procedure Close_Priorities_Widget
     (Object : access Gtkada_Builder_Record'Class);

   -----------------------------
   -- Show and set up the handler/callback
   -- according to the chosen priority assignment algorithm.
   -----------------------------
   procedure Show_Priorities_Rm_Widget;

   procedure Show_Priorities_Dm_Widget;

   procedure Show_Priorities_Audsley_OPA_Widget;

   procedure Show_Priorities_OPA_CRPD_PT_Widget;

   procedure Show_Priorities_OPA_CRPD_PT_Simplified_Widget;

   procedure Show_Priorities_OPA_CRPD_Tree_Widget;

end graphical_editor.priorities;
