------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances 
-- of real time architectures.
--
-- Copyright (C) 2002-2015, by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by 
-- Frank Singhoff, Lab-STICC UMR 6285 laboratory, Université de Bretagne Occidentale
-- 
-- Since 2008, Ellidiss technologies also contributes to the development of 
-- Cheddar and provides industrial support.
--
-- The full list of contributors and sponsors are given into AUTHORS.txt and SPONSORS.txt
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--           
------------------------------------------------------------------------------
-- Last update : 
--    $Rev: 1249 $
--    $Date: 2014-08-28 07:02:15 +0200 (Fri, 28 Aug 2014) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------


with Resources; use Resources; 
with Gtkada.Builder; use Gtkada.Builder;
with graphical_editor.generic_callbacks; 
with graphical_editor.generic_package_widget; use graphical_editor.generic_package_widget;
with Glib.Values; use Glib.Values;
with Glib; use Glib;

package graphical_editor.resources is
	

	procedure Show_Resource_Widget;

	procedure Initialize_Resource(my_tab: in out table_widget_id ; Object : access Gtkada_Builder_Record'Class);

	procedure Add_In_Sys_Resource(my_tab: in out table_widget_id ; Object : access Gtkada_Builder_Record'Class);

	procedure Deleted_In_Sys_Resource(my_tab: in out table_widget_id ; Object : access Gtkada_Builder_Record'Class);

	procedure Show_In_Sys_Resource(my_tab: in out table_widget_id ; Object : access Gtkada_Builder_Record'Class);

	procedure Modify_In_Sys_Resource(my_tab: in out table_widget_id ; Object : access Gtkada_Builder_Record'Class); 

	procedure Check_Resource(my_tab: in out table_widget_id ; Object : access Gtkada_Builder_Record'Class); 

	procedure Add_View_Task (Object : access Gtkada_Builder_Record'Class);

	procedure Delected_lign_view (Object : access Gtkada_Builder_Record'Class);

	procedure Show_Lign_Resource (Object : access Gtkada_Builder_Record'Class);

end graphical_editor.resources;
