--------------------------------------------
------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Text_IO; use Text_IO;


package body boolean_util is

   package boolean_io is new Text_IO.Enumeration_IO (Boolean);

   function format (f : in Boolean) return Unbounded_String is
   begin
      return To_Unbounded_String (Boolean'Image (f));
   end format;

   procedure put (e : in boolean_ptr) is
   begin
      boolean_io.Put (e.all);
   end put;

   procedure put (e : in Boolean) is
   begin
      boolean_io.Put (e);
   end put;

   procedure put_line (e : in Boolean) is
   begin
      boolean_io.Put (e);
      New_Line;
   end put_line;

   procedure initialize (a : out Boolean) is
   begin
      a := True;
   end initialize;

   function copy (e : in boolean_ptr) return boolean_ptr is
      ret : boolean_ptr;
   begin
      ret     := new Boolean;
      ret.all := e.all;
      return ret;
   end copy;

end boolean_util;
