------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded;  use Ada.Strings.Unbounded;
with Unchecked_Deallocation;

package boolean_util is

   type boolean_ptr is access Boolean;

   -- Convert and format a boolean to
   -- an unbounded_string
   --
   function format (f : in Boolean) return Unbounded_String;

   -- Display a Boolean
   --
   procedure put (e : in Boolean);
   procedure put (e : in boolean_ptr);
   procedure put_line (e : in Boolean);

   -- Initialize a Boolean
   --
   procedure initialize (a : out Boolean);

   procedure free is new Unchecked_Deallocation (Boolean, boolean_ptr);

   function copy (e : in boolean_ptr) return boolean_ptr;

--   package boolean_list is new access_lists (
 --     Boolean,
  --    boolean_ptr,
  --    put,
   --   free,
 --     copy,
  --    XML_String);
--   use boolean_list;

end boolean_util;
