-------------------------------------------------------------
-------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 14:09:39 +0100 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Ada.Numerics.Aux;      use Ada.Numerics.Aux;

generic

   type discrete_element is range <>;

package discrete_util is

   -- Conver and format a discrete type
   -- into an unbounded_string
   --
   function format (f : in discrete_element) return Unbounded_String;

   -- Compute Great common Divisor
   -- of two natural
   --
   function gcd
     (left  : discrete_element;
      right : discrete_element)
      return  discrete_element;

   -- Compute Last common multiplier
   -- of two natural
   --
   function lcm
     (a    : in discrete_element;
      b    : in discrete_element)
      return discrete_element;

   function lcm
     (a    : in discrete_element;
      b    : in discrete_element)
      return Double;

end discrete_util;
