------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with unbounded_strings;
use unbounded_strings;

package body id_generators is

   

   procedure put (e : in id) is 
begin
	put("value: "); put(e.value); put ( "; " );
	put("kind: "); put(e.kind); put ( "; " );
end put;

   procedure put (e : in id_ptr) is 
begin
	put(e.all);
end put;


   procedure initialize (a : out id) is 
begin
	a.kind:=bounded_value_type;
	a.value:=id_value_type'first;
end initialize;


procedure generate_id(an_id : in out id; current_id : out id_value_type ) is 
begin
	if (an_id.value=id_value_type'last)
	then
	 if (an_id.kind=bounded_value_type)
		then raise exceeded_id_value;
		else an_id.value:=id_value_type'first;
	  end if;
	else
		an_id.value:=an_id.value+1;
		current_id:=an_id.value;
	end if;

end generate_id;


procedure generate_id(an_id : in out id; current_id : out unbounded_string) is
local_id : id_value_type;
begin
	generate_id(an_id, local_id);
	current_id:=to_unbounded_string("id_");
  	current_id:=current_id & suppress_space(to_unbounded_string(id_value_type'image(local_id)) );
end generate_id;

   
end id_generators;

