------------------------------------------------
--------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 14:09:39 +0100 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Text_IO; use Text_IO;
with discrete_util;

package body integer_util is

   package integer_io is new Text_IO.Integer_IO (Integer);
   package integer_discrete is new discrete_util (Integer);

   function format (f : in Integer) return Unbounded_String is
   begin
      return (integer_discrete.format (f));
   end format;

   procedure put (e : in Integer) is
   begin
      integer_io.Put (e);
   end put;

   procedure put_line (e : in Integer) is
   begin
      integer_io.Put (e);
      New_Line;
   end put_line;

   procedure initialize (a : out Integer) is
   begin
      a := 0;
   end initialize;

   function gcd (a : in Integer; b : in Integer) return Integer is
   begin
      return (integer_discrete.gcd (a, b));
   end gcd;

   function lcm (a : in Integer; b : in Integer) return Integer is
   begin
      return (integer_discrete.lcm (a, b));
   end lcm;

end integer_util;
