------------------------------------------------------------------
--------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 442 $
--    $Date: 2011-05-16 20:17:30 +0200 (lun. 16 mai 2011) $
--    $Author: gaudel $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

package body multi_int_util is

   function gcd (a, b : in multi_int_ptr) return multi_int_ptr is
      c1 : multi_int_ptr;
   begin
      if Equal (a.all rem b.all, Multi (0)) then
         return b;
      else
         c1 := new multi_int'(a.all rem b.all);
         return gcd (b, c1);
      end if;
   end gcd;

   function lcm (a, b : in multi_int_ptr) return multi_int_ptr is
      c : multi_int_ptr;
   begin
      c := new multi_int'((a.all * b.all) / gcd (a, b).all);
      return c;
   end lcm;

   function convert (a : in multi_int) return Float is
   begin
      return Float'Value (Str (a));
   end convert;

   function convert2double (a : in multi_int) return Double is
   begin
      return Double'Value (Str (a));
   end convert2double;

   function convert_multi_integer (a : in multi_int) return Integer is
   begin
      return Integer'Value (Str (a));
   end convert_multi_integer;

end multi_int_util;
