------------------------------------------------------------
--------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2012, by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- Frank Singhoff, LISyC Team, Université de Bretagne Occidentale
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
------------------------------------------------------------------------------
-- Last update :
--    $Rev: 97 $
--    $Date: 2007-07-20 15:17:15 +0200 (Fri, 20 Jul 2007) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------

-- Process to the LCM of two big Number
--
with Ada.Text_IO;                 use Ada.Text_IO;
with Multi_precision_integers;    use Multi_precision_integers;
with Multi_precision_integers_IO; use Multi_precision_integers_IO;
with Ada.Numerics.Aux;            use Ada.Numerics.Aux;

package multi_int_util is

   type multi_int_ptr is access multi_int;

   -- Compute GCD of bid number
   --
   function gcd (a, b : in multi_int_ptr) return multi_int_ptr;

   function lcm (a, b : in multi_int_ptr) return multi_int_ptr;

   -- Convert multi_int to float

   function convert (a : in multi_int) return Float;

   function convert2double (a : in multi_int) return Double;

end multi_int_util;
