------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 541 $
--    $Date: 2012-10-08 22:23:24 +0200 (Mon, 08 Oct 2012) $
--    $Author: singhoff $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with Text_IO; use Text_IO;

package body tables is

   procedure initialize (a_table : out table) is
   begin
      a_table.nb_entries := 0;
   end initialize;

   procedure put (a_table : in table_ptr) is
   begin
      put (a_table.all);
   end put;

   procedure put (a_table : in table) is
   begin
      Put_Line (" Nb entries : " & a_table.nb_entries'Img);
      for i in 0 .. a_table.nb_entries - 1 loop
         put (a_table.entries (i));
         Put ("  ");
      end loop;
   end put;


function XML_root_String(obj : in Table_ptr) return Unbounded_String is
begin
	return xml_root_string(obj.all);
end xml_root_string;


function XML_root_String(obj : in Table) return Unbounded_String is
str : Unbounded_string := To_Unbounded_String ("");
begin
      for I in 0 .. obj.Nb_Entries - 1 loop
         str:= str & xml_string(obj.Entries (I));
      end loop;
	return str;
end XML_root_String;


function XML_String(obj : in Table_ptr) return Unbounded_String is
begin
	return xml_string(obj.all);
end xml_string;


   function xml_string
     (obj   : in table)
      return  Unbounded_String
   is
      str : Unbounded_String := To_Unbounded_String ("");
   begin
      for i in 0 .. obj.nb_entries - 1 loop
         str := str & xml_ref_string (obj.entries (i));
      end loop;
      return str;
   end xml_string;

   procedure delete (a_table : in out table; a_item : table_range) is
   begin

      a_table.entries (a_item) := a_table.entries (a_table.nb_entries - 1);
      a_table.nb_entries       := a_table.nb_entries - 1;

   end delete;

   procedure add (a_table : in out table; a_element : element) is
   begin
      a_table.entries (a_table.nb_entries) := a_element;
      a_table.nb_entries                   := a_table.nb_entries + 1;
   end add;

end tables;
