------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a GNU GPL real time scheduling analysis tool.
-- This program provides services to automatically check performances
-- of real time architectures.
--
-- Copyright (C) 2002-2010,  by Frank Singhoff, Alain Plantec, Jerome Legrand
--
-- The Cheddar project was started in 2002 by
-- the LISyC Team, University of Western Britanny.
--
-- Since 2008, Ellidiss technologies also contributes to the development of
-- Cheddar and provides industrial support.
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : cheddar@listes.univ-brest.fr
--
-----------------------------------------------------------------------------
-- Last update :
--    $Rev: 523 $
--    $Date: 2012-09-26 14:09:39 +0100 (Wed, 26 Sep 2012) $
--    $Author: fotsing $
------------------------------------------------------------------------------
------------------------------------------------------------------------------
with unbounded_strings; use unbounded_strings;
with Version;           use Version;

package body Translate.Francais_Labels is

   procedure Initialize is

   begin

      ----------------------------------------------------
      --   Menu and sub menu titles
      ----------------------------------------------------

      Lb_Root_Title (Francais)                          :=
        To_Unbounded_String
          ("Camembert : un simulateur d'ordonnancement temps rel");
      Lb_File (Francais)                                :=
        To_Unbounded_String ("Fichier");
      Lb_New (Francais)                                 :=
        To_Unbounded_String ("Nouveau");
      Lb_Open (Francais)                                :=
        To_Unbounded_String ("Ouvrir");
      Lb_Save (Francais)                                :=
        To_Unbounded_String ("Sauvegarder");
      Lb_Save_As (Francais)                             :=
        To_Unbounded_String ("Sauvegarder sous");
      Lb_Open_Xml (Francais)                            :=
        To_Unbounded_String ("Ouvrir projet XML");
      Lb_Save_Xml (Francais)                            :=
        To_Unbounded_String ("Sauvegarder projet XML");
      Lb_Save_As_Xml (Francais)                         :=
        To_Unbounded_String ("Sauvegarder projet XML sous");
      Lb_Aadl (Francais)                                :=
        To_Unbounded_String ("AADL");
      Lb_Import_Aadl (Francais)                         :=
        To_Unbounded_String ("Importer projet AADL");
      Lb_Export_Aadl (Francais)                         :=
        To_Unbounded_String ("Exporter projet AADL");
      Lb_export_arinc653_tsp (Francais)                 :=
        To_Unbounded_String ("Exporter TSP ARINC653");
      Lb_Aadl_Options (Francais)                        :=
        To_Unbounded_String ("Options AADL");
      Lb_Other_Aadl_Options (Francais)                  :=
        To_Unbounded_String ("Autres options AADL");
      Lb_Export_Cheddar_Property_Sets (Francais)        :=
        To_Unbounded_String
          ("Exporter les ensembles de proprits de Camembert");
      Lb_Export_Aadl_Standard_Properties_Set (Francais) :=
        To_Unbounded_String
          ("Exporter l'ensemble de proprits standard AADL");
      Lb_Exit (Francais)                                :=
        To_Unbounded_String ("Quitter");

      Lb_Edit (Francais) := To_Unbounded_String ("Edition");

      Lb_Edit_Scheduler (Francais)                   :=
        To_Unbounded_String ("Editer un ordonnanceur");
      Lb_Parametric (Francais)                       :=
        To_Unbounded_String ("Paramtrique");
      Lb_Tools (Francais)                            :=
        To_Unbounded_String ("Outils");
      Lb_Compute_Buffer (Francais)                   :=
        To_Unbounded_String ("Analyse des tampons par tests de faisabilit");
      Lb_Draw_Buffer (Francais)                      :=
        To_Unbounded_String
          ("Analyse des tampons par simulation d'ordonnancement");
      Lb_Clear (Francais)                            :=
        To_Unbounded_String ("Nettoyer l'espace de travail");
      Lb_Scheduling_Simulation (Francais)            :=
        To_Unbounded_String ("Simulation de l'ordonnancement");
      Lb_Scheduling_Feasibility (Francais)           :=
        To_Unbounded_String ("Vrification de la faisabilit");
      Lb_Customized_Scheduling_Simulation (Francais) :=
        To_Unbounded_String ("Simulation paramtrable de l'ordonnancement");
      Lb_Customized_Feasibility_Tests (Francais)     :=
        To_Unbounded_String ("Vrification paramtrable de la faisabilit");
      Lb_Compute_And_Display (Francais)              :=
        To_Unbounded_String ("Calculer et afficher");
      Lb_Compute_And_Update (Francais)               :=
        To_Unbounded_String ("Calculer et mettre  jour les tches");
      Lb_Compute_And_Display_One_Step (Francais)     :=
        To_Unbounded_String ("Calculer et afficher : un pas ");
      Lb_Compute_And_Update_One_Step (Francais)      :=
        To_Unbounded_String
          ("Calculer et mettre  jour les tches : un pas ");
      Lb_Memory_Requirement_Analysis (Francais)      :=
        To_Unbounded_String ("Analyse empreinte mmoire des espaces d'adressage");
      Lb_Check_And_Update_Address_Space (Francais)   :=
        To_Unbounded_String
          ("Vrification et mise jour des espaces d'addressage");
      Lb_Check_Address_Space (Francais)              :=
        To_Unbounded_String ("Vrification des espaces d'addressage");

      Lb_Help (Francais)       := To_Unbounded_String ("Aide");
      Lb_Manual (Francais)     := To_Unbounded_String ("Manuel");
      Lb_Ref (Francais)        :=
        To_Unbounded_String ("Rfrences bibliographiques");
      Lb_About (Francais)      := To_Unbounded_String ("A propos de Camembert");
      Lb_About_Text (Francais) :=
        To_Unbounded_String ("Camembert ") &
      Cheddar_Version &
      unbounded_lf &
      Cheddar_svn_version &
      unbounded_lf &
      unbounded_lf &
      To_Unbounded_String ("Camembert est un outil de simulation ") &
      unbounded_lf &
      To_Unbounded_String ("d'algorithmes d'ordonnancement temps rel.") &
      unbounded_lf &
      To_Unbounded_String ("Camembert is distribu sous la license GNU GPL.");
      Lb_About_Text (Francais) :=
        Lb_About_Text (Francais) &
      unbounded_lf &
      unbounded_lf &
      To_Unbounded_String
        ("Camembert est maintenu par le Lab-STICC, CNRS UMR 6285, Universit de Bretagne Occidentale.") &
      unbounded_lf &
      unbounded_lf &
      To_Unbounded_String(
                          "Cf. http:://beru.univ-brest.fr/~singhoff/cheddar pour de plus amples dtails")
        &
      unbounded_lf;

      ----------------------------------------------------
      --   Edit models
      ----------------------------------------------------

      Lb_Update (Francais)                :=
        To_Unbounded_String ("Mise  jour");
      lb_update_core_unit (Francais)      :=
        To_Unbounded_String ("Mise  jour coeurs de processeur");
      Lb_Update_Task (Francais)           :=
        To_Unbounded_String ("Mise  jour des tches");
      Lb_Update_Address_Space (Francais)  :=
        To_Unbounded_String ("Mise  jour des espaces d'adressage");
      Lb_Update_Message (Francais)        :=
        To_Unbounded_String ("Mise  jour des messages");
      Lb_Update_Buffer (Francais)         :=
        To_Unbounded_String ("Mise  jour des tampons");
      Lb_Update_Processor (Francais)      :=
        To_Unbounded_String ("Mise  jour des processeurs");
      Lb_Update_Resource (Francais)       :=
        To_Unbounded_String ("Mise  jour des ressources");
      Lb_Update_Event_Analyzer (Francais) :=
        To_Unbounded_String ("Mise  jour d'un analyseur d'venements");
      Lb_Update_Network (Francais)        :=
        To_Unbounded_String ("Mise  jour des reseaux");

      Lb_add (Francais) := To_Unbounded_String ("Ajouter");

      lb_delete (Francais) := To_Unbounded_String ("Supprimer");

      ------------------------------------------------------------
      --   Errors on messages/tasks/processors/resources/buffers
      ------------------------------------------------------------

      Lb_core_unit_Not_Found (francais)     :=
        To_Unbounded_String ("Core Inconnu");
      Lb_Cache_Not_Found (Francais)     :=
        To_Unbounded_String ("Cache Inconnu");
      Lb_Dependency_Not_Found (Francais)     :=
        To_Unbounded_String ("Dependence Inconnue");
      Lb_Resource_Not_Found (Francais)       :=
        To_Unbounded_String ("Ressource Inconnue");
      Lb_Message_Not_Found (Francais)        :=
        To_Unbounded_String ("Message inconnu");
      Lb_Task_Not_Found (Francais)           :=
        To_Unbounded_String ("Tche inconnue");
      Lb_Task_group_Not_Found (Francais)           :=
        To_Unbounded_String ("Groupe de tche inconnue");
      Lb_Address_Space_Not_Found (Francais)  :=
        To_Unbounded_String ("Espace d'addressage inconnu");
      lb_core_unit_not_found (Francais)      :=
        To_Unbounded_String ("Coeur inconnu");
      Lb_Processor_Not_Found (Francais)      :=
        To_Unbounded_String ("Processeur inconnu");
      Lb_Buffer_Not_Found (Francais)         :=
        To_Unbounded_String ("Tampon inconnu");
      Lb_Event_Analyzer_Not_Found (Francais) :=
        To_Unbounded_String ("Analiseur d'vnements inconnu");
      Lb_deployment_Not_Found (Francais) :=
        To_Unbounded_String ("Dploiement inconnue");


      Lb_Define_task_groups_Before (Francais)      :=
        To_Unbounded_String ("Dfinir un groupe de tche d'abord");
      Lb_Define_core_units_Before (Francais)      :=
        To_Unbounded_String ("Dfinir un coeur de processeur d'abord");
      Lb_Define_Tasks_Before (Francais)           :=
        To_Unbounded_String ("Dfinir une tche d'abord");
      Lb_Define_Address_Spaces_Before (Francais)  :=
        To_Unbounded_String ("Dfinir un espace d'addressage d'abord");
      Lb_Define_Processors_Before (Francais)      :=
        To_Unbounded_String ("Dfinir un processeur d'abord");
      Lb_Define_Messages_Before (Francais)        :=
        To_Unbounded_String ("Dfinir un message d'abord");
      Lb_Define_Resources_Before (Francais)       :=
        To_Unbounded_String ("Dfinir une ressource d'abord");
      Lb_Define_Buffers_Before (Francais)         :=
        To_Unbounded_String ("Dfinir un tampon d'abord");
      Lb_Define_Event_Analyzers_Before (Francais) :=
        To_Unbounded_String ("Definir un analyseur d'vnements d'abord");
      Lb_Define_deployments_Before (Francais) :=
        To_Unbounded_String ("Definir une liaison d'abord");

      Lb_Can_Not_Define_More_core_units (Francais)      :=
        To_Unbounded_String ("Impossible de dfinir d'autres coeur");
      Lb_Can_Not_Define_More_sections (Francais)        :=
        To_Unbounded_String ("Impossible de dfinir d'autres sections");
      Lb_Can_Not_Define_More_Networks (Francais)        :=
        To_Unbounded_String ("Impossible de dfinir d'autres rseaux");
      Lb_Can_Not_Define_More_Tasks (Francais)           :=
        To_Unbounded_String ("Impossible de dfinir d'autres tches");
      Lb_Can_Not_Define_More_Task_groups (Francais)           :=
        To_Unbounded_String ("Impossible de dfinir d'autres groupe de tches");
      Lb_Can_Not_Define_More_Address_Spaces (Francais)  :=
        To_Unbounded_String
          ("Impossible de dfinir d'autres espaces d'addressage");
      Lb_Can_Not_Define_More_Processors (Francais)      :=
        To_Unbounded_String ("Impossible de dfinir d'autres processeurs");
      Lb_Can_Not_Define_More_Resources (Francais)       :=
        To_Unbounded_String ("Impossible de dfinir d'autres ressources");
      Lb_Can_Not_Define_More_Buffers (Francais)         :=
        To_Unbounded_String ("Impossible de dfinir d'autres tampons");
      Lb_Can_Not_Define_More_Messages (Francais)        :=
        To_Unbounded_String ("Impossible de dfinir d'autres messages");
      Lb_Can_Not_Define_More_Event_Analyzers (Francais) :=
        To_Unbounded_String
          ("Impossible de dfinir d'autres analyseurs d'vnements");
      Lb_Can_Not_Define_More_deployments (Francais) :=
        To_Unbounded_String
          ("Impossible de dfinir d'autres liaisons");

      ----------------------------------------------------
      --    I/O Errors and messages
      ----------------------------------------------------

      Lb_Open_File (Francais)         :=
        To_Unbounded_String ("Ouvrir un fichier");
      Lb_Save_File (Francais)         :=
        To_Unbounded_String ("Sauvegarder un fichier");
      Lb_Not_Saved_File (Francais)    :=
        To_Unbounded_String ("Attention : le fichier n'est pas sauvegard");
      Lb_Can_Not_Open_File (Francais) :=
        To_Unbounded_String ("Impossible d'ouvrir le fichier");
      Lb_Can_Not_Read_File (Francais) :=
        To_Unbounded_String ("Impossible de lire le fichier");
      Lb_Can_Not_Save_File (Francais) :=
        To_Unbounded_String ("Impossible de sauvegarder le fichier");
      Lb_File_Name (Francais)         :=
        To_Unbounded_String ("Nom de fichier");

      Lb_Open_Project (Francais)         :=
        To_Unbounded_String ("Ouvrir un projet");
      Lb_Save_Project (Francais)         :=
        To_Unbounded_String ("Sauvegarder un projet");
      Lb_Not_Saved_Project (Francais)    :=
        To_Unbounded_String ("Attention : le projet n'est pas sauvegard");
      Lb_Can_Not_Open_Project (Francais) :=
        To_Unbounded_String ("Impossible de lire le projet");
      Lb_Can_Not_Save_Project (Francais) :=
        To_Unbounded_String ("Impossible de sauvegarder le projet");

      Lb_Select_File (Francais) :=
        To_Unbounded_String ("Slection de fichiers");

lb_entity_referenced_elsewhere (francais)  :=
        To_Unbounded_String(" Impossible : l'entit est rfrence autre part ");



      ----------------------------------------------------
      --   Widget text fields
      ----------------------------------------------------
      Lb_Select_Line_Before (Francais) :=
        To_Unbounded_String ("Selectionner une Ligne Avant ");

      --
      --  deployment widgets
      --
      Lb_deployment (Francais) :=
        To_Unbounded_String ("Liaison ");
      Lb_deployment_name (Francais) :=
        To_Unbounded_String ("Nom de la liaison ");
      Lb_can_not_be_empty(Francais) :=
        To_Unbounded_String ("ne peut tre vide");
      Lb_sink_set(Francais) :=
        To_Unbounded_String ("Ensemble consommateur ");
      Lb_source_set(Francais) :=
        To_Unbounded_String ("Ensemble ressource");



      --  Event analyzer widgets
      --
      Lb_Event_Analyzer_Name (Francais) :=
        To_Unbounded_String ("Nom de l'analyseur d'vnements");
      Lb_Event_Analyzer (Francais)      :=
        To_Unbounded_String ("Analyseur d'vnements");
      Lb_Run_Event_Analyzers (Francais) :=
        To_Unbounded_String ("Analyseurs d'vnements");

      --
      --  Processors and core widgets
      --
      Lb_Parametric_File_Name (Francais)   := To_Unbounded_String ("Vitesse");
      Lb_Parametric_File_Name (Francais)   :=
        To_Unbounded_String ("Nom de fichier paramtrique");
      Lb_Select_core_unit_First (Francais) :=
        To_Unbounded_String ("Choisissez un coeur d'abord");
      Lb_Select_Processor_First (Francais) :=
        To_Unbounded_String ("Choisissez un processeur d'abord");
      Lb_File_Name_Control (Francais)      :=
        To_Unbounded_String
          ("Nom de fichier invalide avec l'ordonnanceur slectionn");
      Lb_Only_On_Parametric (Francais)     :=
        To_Unbounded_String
          ("Opration possible uniquement avec un ordonnanceur paramtrique");
      Lb_Read (Francais)                   := To_Unbounded_String ("Lire");
      Lb_Quantum_Control (Francais)        :=
        To_Unbounded_String
          ("Valeur du quantum invalide avec l'ordonnanceur slectionn");
      lb_core_unit (Francais)              := To_Unbounded_String ("Coeur ");
      lb_core_unit_id (Francais)              := To_Unbounded_String ("Coeur id");
      Lb_Processor (Francais)              :=
        To_Unbounded_String ("Processeur ");
      lb_core_unit_name (Francais)         :=
        To_Unbounded_String ("Nom du coeur ");
      Lb_Processor_Name (Francais)         :=
        To_Unbounded_String ("Nom du processeur");
      Lb_Processor_id (Francais)         :=
        To_Unbounded_String ("Id du processeur");
      Lb_Scheduler (Francais)              :=
        To_Unbounded_String ("Ordonnanceur");
      Lb_Option (Francais)                 := To_Unbounded_String ("Option");
      Lb_Preemptive (Francais)             :=
        To_Unbounded_String ("Premptif");
      Lb_Not_Preemptive (Francais)         :=
        To_Unbounded_String ("Non premptif");
      Lb_Invalid_Identifier (Francais)     :=
        To_Unbounded_String ("Identificateur invalide");
      lb_automaton (Francais)              :=
        To_Unbounded_String ("Automate");
      Lb_core_units_name_Mandatory (Francais) :=
        To_Unbounded_String ("Nom du coeur Obligatoire");
      Lb_Policy_Mandatory (Francais) :=
        To_Unbounded_String ("Type de Police Obligatoire");
      Lb_buffer_name_Mandatory (Francais) :=
        To_Unbounded_String ("Nom du buffer Obligatoire");
      Lb_task_type_Mandatory (Francais) :=
        To_Unbounded_String ("Type de Tache Obligatoire");
      Lb_address_space_name_Mandatory (Francais) :=
        To_Unbounded_String ("Nom de l'address space Obligatoire");
      lb_create_only_one_core_unit  (Francais) :=
        To_Unbounded_String ("Seulement un coeur cre: choisir monocore et no migration");

      Lb_processor_name_Mandatory (Francais) :=
        To_Unbounded_String ("Nom du processeur Obligatoire");
      Lb_network_name_Mandatory (Francais) :=
        To_Unbounded_String ("Nom du rseau Obligatoire");
      Lb_scheduler_type_Mandatory (Francais):=
        To_Unbounded_String ("Type d'Ordonnanceur Obligatoire");
      Lb_network_type_Mandatory (Francais):=
        To_Unbounded_String ("Type de Rseau Obligatoire");
      Lb_task_name_Mandatory (Francais):=
        To_Unbounded_String ("Nom de la Tache Obligatoire");
      Lb_preemptive_type_Mandatory (Francais):=
        To_Unbounded_String ("Type de Premption Obligatoire");
      Lb_processor_type_Mandatory (Francais):=
        To_Unbounded_String ("Type de Processeur Obligatoire");
      lb_Migration_Type_Not_Allow_With_Several_Cores (Francais):=
        To_Unbounded_String ("Type de Migration non autoris pour plusieurs coeurs");
      lb_Processor_Type_Not_Allow_With_Several_Cores (Francais):=
        To_Unbounded_String ("Type de Processeur non autoris pour plusieurs coeurs");
      Lb_migration_type_Mandatory (francais):=
        To_Unbounded_String ("Type de Migration Obligatoire");
      Lb_priority_Mandatory (Francais) :=
        To_Unbounded_String ("Priorite Obligatoire");
      Lb_core_with_same_scheduler (francais) :=
        To_Unbounded_String( "Tous les cores d'un processeur doivent utiliser le mme ordonnanceur.");
        Lb_multicore_with_hierarchical_not_allowed(English)  :=
        To_Unbounded_String("Processeur multicores interdit avec un ordonnanceur hirarchique.");



      --
      -- Cache Block
      --
      Lb_Cache_Block_Id (Francais)			:=
        To_Unbounded_String("Cache Block Id");
      Lb_Cache_Block (Francais) 			:=
        To_Unbounded_String("Cache Block");
      Lb_Cache_Block_Name (Francais)			:=
        To_Unbounded_String("Nom de Cache Block");
      Lb_Can_Not_Define_More_Cache_Blocks (Francais) 	:=
        To_Unbounded_String("Impossible de dfinir plus de Cache Block");

      --
      -- Cache
      --
      Lb_Cache_Id (Francais)			:=
        To_Unbounded_String ("Cache Id");
      Lb_Cache (Francais)			:=
        To_Unbounded_String ("Cache");
      Lb_Cache_Name (Francais)			:=
        To_Unbounded_String ("Nom de cache");
      Lb_Cache_Size (Francais)			:=
        To_Unbounded_String ("Taille de cache");
      Lb_Number_Of_Block (Francais)		:=
        To_Unbounded_String ("Nombre de blocks");
      Lb_Line_Size (Francais)	 		:=
        To_Unbounded_String ("Taille de ligne");
      Lb_Associativity (Francais)		:=
        To_Unbounded_String ("Associativit");
      Lb_Hit_Time (Francais)			:=
        To_Unbounded_String ("Instant de Hit");
      Lb_Miss_Time (Francais)			:=
        To_Unbounded_String ("Instant de Miss");
      Lb_Miss_Rate (Francais)			:=
        To_Unbounded_String ("Taux de Miss");
      Lb_Can_Not_Define_More_Caches (Francais) 	:=
        To_Unbounded_String ("Impossible de dfinir plus de cache");

      --
      -- Cache_Access_Profile
      --
      Lb_Cache_Access_Profile_Id (Francais)	:=
        To_Unbounded_String ("Cache Access Profile Id");
      Lb_Cache_Access_Profile (Francais)	:=
        To_Unbounded_String ("Cache Access Profile");
      Lb_Cache_Access_Profile_Name (Francais)	:=
        To_Unbounded_String ("Nom du Cache Access Profile");
      Lb_UCBs (Francais)			:=
        To_Unbounded_String ("UCBs");
       Lb_UCBs_Nb_Entries (Francais)		:=
        To_Unbounded_String ("Nombre of UCBs");
      Lb_ECBs (Francais)			:=
        To_Unbounded_String ("ECBs");
      Lb_ECBs_Nb_Entries (Francais)		:=
        To_Unbounded_String ("Nombre de ECBs");
      Lb_Can_Not_Define_More_Cache_Access_Profiles (Francais)	:=
        To_Unbounded_String ("Impossible de dfinir plus de  Cache Access Profile");
      Lb_Cache_Access_Profile_Not_Found	(Francais)		:=
        To_Unbounded_String("Cache Access Profile inconnu");
      Lb_Compute_Cache_Access_Profile (Francais)		:=
        To_Unbounded_String("Calcul Cache Access Profile");
      Lb_Compute_Cache_Access_Profile_Method (Francais)		:=
        To_Unbounded_String("avec UCB and ECB analyse");
      Lb_Cache_Access_Profile_Must_Be_Defined (Francais) :=
        To_Unbounded_String("ERROR: Cache Access Profiles des tches doivent tre dfinies ");

      --
      --  Address space widgets
      --
      Lb_Address_Space_Name (Francais)         :=
        To_Unbounded_String ("Nom de l'espace d'adressage");
      Lb_Address_Space_id (Francais)         :=
        To_Unbounded_String ("Id de l'espace d'adressage");
      Lb_Address_Space (Francais)              :=
        To_Unbounded_String ("Espace d'addressage");
      Lb_Invalid_Scheduler (Francais)          :=
        To_Unbounded_String ("Ordonnanceur invalide");
      Lb_Select_Address_Space_First (Francais) :=
        To_Unbounded_String ("Choisissez un espace d'addressage d'abord");
      Lb_Text_Memory_Size (Francais)           :=
        To_Unbounded_String ("Taille mmoire du code");
      Lb_Heap_Memory_Size (Francais)           :=
        To_Unbounded_String ("Taille mmoire du tas");
      Lb_Data_Memory_Size (Francais)           :=
        To_Unbounded_String ("Taille mmoire des donnes");
      Lb_Stack_Memory_Size (Francais)          :=
        To_Unbounded_String ("Taille mmoire de la pile");
      Lb_Text (Francais)                       :=
        To_Unbounded_String ("Code");
      Lb_Heap (Francais)                       := To_Unbounded_String ("Tas");
      Lb_Data (Francais)                       :=
        To_Unbounded_String ("Donnes");
      Lb_Stack (Francais)                      :=
        To_Unbounded_String ("Pile");
      Lb_require_same_Scheduler_on_all_address_space(Francais) := to_unbounded_string(
                                                                                     "Ncessite le mme ordonnanceur sur tous les espace d'addressage");


      --
      -- Labels related to sections
      --
      Lb_Task_Name (Francais) := To_Unbounded_String ("Nom de la section");
      Lb_Task (Francais)      := To_Unbounded_String ("Section");

      --
      --  Tasks widgets
      --
      Lb_Task_id (Francais)                          :=
        To_Unbounded_String ("Tche id");
      Lb_Task_Group_id (Francais)                    :=
        To_Unbounded_String ("Groupe de tches id");
      Lb_Task_Name (Francais)                        :=
        To_Unbounded_String ("Nom de la tche");
      Lb_Task_Group_Name (Francais)                  :=
        To_Unbounded_String ("Nom du groupe de tches");
      Lb_Task (Francais)                             :=
        To_Unbounded_String ("Tche");
      Lb_Task_Group (Francais)                       :=
        To_Unbounded_String ("Groupe de tches");
      Lb_Task_Type (Francais)                        :=
        To_Unbounded_String ("Type de tche");
      Lb_Capacity (Francais)                         :=
        To_Unbounded_String ("Capacit");
      Lb_Criticality (Francais)                      :=
        To_Unbounded_String ("Criticit");
      Lb_Deadline (Francais)                         :=
        To_Unbounded_String ("Echance");
      Lb_Period (Francais)                           :=
        To_Unbounded_String ("Priode");
      Lb_Jitter (Francais)                           :=
        To_Unbounded_String ("Gigue");
      Lb_Priority (Francais)                         :=
        To_Unbounded_String ("Priorit");
      Lb_Policy (Francais)                           :=
        To_Unbounded_String ("Politique");
      Lb_Policy_Control (Francais)                   :=
        To_Unbounded_String
          ("Politique incompatible avec le niveau de priorit selectionn");
      Lb_Start_Time (Francais)                       :=
        To_Unbounded_String ("Arrive");
      Lb_Offset_Val (Francais)                       :=
        To_Unbounded_String ("Val. offset");
      Lb_Offset_Act (Francais)                       :=
        To_Unbounded_String ("Offset act.");
      Lb_Offsets (Francais)                          :=
        To_Unbounded_String ("Offsets");
      Lb_Activations (Francais)                      :=
        To_Unbounded_String ("Activations");
      Lb_Activation (Francais)                       :=
        To_Unbounded_String ("Activation");
      Lb_Values (Francais)                           :=
        To_Unbounded_String ("Valeurs");
      Lb_Value (Francais)                            :=
        To_Unbounded_String ("Valeur");
      Lb_User_Defined_Parameter (Francais)           :=
        To_Unbounded_String ("Paramtres utilisateurs");
      Lb_Rule_For_Parametric_Only (Francais)         :=
        To_Unbounded_String
          ("Rgle d'activation seulement avec une tche paramtrique");
      Lb_Main (Francais)                             :=
        To_Unbounded_String ("Page principale");
      Lb_Can_Not_Modify (Francais)                   :=
        To_Unbounded_String ("Ne peut pas tre modifi.");
      Lb_No_Period (Francais)                        :=
        To_Unbounded_String ("n'a pas de priode");
      Lb_Require_Period (Francais)                   :=
        To_Unbounded_String ("exige une priode");
      Lb_Require_Activation_Rule (Francais)          :=
        To_Unbounded_String ("exige une rgle d'activation");
      Lb_Have_To_Be_On_The_Same_Processor (Francais) :=
        To_Unbounded_String
          ("doivent tre positionns sur le mme processeur");
      Lb_Select_Task_First (Francais)                :=
        To_Unbounded_String ("Choisissez une tche d'abord");
      Lb_Seed (Francais)                             :=
        To_Unbounded_String ("Graine");
      Lb_Predictable (Francais)                      :=
        To_Unbounded_String ("Prvisible");
      Lb_Unpredictable (Francais)                    :=
        To_Unbounded_String ("Imprvisible");
      Lb_Task_Not_Permitted (Francais)               :=
        To_Unbounded_String
          ("Operation impossible pour la tche selectionne");
      Lb_Activation_Rule (Francais)                  :=
        To_Unbounded_String ("Rgle d'activation");
      lb_context_switch_overhead (Francais)          :=
        To_Unbounded_String ("Commutation de contexte");
      lb_every (Francais)          :=
        To_Unbounded_String ("Every");

      --
      --  Messages widgets
      --
      Lb_message_id(Francais)      :=
        To_Unbounded_String ("Message id");
      Lb_Response_Time_Message (Francais)      :=
        To_Unbounded_String ("Temps de rponse");
      Lb_Communication_Time_Message (Francais) :=
        To_Unbounded_String ("Temps de communication");
      Lb_Message_Type (Francais)               :=
        To_Unbounded_String ("Type du message");
      Lb_Message (Francais)                    :=
        To_Unbounded_String ("Message");
      Lb_Message_Name (Francais)               :=
        To_Unbounded_String ("Nom du message");

      --
      --  Buffers widgets
      --
      Lb_Buffer (Francais)              := To_Unbounded_String ("Tampon");
      Lb_Buffer_id (Francais)         :=
        To_Unbounded_String ("Tampon id");
      Lb_Buffer_Name (Francais)         :=
        To_Unbounded_String ("Nom du tampon");
      Lb_Size (Francais)                := To_Unbounded_String ("Taille");
      Lb_Time (Francais)                := To_Unbounded_String ("Temps");
      Lb_Timeout (Francais)                := To_Unbounded_String ("Chien de garde");
      Lb_Select_Buffer_First (Francais) :=
        To_Unbounded_String ("Choisissez un tampon d'abord");
      Lb_Utilization_Level (Francais)   :=
        To_Unbounded_String ("Taux d'utilisation");
      Lb_Bound_Buffer (Francais)        :=
        To_Unbounded_String ("Borne sur les tampons");
      Lb_Role_Type (Francais)           := To_Unbounded_String ("Type");
      Lb_Role (Francais)                := To_Unbounded_String ("Rle");
      Lb_Role_Consumer (Francais)       :=
        To_Unbounded_String ("Consommateur");
      Lb_Role_Producer (Francais)       := To_Unbounded_String ("Producteur");
      Lb_Buffer_Information (Francais)  :=
        To_Unbounded_String ("Information sur le tampon ");
      Lb_Buffer_List (Francais)         :=
        To_Unbounded_String ("Liste des tampons ");
      Lb_Role_List (Francais)           :=
        To_Unbounded_String ("Tches utilisant le tampon ");
      Lb_Queueing_System (Francais)     :=
        To_Unbounded_String ("File d'attente ");
      Lb_duplicated_buffer_role(Francais)     :=
        To_Unbounded_String (" Rle de tampon redondant ");

      --
      --  Resources widgets
      --
      Lb_Resource_id (Francais)                           :=
        To_Unbounded_String ("Ressource id");
      Lb_Resource_Name (Francais)                           :=
        To_Unbounded_String ("Nom de la ressource");
      Lb_Resource (Francais)                                :=
        To_Unbounded_String ("Ressource");
      Lb_Select_Resource_First (Francais)                   :=
        To_Unbounded_String ("Choisissez une ressource d'abord");
      Lb_Update_Resource_Control (Francais)                 :=
        To_Unbounded_String ("Tche selectionne invalide");
      Lb_Resource_Filter (Francais)                         :=
        To_Unbounded_String ("Selectionner une ressource");
      Lb_Cpu_Filter (Francais)                              :=
        To_Unbounded_String ("Selectionner un processeur");
      lb_address (Francais)                                 :=
        To_Unbounded_String ("Adresse");
      Lb_State (Francais)                                   :=
        To_Unbounded_String ("Etat");
      Lb_Protocol (Francais)                                :=
        To_Unbounded_String ("Protocole");
      Lb_Modify (Francais)                                  :=
        To_Unbounded_String ("Modifier");
      Lb_Used_Protocol (Francais)                           :=
        To_Unbounded_String ("Protocole utilis : ");
      Lb_Resource_State (Francais)                          :=
        To_Unbounded_String ("Etat de la ressource (Entier) : ");
      Lb_Task_Begin (Francais)                              :=
        To_Unbounded_String ("Dbut");
      Lb_Task_End (Francais)                                :=
        To_Unbounded_String ("Fin");
      Lb_Resources (Francais)                               :=
        To_Unbounded_String ("Ressources");
      Lb_Resource_Affect (Francais)                         :=
        To_Unbounded_String ("Ressource partage par les tches ");
      Lb_Resource_Information (Francais)                    :=
        To_Unbounded_String ("Information sur la resource ");
      Lb_Invalid_Protocol (Francais)                        :=
        To_Unbounded_String (" Protocole de partage de resource invalide ");
      Lb_can_not_add_more_task_for_this_resource (Francais) :=
        To_Unbounded_String
          (" Impossible d'ajouter une autre tche pour cette ressource ");
      Lb_duplicated_critical_section(Francais) :=
        To_Unbounded_String
          (" Section critique redondante ");

      --
      -- Networks Widgets
      --
      Lb_Select_network_First (Francais)       :=
        To_Unbounded_String ("Selectionner un rseau d'abord");
      Lb_Only_On_Parametric_Network (Francais) :=
        To_Unbounded_String ("Seulement avec un rseau paramtrique");
      Lb_Network (Francais)                    :=
        To_Unbounded_String ("Rseau");
      Lb_Network_Name (Francais)              :=
        To_Unbounded_String ("Nom du rseau");
      Lb_Network_Type (Francais)              :=
        To_Unbounded_String ("Type du rseau");
      Lb_Networks_List (Francais)              :=
        To_Unbounded_String ("Liste des rseaux");
      Lb_View_Networks_Type (Francais)         :=
        To_Unbounded_String ("Type");
      Lb_Define_Networks_Before (Francais)     :=
        To_Unbounded_String ("Definir un rseau avant");
      Lb_Delete_Network (Francais)             :=
        To_Unbounded_String ("Effacer un rseau");
      Lb_Network_Not_Found (Francais)          :=
        To_Unbounded_String ("Le rseau n'existe pas");

      --
      --  Dependency graph widgets
      --

      Lb_New_Buffer_Role (Francais)   :=
        To_Unbounded_String ("Nouveau rle tampon");
      Lb_Disp1 (Francais)             :=
        To_Unbounded_String ("Disposition 1");
      Lb_Disp2 (Francais)             :=
        To_Unbounded_String ("Disposition 2");
      Lb_Disp3 (Francais)             :=
        To_Unbounded_String ("Disposition 3");
      Lb_Create (Francais)            := To_Unbounded_String ("Crer");
      Lb_Select (Francais)            := To_Unbounded_String ("Selectionner");
      Lb_Name (Francais)              := To_Unbounded_String ("Nom");
      Lb_Select_Row_Before (Francais) :=
        To_Unbounded_String ("Selectionner une ligne avant");
      Lb_Precedencies (Francais)      := To_Unbounded_String ("Prcdences");
      Lb_dependencies (Francais)      := To_Unbounded_String ("Dpendances");
      Lb_Arrow (Francais)             := To_Unbounded_String ("Flche");
      Lb_New_Item (Francais)          := To_Unbounded_String ("Nouvel objet");
      Lb_Graph_View (Francais)        :=
        To_Unbounded_String ("Graphe de prcdences");
      Lb_Choose_Item (Francais)       :=
        To_Unbounded_String ("Choisisser l'objet");

      --
      --  Duplicate widget
      --

      Lb_Duplicate (Francais) := To_Unbounded_String ("Copier");
      Lb_Old (Francais)       := To_Unbounded_String ("Ancien");
      Lb_Object (Francais)    := To_Unbounded_String ("Objet");

      --
      -- Time line selection wifget
      --

      Lb_Select_Time_Line (Francais)                  :=
        To_Unbounded_String ("Selection des chronogrammes");
      Lb_Type (Francais)                              :=
        To_Unbounded_String ("Type");
      Lb_To_Display (Francais)                        :=
        To_Unbounded_String ("A afficher");
      Lb_Can_Not_Display_So_Much_Time_Line (Francais) :=
        To_Unbounded_String ("Impossible d'afficher autant de chronogramme");
      Lb_Select_At_Least_One_Time_Line (Francais)     :=
        To_Unbounded_String ("Slectionner au moins un chronogramme");

      --
      -- AADL options widget
      --

      Lb_Aadl_Process_Second_Import_Pass (Francais)            :=
        To_Unbounded_String(
                            "Appliquer la 2eme passe de l'import : liaison des composants logiciels et matriels"
                           );
      Lb_Aadl_Process_Third_Import_Pass (Francais)             :=
        To_Unbounded_String(
                            "Appliquer la 3eme passe de l'import : traitement des connexions entre composants"
                           );
      Lb_Import_Aadl_Event_To_Precedencies (Francais)          :=
        To_Unbounded_String
          ("Transformer les event ports en prcdence de tches");
      Lb_Import_Aadl_Event_To_Buffers_Messages (Francais)      :=
        To_Unbounded_String
          ("Transformer les event ports en buffers et messages");
      Lb_Import_Aadl_Event_Data_To_Precedencies (Francais)     :=
        To_Unbounded_String
          ("Transformer les event data ports en prcdence de tches");
      Lb_Import_Aadl_Event_Data_To_Buffers_Messages (Francais) :=
        To_Unbounded_String
          ("Transformer les event data ports en buffers et messages");
      Lb_Aadl_Debug (Francais)                                 :=
        To_Unbounded_String ("Activer l'option de Debug pour AADL");
      Lb_Import_Aadl_System_Name (Francais)                    :=
        To_Unbounded_String(
                            "Inclure le nom du systme/sous-systme dans le nom des composants Camembert");
      Lb_Export_Aadl_Precedencies_To_Event (Francais)          :=
        To_Unbounded_String
          ("Transformer les prcdences de tches en event ports");
      Lb_Export_Aadl_Precedencies_To_Event_Data (Francais)     :=
        To_Unbounded_String
          ("Transformer les prcdences de tches en event data ports");
      Lb_Export_Aadl_Precedencies_To_Properties (Francais)     :=
        To_Unbounded_String
          ("Transformer les prcdences de tches en proprits Cheddar");


      --
      -- System entity checks
      --
      Lb_are_unconsistent(francais)     :=
        To_Unbounded_String (" sont incompatibles");


      --
      -- Others ...
      --
      Lb_Advanced (Francais) := To_Unbounded_String ("Avanc");
      Lb_Cancel (Francais)   := To_Unbounded_String ("Annuler");
      Lb_Warning (Francais)  := To_Unbounded_String ("- Attention : ");
      Lb_See (Francais)      := To_Unbounded_String ("cf. ");
      Lb_Equation (Francais) := To_Unbounded_String ("quation ");
      Lb_Theorem (Francais)  := To_Unbounded_String ("thorme ");
      Lb_Lemma (Francais)    := To_Unbounded_String ("lemme ");
      Lb_less_than (Francais) := To_Unbounded_String ("infrieur  ");
      Lb_less_or_equal_than (Francais) := To_Unbounded_String ("infrieur ou gal  ");
      Lb_greater_than (Francais) := To_Unbounded_String ("suprieur  ");
      Lb_greater_or_equal_than (Francais) := To_Unbounded_String ("suprieur ou gal  ");
      Lb_Divisible (Francais) := To_Unbounded_String ("divisible par");
      Lb_Close (Francais)    := To_Unbounded_String ("Fermer");
      Lb_And (Francais)      := To_Unbounded_String ("et ");
      Lb_Continue (Francais) := To_Unbounded_String ("Voulez vous continuer ?");


      ----------------------------------------------------
      --   Event table services
      ----------------------------------------------------

      Lb_Export_Event_Table (Francais)                          :=
        To_Unbounded_String ("Export la table d'vnements");
      Lb_Import_Event_Table (Francais)                          :=
        To_Unbounded_String ("Import une table d'vnemenbts");
      Lb_Event_Table_Services (Francais)                        :=
        To_Unbounded_String ("Oprations sur la table d'vnements");
      Lb_Compute_Scheduling_And_Generate_Event_Table (Francais) :=
        To_Unbounded_String
          ("Calcul de l'ordonnancement et gnration de la table d'vnements"
          );
      Lb_Run_Analysis_On_Event_Table (Francais)                 :=
        To_Unbounded_String ("Excuter l'analyse de la table d'vnements");
      Lb_Draw_Time_Line_From_Event_Table (Francais)             :=
        To_Unbounded_String
          ("Dessiner le chronogramme  partir de la table d'vnements");
      Lb_Display_Event_Table (Francais)                         :=
        To_Unbounded_String ("Affichage de la table d'vnements");
      Lb_Automatically_Export_Event_Table (Francais)            :=
        To_Unbounded_String ("Export automatique de la table d'vnements");
      Lb_Event_Table_File_Name (Francais)                       :=
        To_Unbounded_String ("Nom du fichier de table d'vnements");

      ----------------------------------------------------
      --   Options
      ----------------------------------------------------

      Lb_Seed_Options (Francais)      :=
        To_Unbounded_String ("Options de graine :");
      Lb_Task_Specific (Francais)     :=
        To_Unbounded_String ("Spcifiques aux tches");
      Lb_All_Predictable (Francais)   :=
        To_Unbounded_String ("Prvisible pour toutes les tches");
      Lb_All_Unpredictable (Francais) :=
        To_Unbounded_String ("Imprvisible pour toutes les tches");
      Lb_Max_time_line_to_display (francais) :=
        To_Unbounded_String ("Max time line to display ");
      Lb_Time_Line_Between_Time_Axis(francais) :=
        To_Unbounded_String ("Time Line Between Time Axis");

      ----------------------------------------------------
      --   Data controls
      ----------------------------------------------------

      Lb_Invalid_Priority (Francais) :=
        To_Unbounded_String ("Valeur de priorit incorrect");
      Lb_Mandatory (Francais)        :=
        To_Unbounded_String (" est obligatoire");
      Lb_Already_Defined (Francais)  := To_Unbounded_String (" dj dfini");
      Lb_Must_Be (Francais)          := To_Unbounded_String (" doit tre ");
      Lb_Must_Be_Numeric (Francais)  :=
        To_Unbounded_String (" doit tre numrique");
      Lb_Parameter (Francais)        := To_Unbounded_String ("Le paramtre ");

      ----------------------------------------------------
      --   Parametric scheduler messages
      ----------------------------------------------------

      --
      -- Parser and parametric simulation error
      --

      Lb_Parametric_File_Error (Francais)                                 :=
        To_Unbounded_String ("Erreur sur fichier paramtrique");
      Lb_Type_Error (Francais)                                            :=
        To_Unbounded_String ("Erreur de type");
      Lb_Statement_Error (Francais)                                       :=
        To_Unbounded_String ("Erreur sur instruction");
      Lb_Variable_Error (Francais)                                        :=
        To_Unbounded_String ("Erreur sur variable");
      Lb_Syntax_Error (Francais)                                          :=
        To_Unbounded_String ("Erreur de syntaxe");
      Lb_Identifier_Already_Exists (Francais)                             :=
        To_Unbounded_String ("Identificateur dj dclar");
      Lb_Variable_Declaration_Have_To_Be_Done_In_Start_Section (Francais) :=
        To_Unbounded_String(
                            "Les declarations de variable doivent etre effectuees dans la section start");
      Lb_Undeclared_Identifier (Francais)                                 :=
        To_Unbounded_String ("Identificateur non dclar");
      Lb_Identifier (Francais)                                            :=
        To_Unbounded_String ("Identificateur");
      Lb_Integer_Conversion_Error (Francais)                              :=
        To_Unbounded_String ("Erreur de conversion sur type entier");
      Lb_Double_Conversion_Error (Francais)                               :=
        To_Unbounded_String ("Erreur de conversion sur type double");
      Lb_Index_Error (Francais)                                           :=
        To_Unbounded_String ("Erreur sur index de tableau");
      Lb_Uncompatible_Type_Error (Francais)                               :=
        To_Unbounded_String ("Types incompatibles");
      Lb_Can_Not_Edit_To_Parametric_Object (Francais)                     :=
        To_Unbounded_String
          ("Impossible d'diter deux objets paramtriques au mme instant");
      Lb_Identifier_Already_Declared (Francais)                           :=
        To_Unbounded_String ("Identicateur deja defini");
      Lb_Operation_Not_Permitted (Francais)                               :=
        To_Unbounded_String ("Opration interdite ");
      Lb_Variable_Size (Francais)                                         :=
        To_Unbounded_String(
                            "Les variables de gauche et de droite doivent avoir la meme de tableau");

      ----------------------------------------------------
      --   Logic messages/errors (scheduling, buffer
      --           and blocking time)
      ----------------------------------------------------

      --
      -- Shared resources logic
      --

      Lb_Compute_Blocking_Error1 (Francais) :=
        To_Unbounded_String
          ("Toutes les ressources doivent utiliser le mme protocole.");
      Lb_Compute_Blocking_Error2 (Francais) :=
        To_Unbounded_String(
                            "- Erreur de protocole : protocole de partage de ressource incompatible avec l'ordonnanceur slectionn."
                           );
      Lb_Compute_Blocking_Error3 (Francais) :=
        To_Unbounded_String(
                            "Impossible de calculer les pires temps de blocage avec ce protocole.")
;

      Lb_Deadlock_Detection (Francais)           :=
        To_Unbounded_String
          ("Recherche d'interblocage  partir de la simulation ");
      Lb_Priority_Inversion_Detection (Francais) :=
        To_Unbounded_String
          ("Recherche d'inversion de priorit  partir de la simulation ");

      Lb_Simulation_Deadlock (Francais)           :=
        To_Unbounded_String ("Interblocage  partir de la simulation ");
      Lb_Simulation_Priority_Inversion (Francais) :=
        To_Unbounded_String
          ("Inversion de priorit  partir de la simulation ");
      Lb_Deadlock_At_Time (Francais)              :=
        To_Unbounded_String ("- Interblocage  l'instant");
      Lb_No_Deadlock_Found (Francais)             :=
        To_Unbounded_String
          ("- Pas d'interblocage trouv dans la simulation.");
      Lb_No_Priority_Inversion_Found (Francais)   :=
        To_Unbounded_String
          ("- Pas d'inversion de priorit trouve dans la simulation.");

      Lb_Has_Priority_Inversion (Francais) :=
        To_Unbounded_String
          ("  est victime d'une inversion de priorit sur la resource ");
      Lb_From_The_Time (Francais)          :=
        To_Unbounded_String (" de l'instant ");
      Lb_To_The_Time (Francais)            :=
        To_Unbounded_String ("  l'instant ");

      Lb_Worst_Case_Blocking_Time (Francais)          :=
        To_Unbounded_String ("Pire temps de blocage ");
      Lb_Blocking_Time (Francais)                :=
        To_Unbounded_String ("Temps de blocage ");
      Lb_Simulation_Blocking_Time (Francais)     :=
        To_Unbounded_String(
                            "Temps de blocage  partir de la simulation (peut include le temps d'attente processeur)"
                           );
      Lb_Blocking_Time_Inject_Success (Francais) :=
        To_Unbounded_String
          ("- Modification des temps de blocage effectue.");
      Lb_Blocking_Time_Inject_Failed (Francais)  :=
        To_Unbounded_String
          ("- Modification des temps de blocage non effectue.");
      Lb_Ceiling_Priority(francais) :=
        To_Unbounded_String ("Priorit plafond");
      Lb_Ceiling_Priority_Inject_Success (francais) :=
        To_Unbounded_String ("- Modification des priorits plafonds effectue.");
      Lb_Ceiling_Priority_Inject_Failed (francais)  :=
        To_Unbounded_String ("- Modification des priorits plafonds non effectue.");


      --
      -- Scheduling logic
      --
      Lb_Pb_Strict_Constraints (Francais)    :=
        To_Unbounded_String(
                            "- Contraintes non strictes :  Impossible d'appliquer le test de faisabilit sur le taux d'utilisation processeur."
                           );
      Lb_Pb_Sched_Unknown (Francais)         :=
        To_Unbounded_String(
                            "- Ordonnanceur invalide :  Impossible d'appliquer le test de faisabilit sur le taux d'utilisation processeur."
                           );
      Lb_feasibility_test_by_name(francais) :=
        To_Unbounded_String ("Calcul d'un test de faisabilit");
      Lb_Select_Almost_One_Feasilibity_Test (Francais)               :=
        To_Unbounded_String ("Selectionner au moins un test de faisabilite");
      Lb_Feasibility_Number1 (Francais)                              :=
        To_Unbounded_String(
                            "1) Test de faisabilit bas sur le taux d'utilisation du processeur : ");
      Lb_Feasibility_Number2 (Francais)                              :=
        To_Unbounded_String
          ("2) Test de faisabilit bas sur le pire temps de rponse de tches priodiques : ");
      Lb_Compute_Scheduling (Francais)                               :=
        To_Unbounded_String ("Calcul de l'ordonnancement");
      Lb_Generate_Events (Francais)                                  :=
        To_Unbounded_String ("Gnration des vnements");
      Lb_Para (Francais)                                             :=
        To_Unbounded_String ("avec un ordonnanceur Paramtrique, ");
      Lb_Edf (Francais)                                              :=
        To_Unbounded_String ("avec EDF, ");
      Lb_Muf (Francais)                                              :=
        To_Unbounded_String ("avec MUF, ");
      Lb_Rm (Francais)                                               :=
        To_Unbounded_String ("avec RM, ");
      Lb_D_Over (Francais)                                           :=
        To_Unbounded_String ("with D-Over, ");
      Lb_Dm (Francais)                                               :=
        To_Unbounded_String ("avec DM, ");
      Lb_Llf (Francais)                                              :=
        To_Unbounded_String ("avec LLF, ");
      Lb_Run_Simulation_On_One_Processor_Only (Francais)             :=
        To_Unbounded_String ("Ordonnance tous les processeurs");
      Lb_Run_Feasibility_Tests_On_One_Processor_Only (Francais)      :=
        To_Unbounded_String (" Faisabilit sur tous les processeurs");
      Lb_Worst_Case (Francais)                                       :=
        To_Unbounded_String ("Pire cas");
      Lb_Best_Case (Francais)                                        :=
        To_Unbounded_String ("Meilleur cas");
      Lb_Average_Case (Francais)                                     :=
        To_Unbounded_String ("Cas moyen");
      Lb_Curve (Francais)                                            :=
        To_Unbounded_String ("Courbe");
      Lb_Simulation_warning (Francais)                               :=
        To_Unbounded_String ("Warning sur simulation : ");
      Lb_Simulation_Error (Francais)                                 :=
        To_Unbounded_String ("Erreur de simulation : ");
      Lb_Priorities_Error1 (Francais)                                 :=
        To_Unbounded_String
          ("- Tches non priodiques : impossible de modifier les priorits.") ;
      Lb_Priorities_Error2 (francais)                                 :=
        To_Unbounded_String
          ("- Processor sans tche : impossible de modifier les priorits.");
      Lb_Priorities_Error_OPA (Francais)				    :=
        To_Unbounded_String
          ("- Ensemble de tche n'est pas faisable: impossible de modifier les priorits.");
      Lb_Priorities_Error_OPA_CRPD (Francais)				    :=
        To_Unbounded_String
          ("- Ensemble de tche n'est pas faisable avec solution de calcul CRPD Interfrence choisi");
      Lb_Set_Priorities_Dm (Francais)                                :=
        To_Unbounded_String
          ("Affectation des priorits selon Deadline Monotonic");
      Lb_Set_Priorities_Rm (Francais)                                :=
        To_Unbounded_String
          ("Affectation des priorits selon Rate Monotonic");
      Lb_Set_Priorities_Audsley_OPA (Francais)			     :=
        To_Unbounded_String
          ("Affectation des priorits selon Audsley OPA");
       Lb_Set_Priorities_OPA_CRPD_PT (Francais)			     :=
        To_Unbounded_String
          ("Affectation des priorits selon Audsley OPA avec CRPD (OPA_CRPD-PT solution)");
       Lb_Set_Priorities_OPA_CRPD_PT_Simplified (Francais)	     :=
        To_Unbounded_String
          ("Affectation des priorits selon Audsley OPA avec CRPD (OPA_CRPD-PT-Simplified solution)");
       Lb_Set_Priorities_OPA_CRPD_Tree (Francais)	             :=
        To_Unbounded_String
          ("Affectation des priorits selon Audsley OPA avec CRPD (OPA_CRPD-Tree solution)");
      Lb_Set_Priorities (Francais)                                   :=
        To_Unbounded_String ("Affectation des priorits");
      Lb_Scheduling_Options (Francais)                               :=
        To_Unbounded_String ("Paramtrage de l'ordonnancement");
      Lb_Schedule_According_To (Francais)                            :=
        To_Unbounded_String ("Ordonnancement en tenant compte des :");
      Lb_Unit_Of_Times (Francais)                                    :=
        To_Unbounded_String (" units de temps ");
      Lb_Draw_From (Francais)                                        :=
        To_Unbounded_String ("Tracer  partir de");
      Lb_Draw_To (Francais)                                          :=
        To_Unbounded_String ("Tracer jusqu'");
      Lb_Schedule_To (Francais)                                      :=
        To_Unbounded_String (" Ordonnancer de 0 ");
      Lb_Periodic_Situation (Francais)                               :=
        To_Unbounded_String (" dans le cas priodique");
      Lb_Schedule_Time_Line_Too_Large (Francais)                     :=
        To_Unbounded_String
          (" Impossible de calculer un aussi grand ordonnancement ");
      Lb_Draw_Time_Line_Too_Large (Francais)                         :=
        To_Unbounded_String
          (" Impossible d'afficher plus de 1500 units de temps ");
      Lb_Scheduling (Francais)                                       :=
        To_Unbounded_String ("Ordonnancement");
      Lb_Free_Unit_Time (Francais)                                   :=
        To_Unbounded_String
          (" units de temps sont libres sur la priode d'tude.");
      Lb_Utilization_With_Period (Francais)                          :=
        To_Unbounded_String
          ("- Le taux d'utilisation calcul avec les priodes est de ");
      Lb_Utilization_With_Deadline (Francais)                        :=
        To_Unbounded_String
          ("- Le taux d'utilisation calcul avec les chances est de ");
      Lb_Utilization_Bound1 (Francais)                               :=
        To_Unbounded_String ("- Dans le cas premptif, ");
      Lb_Utilization_Bound11 (Francais)                              :=
        To_Unbounded_String ("- Dans le cas non premptif, ");
      Lb_Sched_Explanation1 (Francais)                               :=
        To_Unbounded_String(
                            "les taches sont ordonnancables car le taux d'utilisation processeur ");
      Lb_Sched_Explanation12 (Francais)                              :=
        To_Unbounded_String (" est inferieur ou egal a ");
      Lb_Sched_Explanation2 (Francais)                               :=
        To_Unbounded_String(
                            "les taches ne sont pas ordonnancables car le taux d'utilisation processeur ");
      Lb_Sched_Explanation22 (Francais)                              :=
        To_Unbounded_String (" est superieur a ");
      Lb_Sched_Explanation3 (Francais)                               :=
        To_Unbounded_String(
                            "il n'est pas possible de prouver que les taches sont ordonnancables car le taux d'utilisation processeur "
                           );
      Lb_Sched_Explanation5 (Francais)                               :=
        To_Unbounded_String
          ("le jeu de taches est ordonnancable car pour chaque tache ");
      Lb_Sched_Explanation52 (Francais)                              :=
        To_Unbounded_String(
                            "le taux d'utilisation du processeur est plus petit ou gal  la borne ");
      Lb_Sched_Explanation6 (Francais)                               :=
        To_Unbounded_String
          ("le jeu de taches n'est pas ordonnancable car ");
      Lb_Sched_Explanation62 (Francais)                              :=
        To_Unbounded_String(
                            "une ou plusieurs taches ne remplissent pas le test de faisabilit sur le taux d'utilisation processeur"
                           );
      Lb_Sched_Explanation7 (Francais)                               :=
        To_Unbounded_String ("  Liste des taches non ordonnancables : ");
      Lb_Sched_Explanation8 (Francais)                               :=
        To_Unbounded_String(
                            "il n'est pas possible de prouver que le jeu de taches est ordonnancable car ")
;
      Lb_Sched_Explanation81 (Francais)                              :=
        To_Unbounded_String(
                            "une ou plusieurs taches ne remplissent pas le test de faisabilit sur le taux d'utilisation processeur"
                           );
      Lb_Sched_Explanation82 (Francais)                              :=
        To_Unbounded_String ("  Liste des taches concernes : ");
      Lb_No_Deadline_Missed_In_The_Computed_Scheduling (Francais)    :=
        To_Unbounded_String(
                            "- Aucune chance de manque dans la simulation d'ordonnancement : le jeu de tches est ordonnanable si l'ordonnancement a t calcul sur l'interval de faisabilit."
                           );
Lb_Cannot_Say_If_Deadline_will_be_Missed_In_The_Computed_Scheduling
(francais)    :=
        To_Unbounded_String(
                            "- Une ou plusieurs tches n'ont pas termin leur excution."
                           );
      Lb_No_Deadline_Will_Be_Missed_Task_Are_Schedulable (Francais)  :=
        To_Unbounded_String(
                            "- Toutes les chances seront respectes : le jeu de tches est ordonnanable."
                           );
      Lb_Deadline_Will_Be_Missed_Task_Are_Not_Schedulable (Francais) :=
        To_Unbounded_String(
                            "- Certaines chances ne seront pas respectes : le jeu de tches n'est pas ordonnanable."
                           );
      Lb_Worst_Case_Task_Response_Time (Francais)                      :=
        To_Unbounded_String ("Pire temps de rponse des tches");
      Lb_Task_Response_Time (Francais)                               :=
        To_Unbounded_String
          ("- Borne maximale sur les temps de rponse des tches : ");
      Lb_Task_Response_Time (Francais)                               :=
        To_Unbounded_String ("Temps de rponse des tches");
      Lb_Task_Response_Time_From_Simulation (Francais)               :=
        To_Unbounded_String
          ("Temps de rponse des tches calcul  partir de la simulation");
      Lb_Scheduling_Period (Francais)                                :=
        To_Unbounded_String ("- La priode d'tude est");
      Lb_Number_Of_Preemption (Francais)                             :=
        To_Unbounded_String ("Nombre de premption");
      Lb_Number_Of_Context_Switch (Francais)                         :=
        To_Unbounded_String ("Nombre de commutation de contexte");
      Lb_Priorities (Francais)                                       :=
        To_Unbounded_String ("- Nouvelles priorits :");
      Lb_Partition_Best_Fit (Francais)                               :=
        To_Unbounded_String ("Avec Best Fit");
      Lb_Partition_General_Task (Francais)                           :=
        To_Unbounded_String ("Avec General Task");
      Lb_Partition_Next_Fit (Francais)                               :=
        To_Unbounded_String ("Avec Next Fit");
      Lb_Partition_First_Fit (Francais)                              :=
        To_Unbounded_String ("Avec First Fit");
      Lb_Partition_Small_Task (Francais)                             :=
        To_Unbounded_String ("Avec Small Task");
      Lb_Partition (Francais)                                        :=
        To_Unbounded_String ("Partitionnement ");
      Lb_Partitioning_Result (Francais)                              :=
        To_Unbounded_String ("Placement des tches aprs partitionnement");
      Lb_Partition_Error1 (Francais)                                 :=
        To_Unbounded_String(
                            "- Impossible de partitionner : tous les processeurs doivent avoir le mme ordonnanceur."
                           );
      Lb_Partition_Error2 (Francais)                                 :=
        To_Unbounded_String
          ("- Impossible de partitionner : nombre de processeur insuffisant.")
;
      Lb_Partition_Error3 (Francais)                                 :=
        To_Unbounded_String(
                            "- Impossible de partitionner : Ordonnanceur invalide. ");
      Lb_Partition_Error4 (francais)                                 :=
        To_Unbounded_String
          ("- Impossible de partitionner : les tches doivent tre priodiques.");


      Lb_Compute_Scheduling_Error_1 (Francais)                     :=
        To_Unbounded_String(
                            "- Erreur sur le modle de tche : l'ordonnanceur slectionne est incompatible."
                           );
      Lb_Compute_Scheduling_Error_2 (Francais)                     :=
        To_Unbounded_String(
                            "- Tches non priodiques : impossible de calculer la priode d'tude avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_3 (Francais)                     :=
        To_Unbounded_String(
                            "- Erreur sur le modle de tche : impossible de calculer la priode d'tude avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_4 (Francais)                     :=
        To_Unbounded_String(
                            "- Tches avec priodes diffrentes des chances : impossible de calculer les pires temps de rponse avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_5 (Francais)                     :=
        To_Unbounded_String(
                            "- Tches non priodiques : impossible de calculer les pires temps de rponse avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_6 (Francais)                     :=
        To_Unbounded_String(
                            "- Erreur sur le modle de tche : impossible de calculer les pires temps de rponse avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_7 (Francais)                     :=
        To_Unbounded_String(
                            "- Taux d'utilisation trp lev : impossible de calculer les pires temps de rponse avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_8 (Francais)                     :=
        To_Unbounded_String(
                            "- Erreur interne : impossible de calculer les pires temps de rponse avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_9 (Francais)                     :=
        To_Unbounded_String(
                            "- Tches non priodiques : impossible de calculer un taux d'utilisation bas sur les priodes avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_10 (Francais)                    :=
        To_Unbounded_String(
                            "- Erreur sur le modle de tche : impossible de calculer un taux d'utilisation avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_11 (Francais)                    :=
        To_Unbounded_String(
                            "- Tches avec priorit identique : l'ordonnanceur slectionne est incompatible."
                           );
      Lb_Compute_Scheduling_Error_12 (Francais)                    :=
        To_Unbounded_String(
                            "- Tches avec date d'arrive >  zro : impossible de calculer les pires temps de rponse avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_13 (Francais)                    :=
        To_Unbounded_String(
                            "- Tches avec offset diffrents de zro : impossible de calculer les pires temps de rponse avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_14 (Francais)                    :=
        To_Unbounded_String(
                            "- Tches avec priodes diffrentes des chances : l'ordonnanceur slectionn est incompatible."
                           );
      Lb_Compute_Scheduling_Error_15 (Francais)                    :=
        To_Unbounded_String(
                            "- Tches non priodiques : l'ordonnanceur slectionn est incompatible.");
      Lb_Compute_Scheduling_Error_18 (Francais)                    :=
        To_Unbounded_String(
                            "- Ordonnanceur invalide : impossible de calculer les pires  temps de rponse avec cet ordonnanceur."
                           );
      Lb_Compute_Scheduling_Error_19 (Francais)                    :=
        To_Unbounded_String(
                            "- Ordonnanceur invalide : impossible de calculer une borne sur le taux d'utilisation."
                           );
      Lb_Compute_Scheduling_Error_21 (Francais)                    :=
        To_Unbounded_String(
                            "- Tches avec chance nulle : impossible de calculer un taux d'utilisation bas sur les chances avec ce jeu de tches."
                           );
      Lb_Compute_Scheduling_Error_22 (Francais)                    :=
        To_Unbounded_String
          ("- Impossible de calculer un ordonnancement aussi grand. ");
      Lb_Compute_Scheduling_Error_23 (Francais)                    :=
        To_Unbounded_String(
                            "- Tches avec date d'arrive >  zro : impossible de calculer le test de de faisabilit sur le taux d'occupation processeur."
                           );
      Lb_Compute_Scheduling_Error_24 (Francais)                    :=
        To_Unbounded_String(
                            "- Tches avec offset diffrents de zro : impossible de calculer le test de de faisabilit sur le taux d'occupation processeur."
                           );
      Lb_Compute_Scheduling_Error_25 (francais)                    :=
        To_Unbounded_String(
                            "- Groupes de tches non transactionnel : impossible de calculer les pires temps de rponse avec ce jeu de tche."
                           );
      Lb_Compute_Scheduling_Error_26 (francais)                    :=
        To_Unbounded_String(
                            "- Transaction sans tahe : impossible de calculer les pires temps de rponse avec ce jeu de tche."
                           );
      Lb_Check_Deadline (Francais)                                 :=
        To_Unbounded_String (" a rat son chance (chance = ");
      Lb_Check_absolute_Deadline (English)                                 :=
        To_Unbounded_String (" a rat son chance (chance absolue = ");
      Lb_Periodic (Francais)                                       :=
        To_Unbounded_String ("La tche priodique ");
      Lb_Periodic (Francais)                                       :=
        To_Unbounded_String ("La trame ");
      Lb_Aperiodic (Francais)                                      :=
        To_Unbounded_String ("La tche apriodique ");
      Lb_Poisson_Process_Task (Francais)                           :=
        To_Unbounded_String ("La tche Processus de Poisson ");
      Lb_Sporadic_Task (Francais)                                  :=
        To_Unbounded_String ("La tche Sporadique ");
      Lb_Parametric_Task (Francais)                                :=
        To_Unbounded_String ("La tche paramtrique ");
      Lb_Completion_Time (Francais)                                :=
        To_Unbounded_String (" ; terminaison = ");
      lb_task_is_not_over_response_time_is_not_computed (Francais) :=
        To_Unbounded_String(
                            " temps de reponse non calcule car la tache n'a pas termin sa capacit");
    Lb_Computation_time_exceeded(francais)                                :=
        To_Unbounded_String ("- Computation exceeded exception : impossible de calculer cette analyse avec ce jeu de tches.");



      --
      -- Buffer logic
      --

      Lb_Schedule_Before (Francais)        :=
        To_Unbounded_String ("Calculer un ordonnancement d'abord");
      Lb_Buffer_Utilization (Francais)     :=
        To_Unbounded_String ("Taux d'occupation du tampon : ");
      Lb_Compute_Buffer_Error_1 (Francais) :=
        To_Unbounded_String(
                            "- Contrainte de dbit non respecte : impossible de calculer la borne du tampon avec ce jeu de tches."
                           );
      Lb_Compute_Buffer_Error_2 (Francais) :=
        To_Unbounded_String(
                            "- Tches non priodiques : impossible de calculer la borne du tampon avec ce jeu de tche."
                           );
      Lb_Harmonic (Francais)               :=
        To_Unbounded_String ("Harmonique");
      Lb_Compute_Buffer_Error_3 (Francais) :=
        To_Unbounded_String(
                            "- Erreur sur le modle de tche : impossible de calculer la borne du tampon avec plusieurs consommateurs. "
                           );
      Lb_Compute_Buffer_Error_4 (Francais) :=
        To_Unbounded_String(
                            "- Erreur file d'attente : impossible de calculer les critres de performance avec cette file d'atttente. "
                           );
      Lb_Maximum_Buffer_Size (Francais)    :=
        To_Unbounded_String
          ("- Nombre maximum de message dans le tampon : ");
      Lb_Average_Buffer_Size (Francais)    :=
        To_Unbounded_String ("- Nombre moyen de message dans le tampon : ");
      Lb_Maximum_Waiting_Time (Francais)   :=
        To_Unbounded_String ("- Temps d'attente maximum d'un message : ");
      Lb_Average_Waiting_Time (Francais)   :=
        To_Unbounded_String ("- Temps d'attente moyen d'un message : ");

      --
      -- Dependencies logic
      --
      Lb_Chetto (Francais)          :=
        To_Unbounded_String ("Applications des rgles de Chetto/Blazewicz");
      Lb_Chetto_Deadline (Francais) :=
        To_Unbounded_String
          ("Modification des chances selon Chetto/Blazewicz");
      Lb_Chetto_Priority (Francais) :=
        To_Unbounded_String
          ("Modification des priorits selon Chetto/Blazewicz");

      Lb_Jitter_From_Response_Time_One_Step (Francais)  :=
        To_Unbounded_String ("Un pas de calcul");
      Lb_Jitter_From_Response_Time_All_Steps (Francais) :=
        To_Unbounded_String ("Tous les pas de calcul");
      Lb_Jitter_From_Response_Time (Francais)           :=
        To_Unbounded_String ("Pire temps de rponse de bout en bout");

      Lb_Deadlines_Are_Updated (Francais)     :=
        To_Unbounded_String ("- Mise  jour des chances effectue.");
      Lb_Priorities_Are_Updated (Francais)    :=
        To_Unbounded_String ("- Mise  jour des priorits effectue.");
      Lb_Jitters_Are_Updated (Francais)       :=
        To_Unbounded_String ("- Mise  jour des gigues effectue.");
      Lb_Precedencies_Period_Error (Francais) :=
        To_Unbounded_String(
                            "- Imposible d'ordonnancer avec les contraintes de precedence : les tches ayant des contraintes de prcdence doivent avoir une priode identique."
                           );
 Lb_holistique_Error1 (francais)             :=
        To_Unbounded_String(
                            "- Tches avec des priodes diffrentes et des contraintes de prcdence : impossible d'appliquer la mthode holistique/pire temps de rponse de bout en bout sur ce jeu de tache "
                           );
 Lb_holistique_Error2 (francais)             :=
        To_Unbounded_String(
                            "- Tches de types diffrents et des contraintes de prcdence : impossible d'appliquer la mthode holistique/pire temps de rponse de bout en bout sur ce jeu de tache "
                           );
      Lb_Chetto_Error1 (Francais)             :=
        To_Unbounded_String(
                            "- Chetto/Blazewicz impossible  appliquer : le graphe de prcdence doit tre acyclique."
                           );
      Lb_Chetto_Error2 (Francais)             :=
        To_Unbounded_String(
                            "- Tches avec des priodes diffrentes : impossible d'appliquer la mthode de Chetto/Blazewicz. "
                           );
      Lb_Chetto_Error3 (Francais)             :=
        To_Unbounded_String(
                            "- Erreur sur le modle de tche : impossible d'appliquer la mthode de Chetto/Blazewicz. "
                           );
      Lb_Chetto_Error4 (Francais)             :=
        To_Unbounded_String(
                            "- Chetto/Blazewicz impossible  appliquer : chance de certaines courtes trop courtes. "
                           );

      Lb_Select_Precedence_Sink_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Selectionner une Precedence Source "
                           );

      Lb_Select_Precedence_Source_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Selectionner une Precedence Destination "
                           );

      Lb_Select_buffer_dependency_task_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Selectionner une Tche dpendante du Buffer"
                           );

      Lb_Select_buffer_dependency_object_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Selectionner un Objet dpendant du Buffer"
                           );

      Lb_Select_communication_dependency_object_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Selectionner un communication dpendant objet"
                           );

      Lb_Select_communication_orientation_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Selectionner une Communication Orientation"
                           );

      Lb_Select_communication_dependency_task_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Selectionner une Communication Dpendant de la Tche"
                           );

      Lb_Select_Buffer_Orientation_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner une Orientation du Buffer "
                           );

      Lb_Select_time_triggered_communication_sink_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner une time triggered communication sink "
                           );

      Lb_Select_time_triggered_communication_source_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner une time triggered communication source"
                           );

      Lb_Select_timing_property_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner une timing property"
                           );

      Lb_Select_resource_dependency_resource_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner une resource dependency resource"
                           );

      Lb_Select_resource_dependency_task_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner une resource dependency task"
                           );

      Lb_Select_black_board_dependent_task_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner une black board dependent task"
                           );

      Lb_Select_black_board_dependency_object_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner une black board dependency object"
                           );

      Lb_Select_dependency_type_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner un type de dpendance"
                           );

      Lb_Add_Precedence_Dependency_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Ajouter une Dependence de Precedence"
                           );

      Lb_Add_Queuing_Buffer_Dependency_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Ajouter une Queuing Buffer Dependence"
                           );

      Lb_Add_Communication_Dependency_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Ajouter une Dependence de Communication"
                           );

      Lb_Add_Time_Triggered_Dependency_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Ajouter une Time Triggered Dependency"
                           );

      Lb_Add_Resource_Dependency_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Ajouter une Dpendence de Ressource "
                           );

      Lb_Add_Black_Board_Buffer_Dependency_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Ajouter une Black Board Buffer Dependency"
                           );

      Lb_Select_black_board_orientation_Before (Francais) :=
        To_Unbounded_String(
                            "Veuillez d'abord Slectionner une black board orientation "
                           );

      --
      -- Random tools
      --

      Lb_Random (Francais)                        :=
        To_Unbounded_String ("Alatoire");
      Lb_Compute_Response_Time_Density (Francais) :=
        To_Unbounded_String ("Calculer la densit sur temps de rponse");
      Lb_Response_Time_Density (Francais)         :=
        To_Unbounded_String ("Densit des temps de rponse");
      Lb_Response_Time (Francais)                 :=
        To_Unbounded_String ("temps de rponse");


      --
      -- CFG
      --
      Lb_CFG (Francais)				:=
        To_Unbounded_String("CFG");
      Lb_CFG_Id (Francais)			:=
        To_Unbounded_String("CFG Id");
      Lb_CFG_Name (Francais)			:=
        To_Unbounded_String("Nom de CFG");
      Lb_Can_Not_Define_More_CFG (Francais)	:=
        To_Unbounded_String("Vous ne pouvez pas dfinir plusieurs CFG");

      --
      -- CFG_Node
      --
      Lb_CFG_Node (Francais)			:=
        To_Unbounded_String("CFG noeuds");
      Lb_CFG_Node_Id (Francais)		:=
        To_Unbounded_String("Basique Bloc Id");
      Lb_CFG_Node_Name (Francais)		:=
        To_Unbounded_String("Nom de CFG noeuds");
      Lb_Previous_Nodes (Francais)		:=
        To_Unbounded_String("Prcdent CFG noeuds");
      Lb_Next_Nodes (Francais)			:=
        To_Unbounded_String("Suivant CFG noeuds");
      Lb_Instruction_Offset (Francais)		:=
        To_Unbounded_String("Instruction Offset");
      Lb_Instruction_Capacity (Francais)		:=
        To_Unbounded_String("Instruction Capacit");
      Lb_Data_Offset (Francais)			:=
        To_Unbounded_String("Data Offset");
      Lb_Data_Capacity (Francais)		:=
        To_Unbounded_String("Data Capacity");
      Lb_CFG_Node_Type (Francais)		:=
        To_Unbounded_String("Type de CFG noeud");
      Lb_Can_Not_Define_More_CFG_Node (Francais):=
        To_Unbounded_String("Vous ne pouvez pas dfinir plusieurs CFG Node");

      --
      -- CFG_Edge
      --
      Lb_CFG_Edge_Id (Francais)			:=
        To_Unbounded_String("CFG Edge Id");
      Lb_CFG_Edge (Francais)			:=
        To_Unbounded_String("CFG Edge");
      Lb_CFG_Edge_Name (Francais)		:=
        To_Unbounded_String("Nom du CFG Edge");
      Lb_Can_Not_Define_More_CFG_Edge (Francais):=
        To_Unbounded_String("Vous ne pouvez pas dfinir plusieurs CFG Edge");

      --
      -- OPA, OPA_CRPD Requirement
      --
      Lb_Offset_Must_Be_Defined_For_OPA (Francais) :=
        To_Unbounded_String("Offsets des tches doivent tre dfinies avant d'effectuer Audsleys OPA");
      Lb_Cache_Access_Profile_Must_Be_Defined_For_OPA (Francais) :=
        To_Unbounded_String("Cache Access Profiles des tches doivent tre dfinies avant d'effectuer Audsleys OPA");


      --
      -- WCRT+CRPD
      --
      Lb_WCRT_CRPD_Preemptive_Only (Francais) :=
        To_Unbounded_String("WCRT analysis + CRPD only applied to preemptive scheduler");

   end Initialize;

end Translate.Francais_Labels;
