with applicability_constraint.Unsimultaneous_Release_Time_Constraint;
use applicability_constraint.Unsimultaneous_Release_Time_Constraint;
with applicability_constraint.Simultaneous_Release_Time_Constraint;
use applicability_constraint.Simultaneous_Release_Time_Constraint;
with applicability_constraint.Period_Equal_Deadline_Constraint;
use applicability_constraint.Period_Equal_Deadline_Constraint;
with applicability_constraint.Period_Smaller_Than_Deadline_Constraint;
use applicability_constraint.Period_Smaller_Than_Deadline_Constraint;
with applicability_constraint.Period_Larger_Than_Deadline_Constraint;
use applicability_constraint.Period_Larger_Than_Deadline_Constraint;
with applicability_constraint.arbitrary_deadlines;
use applicability_constraint.arbitrary_deadlines;
with Applicability_Constraints_Main_Structure;
use Applicability_Constraints_Main_Structure;
with Applicability_Constraints_Main_Structure.extended;
use Applicability_Constraints_Main_Structure.extended;
with feasibility_tests_for_Time_Triggered_Communication;
use feasibility_tests_for_Time_Triggered_Communication;
with feasibility_tests_for_unplugged;
with feasibility_tests_for_ravenscar;
with debug;
use debug;

package body feasibility_tests_main_structure_factory is

   procedure Time_Triggered_Communication_feasibility_tests_main_structure
     (All_Cases : out All_Cases_Structure;
      Sys       : in System)
   is

      constraint_temp      :
        Applicability_Constraints_Main_Structure.Applicability_Constraint_Ptr;
      constraint_case_temp : Applicability_Constraint_Case_Ptr;

   begin

      Initialize (All_Cases);
      Initialize (constraint_temp);
      Initialize (constraint_case_temp);

      --CASE_1
      --("CASE 1");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_1");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String
           ("Test_S1 ; Test_R1 ; Test_R2 ; Test_C7 ; Test_C1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;
	Put_debug("added ref to constraint function");

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_1_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_1_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_1'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_1 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_2
      --("CASE 2");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_2");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_2_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_2_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_2'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_2 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_3
      --("CASE 3");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_3");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ; Test_R1 ; Test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_3_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_3_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_3'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_3 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_4
      --("CASE 4");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_4");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_4_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_4_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_4'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_4 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_5
      --("CASE 5");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_5");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_5_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_5_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_5'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_5 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_6
      --("CASE 6");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_6");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_6_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_6_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_6'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_6 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_7
      --("CASE 7");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_7");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R2");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --arbitrary_deadlines_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("arbitrary_deadlines_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.arbitrary_deadlines.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_7_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_7_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_7'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_7 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_8
      --("CASE 8");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_8");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;


      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_8_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_8_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_8'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_8 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_9
      --("CASE 9");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_9");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C3, test_C4, test_R4  ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_9_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_9_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_9'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_9 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_10
      --("CASE 10");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_10");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_10_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_10_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_10'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_10 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_11
      --("CASE 11");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_11");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_11_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_11_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_11'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_11 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_12
      --("CASE 12");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_12");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_12_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_12_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_12'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_12 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_13
      --("CASE 13");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_13");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_13_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_13_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_13'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_13 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_14
      --("CASE 14");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_14");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_14_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_14_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_14'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_14 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_15
      --("CASE 15");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_15");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_15_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_15_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_15'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_15 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_16
      --("CASE 16");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_16");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_16_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_16_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_16'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_16 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_17
      --("CASE 17");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_17");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String
           (" test_S1, test_C5, test_C7, test_R1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_17_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_17_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_17'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_17 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_18
      --("CASE 18");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_18");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_18_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_18_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_18'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_18 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_19
      --("CASE 19");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_19");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_C5, test_R1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_19_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_19_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_19'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_19 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_20
      --("CASE 20");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_20");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_20_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_20_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_20'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_20 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_21
      --("CASE 21");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_21");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_21_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_21_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_21'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_21 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_22
      --("CASE 22");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_22");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_22_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_22_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_22'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_22 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_23
      --("CASE 23");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_23");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_23_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_23_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_23'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_23 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_24
      --("CASE 24");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_24");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_24_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_24_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_24'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_24 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_25
      --("CASE 25");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_25");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_25_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_25_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_25'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_25 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_26
      --("CASE 26");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_26");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_26_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_26_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_26'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_26 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_27
      --("CASE 27");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_27");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_27_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_27_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_27'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_27 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_28
      --("CASE 28");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_28");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_28_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_28_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_28'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_28 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_29
      --("CASE 29");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_29");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_29_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_29_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_29'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_29 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_30
      --("CASE 30");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_30");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_30_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_30_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_30'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_30 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_31
      --("CASE 31");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_31");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_31_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_31_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_31'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_31 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_32
      --("CASE 32");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_32");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_32_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_32_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_32'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_32 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_33
      --("CASE 33");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_33");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C7, test_R1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_33_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_33_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_33'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_33 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_34
      --("CASE 34");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_34");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_34_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_34_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_34'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_34 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_35
      --("CASE 35");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_35");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ; Test_R1 ; Test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_35_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_35_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_35'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_35 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_36
      --("CASE 36");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_36");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_36_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_36_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_36'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_36 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_37
      --("CASE 37");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_37");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_37_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_37_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_37'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_37 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_38
      --("CASE 38");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_38");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_38_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_38_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_38'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_38 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_39
      --("CASE 39");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_39");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1, Test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_39_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_39_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_39'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_39 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_40
      --("CASE 40");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_40");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_40_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_40_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_40'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_40 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_41
      --("CASE 41");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_41");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R4  ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_41_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_41_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_41'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_41 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_42
      --("CASE 42");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_42");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_42_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_42_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_42'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_42 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_43
      --("CASE 43");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_43");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_43_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_43_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_43'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_43 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_44
      --("CASE 44");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_44");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_44_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_44_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_44'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_44 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_45
      --("CASE 45");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_45");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_45_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_45_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_45'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_45 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_46
      --("CASE 46");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_46");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_46_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_46_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_46'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_46 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_47
      --("CASE 47");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_47");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_47_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_47_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_47'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_47 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_48
      --("CASE 48");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_48");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_48_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_48_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_48'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_48 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_49
      --("CASE 49");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_49");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String
           (" test_S1, test_C1, test_C8, test_C9, test_C10, test_R1, test_R3");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_49_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_49_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_49'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_49 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_50
      --("CASE 50");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_50");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_C8, test_C9, test_C10, test_R3");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_50_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_50_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_50'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_50 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_51
      --("CASE 51");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_51");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C9, test_R3 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_3_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_51_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_51'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_51 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_52
      --("CASE 52");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_52");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_C9, test_R3 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_52_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_52_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_52'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_52 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_53
      --("CASE 53");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_53");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_C8, test_C10, test_R3 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_53_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_53_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_53'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_53 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_54
      --("CASE 54");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_54");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_C8, test_C10, test_R3 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_54_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_54_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_54'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_54 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_55
      --("CASE 55");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_55");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R3 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_55_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_55_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_55'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_55 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_56
      --("CASE 56");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_56");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_R3");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_56_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_56_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_56'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_56 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_57
      --("CASE 57");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_57");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C6, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_57_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_57_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_57'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_57 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_58
      --("CASE 58");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_58");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_58_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_58_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_58'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_58 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_59
      --("CASE 59");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_59");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_59_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_59_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_59'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_59 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_60
      --("CASE 60");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_60");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_60_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_60_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_60'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_60 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_61
      --("CASE 61");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_61");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_5_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_61_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_61'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_61 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_62
      --("CASE 62");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_62");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_62_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_62_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_62'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_62 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_63
      --("CASE 63");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_63");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_63_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_63_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_63'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_63 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_64
      --("CASE 64");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_64");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_64_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_64_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_64'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_64 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

   end Time_Triggered_Communication_feasibility_tests_main_structure;

   procedure ravenscar_feasibility_tests_main_structure
     (All_Cases : out All_Cases_Structure;
      Sys       : System)
   is

      constraint_temp      :
        Applicability_Constraints_Main_Structure.Applicability_Constraint_Ptr;
      constraint_case_temp : Applicability_Constraint_Case_Ptr;

   begin

      Initialize (All_Cases);
      Initialize (constraint_temp);
      Initialize (constraint_case_temp);

      --CASE_1
      --("CASE 1");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_1");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_s1, test_R1, test_R2, test_C3, test_C4");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_1_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_1_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_1'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_1 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_2
      --("CASE 2");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_2");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_2_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_2_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_2'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_2 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_3
      --("CASE 3");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_3");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ; Test_R1 ; Test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_3_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_3_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_3'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_3 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_4
      --("CASE 4");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_4");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_4_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_4_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_4'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_4 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_5
      --("CASE 5");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_5");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_5_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_5_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_5'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_5 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_6
      --("CASE 6");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_6");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_6_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_6_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_6'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_6 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_7
      --("CASE 7");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_7");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R2");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_7_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_7_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_7'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_7 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_8
      --("CASE 8");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_8");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_8_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_8_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_8'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_8 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_9
      --("CASE 9");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_9");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C3, test_C4, test_R4  ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_9_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_9_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_9'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_9 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_10
      --("CASE 10");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_10");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_10_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_10_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_10'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_10 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_11
      --("CASE 11");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_11");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_11_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_11_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_11'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_11 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_12
      --("CASE 12");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_12");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_12_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_12_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_12'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_12 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_13
      --("CASE 13");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_13");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_13_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_13_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_13'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_13 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_14
      --("CASE 14");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_14");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_14_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_14_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_14'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_14 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_15
      --("CASE 15");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_15");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_15_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_15_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_15'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_15 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_16
      --("CASE 16");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_16");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_16_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_16_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_16'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_16 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_17
      --("CASE 17");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_17");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_17_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_17_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_17'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_17 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_18
      --("CASE 18");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_18");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_18_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_18_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_18'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_18 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_19
      --("CASE 19");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_19");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_19_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_19_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_19'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_19 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_20
      --("CASE 20");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_20");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_20_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_20_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_20'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_20 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_21
      --("CASE 21");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_21");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_21_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_21_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_21'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_21 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_22
      --("CASE 22");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_22");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_22_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_22_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_22'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_22 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_23
      --("CASE 23");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_23");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_23_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_23_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_23'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_23 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_24
      --("CASE 24");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_24");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_24_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_24_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_24'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_24 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_25
      --("CASE 25");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_25");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_25_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_25_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_25'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_25 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_26
      --("CASE 26");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_26");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_26_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_26_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_26'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_26 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_27
      --("CASE 27");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_27");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_27_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_27_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_27'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_27 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_28
      --("CASE 28");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_28");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_28_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_28_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_28'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_28 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_29
      --("CASE 29");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_29");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_29_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_29_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_29'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_29 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_30
      --("CASE 30");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_30");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_30_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_30_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_30'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_30 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_31
      --("CASE 31");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_31");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_31_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_31_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_31'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_31 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_32
      --("CASE 32");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_32");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_32_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_32_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_32'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_32 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_33
      --("CASE 33");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_33");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_33_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_33_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_33'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_33 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_34
      --("CASE 34");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_34");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_34_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_34_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_34'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_34 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_35
      --("CASE 35");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_35");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ; Test_R1 ; Test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_35_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_35_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_35'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_35 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_36
      --("CASE 36");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_36");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_36_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_36_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_36'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_36 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_37
      --("CASE 37");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_37");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_37_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_37_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_37'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_37 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_38
      --("CASE 38");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_38");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_38_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_38_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_38'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_38 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_39
      --("CASE 39");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_39");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1, Test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_39_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_39_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_39'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_39 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_40
      --("CASE 40");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_40");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_40_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_40_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_40'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_40 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_41
      --("CASE 41");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_41");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R4  ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_41_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_41_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_41'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_41 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_42
      --("CASE 42");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_42");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_42_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_42_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_42'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_42 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_43
      --("CASE 43");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_43");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_43_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_43_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_43'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_43 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_44
      --("CASE 44");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_44");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_44_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_44_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_44'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_44 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_45
      --("CASE 45");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_45");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_45_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_45_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_45'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_45 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_46
      --("CASE 46");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_46");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_46_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_46_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_46'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_46 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_47
      --("CASE 47");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_47");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_47_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_47_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_47'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_47 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_48
      --("CASE 48");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_48");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_48_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_48_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_48'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_48 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_49
      --("CASE 49");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_49");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_49_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_49_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_49'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_49 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_50
      --("CASE 50");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_50");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_50_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_50_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_50'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_50 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_51
      --("CASE 51");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_51");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_3_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_51_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_51'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_51 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_52
      --("CASE 52");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_52");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_52_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_52_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_52'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_52 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_53
      --("CASE 53");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_53");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_53_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_53_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_53'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_53 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_54
      --("CASE 54");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_54");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_54_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_54_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_54'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_54 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_55
      --("CASE 55");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_55");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_55_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_55_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_55'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_55 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_56
      --("CASE 56");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_56");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_56_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_56_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_56'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_56 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_57
      --("CASE 57");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_57");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C6, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_57_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_57_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_57'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_57 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_58
      --("CASE 58");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_58");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_58_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_58_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_58'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_58 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_59
      --("CASE 59");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_59");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_59_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_59_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_59'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_59 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_60
      --("CASE 60");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_60");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_60_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_60_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_60'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_60 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_61
      --("CASE 61");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_61");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_5_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_61_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_61'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_61 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_62
      --("CASE 62");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_62");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_62_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_62_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_62'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_62 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_63
      --("CASE 63");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_63");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_63_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_63_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_63'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_63 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_64
      --("CASE 64");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_64");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_64_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_64_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_ravenscar.Function_Case_64'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_64 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

   end ravenscar_feasibility_tests_main_structure;

   procedure unplugged_feasibility_tests_main_structure
     (All_Cases : out All_Cases_Structure;
      Sys       : System)
   is

      constraint_temp      :
        Applicability_Constraints_Main_Structure.Applicability_Constraint_Ptr;
      constraint_case_temp : Applicability_Constraint_Case_Ptr;

   begin

      Initialize (All_Cases);
      Initialize (constraint_temp);
      Initialize (constraint_case_temp);

      --CASE_1
      --("CASE 1");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_1");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String
           ("Test_S1 ; Test_R1 ; Test_R2 ; Test_C7 ; Test_C1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_1_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_1_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_1'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_1 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_2
      --("CASE 2");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_2");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_2_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_2_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_2'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_2 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_3
      --("CASE 3");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_3");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ; Test_R1 ; Test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_3_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_3_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_3'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_3 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_4
      --("CASE 4");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_4");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_4_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_4_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_4'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_4 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_5
      --("CASE 5");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_5");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_5_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_5_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_5'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_5 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_6
      --("CASE 6");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_6");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_6_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_6_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_6'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_6 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_7
      --("CASE 7");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_7");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R2");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_7_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_7_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_7'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_7 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_8
      --("CASE 8");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_8");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_8_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_8_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_8'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_8 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_9
      ----("CASE 9");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_9");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C3, test_C4, test_R4  ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_9_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_9_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_9'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_9 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_10
      --("CASE 10");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_10");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_10_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_10_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_10'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_10 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_11
      --("CASE 11");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_11");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_11_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_11_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_11'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_11 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_12
      --("CASE 12");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_12");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_12_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_12_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_12'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_12 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_13
      --("CASE 13");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_13");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_13_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_13_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_13'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_13 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_14
      --("CASE 14");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_14");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_14_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_14_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_14'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_14 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_15
      --("CASE 15");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_15");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_15_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_15_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_15'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_15 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_16
      --("CASE 16");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_16");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_16_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_16_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_16'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_16 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_17
      --("CASE 17");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_17");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String
           (" test_S1, test_C5, test_C7, test_R1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_17_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_17_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_17'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_17 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_18
      --("CASE 18");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_18");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_18_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_18_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_18'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_18 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_19
      --("CASE 19");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_19");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_C5, test_R1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_19_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_19_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_19'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_19 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_20
      --("CASE 20");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_20");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_20_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_20_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_20'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_20 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_21
      --("CASE 21");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_21");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_21_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_21_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_21'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_21 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_22
      --("CASE 22");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_22");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_22_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_22_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_22'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_22 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_23
      --("CASE 23");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_23");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_23_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_23_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_23'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_23 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_24
      --("CASE 24");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_24");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_24_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_24_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_24'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_24 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_25
      --("CASE 25");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_25");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_25_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_25_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_25'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_25 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_26
      --("CASE 26");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_26");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_26_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_26_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_26'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_26 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_27
      --("CASE 27");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_27");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_27_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_27_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_27'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_27 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_28
      --("CASE 28");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_28");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_28_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_28_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_28'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_28 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_29
      --("CASE 29");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_29");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_29_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_29_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_29'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_29 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_30
      --("CASE 30");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_30");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_30_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_30_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_30'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_30 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_31
      --("CASE 31");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_31");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_31_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_31_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_31'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_31 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_32
      --("CASE 32");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_32");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_32_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_32_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_32'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_32 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_33
      --("CASE 33");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_33");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C7, test_R1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_33_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_33_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_33'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_33 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_34
      --("CASE 34");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_34");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_34_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_34_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_34'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_34 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_35
      --("CASE 35");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_35");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ; Test_R1 ; Test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_35_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_35_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_35'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_35 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_36
      --("CASE 36");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_36");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_36_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_36_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_36'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_36 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_37
      --("CASE 37");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_37");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_37_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_37_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_37'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_37 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_38
      --("CASE 38");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_38");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_38_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_38_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_38'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_38 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_39
      --("CASE 39");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_39");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1, Test_R2 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_39_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_39_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_39'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_39 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_40
      --("CASE 40");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_40");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_40_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_40_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_40'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_40 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_41
      --("CASE 41");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_41");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R4  ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_41_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_41_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_41'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_41 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_42
      --("CASE 42");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_42");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_42_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_42_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_42'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_42 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_43
      --("CASE 43");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_43");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R4 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_43_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_43_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_43'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_43 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_44
      --("CASE 44");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_44");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_44_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_44_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_44'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_44 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_45
      --("CASE 45");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_45");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S1 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_45_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_45_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_45'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_45 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_46
      --("CASE 46");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_46");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_46_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_46_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_46'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_46 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_47
      --("CASE 47");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_47");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_47_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_47_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_47'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_47 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_48
      --("CASE 48");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_48");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("Test_S2 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_48_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_48_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_48'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_48 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_49
      --("CASE 49");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_49");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String
           (" test_S1, test_C1, test_C8, test_C9, test_C10, test_R1, test_R3");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_49_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_49_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_49'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_49 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_50
      --("CASE 50");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_50");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_C8, test_C9, test_C10, test_R3");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_50_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_50_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_50'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_50 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_51
      --("CASE 51");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_51");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C9, test_R3 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_3_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_51_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_51'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_51 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_52
      --("CASE 52");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_52");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_C9, test_R3 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_52_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_52_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_52'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_52 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_53
      --("CASE 53");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_53");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_C8, test_C10, test_R3 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_53_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_53_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_53'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_53 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_54
      --("CASE 54");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_54");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_C8, test_C10, test_R3 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_54_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_54_Constraint");
      constraint_temp.all.Corresponding_Function := Function_Case_54'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_54 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_55
      --("CASE 55");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_55");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R3 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_55_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_55_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_55'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_55 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_56
      --("CASE 56");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_56");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_R3");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_56_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_56_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_56'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_56 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_57
      --("CASE 57");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_57");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_C6, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_57_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_57_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_57'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_57 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_58
      --("CASE 58");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_58");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Equal_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Equal_Deadline_Constraint.apply'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_58_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_58_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_58'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_58 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_59
      --("CASE 59");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_59");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_59_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_59_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_59'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_59 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_60
      --("CASE 60");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_60");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Larger_Than_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Larger_Than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Larger_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_60_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_60_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_60'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_60 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_61
      --("CASE 61");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_61");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S1, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_5_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_61_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_61'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_61 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_62
      --("CASE 62");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_62");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --Period_Equal_Deadline_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Period_Smaller_than_Deadline_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Period_Smaller_Than_Deadline_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));
      --CASE_62_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_62_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_62'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_62 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_63
      --("CASE 63");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_63");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String ("test_S1, test_R5 ");
      --Simultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Simultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Simultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_63_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_63_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_63'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_63 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

      --CASE_64
      --("CASE 64");
      constraint_case_temp.all.Name                   :=
         To_Unbounded_String ("Case_64");
      constraint_case_temp.all.Feasibility_Test_Names :=
         To_Unbounded_String (" test_S2, test_R5 ");
      --Unsimultaneous_Release_Time_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("Unsimultaneous_Release_Time_Constraint");
      constraint_temp.all.Corresponding_Function :=
        applicability_constraint.Unsimultaneous_Release_Time_Constraint.apply'
        Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --CASE_64_Constraint
      constraint_temp.all.Name                   :=
         To_Unbounded_String ("CASE_64_Constraint");
      constraint_temp.all.Corresponding_Function :=
        feasibility_tests_for_unplugged.Function_Case_64'Access;

      Applicability_Constraints_List_Package.Add
        (constraint_case_temp.all.Applicability_Constraints,
         duplicate (constraint_temp));

      --adding to CASE_64 to All_Cases
      Applicability_Constraint_Cases_List_Package.Add
        (All_Cases.Cases,
         duplicate (constraint_case_temp));
      Applicability_Constraints_List_Package.Initialize
        (constraint_case_temp.all.Applicability_Constraints);

   end unplugged_feasibility_tests_main_structure;

end feasibility_tests_main_structure_factory;
